/* Box.c generated by valac 0.11.7, the Vala compiler
 * generated from Box.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>


#define TYPE_BOX_LOCATION (box_location_get_type ())

#define TYPE_BOX_COMPLEMENTS (box_complements_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	BOX_LOCATION_OUTSIDE,
	BOX_LOCATION_INSIDE,
	BOX_LOCATION_TOP_SIDE,
	BOX_LOCATION_LEFT_SIDE,
	BOX_LOCATION_RIGHT_SIDE,
	BOX_LOCATION_BOTTOM_SIDE,
	BOX_LOCATION_TOP_LEFT,
	BOX_LOCATION_BOTTOM_LEFT,
	BOX_LOCATION_TOP_RIGHT,
	BOX_LOCATION_BOTTOM_RIGHT
} BoxLocation;

typedef enum  {
	BOX_COMPLEMENTS_NONE,
	BOX_COMPLEMENTS_VERTICAL,
	BOX_COMPLEMENTS_HORIZONTAL,
	BOX_COMPLEMENTS_BOTH
} BoxComplements;

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _Dimensions {
	gint width;
	gint height;
};



GType box_location_get_type (void) G_GNUC_CONST;
GType box_complements_get_type (void) G_GNUC_CONST;
BoxComplements box_complements_derive (gboolean horizontal_complement, gboolean vertical_complement);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
#define BOX_HAND_GRENADES 12
void box_init (Box *self, gint left, gint top, gint right, gint bottom);
void box_from_rectangle (GdkRectangle* rect, Box* result);
void box_from_allocation (GtkAllocation* alloc, Box* result);
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
gboolean box_is_valid (Box *self);
gboolean box_equals (Box *self, Box* box);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void box_get_scaled (Box *self, Dimensions* scaled, Box* result);
void box_get_dimensions (Box *self, Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, gdouble* width_ratio, gdouble* height_ratio);
void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result);
void box_get_offset (Box *self, gint xofs, gint yofs, Box* result);
void dimensions_init (Dimensions *self, gint width, gint height);
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right);
void box_get_rectangle (Box *self, GdkRectangle* result);
void box_rotate_clockwise (Box *self, Dimensions* space, Box* result);
void box_rotate_counterclockwise (Box *self, Dimensions* space, Box* result);
void box_flip_left_to_right (Box *self, Dimensions* space, Box* result);
void box_flip_top_to_bottom (Box *self, Dimensions* space, Box* result);
gboolean box_intersects (Box *self, Box* compare);
void box_get_reduced (Box *self, gint amount, Box* result);
void box_get_expanded (Box *self, gint amount, Box* result);
gboolean box_contains (Box *self, GdkPoint* point);
BoxComplements box_resized_complements (Box *self, Box* resized, Box* horizontal, gboolean* horizontal_enlarged, Box* vertical, gboolean* vertical_enlarged);
BoxComplements box_shifted_complements (Box *self, Box* shifted, Box* horizontal_this, Box* vertical_this, Box* horizontal_shifted, Box* vertical_shifted);
void box_rubber_band (Box *self, GdkPoint* point, Box* result);
gchar* box_to_string (Box *self);
gchar* dimensions_to_string (Dimensions *self);
static gboolean box_in_zone (gdouble pos, gint zone);
static gboolean box_in_between (gdouble pos, gint top, gint bottom);
static gboolean box_near_in_between (gdouble pos, gint top, gint bottom);
BoxLocation box_approx_location (Box *self, gint x, gint y);


GType box_location_get_type (void) {
	static volatile gsize box_location_type_id__volatile = 0;
	if (g_once_init_enter (&box_location_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_LOCATION_OUTSIDE, "BOX_LOCATION_OUTSIDE", "outside"}, {BOX_LOCATION_INSIDE, "BOX_LOCATION_INSIDE", "inside"}, {BOX_LOCATION_TOP_SIDE, "BOX_LOCATION_TOP_SIDE", "top-side"}, {BOX_LOCATION_LEFT_SIDE, "BOX_LOCATION_LEFT_SIDE", "left-side"}, {BOX_LOCATION_RIGHT_SIDE, "BOX_LOCATION_RIGHT_SIDE", "right-side"}, {BOX_LOCATION_BOTTOM_SIDE, "BOX_LOCATION_BOTTOM_SIDE", "bottom-side"}, {BOX_LOCATION_TOP_LEFT, "BOX_LOCATION_TOP_LEFT", "top-left"}, {BOX_LOCATION_BOTTOM_LEFT, "BOX_LOCATION_BOTTOM_LEFT", "bottom-left"}, {BOX_LOCATION_TOP_RIGHT, "BOX_LOCATION_TOP_RIGHT", "top-right"}, {BOX_LOCATION_BOTTOM_RIGHT, "BOX_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType box_location_type_id;
		box_location_type_id = g_enum_register_static ("BoxLocation", values);
		g_once_init_leave (&box_location_type_id__volatile, box_location_type_id);
	}
	return box_location_type_id__volatile;
}


BoxComplements box_complements_derive (gboolean horizontal_complement, gboolean vertical_complement) {
	BoxComplements result = 0;
	gboolean _tmp0_ = FALSE;
	if (horizontal_complement) {
		_tmp0_ = vertical_complement;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = BOX_COMPLEMENTS_BOTH;
		return result;
	} else {
		if (horizontal_complement) {
			result = BOX_COMPLEMENTS_HORIZONTAL;
			return result;
		} else {
			if (vertical_complement) {
				result = BOX_COMPLEMENTS_VERTICAL;
				return result;
			}
		}
	}
	result = BOX_COMPLEMENTS_NONE;
	return result;
}


GType box_complements_get_type (void) {
	static volatile gsize box_complements_type_id__volatile = 0;
	if (g_once_init_enter (&box_complements_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_COMPLEMENTS_NONE, "BOX_COMPLEMENTS_NONE", "none"}, {BOX_COMPLEMENTS_VERTICAL, "BOX_COMPLEMENTS_VERTICAL", "vertical"}, {BOX_COMPLEMENTS_HORIZONTAL, "BOX_COMPLEMENTS_HORIZONTAL", "horizontal"}, {BOX_COMPLEMENTS_BOTH, "BOX_COMPLEMENTS_BOTH", "both"}, {0, NULL, NULL}};
		GType box_complements_type_id;
		box_complements_type_id = g_enum_register_static ("BoxComplements", values);
		g_once_init_leave (&box_complements_type_id__volatile, box_complements_type_id);
	}
	return box_complements_type_id__volatile;
}


void box_init (Box *self, gint left, gint top, gint right, gint bottom) {
	memset (self, 0, sizeof (Box));
	g_assert (left >= 0);
	g_assert (top >= 0);
	g_assert (right >= left);
	g_assert (bottom >= top);
	(*self).left = left;
	(*self).top = top;
	(*self).right = right;
	(*self).bottom = bottom;
}


void box_from_rectangle (GdkRectangle* rect, Box* result) {
	Box _tmp0_ = {0};
	Box _tmp1_ = {0};
	box_init (&_tmp0_, (*rect).x, (*rect).y, ((*rect).x + (*rect).width) - 1, ((*rect).y + (*rect).height) - 1);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


void box_from_allocation (GtkAllocation* alloc, Box* result) {
	Box _tmp0_ = {0};
	Box _tmp1_ = {0};
	box_init (&_tmp0_, (*alloc).x, (*alloc).y, ((*alloc).x + (*alloc).width) - 1, ((*alloc).y + (*alloc).height) - 1);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Box _tmp4_ = {0};
	Box _tmp5_ = {0};
	_tmp0_ = MIN ((*corner1).x, (*corner2).x);
	_tmp1_ = MIN ((*corner1).y, (*corner2).y);
	_tmp2_ = MAX ((*corner1).x, (*corner2).x);
	_tmp3_ = MAX ((*corner1).y, (*corner2).y);
	box_init (&_tmp4_, _tmp0_, _tmp1_, _tmp2_, _tmp3_);
	_tmp5_ = _tmp4_;
	*result = _tmp5_;
	return;
}


gint box_get_width (Box *self) {
	gint result = 0;
	g_assert ((*self).right >= (*self).left);
	result = ((*self).right - (*self).left) + 1;
	return result;
}


gint box_get_height (Box *self) {
	gint result = 0;
	g_assert ((*self).bottom >= (*self).top);
	result = ((*self).bottom - (*self).top) + 1;
	return result;
}


gboolean box_is_valid (Box *self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	if ((*self).left >= 0) {
		_tmp2_ = (*self).top >= 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = (*self).right >= (*self).left;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = (*self).bottom >= (*self).top;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean box_equals (Box *self, Box* box) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	if ((*self).left == (*box).left) {
		_tmp2_ = (*self).top == (*box).top;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = (*self).right == (*box).right;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = (*self).bottom == (*box).bottom;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


void box_get_scaled (Box *self, Dimensions* scaled, Box* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gint l;
	gdouble _tmp5_;
	gint t;
	gint r;
	gint b;
	Box box = {0};
	gboolean _tmp6_ = FALSE;
	gint _tmp7_;
	box_get_dimensions (&(*self), &_tmp0_);
	_tmp1_ = _tmp0_;
	dimensions_get_scale_ratios (&_tmp1_, scaled, &_tmp2_, &_tmp3_);
	x_scale = _tmp2_;
	y_scale = _tmp3_;
	_tmp4_ = round (((gdouble) (*self).left) * x_scale);
	l = (gint) _tmp4_;
	_tmp5_ = round (((gdouble) (*self).top) * y_scale);
	t = (gint) _tmp5_;
	r = (l + (*scaled).width) - 1;
	b = (t + (*scaled).height) - 1;
	box_init (&box, l, t, r, b);
	_tmp7_ = box_get_width (&box);
	if (_tmp7_ == (*scaled).width) {
		_tmp6_ = TRUE;
	} else {
		gint _tmp8_;
		_tmp8_ = box_get_height (&box);
		_tmp6_ = _tmp8_ == (*scaled).height;
	}
	g_assert (_tmp6_);
	*result = box;
	return;
}


void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gint l;
	gdouble _tmp3_;
	gint t;
	gdouble _tmp4_;
	gint r;
	gdouble _tmp5_;
	gint b;
	Box _tmp6_ = {0};
	Box _tmp7_ = {0};
	dimensions_get_scale_ratios (original, scaled, &_tmp0_, &_tmp1_);
	x_scale = _tmp0_;
	y_scale = _tmp1_;
	_tmp2_ = round (((gdouble) (*self).left) * x_scale);
	l = (gint) _tmp2_;
	_tmp3_ = round (((gdouble) (*self).top) * y_scale);
	t = (gint) _tmp3_;
	_tmp4_ = round (((gdouble) (*self).right) * x_scale);
	r = (gint) _tmp4_;
	_tmp5_ = round (((gdouble) (*self).bottom) * y_scale);
	b = (gint) _tmp5_;
	if (r >= (*scaled).width) {
		r = (*scaled).width - 1;
	}
	if (b >= (*scaled).height) {
		b = (*scaled).height - 1;
	}
	box_init (&_tmp6_, l, t, r, b);
	_tmp7_ = _tmp6_;
	*result = _tmp7_;
	return;
}


void box_get_offset (Box *self, gint xofs, gint yofs, Box* result) {
	Box _tmp0_ = {0};
	Box _tmp1_ = {0};
	box_init (&_tmp0_, (*self).left + xofs, (*self).top + yofs, (*self).right + xofs, (*self).bottom + yofs);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


void box_get_dimensions (Box *self, Dimensions* result) {
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	_tmp0_ = box_get_width (&(*self));
	_tmp1_ = box_get_height (&(*self));
	dimensions_init (&_tmp2_, _tmp0_, _tmp1_);
	_tmp3_ = _tmp2_;
	*result = _tmp3_;
	return;
}


void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right) {
	GdkPoint _top_left = {0};
	GdkPoint _bottom_right = {0};
	_top_left.x = (*self).left;
	_top_left.y = (*self).top;
	_bottom_right.x = (*self).right;
	_bottom_right.y = (*self).bottom;
	if (top_left) {
		*top_left = _top_left;
	}
	if (bottom_right) {
		*bottom_right = _bottom_right;
	}
}


void box_get_rectangle (Box *self, GdkRectangle* result) {
	GdkRectangle rect = {0};
	gint _tmp0_;
	gint _tmp1_;
	memset (&rect, 0, sizeof (GdkRectangle));
	rect.x = (*self).left;
	rect.y = (*self).top;
	_tmp0_ = box_get_width (&(*self));
	rect.width = _tmp0_;
	_tmp1_ = box_get_height (&(*self));
	rect.height = _tmp1_;
	*result = rect;
	return;
}


void box_rotate_clockwise (Box *self, Dimensions* space, Box* result) {
	gint l;
	gint t;
	gint r;
	gint b;
	Box _tmp0_ = {0};
	Box _tmp1_ = {0};
	l = ((*space).width - (*self).bottom) - 1;
	t = (*self).left;
	r = ((*space).width - (*self).top) - 1;
	b = (*self).right;
	box_init (&_tmp0_, l, t, r, b);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


void box_rotate_counterclockwise (Box *self, Dimensions* space, Box* result) {
	gint l;
	gint t;
	gint r;
	gint b;
	Box _tmp0_ = {0};
	Box _tmp1_ = {0};
	l = (*self).top;
	t = ((*space).height - (*self).right) - 1;
	r = (*self).bottom;
	b = ((*space).height - (*self).left) - 1;
	box_init (&_tmp0_, l, t, r, b);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


void box_flip_left_to_right (Box *self, Dimensions* space, Box* result) {
	gint l;
	gint r;
	Box _tmp0_ = {0};
	Box _tmp1_ = {0};
	l = ((*space).width - (*self).right) - 1;
	r = ((*space).width - (*self).left) - 1;
	box_init (&_tmp0_, l, (*self).top, r, (*self).bottom);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


void box_flip_top_to_bottom (Box *self, Dimensions* space, Box* result) {
	gint t;
	gint b;
	Box _tmp0_ = {0};
	Box _tmp1_ = {0};
	t = ((*space).height - (*self).bottom) - 1;
	b = ((*space).height - (*self).top) - 1;
	box_init (&_tmp0_, (*self).left, t, (*self).right, b);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


gboolean box_intersects (Box *self, Box* compare) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint left_intersect;
	gint _tmp1_;
	gint top_intersect;
	gint _tmp2_;
	gint right_intersect;
	gint _tmp3_;
	gint bottom_intersect;
	gboolean _tmp4_ = FALSE;
	_tmp0_ = MAX ((*self).left, (*compare).left);
	left_intersect = _tmp0_;
	_tmp1_ = MAX ((*self).top, (*compare).top);
	top_intersect = _tmp1_;
	_tmp2_ = MIN ((*self).right, (*compare).right);
	right_intersect = _tmp2_;
	_tmp3_ = MIN ((*self).bottom, (*compare).bottom);
	bottom_intersect = _tmp3_;
	if (right_intersect >= left_intersect) {
		_tmp4_ = bottom_intersect >= top_intersect;
	} else {
		_tmp4_ = FALSE;
	}
	result = _tmp4_;
	return result;
}


void box_get_reduced (Box *self, gint amount, Box* result) {
	Box _tmp0_ = {0};
	Box _tmp1_ = {0};
	box_init (&_tmp0_, (*self).left + amount, (*self).top + amount, (*self).right - amount, (*self).bottom - amount);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


void box_get_expanded (Box *self, gint amount, Box* result) {
	Box _tmp0_ = {0};
	Box _tmp1_ = {0};
	box_init (&_tmp0_, (*self).left - amount, (*self).top - amount, (*self).right + amount, (*self).bottom + amount);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


gboolean box_contains (Box *self, GdkPoint* point) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	if ((*point).x >= (*self).left) {
		_tmp2_ = (*point).x <= (*self).right;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = (*point).y >= (*self).top;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = (*point).y <= (*self).bottom;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


BoxComplements box_resized_complements (Box *self, Box* resized, Box* horizontal, gboolean* horizontal_enlarged, Box* vertical, gboolean* vertical_enlarged) {
	Box _horizontal = {0};
	gboolean _horizontal_enlarged = FALSE;
	Box _vertical = {0};
	gboolean _vertical_enlarged = FALSE;
	BoxComplements result = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean horizontal_complement;
	gboolean vertical_complement;
	BoxComplements _tmp21_;
	_tmp1_ = box_get_width (&(*self));
	_tmp2_ = box_get_width (resized);
	if (_tmp1_ != _tmp2_) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp3_;
		gint _tmp4_;
		_tmp3_ = box_get_height (&(*self));
		_tmp4_ = box_get_height (resized);
		_tmp0_ = _tmp3_ != _tmp4_;
	}
	g_assert (_tmp0_);
	horizontal_complement = TRUE;
	if ((*resized).top < (*self).top) {
		Box _tmp5_ = {0};
		Box _tmp6_ = {0};
		box_init (&_tmp5_, (*resized).left, (*resized).top, (*resized).right, (*self).top);
		_tmp6_ = _tmp5_;
		_horizontal = _tmp6_;
		_horizontal_enlarged = TRUE;
	} else {
		if ((*resized).top > (*self).top) {
			Box _tmp7_ = {0};
			Box _tmp8_ = {0};
			box_init (&_tmp7_, (*self).left, (*self).top, (*self).right, (*resized).top);
			_tmp8_ = _tmp7_;
			_horizontal = _tmp8_;
			_horizontal_enlarged = FALSE;
		} else {
			if ((*resized).bottom < (*self).bottom) {
				Box _tmp9_ = {0};
				Box _tmp10_ = {0};
				box_init (&_tmp9_, (*self).left, (*resized).bottom, (*self).right, (*self).bottom);
				_tmp10_ = _tmp9_;
				_horizontal = _tmp10_;
				_horizontal_enlarged = FALSE;
			} else {
				if ((*resized).bottom > (*self).bottom) {
					Box _tmp11_ = {0};
					Box _tmp12_ = {0};
					box_init (&_tmp11_, (*resized).left, (*self).bottom, (*resized).right, (*resized).bottom);
					_tmp12_ = _tmp11_;
					_horizontal = _tmp12_;
					_horizontal_enlarged = TRUE;
				} else {
					horizontal_complement = FALSE;
				}
			}
		}
	}
	vertical_complement = TRUE;
	if ((*resized).left < (*self).left) {
		Box _tmp13_ = {0};
		Box _tmp14_ = {0};
		box_init (&_tmp13_, (*resized).left, (*resized).top, (*self).left, (*resized).bottom);
		_tmp14_ = _tmp13_;
		_vertical = _tmp14_;
		_vertical_enlarged = TRUE;
	} else {
		if ((*resized).left > (*self).left) {
			Box _tmp15_ = {0};
			Box _tmp16_ = {0};
			box_init (&_tmp15_, (*self).left, (*self).top, (*resized).left, (*self).bottom);
			_tmp16_ = _tmp15_;
			_vertical = _tmp16_;
			_vertical_enlarged = FALSE;
		} else {
			if ((*resized).right < (*self).right) {
				Box _tmp17_ = {0};
				Box _tmp18_ = {0};
				box_init (&_tmp17_, (*resized).right, (*self).top, (*self).right, (*self).bottom);
				_tmp18_ = _tmp17_;
				_vertical = _tmp18_;
				_vertical_enlarged = FALSE;
			} else {
				if ((*resized).right > (*self).right) {
					Box _tmp19_ = {0};
					Box _tmp20_ = {0};
					box_init (&_tmp19_, (*self).right, (*resized).top, (*resized).right, (*resized).bottom);
					_tmp20_ = _tmp19_;
					_vertical = _tmp20_;
					_vertical_enlarged = TRUE;
				} else {
					vertical_complement = FALSE;
				}
			}
		}
	}
	_tmp21_ = box_complements_derive (horizontal_complement, vertical_complement);
	result = _tmp21_;
	if (horizontal) {
		*horizontal = _horizontal;
	}
	if (horizontal_enlarged) {
		*horizontal_enlarged = _horizontal_enlarged;
	}
	if (vertical) {
		*vertical = _vertical;
	}
	if (vertical_enlarged) {
		*vertical_enlarged = _vertical_enlarged;
	}
	return result;
}


BoxComplements box_shifted_complements (Box *self, Box* shifted, Box* horizontal_this, Box* vertical_this, Box* horizontal_shifted, Box* vertical_shifted) {
	Box _horizontal_this = {0};
	Box _vertical_this = {0};
	Box _horizontal_shifted = {0};
	Box _vertical_shifted = {0};
	BoxComplements result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean horizontal_complement;
	gboolean _tmp4_ = FALSE;
	gboolean vertical_complement;
	gboolean _tmp14_ = FALSE;
	BoxComplements _tmp24_;
	_tmp0_ = box_get_width (&(*self));
	_tmp1_ = box_get_width (shifted);
	g_assert (_tmp0_ == _tmp1_);
	_tmp2_ = box_get_height (&(*self));
	_tmp3_ = box_get_height (shifted);
	g_assert (_tmp2_ == _tmp3_);
	horizontal_complement = TRUE;
	if ((*shifted).top < (*self).top) {
		_tmp4_ = (*shifted).bottom > (*self).top;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		Box _tmp5_ = {0};
		Box _tmp6_ = {0};
		Box _tmp7_ = {0};
		Box _tmp8_ = {0};
		box_init (&_tmp5_, (*self).left, (*shifted).bottom, (*self).right, (*self).bottom);
		_tmp6_ = _tmp5_;
		_horizontal_this = _tmp6_;
		box_init (&_tmp7_, (*shifted).left, (*shifted).top, (*shifted).right, (*self).top);
		_tmp8_ = _tmp7_;
		_horizontal_shifted = _tmp8_;
	} else {
		gboolean _tmp9_ = FALSE;
		if ((*shifted).top > (*self).top) {
			_tmp9_ = (*shifted).top < (*self).bottom;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			Box _tmp10_ = {0};
			Box _tmp11_ = {0};
			Box _tmp12_ = {0};
			Box _tmp13_ = {0};
			box_init (&_tmp10_, (*self).left, (*self).top, (*self).right, (*shifted).top);
			_tmp11_ = _tmp10_;
			_horizontal_this = _tmp11_;
			box_init (&_tmp12_, (*shifted).left, (*self).bottom, (*shifted).right, (*shifted).bottom);
			_tmp13_ = _tmp12_;
			_horizontal_shifted = _tmp13_;
		} else {
			horizontal_complement = FALSE;
		}
	}
	vertical_complement = TRUE;
	if ((*shifted).left < (*self).left) {
		_tmp14_ = (*shifted).right > (*self).left;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		Box _tmp15_ = {0};
		Box _tmp16_ = {0};
		Box _tmp17_ = {0};
		Box _tmp18_ = {0};
		box_init (&_tmp15_, (*shifted).right, (*self).top, (*self).right, (*self).bottom);
		_tmp16_ = _tmp15_;
		_vertical_this = _tmp16_;
		box_init (&_tmp17_, (*shifted).left, (*shifted).top, (*self).left, (*shifted).bottom);
		_tmp18_ = _tmp17_;
		_vertical_shifted = _tmp18_;
	} else {
		gboolean _tmp19_ = FALSE;
		if ((*shifted).left > (*self).left) {
			_tmp19_ = (*shifted).left < (*self).right;
		} else {
			_tmp19_ = FALSE;
		}
		if (_tmp19_) {
			Box _tmp20_ = {0};
			Box _tmp21_ = {0};
			Box _tmp22_ = {0};
			Box _tmp23_ = {0};
			box_init (&_tmp20_, (*self).left, (*self).top, (*shifted).left, (*self).bottom);
			_tmp21_ = _tmp20_;
			_vertical_this = _tmp21_;
			box_init (&_tmp22_, (*self).right, (*shifted).top, (*shifted).right, (*shifted).bottom);
			_tmp23_ = _tmp22_;
			_vertical_shifted = _tmp23_;
		} else {
			vertical_complement = FALSE;
		}
	}
	_tmp24_ = box_complements_derive (horizontal_complement, vertical_complement);
	result = _tmp24_;
	if (horizontal_this) {
		*horizontal_this = _horizontal_this;
	}
	if (vertical_this) {
		*vertical_this = _vertical_this;
	}
	if (horizontal_shifted) {
		*horizontal_shifted = _horizontal_shifted;
	}
	if (vertical_shifted) {
		*vertical_shifted = _vertical_shifted;
	}
	return result;
}


void box_rubber_band (Box *self, GdkPoint* point, Box* result) {
	gint _tmp0_;
	gint t;
	gint _tmp1_;
	gint b;
	gint _tmp2_;
	gint l;
	gint _tmp3_;
	gint r;
	Box _tmp4_ = {0};
	Box _tmp5_ = {0};
	g_assert ((*point).x >= 0);
	g_assert ((*point).y >= 0);
	_tmp0_ = MIN ((*self).top, (*point).y);
	t = _tmp0_;
	_tmp1_ = MAX ((*self).bottom, (*point).y);
	b = _tmp1_;
	_tmp2_ = MIN ((*self).left, (*point).x);
	l = _tmp2_;
	_tmp3_ = MAX ((*self).right, (*point).x);
	r = _tmp3_;
	box_init (&_tmp4_, l, t, r, b);
	_tmp5_ = _tmp4_;
	*result = _tmp5_;
	return;
}


gchar* box_to_string (Box *self) {
	gchar* result = NULL;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	box_get_dimensions (&(*self), &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = dimensions_to_string (&_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup_printf ("%d,%d %d,%d (%s)", (*self).left, (*self).top, (*self).right, (*self).bottom, _tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	result = _tmp5_;
	return result;
}


static gboolean box_in_zone (gdouble pos, gint zone) {
	gboolean result = FALSE;
	gint top_zone;
	gint bottom_zone;
	gboolean _tmp0_;
	top_zone = zone - BOX_HAND_GRENADES;
	bottom_zone = zone + BOX_HAND_GRENADES;
	_tmp0_ = box_in_between (pos, top_zone, bottom_zone);
	result = _tmp0_;
	return result;
}


static gboolean box_in_between (gdouble pos, gint top, gint bottom) {
	gboolean result = FALSE;
	gint ipos;
	gboolean _tmp0_ = FALSE;
	ipos = (gint) pos;
	if (ipos > top) {
		_tmp0_ = ipos < bottom;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static gboolean box_near_in_between (gdouble pos, gint top, gint bottom) {
	gboolean result = FALSE;
	gint ipos;
	gint top_zone;
	gint bottom_zone;
	gboolean _tmp0_ = FALSE;
	ipos = (gint) pos;
	top_zone = top - BOX_HAND_GRENADES;
	bottom_zone = bottom + BOX_HAND_GRENADES;
	if (ipos > top_zone) {
		_tmp0_ = ipos < bottom_zone;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


BoxLocation box_approx_location (Box *self, gint x, gint y) {
	BoxLocation result = 0;
	gboolean _tmp0_;
	gboolean near_width;
	gboolean _tmp1_;
	gboolean near_height;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	_tmp0_ = box_near_in_between ((gdouble) x, (*self).left, (*self).right);
	near_width = _tmp0_;
	_tmp1_ = box_near_in_between ((gdouble) y, (*self).top, (*self).bottom);
	near_height = _tmp1_;
	_tmp3_ = box_in_zone ((gdouble) x, (*self).left);
	if (_tmp3_) {
		_tmp2_ = near_height;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gboolean _tmp4_;
		_tmp4_ = box_in_zone ((gdouble) y, (*self).top);
		if (_tmp4_) {
			result = BOX_LOCATION_TOP_LEFT;
			return result;
		} else {
			gboolean _tmp5_;
			_tmp5_ = box_in_zone ((gdouble) y, (*self).bottom);
			if (_tmp5_) {
				result = BOX_LOCATION_BOTTOM_LEFT;
				return result;
			} else {
				result = BOX_LOCATION_LEFT_SIDE;
				return result;
			}
		}
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		_tmp7_ = box_in_zone ((gdouble) x, (*self).right);
		if (_tmp7_) {
			_tmp6_ = near_height;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			gboolean _tmp8_;
			_tmp8_ = box_in_zone ((gdouble) y, (*self).top);
			if (_tmp8_) {
				result = BOX_LOCATION_TOP_RIGHT;
				return result;
			} else {
				gboolean _tmp9_;
				_tmp9_ = box_in_zone ((gdouble) y, (*self).bottom);
				if (_tmp9_) {
					result = BOX_LOCATION_BOTTOM_RIGHT;
					return result;
				} else {
					result = BOX_LOCATION_RIGHT_SIDE;
					return result;
				}
			}
		} else {
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_;
			_tmp11_ = box_in_zone ((gdouble) y, (*self).top);
			if (_tmp11_) {
				_tmp10_ = near_width;
			} else {
				_tmp10_ = FALSE;
			}
			if (_tmp10_) {
				result = BOX_LOCATION_TOP_SIDE;
				return result;
			} else {
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
				_tmp13_ = box_in_zone ((gdouble) y, (*self).bottom);
				if (_tmp13_) {
					_tmp12_ = near_width;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					result = BOX_LOCATION_BOTTOM_SIDE;
					return result;
				} else {
					gboolean _tmp14_ = FALSE;
					gboolean _tmp15_;
					_tmp15_ = box_in_between ((gdouble) x, (*self).left, (*self).right);
					if (_tmp15_) {
						gboolean _tmp16_;
						_tmp16_ = box_in_between ((gdouble) y, (*self).top, (*self).bottom);
						_tmp14_ = _tmp16_;
					} else {
						_tmp14_ = FALSE;
					}
					if (_tmp14_) {
						result = BOX_LOCATION_INSIDE;
						return result;
					} else {
						result = BOX_LOCATION_OUTSIDE;
						return result;
					}
				}
			}
		}
	}
}


Box* box_dup (const Box* self) {
	Box* dup;
	dup = g_new0 (Box, 1);
	memcpy (dup, self, sizeof (Box));
	return dup;
}


void box_free (Box* self) {
	g_free (self);
}


GType box_get_type (void) {
	static volatile gsize box_type_id__volatile = 0;
	if (g_once_init_enter (&box_type_id__volatile)) {
		GType box_type_id;
		box_type_id = g_boxed_type_register_static ("Box", (GBoxedCopyFunc) box_dup, (GBoxedFreeFunc) box_free);
		g_once_init_leave (&box_type_id__volatile, box_type_id);
	}
	return box_type_id__volatile;
}



