/* Orientation.c generated by valac 0.11.7, the Vala compiler
 * generated from Orientation.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gdk/gdk.h>


#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};



GType orientation_get_type (void) G_GNUC_CONST;
gchar* orientation_to_string (Orientation self);
Orientation orientation_rotate_clockwise (Orientation self);
Orientation orientation_rotate_counterclockwise (Orientation self);
Orientation orientation_flip_top_to_bottom (Orientation self);
Orientation orientation_flip_left_to_right (Orientation self);
GType rotation_get_type (void) G_GNUC_CONST;
Orientation orientation_perform (Orientation self, Rotation rotation);
Rotation* orientation_to_rotations (Orientation self, int* result_length1);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void dimensions_init (Dimensions *self, gint width, gint height);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
gboolean dimensions_has_area (Dimensions *self);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right);
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
GdkPixbuf* rotation_perform (Rotation self, GdkPixbuf* pixbuf);
Rotation rotation_opposite (Rotation self);


gchar* orientation_to_string (Orientation self) {
	gchar* result = NULL;
	switch (self) {
		case ORIENTATION_TOP_LEFT:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("top-left");
			result = _tmp0_;
			return result;
		}
		case ORIENTATION_TOP_RIGHT:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("top-right");
			result = _tmp1_;
			return result;
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("bottom-right");
			result = _tmp2_;
			return result;
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("bottom-left");
			result = _tmp3_;
			return result;
		}
		case ORIENTATION_LEFT_TOP:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("left-top");
			result = _tmp4_;
			return result;
		}
		case ORIENTATION_RIGHT_TOP:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("right-top");
			result = _tmp5_;
			return result;
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("right-bottom");
			result = _tmp6_;
			return result;
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("left-bottom");
			result = _tmp7_;
			return result;
		}
		default:
		{
			gchar* _tmp8_ = NULL;
			_tmp8_ = g_strdup_printf ("unknown orientation %d", (gint) self);
			result = _tmp8_;
			return result;
		}
	}
}


Orientation orientation_rotate_clockwise (Orientation self) {
	Orientation result = 0;
	switch (self) {
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_RIGHT_TOP;
			return result;
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
			return result;
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_LEFT_BOTTOM;
			return result;
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_LEFT_TOP;
			return result;
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_TOP_RIGHT;
			return result;
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
			return result;
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_BOTTOM_LEFT;
			return result;
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_TOP_LEFT;
			return result;
		}
		default:
		{
			g_error ("Orientation.vala:77: rotate_clockwise: %d", (gint) self);
		}
	}
}


Orientation orientation_rotate_counterclockwise (Orientation self) {
	Orientation result = 0;
	switch (self) {
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_LEFT_BOTTOM;
			return result;
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_LEFT_TOP;
			return result;
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_RIGHT_TOP;
			return result;
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
			return result;
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_BOTTOM_LEFT;
			return result;
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_TOP_LEFT;
			return result;
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_TOP_RIGHT;
			return result;
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
			return result;
		}
		default:
		{
			g_error ("Orientation.vala:108: rotate_counterclockwise: %d", (gint) self);
		}
	}
}


Orientation orientation_flip_top_to_bottom (Orientation self) {
	Orientation result = 0;
	switch (self) {
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_BOTTOM_LEFT;
			return result;
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
			return result;
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_TOP_RIGHT;
			return result;
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_TOP_LEFT;
			return result;
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_LEFT_BOTTOM;
			return result;
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
			return result;
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_RIGHT_TOP;
			return result;
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_LEFT_TOP;
			return result;
		}
		default:
		{
			g_error ("Orientation.vala:139: flip_top_to_bottom: %d", (gint) self);
		}
	}
}


Orientation orientation_flip_left_to_right (Orientation self) {
	Orientation result = 0;
	switch (self) {
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_TOP_RIGHT;
			return result;
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_TOP_LEFT;
			return result;
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_BOTTOM_LEFT;
			return result;
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
			return result;
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_RIGHT_TOP;
			return result;
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_LEFT_TOP;
			return result;
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_LEFT_BOTTOM;
			return result;
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
			return result;
		}
		default:
		{
			g_error ("Orientation.vala:170: flip_left_to_right: %d", (gint) self);
		}
	}
}


Orientation orientation_perform (Orientation self, Rotation rotation) {
	Orientation result = 0;
	switch (rotation) {
		case ROTATION_CLOCKWISE:
		{
			Orientation _tmp0_;
			_tmp0_ = orientation_rotate_clockwise (self);
			result = _tmp0_;
			return result;
		}
		case ROTATION_COUNTERCLOCKWISE:
		{
			Orientation _tmp1_;
			_tmp1_ = orientation_rotate_counterclockwise (self);
			result = _tmp1_;
			return result;
		}
		case ROTATION_MIRROR:
		{
			Orientation _tmp2_;
			_tmp2_ = orientation_flip_left_to_right (self);
			result = _tmp2_;
			return result;
		}
		case ROTATION_UPSIDE_DOWN:
		{
			Orientation _tmp3_;
			_tmp3_ = orientation_flip_top_to_bottom (self);
			result = _tmp3_;
			return result;
		}
		default:
		{
			g_error ("Orientation.vala:189: perform: %d", (gint) rotation);
		}
	}
}


Rotation* orientation_to_rotations (Orientation self, int* result_length1) {
	Rotation* result = NULL;
	switch (self) {
		case ORIENTATION_TOP_LEFT:
		{
			Rotation* _tmp0_ = NULL;
			Rotation* _tmp1_;
			_tmp0_ = g_new0 (Rotation, 0);
			_tmp1_ = _tmp0_;
			*result_length1 = 0;
			result = _tmp1_;
			return result;
		}
		case ORIENTATION_TOP_RIGHT:
		{
			Rotation* _tmp2_ = NULL;
			Rotation* _tmp3_;
			_tmp2_ = g_new0 (Rotation, 1);
			_tmp2_[0] = ROTATION_MIRROR;
			_tmp3_ = _tmp2_;
			*result_length1 = 1;
			result = _tmp3_;
			return result;
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			Rotation* _tmp4_ = NULL;
			Rotation* _tmp5_;
			_tmp4_ = g_new0 (Rotation, 1);
			_tmp4_[0] = ROTATION_UPSIDE_DOWN;
			_tmp5_ = _tmp4_;
			*result_length1 = 1;
			result = _tmp5_;
			return result;
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			Rotation* _tmp6_ = NULL;
			Rotation* _tmp7_;
			_tmp6_ = g_new0 (Rotation, 2);
			_tmp6_[0] = ROTATION_MIRROR;
			_tmp6_[1] = ROTATION_UPSIDE_DOWN;
			_tmp7_ = _tmp6_;
			*result_length1 = 2;
			result = _tmp7_;
			return result;
		}
		case ORIENTATION_LEFT_TOP:
		{
			Rotation* _tmp8_ = NULL;
			Rotation* _tmp9_;
			_tmp8_ = g_new0 (Rotation, 2);
			_tmp8_[0] = ROTATION_COUNTERCLOCKWISE;
			_tmp8_[1] = ROTATION_UPSIDE_DOWN;
			_tmp9_ = _tmp8_;
			*result_length1 = 2;
			result = _tmp9_;
			return result;
		}
		case ORIENTATION_RIGHT_TOP:
		{
			Rotation* _tmp10_ = NULL;
			Rotation* _tmp11_;
			_tmp10_ = g_new0 (Rotation, 1);
			_tmp10_[0] = ROTATION_CLOCKWISE;
			_tmp11_ = _tmp10_;
			*result_length1 = 1;
			result = _tmp11_;
			return result;
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			Rotation* _tmp12_ = NULL;
			Rotation* _tmp13_;
			_tmp12_ = g_new0 (Rotation, 2);
			_tmp12_[0] = ROTATION_CLOCKWISE;
			_tmp12_[1] = ROTATION_UPSIDE_DOWN;
			_tmp13_ = _tmp12_;
			*result_length1 = 2;
			result = _tmp13_;
			return result;
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			Rotation* _tmp14_ = NULL;
			Rotation* _tmp15_;
			_tmp14_ = g_new0 (Rotation, 1);
			_tmp14_[0] = ROTATION_COUNTERCLOCKWISE;
			_tmp15_ = _tmp14_;
			*result_length1 = 1;
			result = _tmp15_;
			return result;
		}
		default:
		{
			g_error ("Orientation.vala:222: to_rotations: %d", (gint) self);
		}
	}
}


void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
	switch (self) {
		case ORIENTATION_TOP_LEFT:
		case ORIENTATION_TOP_RIGHT:
		case ORIENTATION_BOTTOM_RIGHT:
		case ORIENTATION_BOTTOM_LEFT:
		{
			*result = *dim;
			return;
		}
		case ORIENTATION_LEFT_TOP:
		case ORIENTATION_RIGHT_TOP:
		case ORIENTATION_RIGHT_BOTTOM:
		case ORIENTATION_LEFT_BOTTOM:
		{
			Dimensions _tmp0_ = {0};
			Dimensions _tmp1_ = {0};
			dimensions_init (&_tmp0_, (*dim).height, (*dim).width);
			_tmp1_ = _tmp0_;
			*result = _tmp1_;
			return;
		}
		default:
		{
			g_error ("Orientation.vala:243: rotate_dimensions: %d", (gint) self);
		}
	}
}


void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	orientation_rotate_dimensions (self, dim, &_tmp0_);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* rotated = NULL;
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
	switch (self) {
		case ORIENTATION_TOP_LEFT:
		{
			GdkPixbuf* _tmp0_;
			_tmp0_ = _g_object_ref0 (pixbuf);
			_g_object_unref0 (rotated);
			rotated = _tmp0_;
			break;
		}
		case ORIENTATION_TOP_RIGHT:
		{
			GdkPixbuf* _tmp1_ = NULL;
			_tmp1_ = gdk_pixbuf_flip (pixbuf, TRUE);
			_g_object_unref0 (rotated);
			rotated = _tmp1_;
			break;
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			GdkPixbuf* _tmp2_ = NULL;
			_tmp2_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_UPSIDEDOWN);
			_g_object_unref0 (rotated);
			rotated = _tmp2_;
			break;
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			GdkPixbuf* _tmp3_ = NULL;
			_tmp3_ = gdk_pixbuf_flip (pixbuf, FALSE);
			_g_object_unref0 (rotated);
			rotated = _tmp3_;
			break;
		}
		case ORIENTATION_LEFT_TOP:
		{
			GdkPixbuf* _tmp4_ = NULL;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_ = NULL;
			_tmp4_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
			_tmp5_ = _tmp4_;
			_tmp6_ = gdk_pixbuf_flip (_tmp5_, FALSE);
			_g_object_unref0 (rotated);
			rotated = _tmp6_;
			_g_object_unref0 (_tmp5_);
			break;
		}
		case ORIENTATION_RIGHT_TOP:
		{
			GdkPixbuf* _tmp7_ = NULL;
			_tmp7_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
			_g_object_unref0 (rotated);
			rotated = _tmp7_;
			break;
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			GdkPixbuf* _tmp8_ = NULL;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_ = NULL;
			_tmp8_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
			_tmp9_ = _tmp8_;
			_tmp10_ = gdk_pixbuf_flip (_tmp9_, FALSE);
			_g_object_unref0 (rotated);
			rotated = _tmp10_;
			_g_object_unref0 (_tmp9_);
			break;
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			GdkPixbuf* _tmp11_ = NULL;
			_tmp11_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
			_g_object_unref0 (rotated);
			rotated = _tmp11_;
			break;
		}
		default:
		{
			g_error ("Orientation.vala:290: rotate_pixbuf: %d", (gint) self);
		}
	}
	result = rotated;
	return result;
}


void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
	gboolean _tmp0_;
	GdkPoint rotated = {0};
	_tmp0_ = dimensions_has_area (space);
	g_assert (_tmp0_);
	g_assert ((*point).x >= 0);
	g_assert ((*point).x < (*space).width);
	g_assert ((*point).y >= 0);
	g_assert ((*point).y < (*space).height);
	memset (&rotated, 0, sizeof (GdkPoint));
	switch (self) {
		case ORIENTATION_TOP_LEFT:
		{
			rotated = *point;
			break;
		}
		case ORIENTATION_TOP_RIGHT:
		{
			rotated.x = ((*space).width - (*point).x) - 1;
			rotated.y = (*point).y;
			break;
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			rotated.x = ((*space).width - (*point).x) - 1;
			rotated.y = ((*space).height - (*point).y) - 1;
			break;
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			rotated.x = (*point).x;
			rotated.y = ((*space).height - (*point).y) - 1;
			break;
		}
		case ORIENTATION_LEFT_TOP:
		{
			rotated.x = (*point).y;
			rotated.y = (*point).x;
			break;
		}
		case ORIENTATION_RIGHT_TOP:
		{
			rotated.x = ((*space).height - (*point).y) - 1;
			rotated.y = (*point).x;
			break;
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			rotated.x = ((*space).height - (*point).y) - 1;
			rotated.y = ((*space).width - (*point).x) - 1;
			break;
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			rotated.x = (*point).y;
			rotated.y = ((*space).width - (*point).x) - 1;
			break;
		}
		default:
		{
			g_error ("Orientation.vala:355: rotate_point: %d", (gint) self);
		}
	}
	*result = rotated;
	return;
}


void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
	gboolean _tmp0_;
	GdkPoint derotated = {0};
	_tmp0_ = dimensions_has_area (space);
	g_assert (_tmp0_);
	memset (&derotated, 0, sizeof (GdkPoint));
	switch (self) {
		case ORIENTATION_TOP_LEFT:
		{
			derotated = *point;
			break;
		}
		case ORIENTATION_TOP_RIGHT:
		{
			derotated.x = ((*space).width - (*point).x) - 1;
			derotated.y = (*point).y;
			break;
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			derotated.x = ((*space).width - (*point).x) - 1;
			derotated.y = ((*space).height - (*point).y) - 1;
			break;
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			derotated.x = (*point).x;
			derotated.y = ((*space).height - (*point).y) - 1;
			break;
		}
		case ORIENTATION_LEFT_TOP:
		{
			derotated.x = (*point).y;
			derotated.y = (*point).x;
			break;
		}
		case ORIENTATION_RIGHT_TOP:
		{
			derotated.x = (*point).y;
			derotated.y = ((*space).height - (*point).x) - 1;
			break;
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			derotated.x = ((*space).width - (*point).y) - 1;
			derotated.y = ((*space).height - (*point).x) - 1;
			break;
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			derotated.x = ((*space).width - (*point).y) - 1;
			derotated.y = (*point).x;
			break;
		}
		default:
		{
			g_error ("Orientation.vala:416: rotate_point: %d", (gint) self);
		}
	}
	*result = derotated;
	return;
}


void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	GdkPoint _tmp2_ = {0};
	GdkPoint _tmp3_ = {0};
	GdkPoint _tmp4_ = {0};
	GdkPoint _tmp5_ = {0};
	Box _tmp6_ = {0};
	Box _tmp7_ = {0};
	box_get_points (box, &_tmp0_, &_tmp1_);
	top_left = _tmp0_;
	bottom_right = _tmp1_;
	orientation_rotate_point (self, space, &top_left, &_tmp2_);
	_tmp3_ = _tmp2_;
	top_left = _tmp3_;
	orientation_rotate_point (self, space, &bottom_right, &_tmp4_);
	_tmp5_ = _tmp4_;
	bottom_right = _tmp5_;
	box_from_points (&top_left, &bottom_right, &_tmp6_);
	_tmp7_ = _tmp6_;
	*result = _tmp7_;
	return;
}


void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	GdkPoint _tmp2_ = {0};
	GdkPoint _tmp3_ = {0};
	GdkPoint _tmp4_ = {0};
	GdkPoint _tmp5_ = {0};
	Box _tmp6_ = {0};
	Box _tmp7_ = {0};
	box_get_points (box, &_tmp0_, &_tmp1_);
	top_left = _tmp0_;
	bottom_right = _tmp1_;
	orientation_derotate_point (self, space, &top_left, &_tmp2_);
	_tmp3_ = _tmp2_;
	top_left = _tmp3_;
	orientation_derotate_point (self, space, &bottom_right, &_tmp4_);
	_tmp5_ = _tmp4_;
	bottom_right = _tmp5_;
	box_from_points (&top_left, &bottom_right, &_tmp6_);
	_tmp7_ = _tmp6_;
	*result = _tmp7_;
	return;
}


GType orientation_get_type (void) {
	static volatile gsize orientation_type_id__volatile = 0;
	if (g_once_init_enter (&orientation_type_id__volatile)) {
		static const GEnumValue values[] = {{ORIENTATION_MIN, "ORIENTATION_MIN", "min"}, {ORIENTATION_TOP_LEFT, "ORIENTATION_TOP_LEFT", "top-left"}, {ORIENTATION_TOP_RIGHT, "ORIENTATION_TOP_RIGHT", "top-right"}, {ORIENTATION_BOTTOM_RIGHT, "ORIENTATION_BOTTOM_RIGHT", "bottom-right"}, {ORIENTATION_BOTTOM_LEFT, "ORIENTATION_BOTTOM_LEFT", "bottom-left"}, {ORIENTATION_LEFT_TOP, "ORIENTATION_LEFT_TOP", "left-top"}, {ORIENTATION_RIGHT_TOP, "ORIENTATION_RIGHT_TOP", "right-top"}, {ORIENTATION_RIGHT_BOTTOM, "ORIENTATION_RIGHT_BOTTOM", "right-bottom"}, {ORIENTATION_LEFT_BOTTOM, "ORIENTATION_LEFT_BOTTOM", "left-bottom"}, {ORIENTATION_MAX, "ORIENTATION_MAX", "max"}, {0, NULL, NULL}};
		GType orientation_type_id;
		orientation_type_id = g_enum_register_static ("Orientation", values);
		g_once_init_leave (&orientation_type_id__volatile, orientation_type_id);
	}
	return orientation_type_id__volatile;
}


GdkPixbuf* rotation_perform (Rotation self, GdkPixbuf* pixbuf) {
	GdkPixbuf* result = NULL;
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
	switch (self) {
		case ROTATION_CLOCKWISE:
		{
			GdkPixbuf* _tmp0_ = NULL;
			_tmp0_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
			result = _tmp0_;
			return result;
		}
		case ROTATION_COUNTERCLOCKWISE:
		{
			GdkPixbuf* _tmp1_ = NULL;
			_tmp1_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
			result = _tmp1_;
			return result;
		}
		case ROTATION_MIRROR:
		{
			GdkPixbuf* _tmp2_ = NULL;
			_tmp2_ = gdk_pixbuf_flip (pixbuf, TRUE);
			result = _tmp2_;
			return result;
		}
		case ROTATION_UPSIDE_DOWN:
		{
			GdkPixbuf* _tmp3_ = NULL;
			_tmp3_ = gdk_pixbuf_flip (pixbuf, FALSE);
			result = _tmp3_;
			return result;
		}
		default:
		{
			g_error ("Orientation.vala:466: Unknown rotation: %d", (gint) self);
		}
	}
}


Rotation rotation_opposite (Rotation self) {
	Rotation result = 0;
	switch (self) {
		case ROTATION_CLOCKWISE:
		{
			result = ROTATION_COUNTERCLOCKWISE;
			return result;
		}
		case ROTATION_COUNTERCLOCKWISE:
		{
			result = ROTATION_CLOCKWISE;
			return result;
		}
		case ROTATION_MIRROR:
		case ROTATION_UPSIDE_DOWN:
		{
			result = self;
			return result;
		}
		default:
		{
			g_error ("Orientation.vala:483: Unknown rotation: %d", (gint) self);
		}
	}
}


GType rotation_get_type (void) {
	static volatile gsize rotation_type_id__volatile = 0;
	if (g_once_init_enter (&rotation_type_id__volatile)) {
		static const GEnumValue values[] = {{ROTATION_CLOCKWISE, "ROTATION_CLOCKWISE", "clockwise"}, {ROTATION_COUNTERCLOCKWISE, "ROTATION_COUNTERCLOCKWISE", "counterclockwise"}, {ROTATION_MIRROR, "ROTATION_MIRROR", "mirror"}, {ROTATION_UPSIDE_DOWN, "ROTATION_UPSIDE_DOWN", "upside-down"}, {0, NULL, NULL}};
		GType rotation_type_id;
		rotation_type_id = g_enum_register_static ("Rotation", values);
		g_once_init_leave (&rotation_type_id__volatile, rotation_type_id);
	}
	return rotation_type_id__volatile;
}



