/* SortedList.c generated by valac 0.11.7, the Vala compiler
 * generated from SortedList.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>

#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;
typedef struct _SortedListPrivate SortedListPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
struct _SortedList {
	GObject parent_instance;
	SortedListPrivate * priv;
};

struct _SortedListClass {
	GObjectClass parent_class;
};

struct _SortedListPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeArrayList* list;
	Comparator cmp;
	gpointer cmp_target;
	GDestroyNotify cmp_target_destroy_notify;
};


static gpointer sorted_list_parent_class = NULL;
static GeeIterableIface* sorted_list_gee_iterable_parent_iface = NULL;
static GeeCollectionIface* sorted_list_gee_collection_parent_iface = NULL;

gchar* g_utf8_collate_key_for_filename (const gchar* str, gssize len);
gint64 file_comparator (void* a, void* b);
GType sorted_list_get_type (void) G_GNUC_CONST;
#define SORTED_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SORTED_LIST, SortedListPrivate))
enum  {
	SORTED_LIST_DUMMY_PROPERTY,
	SORTED_LIST_G_TYPE,
	SORTED_LIST_G_DUP_FUNC,
	SORTED_LIST_G_DESTROY_FUNC,
	SORTED_LIST_ELEMENT_TYPE,
	SORTED_LIST_IS_EMPTY,
	SORTED_LIST_SIZE,
	SORTED_LIST_READ_ONLY_VIEW,
	SORTED_LIST_READ_ONLY_VIEW_AS_LIST
};
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
static GeeIterator* sorted_list_real_iterator (GeeIterable* base);
static gboolean sorted_list_real_add (GeeCollection* base, gconstpointer item);
static gint sorted_list_get_sorted_insert_pos (SortedList* self, gconstpointer item);
static gboolean sorted_list_real_add_all (GeeCollection* base, GeeCollection* collection);
gboolean sorted_list_add_list (SortedList* self, GeeList* items);
static gboolean sorted_list_merge_sort (SortedList* self, GeeList* add);
static void sorted_list_real_clear (GeeCollection* base);
static gboolean sorted_list_real_contains (GeeCollection* base, gconstpointer item);
static gboolean sorted_list_real_contains_all (GeeCollection* base, GeeCollection* collection);
static gboolean sorted_list_real_remove (GeeCollection* base, gconstpointer item);
static gboolean sorted_list_real_remove_all (GeeCollection* base, GeeCollection* collection);
static gboolean sorted_list_real_retain_all (GeeCollection* base, GeeCollection* collection);
gint sorted_list_get_count (SortedList* self);
gpointer sorted_list_get_at (SortedList* self, gint index);
static gint sorted_list_binary_search (SortedList* self, gconstpointer search, GEqualFunc equal_func);
gint sorted_list_index_of (SortedList* self, gconstpointer search);
gint sorted_list_locate (SortedList* self, gconstpointer search, gboolean altered, GEqualFunc equal_func);
gpointer sorted_list_remove_at (SortedList* self, gint index);
static gpointer* sorted_list_real_to_array (GeeCollection* base, int* result_length1);
void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target);
gboolean sorted_list_resort_item (SortedList* self, gconstpointer item);
SortedList* sorted_list_copy (SortedList* self);
static void _sorted_list_merge_sort (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint end_index);
static void sorted_list_merge (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint middle_index, gint end_index);
GeeList* sorted_list_get_read_only_view_as_list (SortedList* self);
static void sorted_list_finalize (GObject* obj);
static void _vala_sorted_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_sorted_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


gint64 file_comparator (void* a, void* b) {
	gint64 result = 0LL;
	gchar* _tmp0_ = NULL;
	gchar* path_a;
	gchar* _tmp1_ = NULL;
	gchar* path_b;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	gint _tmp7_;
	gint64 _tmp8_;
	_tmp0_ = g_file_get_path (G_FILE ((GFile*) a));
	path_a = _tmp0_;
	_tmp1_ = g_file_get_path (G_FILE ((GFile*) b));
	path_b = _tmp1_;
	if (path_a == NULL) {
		gint _tmp2_ = 0;
		if (path_b == NULL) {
			_tmp2_ = 0;
		} else {
			_tmp2_ = 1;
		}
		result = (gint64) _tmp2_;
		_g_free0 (path_b);
		_g_free0 (path_a);
		return result;
	}
	if (path_b == NULL) {
		result = (gint64) (-1);
		_g_free0 (path_b);
		_g_free0 (path_a);
		return result;
	}
	_tmp3_ = g_utf8_collate_key_for_filename (path_a, (gssize) (-1));
	_tmp4_ = _tmp3_;
	_tmp5_ = g_utf8_collate_key_for_filename (path_b, (gssize) (-1));
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strcmp0 (_tmp4_, _tmp6_);
	_tmp8_ = (gint64) _tmp7_;
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	result = _tmp8_;
	_g_free0 (path_b);
	_g_free0 (path_a);
	return result;
}


SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target) {
	SortedList * self = NULL;
	GeeArrayList* _tmp0_ = NULL;
	Comparator _tmp1_;
	self = (SortedList*) g_object_new (object_type, NULL);
	self->priv->g_type = g_type;
	self->priv->g_dup_func = g_dup_func;
	self->priv->g_destroy_func = g_destroy_func;
	_tmp0_ = gee_array_list_new (g_type, (GBoxedCopyFunc) g_dup_func, g_destroy_func, NULL);
	_g_object_unref0 (self->priv->list);
	self->priv->list = _tmp0_;
	_tmp1_ = cmp;
	(self->priv->cmp_target_destroy_notify == NULL) ? NULL : (self->priv->cmp_target_destroy_notify (self->priv->cmp_target), NULL);
	self->priv->cmp = NULL;
	self->priv->cmp_target = NULL;
	self->priv->cmp_target_destroy_notify = NULL;
	self->priv->cmp = _tmp1_;
	self->priv->cmp_target = cmp_target;
	self->priv->cmp_target_destroy_notify = NULL;
	return self;
}


SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target) {
	return sorted_list_construct (TYPE_SORTED_LIST, g_type, g_dup_func, g_destroy_func, cmp, cmp_target);
}


static GeeIterator* sorted_list_real_iterator (GeeIterable* base) {
	SortedList * self;
	GeeIterator* result = NULL;
	GeeIterator* _tmp0_ = NULL;
	self = SORTED_LIST (base);
	_tmp0_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->list));
	result = _tmp0_;
	return result;
}


static gboolean sorted_list_real_add (GeeCollection* base, gconstpointer item) {
	SortedList * self;
	gboolean result = FALSE;
	self = SORTED_LIST (base);
	if (self->priv->cmp == NULL) {
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->list), item);
	} else {
		gint _tmp0_;
		_tmp0_ = sorted_list_get_sorted_insert_pos (self, item);
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), _tmp0_, item);
	}
	result = TRUE;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean sorted_list_real_add_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	gint _tmp0_;
	GeeCollection* _tmp1_;
	GeeList* _tmp2_;
	GeeList* as_list;
	gboolean changed;
	gint _tmp5_;
	self = SORTED_LIST (base);
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
	_tmp0_ = gee_collection_get_size (collection);
	if (_tmp0_ == 0) {
		result = FALSE;
		return result;
	}
	_tmp1_ = collection;
	_tmp2_ = _g_object_ref0 (GEE_IS_LIST (_tmp1_) ? ((GeeList*) _tmp1_) : NULL);
	as_list = _tmp2_;
	if (as_list != NULL) {
		gboolean _tmp3_;
		_tmp3_ = sorted_list_add_list (self, as_list);
		result = _tmp3_;
		_g_object_unref0 (as_list);
		return result;
	}
	if (self->priv->cmp == NULL) {
		gboolean _tmp4_;
		_tmp4_ = gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->list), collection);
		result = _tmp4_;
		_g_object_unref0 (as_list);
		return result;
	}
	changed = FALSE;
	_tmp5_ = gee_collection_get_size (collection);
	if (_tmp5_ == 1) {
		GeeIterator* _tmp6_ = NULL;
		GeeIterator* iter;
		gpointer _tmp7_ = NULL;
		gpointer item;
		gint _tmp8_;
		_tmp6_ = gee_iterable_iterator (GEE_ITERABLE (collection));
		iter = _tmp6_;
		gee_iterator_next (iter);
		_tmp7_ = gee_iterator_get (iter);
		item = _tmp7_;
		_tmp8_ = sorted_list_get_sorted_insert_pos (self, item);
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), _tmp8_, item);
		changed = TRUE;
		((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
		_g_object_unref0 (iter);
	} else {
		GeeArrayList* _tmp9_ = NULL;
		GeeList* items;
		gboolean _tmp10_;
		_tmp9_ = gee_array_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, self->priv->g_destroy_func, NULL);
		items = GEE_LIST (_tmp9_);
		gee_collection_add_all (GEE_COLLECTION (items), collection);
		_tmp10_ = sorted_list_merge_sort (self, items);
		changed = _tmp10_;
		_g_object_unref0 (items);
	}
	result = changed;
	_g_object_unref0 (as_list);
	return result;
}


gboolean sorted_list_add_list (SortedList* self, GeeList* items) {
	gboolean result = FALSE;
	gboolean added;
	gint _tmp0_;
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
	g_return_val_if_fail (GEE_IS_LIST (items), FALSE);
	added = FALSE;
	_tmp0_ = gee_collection_get_size (GEE_COLLECTION (items));
	if (_tmp0_ == 0) {
	} else {
		if (self->priv->cmp != NULL) {
			gint _tmp1_;
			_tmp1_ = gee_collection_get_size (GEE_COLLECTION (items));
			if (_tmp1_ == 1) {
				gpointer _tmp2_ = NULL;
				gpointer _tmp3_;
				gint _tmp4_;
				gpointer _tmp5_ = NULL;
				gpointer _tmp6_;
				_tmp2_ = gee_list_get (items, 0);
				_tmp3_ = _tmp2_;
				_tmp4_ = sorted_list_get_sorted_insert_pos (self, _tmp3_);
				_tmp5_ = gee_list_get (items, 0);
				_tmp6_ = _tmp5_;
				gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), _tmp4_, _tmp6_);
				((_tmp6_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp6_ = (self->priv->g_destroy_func (_tmp6_), NULL));
				((_tmp3_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp3_ = (self->priv->g_destroy_func (_tmp3_), NULL));
				added = TRUE;
			} else {
				gboolean _tmp7_;
				_tmp7_ = sorted_list_merge_sort (self, items);
				added = _tmp7_;
			}
		} else {
			gboolean _tmp8_;
			_tmp8_ = gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->list), GEE_COLLECTION (items));
			added = _tmp8_;
		}
	}
	result = added;
	return result;
}


static void sorted_list_real_clear (GeeCollection* base) {
	SortedList * self;
	self = SORTED_LIST (base);
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->list));
}


static gboolean sorted_list_real_contains (GeeCollection* base, gconstpointer item) {
	SortedList * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	self = SORTED_LIST (base);
	_tmp0_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->list), item);
	result = _tmp0_;
	return result;
}


static gboolean sorted_list_real_contains_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	self = SORTED_LIST (base);
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
	_tmp0_ = gee_abstract_collection_contains_all (GEE_ABSTRACT_COLLECTION (self->priv->list), collection);
	result = _tmp0_;
	return result;
}


static gboolean sorted_list_real_remove (GeeCollection* base, gconstpointer item) {
	SortedList * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	self = SORTED_LIST (base);
	_tmp0_ = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->list), item);
	result = _tmp0_;
	return result;
}


static gboolean sorted_list_real_remove_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	self = SORTED_LIST (base);
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
	_tmp0_ = gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (self->priv->list), collection);
	result = _tmp0_;
	return result;
}


static gboolean sorted_list_real_retain_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	self = SORTED_LIST (base);
	g_return_val_if_fail (GEE_IS_COLLECTION (collection), FALSE);
	_tmp0_ = gee_abstract_collection_retain_all (GEE_ABSTRACT_COLLECTION (self->priv->list), collection);
	result = _tmp0_;
	return result;
}


inline gint sorted_list_get_count (SortedList* self) {
	gint result = 0;
	gint _tmp0_;
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
	_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
	result = _tmp0_;
	return result;
}


gpointer sorted_list_get_at (SortedList* self, gint index) {
	gpointer result = NULL;
	gpointer _tmp0_ = NULL;
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
	_tmp0_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), index);
	result = _tmp0_;
	return result;
}


static gint sorted_list_binary_search (SortedList* self, gconstpointer search, GEqualFunc equal_func) {
	gint result = 0;
	gint min;
	gint _tmp0_;
	gint max;
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
	g_assert (self->priv->cmp != NULL);
	min = 0;
	_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
	max = _tmp0_;
	{
		gboolean _tmp1_;
		_tmp1_ = TRUE;
		while (TRUE) {
			gint mid;
			gpointer _tmp2_ = NULL;
			gpointer item;
			gboolean _tmp3_ = FALSE;
			gint64 _tmp5_;
			gint64 compare;
			if (!_tmp1_) {
			}
			_tmp1_ = FALSE;
			mid = min + ((max - min) / 2);
			_tmp2_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), mid);
			item = _tmp2_;
			if (equal_func != NULL) {
				gboolean _tmp4_;
				_tmp4_ = equal_func (item, search);
				_tmp3_ = _tmp4_;
			} else {
				_tmp3_ = FALSE;
			}
			if (_tmp3_) {
				result = mid;
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
				return result;
			}
			_tmp5_ = self->priv->cmp (item, search, self->priv->cmp_target);
			compare = _tmp5_;
			if (compare == 0) {
				result = mid;
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
				return result;
			} else {
				if (compare > 0) {
					max = mid - 1;
				} else {
					min = mid + 1;
				}
			}
			if (min > max) {
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
				break;
			}
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
		}
	}
	result = -1;
	return result;
}


gint sorted_list_index_of (SortedList* self, gconstpointer search) {
	gint result = 0;
	gint _tmp0_ = 0;
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
	if (self->priv->cmp != NULL) {
		gint _tmp1_;
		_tmp1_ = sorted_list_binary_search (self, search, NULL);
		_tmp0_ = _tmp1_;
	} else {
		gint _tmp2_;
		_tmp2_ = sorted_list_locate (self, search, FALSE, g_direct_equal);
		_tmp0_ = _tmp2_;
	}
	result = _tmp0_;
	return result;
}


gint sorted_list_locate (SortedList* self, gconstpointer search, gboolean altered, GEqualFunc equal_func) {
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp7_;
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
	if (self->priv->cmp == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = altered;
	}
	if (_tmp0_) {
		gint _tmp1_;
		gint count;
		_tmp1_ = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
		count = _tmp1_;
		{
			gint ctr;
			ctr = 0;
			{
				gboolean _tmp2_;
				_tmp2_ = TRUE;
				while (TRUE) {
					gpointer _tmp3_ = NULL;
					gpointer _tmp4_;
					gboolean _tmp5_;
					gboolean _tmp6_;
					if (!_tmp2_) {
						ctr++;
					}
					_tmp2_ = FALSE;
					if (!(ctr < count)) {
						break;
					}
					_tmp3_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), ctr);
					_tmp4_ = _tmp3_;
					_tmp5_ = equal_func (_tmp4_, search);
					_tmp6_ = _tmp5_;
					((_tmp4_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp4_ = (self->priv->g_destroy_func (_tmp4_), NULL));
					if (_tmp6_) {
						result = ctr;
						return result;
					}
				}
			}
		}
		result = -1;
		return result;
	}
	_tmp7_ = sorted_list_binary_search (self, search, equal_func);
	result = _tmp7_;
	return result;
}


gpointer sorted_list_remove_at (SortedList* self, gint index) {
	gpointer result = NULL;
	gpointer _tmp0_ = NULL;
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
	_tmp0_ = gee_abstract_list_remove_at (GEE_ABSTRACT_LIST (self->priv->list), index);
	result = _tmp0_;
	return result;
}


static gpointer* sorted_list_real_to_array (GeeCollection* base, int* result_length1) {
	SortedList * self;
	gpointer* result = NULL;
	gint _tmp0_;
	gpointer* _tmp1_ = NULL;
	gpointer* _tmp2_;
	self = SORTED_LIST (base);
	_tmp1_ = gee_abstract_collection_to_array (GEE_ABSTRACT_COLLECTION (self->priv->list), &_tmp0_);
	_tmp2_ = _tmp1_;
	*result_length1 = _tmp0_;
	result = _tmp2_;
	return result;
}


void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target) {
	Comparator _tmp0_;
	g_return_if_fail (IS_SORTED_LIST (self));
	_tmp0_ = new_cmp;
	(self->priv->cmp_target_destroy_notify == NULL) ? NULL : (self->priv->cmp_target_destroy_notify (self->priv->cmp_target), NULL);
	self->priv->cmp = NULL;
	self->priv->cmp_target = NULL;
	self->priv->cmp_target_destroy_notify = NULL;
	self->priv->cmp = _tmp0_;
	self->priv->cmp_target = new_cmp_target;
	self->priv->cmp_target_destroy_notify = NULL;
	sorted_list_merge_sort (self, NULL);
}


gboolean sorted_list_resort_item (SortedList* self, gconstpointer item) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint index;
	gint _tmp1_;
	gint new_index;
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
	_tmp0_ = sorted_list_locate (self, item, TRUE, g_direct_equal);
	index = _tmp0_;
	g_assert (index >= 0);
	_tmp1_ = sorted_list_get_sorted_insert_pos (self, item);
	new_index = _tmp1_;
	if (index == new_index) {
		result = FALSE;
		return result;
	}
	if (new_index > index) {
		gpointer _tmp2_ = NULL;
		gpointer removed_item;
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), new_index, item);
		_tmp2_ = gee_abstract_list_remove_at (GEE_ABSTRACT_LIST (self->priv->list), index);
		removed_item = _tmp2_;
		g_assert (item == removed_item);
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
	} else {
		gpointer _tmp3_ = NULL;
		gpointer removed_item;
		_tmp3_ = gee_abstract_list_remove_at (GEE_ABSTRACT_LIST (self->priv->list), index);
		removed_item = _tmp3_;
		g_assert (item == removed_item);
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), new_index, item);
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
	}
	result = TRUE;
	return result;
}


static gint sorted_list_get_sorted_insert_pos (SortedList* self, gconstpointer item) {
	gint result = 0;
	gint low;
	gint _tmp0_;
	gint high;
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
	low = 0;
	_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
	high = _tmp0_;
	{
		gboolean _tmp1_;
		_tmp1_ = TRUE;
		while (TRUE) {
			gint mid;
			gpointer _tmp2_ = NULL;
			gpointer cmp_item;
			gint64 _tmp6_;
			gint64 _result_;
			if (!_tmp1_) {
			}
			_tmp1_ = FALSE;
			if (low == high) {
				result = low;
				return result;
			}
			mid = low + ((high - low) / 2);
			_tmp2_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), mid);
			cmp_item = _tmp2_;
			if (item == cmp_item) {
				gint _tmp3_;
				gpointer _tmp5_ = NULL;
				_tmp3_ = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
				if (mid >= (_tmp3_ - 1)) {
					gint _tmp4_;
					_tmp4_ = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
					result = _tmp4_;
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
					return result;
				}
				_tmp5_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), mid + 1);
				((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
				cmp_item = _tmp5_;
			}
			_tmp6_ = self->priv->cmp (item, cmp_item, self->priv->cmp_target);
			_result_ = _tmp6_;
			if (_result_ < 0) {
				high = mid;
			} else {
				if (_result_ > 0) {
					low = mid + 1;
				} else {
					result = mid;
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
					return result;
				}
			}
			((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
		}
	}
}


SortedList* sorted_list_copy (SortedList* self) {
	SortedList* result = NULL;
	SortedList* _tmp0_ = NULL;
	SortedList* copy;
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
	_tmp0_ = sorted_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, self->priv->g_destroy_func, self->priv->cmp, self->priv->cmp_target);
	copy = _tmp0_;
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (copy->priv->list), GEE_COLLECTION (self->priv->list));
	result = copy;
	return result;
}


static gboolean sorted_list_merge_sort (SortedList* self, GeeList* add) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint list_count;
	gint _tmp1_ = 0;
	gint add_count;
	gint count;
	gpointer* _tmp3_ = NULL;
	gpointer* array;
	gint array_length1;
	gint _array_size_;
	gint offset;
	gpointer* _tmp9_ = NULL;
	gpointer* _tmp10_;
	gint _tmp10__length1;
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
	g_return_val_if_fail ((add == NULL) || GEE_IS_LIST (add), FALSE);
	g_assert (self->priv->cmp != NULL);
	_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
	list_count = _tmp0_;
	if (add != NULL) {
		gint _tmp2_;
		_tmp2_ = gee_collection_get_size (GEE_COLLECTION (add));
		_tmp1_ = _tmp2_;
	} else {
		_tmp1_ = 0;
	}
	add_count = _tmp1_;
	count = list_count + add_count;
	if (count == 0) {
		result = FALSE;
		return result;
	}
	_tmp3_ = g_new0 (gpointer, count);
	array = _tmp3_;
	array_length1 = count;
	_array_size_ = count;
	offset = 0;
	while (TRUE) {
		gpointer _tmp4_ = NULL;
		gpointer _tmp5_;
		if (!(offset < list_count)) {
			break;
		}
		_tmp4_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), offset);
		_tmp5_ = _tmp4_;
		((array[offset] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (array[offset] = (self->priv->g_destroy_func (array[offset]), NULL));
		array[offset] = _tmp5_;
		offset++;
	}
	if (add != NULL) {
		gint add_ctr;
		add_ctr = 0;
		while (TRUE) {
			gint _tmp6_;
			gpointer _tmp7_ = NULL;
			gpointer _tmp8_;
			if (!(offset < count)) {
				break;
			}
			_tmp6_ = add_ctr;
			add_ctr = _tmp6_ + 1;
			_tmp7_ = gee_list_get (add, _tmp6_);
			_tmp8_ = _tmp7_;
			((array[offset] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (array[offset] = (self->priv->g_destroy_func (array[offset]), NULL));
			array[offset] = _tmp8_;
			offset++;
		}
	}
	g_assert (offset == count);
	_tmp9_ = g_new0 (gpointer, count);
	_tmp10_ = _tmp9_;
	_tmp10__length1 = count;
	_sorted_list_merge_sort (self, array, array_length1, _tmp10_, count, 0, count - 1);
	_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
	offset = 0;
	while (TRUE) {
		if (!(offset < list_count)) {
			break;
		}
		gee_abstract_list_set (GEE_ABSTRACT_LIST (self->priv->list), offset, array[offset]);
		offset++;
	}
	while (TRUE) {
		if (!(offset < count)) {
			break;
		}
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), offset, array[offset]);
		offset++;
	}
	result = TRUE;
	array = (_vala_array_free (array, array_length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
	return result;
}


static void _sorted_list_merge_sort (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint end_index) {
	gint count;
	gint middle_index;
	gint64 _tmp0_;
	g_return_if_fail (IS_SORTED_LIST (self));
	g_assert (start_index <= end_index);
	count = (end_index - start_index) + 1;
	if (count <= 1) {
		return;
	}
	middle_index = start_index + (count / 2);
	_sorted_list_merge_sort (self, array, array_length1, scratch, scratch_length1, start_index, middle_index - 1);
	_sorted_list_merge_sort (self, array, array_length1, scratch, scratch_length1, middle_index, end_index);
	_tmp0_ = self->priv->cmp (array[middle_index - 1], array[middle_index], self->priv->cmp_target);
	if (_tmp0_ > 0) {
		sorted_list_merge (self, array, array_length1, scratch, scratch_length1, start_index, middle_index, end_index);
	}
}


static void sorted_list_merge (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint middle_index, gint end_index) {
	gint count;
	gint left_start;
	gint left_end;
	gint right_start;
	gint right_end;
	gint scratch_index;
	g_return_if_fail (IS_SORTED_LIST (self));
	g_assert (start_index < end_index);
	count = (end_index - start_index) + 1;
	left_start = start_index;
	left_end = middle_index - 1;
	right_start = middle_index;
	right_end = end_index;
	g_assert (scratch_length1 >= count);
	scratch_index = 0;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gpointer _tmp1_;
		gconstpointer _tmp2_;
		gpointer left;
		gpointer _tmp3_;
		gconstpointer _tmp4_;
		gpointer right;
		gint64 _tmp5_;
		if (left_start <= left_end) {
			_tmp0_ = right_start <= right_end;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_tmp1_ = (_tmp2_ = array[left_start], ((_tmp2_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp2_) : self->priv->g_dup_func ((gpointer) _tmp2_));
		left = _tmp1_;
		_tmp3_ = (_tmp4_ = array[right_start], ((_tmp4_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp4_) : self->priv->g_dup_func ((gpointer) _tmp4_));
		right = _tmp3_;
		_tmp5_ = self->priv->cmp (left, right, self->priv->cmp_target);
		if (_tmp5_ <= 0) {
			gint _tmp6_;
			gpointer _tmp7_;
			gconstpointer _tmp8_;
			gpointer _tmp9_;
			_tmp6_ = scratch_index;
			scratch_index = _tmp6_ + 1;
			_tmp7_ = (_tmp8_ = left, ((_tmp8_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp8_) : self->priv->g_dup_func ((gpointer) _tmp8_));
			_tmp9_ = _tmp7_;
			((scratch[_tmp6_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp6_] = (self->priv->g_destroy_func (scratch[_tmp6_]), NULL));
			scratch[_tmp6_] = _tmp9_;
			left_start++;
		} else {
			gint _tmp10_;
			gpointer _tmp11_;
			gconstpointer _tmp12_;
			gpointer _tmp13_;
			_tmp10_ = scratch_index;
			scratch_index = _tmp10_ + 1;
			_tmp11_ = (_tmp12_ = right, ((_tmp12_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp12_) : self->priv->g_dup_func ((gpointer) _tmp12_));
			_tmp13_ = _tmp11_;
			((scratch[_tmp10_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp10_] = (self->priv->g_destroy_func (scratch[_tmp10_]), NULL));
			scratch[_tmp10_] = _tmp13_;
			right_start++;
		}
		((right == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (right = (self->priv->g_destroy_func (right), NULL));
		((left == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (left = (self->priv->g_destroy_func (left), NULL));
	}
	while (TRUE) {
		gint _tmp14_;
		gint _tmp15_;
		gpointer _tmp16_;
		gconstpointer _tmp17_;
		gpointer _tmp18_;
		if (!(left_start <= left_end)) {
			break;
		}
		_tmp14_ = scratch_index;
		scratch_index = _tmp14_ + 1;
		_tmp15_ = left_start;
		left_start = _tmp15_ + 1;
		_tmp16_ = (_tmp17_ = array[_tmp15_], ((_tmp17_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp17_) : self->priv->g_dup_func ((gpointer) _tmp17_));
		_tmp18_ = _tmp16_;
		((scratch[_tmp14_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp14_] = (self->priv->g_destroy_func (scratch[_tmp14_]), NULL));
		scratch[_tmp14_] = _tmp18_;
	}
	while (TRUE) {
		gint _tmp19_;
		gint _tmp20_;
		gpointer _tmp21_;
		gconstpointer _tmp22_;
		gpointer _tmp23_;
		if (!(right_start <= right_end)) {
			break;
		}
		_tmp19_ = scratch_index;
		scratch_index = _tmp19_ + 1;
		_tmp20_ = right_start;
		right_start = _tmp20_ + 1;
		_tmp21_ = (_tmp22_ = array[_tmp20_], ((_tmp22_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp22_) : self->priv->g_dup_func ((gpointer) _tmp22_));
		_tmp23_ = _tmp21_;
		((scratch[_tmp19_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (scratch[_tmp19_] = (self->priv->g_destroy_func (scratch[_tmp19_]), NULL));
		scratch[_tmp19_] = _tmp23_;
	}
	g_assert (scratch_index == count);
	scratch_index = 0;
	{
		gint list_index;
		list_index = start_index;
		{
			gboolean _tmp24_;
			_tmp24_ = TRUE;
			while (TRUE) {
				gint _tmp25_;
				gpointer _tmp26_;
				gconstpointer _tmp27_;
				gpointer _tmp28_;
				if (!_tmp24_) {
					list_index++;
				}
				_tmp24_ = FALSE;
				if (!(list_index <= end_index)) {
					break;
				}
				_tmp25_ = scratch_index;
				scratch_index = _tmp25_ + 1;
				_tmp26_ = (_tmp27_ = scratch[_tmp25_], ((_tmp27_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp27_) : self->priv->g_dup_func ((gpointer) _tmp27_));
				_tmp28_ = _tmp26_;
				((array[list_index] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (array[list_index] = (self->priv->g_destroy_func (array[list_index]), NULL));
				array[list_index] = _tmp28_;
			}
		}
	}
}


static GType sorted_list_real_get_element_type (GeeIterable* base) {
	GType result;
	SortedList* self;
	self = SORTED_LIST (base);
	result = self->priv->g_type;
	return result;
}


static gboolean sorted_list_real_get_is_empty (GeeCollection* base) {
	gboolean result;
	SortedList* self;
	gboolean _tmp0_;
	self = SORTED_LIST (base);
	_tmp0_ = gee_abstract_collection_get_is_empty (GEE_ABSTRACT_COLLECTION (self->priv->list));
	result = _tmp0_;
	return result;
}


static gint sorted_list_real_get_size (GeeCollection* base) {
	gint result;
	SortedList* self;
	gint _tmp0_;
	self = SORTED_LIST (base);
	_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
	result = _tmp0_;
	return result;
}


static GeeCollection* sorted_list_real_get_read_only_view (GeeCollection* base) {
	GeeCollection* result;
	SortedList* self;
	GeeList* _tmp0_ = NULL;
	self = SORTED_LIST (base);
	_tmp0_ = gee_abstract_list_get_read_only_view (GEE_ABSTRACT_LIST (self->priv->list));
	result = GEE_COLLECTION (_tmp0_);
	return result;
}


GeeList* sorted_list_get_read_only_view_as_list (SortedList* self) {
	GeeList* result;
	GeeList* _tmp0_ = NULL;
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
	_tmp0_ = gee_abstract_list_get_read_only_view (GEE_ABSTRACT_LIST (self->priv->list));
	result = _tmp0_;
	return result;
}


static void sorted_list_class_init (SortedListClass * klass) {
	sorted_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SortedListPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_sorted_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sorted_list_set_property;
	G_OBJECT_CLASS (klass)->finalize = sorted_list_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_override_property (G_OBJECT_CLASS (klass), SORTED_LIST_ELEMENT_TYPE, "element-type");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SORTED_LIST_IS_EMPTY, "is-empty");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SORTED_LIST_SIZE, "size");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_VIEW, "read-only-view");
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_VIEW_AS_LIST, g_param_spec_object ("read-only-view-as-list", "read-only-view-as-list", "read-only-view-as-list", GEE_TYPE_LIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void sorted_list_gee_iterable_interface_init (GeeIterableIface * iface) {
	sorted_list_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
	iface->iterator = (GeeIterator* (*)(GeeIterable*)) sorted_list_real_iterator;
	iface->get_element_type = sorted_list_real_get_element_type;
}


static void sorted_list_gee_collection_interface_init (GeeCollectionIface * iface) {
	sorted_list_gee_collection_parent_iface = g_type_interface_peek_parent (iface);
	iface->add = (gboolean (*)(GeeCollection* ,gconstpointer)) sorted_list_real_add;
	iface->add_all = (gboolean (*)(GeeCollection* ,GeeCollection*)) sorted_list_real_add_all;
	iface->clear = (void (*)(GeeCollection*)) sorted_list_real_clear;
	iface->contains = (gboolean (*)(GeeCollection* ,gconstpointer)) sorted_list_real_contains;
	iface->contains_all = (gboolean (*)(GeeCollection* ,GeeCollection*)) sorted_list_real_contains_all;
	iface->remove = (gboolean (*)(GeeCollection* ,gconstpointer)) sorted_list_real_remove;
	iface->remove_all = (gboolean (*)(GeeCollection* ,GeeCollection*)) sorted_list_real_remove_all;
	iface->retain_all = (gboolean (*)(GeeCollection* ,GeeCollection*)) sorted_list_real_retain_all;
	iface->to_array = (gpointer* (*)(GeeCollection* ,int*)) sorted_list_real_to_array;
	iface->get_is_empty = sorted_list_real_get_is_empty;
	iface->get_size = sorted_list_real_get_size;
	iface->get_read_only_view = sorted_list_real_get_read_only_view;
}


static void sorted_list_instance_init (SortedList * self) {
	self->priv = SORTED_LIST_GET_PRIVATE (self);
}


static void sorted_list_finalize (GObject* obj) {
	SortedList * self;
	self = SORTED_LIST (obj);
	_g_object_unref0 (self->priv->list);
	(self->priv->cmp_target_destroy_notify == NULL) ? NULL : (self->priv->cmp_target_destroy_notify (self->priv->cmp_target), NULL);
	self->priv->cmp = NULL;
	self->priv->cmp_target = NULL;
	self->priv->cmp_target_destroy_notify = NULL;
	G_OBJECT_CLASS (sorted_list_parent_class)->finalize (obj);
}


GType sorted_list_get_type (void) {
	static volatile gsize sorted_list_type_id__volatile = 0;
	if (g_once_init_enter (&sorted_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SortedListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sorted_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SortedList), 0, (GInstanceInitFunc) sorted_list_instance_init, NULL };
		static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) sorted_list_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gee_collection_info = { (GInterfaceInitFunc) sorted_list_gee_collection_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType sorted_list_type_id;
		sorted_list_type_id = g_type_register_static (G_TYPE_OBJECT, "SortedList", &g_define_type_info, 0);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_COLLECTION, &gee_collection_info);
		g_once_init_leave (&sorted_list_type_id__volatile, sorted_list_type_id);
	}
	return sorted_list_type_id__volatile;
}


static void _vala_sorted_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SortedList * self;
	self = SORTED_LIST (object);
	switch (property_id) {
		case SORTED_LIST_ELEMENT_TYPE:
		g_value_set_gtype (value, gee_iterable_get_element_type (GEE_ITERABLE (self)));
		break;
		case SORTED_LIST_IS_EMPTY:
		g_value_set_boolean (value, gee_collection_get_is_empty (GEE_COLLECTION (self)));
		break;
		case SORTED_LIST_SIZE:
		g_value_set_int (value, gee_collection_get_size (GEE_COLLECTION (self)));
		break;
		case SORTED_LIST_READ_ONLY_VIEW:
		g_value_take_object (value, gee_collection_get_read_only_view (GEE_COLLECTION (self)));
		break;
		case SORTED_LIST_READ_ONLY_VIEW_AS_LIST:
		g_value_take_object (value, sorted_list_get_read_only_view_as_list (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_sorted_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SortedList * self;
	self = SORTED_LIST (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case SORTED_LIST_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case SORTED_LIST_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case SORTED_LIST_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



