/* Alteration.c generated by valac 0.11.7, the Vala compiler
 * generated from Alteration.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/**/
/* Alteration represents a description of what has changed in the DataObject (reported via the*/
/* "altered" signal).  Since the descriptions can vary wildly depending on the semantics of each*/
/* DataObject, no assumptions or requirements are placed on Alteration other than it must have*/
/* one or more "subjects", each with a "detail".  Subscribers to the "altered" signal can query*/
/* the Alteration object to determine if the change is important to them.*/
/**/
/* Alteration is an immutable type.  This means it's possible to store const Alterations of oft-used*/
/* values for reuse.*/
/**/
/* Alterations may be compressed, merging their subjects and details into a new aggregated*/
/* Alteration.  Generally this is handled automatically by DataObject and DataCollection, when*/
/* necessary.*/
/**/
/* NOTE: subjects and details should be ASCII labels (as in, plain-old ASCII, no code pages).*/
/* They are treated as case-sensitive strings.*/
/**/
/* Recommended subjects include: image, thumbnail, metadata.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;
typedef struct _AlterationPrivate AlterationPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecAlteration ParamSpecAlteration;

struct _Alteration {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AlterationPrivate * priv;
};

struct _AlterationClass {
	GTypeClass parent_class;
	void (*finalize) (Alteration *self);
};

struct _AlterationPrivate {
	gchar* subject;
	gchar* detail;
	GeeMultiMap* map;
};

struct _ParamSpecAlteration {
	GParamSpec parent_instance;
};


static gpointer alteration_parent_class = NULL;

gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
#define ALTERATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ALTERATION, AlterationPrivate))
enum  {
	ALTERATION_DUMMY_PROPERTY
};
Alteration* alteration_new (const gchar* subject, const gchar* detail);
Alteration* alteration_construct (GType object_type, const gchar* subject, const gchar* detail);
static void alteration_add_detail (Alteration* self, const gchar* sub, const gchar* det);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type, const gchar* list);
Alteration* alteration_new_from_array (gchar** array, int array_length1);
Alteration* alteration_construct_from_array (GType object_type, gchar** array, int array_length1);
static Alteration* alteration_new_from_map (GeeMultiMap* map);
static Alteration* alteration_construct_from_map (GType object_type, GeeMultiMap* map);
static GeeMultiMap* alteration_create_map (Alteration* self);
static guint alteration_case_hash (void* a);
static guint _alteration_case_hash_ghash_func (gconstpointer key);
static gboolean alteration_case_equal (void* a, void* b);
static gboolean _alteration_case_equal_gequal_func (gconstpointer a, gconstpointer b);
static inline gboolean alteration_equal_values (const gchar* str1, const gchar* str2);
static inline guint alteration_hash_value (const gchar* str);
gboolean alteration_has_subject (Alteration* self, const gchar* subject);
gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail);
GeeCollection* alteration_get_details (Alteration* self, const gchar* subject);
gchar* alteration_to_string (Alteration* self);
gboolean alteration_contains_any (Alteration* self, Alteration* other);
gboolean alteration_equals (Alteration* self, Alteration* other);
static void alteration_multimap_add_all (GeeMultiMap* dest, GeeMultiMap* src);
Alteration* alteration_compress (Alteration* self, Alteration* other);
static void alteration_finalize (Alteration* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


Alteration* alteration_construct (GType object_type, const gchar* subject, const gchar* detail) {
	Alteration* self = NULL;
	g_return_val_if_fail (subject != NULL, NULL);
	g_return_val_if_fail (detail != NULL, NULL);
	self = (Alteration*) g_type_create_instance (object_type);
	alteration_add_detail (self, subject, detail);
	return self;
}


Alteration* alteration_new (const gchar* subject, const gchar* detail) {
	return alteration_construct (TYPE_ALTERATION, subject, detail);
}


Alteration* alteration_construct_from_list (GType object_type, const gchar* list) {
	Alteration* self = NULL;
	gint _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_ = NULL;
	gchar** pairs;
	gint pairs_length1;
	gint _pairs_size_;
	g_return_val_if_fail (list != NULL, NULL);
	self = (Alteration*) g_type_create_instance (object_type);
	_tmp0_ = strlen (list);
	g_return_val_if_fail (_tmp0_ > 0, NULL);
	_tmp2_ = _tmp1_ = g_strsplit (list, ",", 0);
	pairs = _tmp2_;
	pairs_length1 = _vala_array_length (_tmp1_);
	_pairs_size_ = _vala_array_length (_tmp1_);
	g_assert (pairs_length1 >= 1);
	{
		gchar** pair_collection;
		int pair_collection_length1;
		int pair_it;
		pair_collection = pairs;
		pair_collection_length1 = pairs_length1;
		for (pair_it = 0; pair_it < pairs_length1; pair_it = pair_it + 1) {
			gchar* _tmp3_;
			gchar* pair;
			_tmp3_ = g_strdup (pair_collection[pair_it]);
			pair = _tmp3_;
			{
				gchar** _tmp4_;
				gchar** _tmp5_ = NULL;
				gchar** subject_detail;
				gint subject_detail_length1;
				gint _subject_detail_size_;
				_tmp5_ = _tmp4_ = g_strsplit (pair, ":", 2);
				subject_detail = _tmp5_;
				subject_detail_length1 = _vala_array_length (_tmp4_);
				_subject_detail_size_ = _vala_array_length (_tmp4_);
				g_assert (subject_detail_length1 == 2);
				alteration_add_detail (self, subject_detail[0], subject_detail[1]);
				subject_detail = (_vala_array_free (subject_detail, subject_detail_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (pair);
			}
		}
	}
	pairs = (_vala_array_free (pairs, pairs_length1, (GDestroyNotify) g_free), NULL);
	return self;
}


Alteration* alteration_new_from_list (const gchar* list) {
	return alteration_construct_from_list (TYPE_ALTERATION, list);
}


Alteration* alteration_construct_from_array (GType object_type, gchar** array, int array_length1) {
	Alteration* self = NULL;
	self = (Alteration*) g_type_create_instance (object_type);
	g_return_val_if_fail (array_length1 > 0, NULL);
	{
		gchar** pair_collection;
		int pair_collection_length1;
		int pair_it;
		pair_collection = array;
		pair_collection_length1 = array_length1;
		for (pair_it = 0; pair_it < array_length1; pair_it = pair_it + 1) {
			gchar* _tmp0_;
			gchar* pair;
			_tmp0_ = g_strdup (pair_collection[pair_it]);
			pair = _tmp0_;
			{
				gchar** _tmp1_;
				gchar** _tmp2_ = NULL;
				gchar** subject_detail;
				gint subject_detail_length1;
				gint _subject_detail_size_;
				_tmp2_ = _tmp1_ = g_strsplit (pair, ":", 2);
				subject_detail = _tmp2_;
				subject_detail_length1 = _vala_array_length (_tmp1_);
				_subject_detail_size_ = _vala_array_length (_tmp1_);
				g_assert (subject_detail_length1 == 2);
				alteration_add_detail (self, subject_detail[0], subject_detail[1]);
				subject_detail = (_vala_array_free (subject_detail, subject_detail_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (pair);
			}
		}
	}
	return self;
}


Alteration* alteration_new_from_array (gchar** array, int array_length1) {
	return alteration_construct_from_array (TYPE_ALTERATION, array, array_length1);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static Alteration* alteration_construct_from_map (GType object_type, GeeMultiMap* map) {
	Alteration* self = NULL;
	GeeMultiMap* _tmp0_;
	g_return_val_if_fail (GEE_IS_MULTI_MAP (map), NULL);
	self = (Alteration*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (map);
	_g_object_unref0 (self->priv->map);
	self->priv->map = _tmp0_;
	return self;
}


static Alteration* alteration_new_from_map (GeeMultiMap* map) {
	return alteration_construct_from_map (TYPE_ALTERATION, map);
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}


static void alteration_add_detail (Alteration* self, const gchar* sub, const gchar* det) {
	gchar* _tmp0_ = NULL;
	gchar* subject;
	gint _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* detail;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
	g_return_if_fail (IS_ALTERATION (self));
	g_return_if_fail (sub != NULL);
	g_return_if_fail (det != NULL);
	_tmp0_ = string_strip (sub);
	subject = _tmp0_;
	_tmp1_ = strlen (subject);
	g_assert (_tmp1_ > 0);
	_tmp2_ = string_strip (det);
	detail = _tmp2_;
	_tmp3_ = strlen (detail);
	g_assert (_tmp3_ > 0);
	if (self->priv->subject == NULL) {
		_tmp4_ = self->priv->map == NULL;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		gchar* _tmp5_;
		gchar* _tmp6_;
		g_assert (self->priv->detail == NULL);
		_tmp5_ = g_strdup (subject);
		_g_free0 (self->priv->subject);
		self->priv->subject = _tmp5_;
		_tmp6_ = g_strdup (detail);
		_g_free0 (self->priv->detail);
		self->priv->detail = _tmp6_;
		_g_free0 (detail);
		_g_free0 (subject);
		return;
	}
	if (self->priv->map == NULL) {
		GeeMultiMap* _tmp7_ = NULL;
		_tmp7_ = alteration_create_map (self);
		_g_object_unref0 (self->priv->map);
		self->priv->map = _tmp7_;
	}
	if (self->priv->subject != NULL) {
		g_assert (self->priv->detail != NULL);
		gee_multi_map_set (self->priv->map, self->priv->subject, self->priv->detail);
		_g_free0 (self->priv->subject);
		self->priv->subject = NULL;
		_g_free0 (self->priv->detail);
		self->priv->detail = NULL;
	}
	gee_multi_map_set (self->priv->map, subject, detail);
	_g_free0 (detail);
	_g_free0 (subject);
}


static guint _alteration_case_hash_ghash_func (gconstpointer key) {
	guint result;
	result = alteration_case_hash (key);
	return result;
}


static gboolean _alteration_case_equal_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = alteration_case_equal (a, b);
	return result;
}


static GeeMultiMap* alteration_create_map (Alteration* self) {
	GeeMultiMap* result = NULL;
	GeeHashMultiMap* _tmp0_ = NULL;
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _alteration_case_hash_ghash_func, _alteration_case_equal_gequal_func, _alteration_case_hash_ghash_func, _alteration_case_equal_gequal_func);
	result = GEE_MULTI_MAP (_tmp0_);
	return result;
}


static gboolean alteration_case_equal (void* a, void* b) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	_tmp0_ = alteration_equal_values ((const gchar*) a, (const gchar*) b);
	result = _tmp0_;
	return result;
}


static guint alteration_case_hash (void* a) {
	guint result = 0U;
	guint _tmp0_;
	_tmp0_ = alteration_hash_value ((const gchar*) a);
	result = _tmp0_;
	return result;
}


static inline gboolean alteration_equal_values (const gchar* str1, const gchar* str2) {
	gboolean result = FALSE;
	gint _tmp0_;
	g_return_val_if_fail (str1 != NULL, FALSE);
	g_return_val_if_fail (str2 != NULL, FALSE);
	_tmp0_ = g_ascii_strcasecmp (str1, str2);
	result = _tmp0_ == 0;
	return result;
}


static inline guint alteration_hash_value (const gchar* str) {
	guint result = 0U;
	guint _tmp0_;
	g_return_val_if_fail (str != NULL, 0U);
	_tmp0_ = g_str_hash (str);
	result = _tmp0_;
	return result;
}


gboolean alteration_has_subject (Alteration* self, const gchar* subject) {
	gboolean result = FALSE;
	GeeSet* _tmp1_ = NULL;
	GeeSet* keys;
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
	g_return_val_if_fail (subject != NULL, FALSE);
	if (self->priv->subject != NULL) {
		gboolean _tmp0_;
		_tmp0_ = alteration_equal_values (self->priv->subject, subject);
		result = _tmp0_;
		return result;
	}
	g_assert (self->priv->map != NULL);
	_tmp1_ = gee_multi_map_get_keys (self->priv->map);
	keys = _tmp1_;
	if (keys != NULL) {
		{
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _key_it;
			_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (keys));
			_key_it = _tmp2_;
			while (TRUE) {
				gboolean _tmp3_;
				gpointer _tmp4_ = NULL;
				gchar* key;
				gboolean _tmp5_;
				_tmp3_ = gee_iterator_next (_key_it);
				if (!_tmp3_) {
					break;
				}
				_tmp4_ = gee_iterator_get (_key_it);
				key = (gchar*) _tmp4_;
				_tmp5_ = alteration_equal_values (key, subject);
				if (_tmp5_) {
					result = TRUE;
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (keys);
					return result;
				}
				_g_free0 (key);
			}
			_g_object_unref0 (_key_it);
		}
	}
	result = FALSE;
	_g_object_unref0 (keys);
	return result;
}


gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GeeCollection* _tmp4_ = NULL;
	GeeCollection* values;
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
	g_return_val_if_fail (subject != NULL, FALSE);
	g_return_val_if_fail (detail != NULL, FALSE);
	if (self->priv->subject != NULL) {
		_tmp0_ = self->priv->detail != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_;
		_tmp2_ = alteration_equal_values (self->priv->subject, subject);
		if (_tmp2_) {
			gboolean _tmp3_;
			_tmp3_ = alteration_equal_values (self->priv->detail, detail);
			_tmp1_ = _tmp3_;
		} else {
			_tmp1_ = FALSE;
		}
		result = _tmp1_;
		return result;
	}
	g_assert (self->priv->map != NULL);
	_tmp4_ = gee_multi_map_get (self->priv->map, subject);
	values = _tmp4_;
	if (values != NULL) {
		{
			GeeIterator* _tmp5_ = NULL;
			GeeIterator* _value_it;
			_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (values));
			_value_it = _tmp5_;
			while (TRUE) {
				gboolean _tmp6_;
				gpointer _tmp7_ = NULL;
				gchar* value;
				gboolean _tmp8_;
				_tmp6_ = gee_iterator_next (_value_it);
				if (!_tmp6_) {
					break;
				}
				_tmp7_ = gee_iterator_get (_value_it);
				value = (gchar*) _tmp7_;
				_tmp8_ = alteration_equal_values (value, detail);
				if (_tmp8_) {
					result = TRUE;
					_g_free0 (value);
					_g_object_unref0 (_value_it);
					_g_object_unref0 (values);
					return result;
				}
				_g_free0 (value);
			}
			_g_object_unref0 (_value_it);
		}
	}
	result = FALSE;
	_g_object_unref0 (values);
	return result;
}


GeeCollection* alteration_get_details (Alteration* self, const gchar* subject) {
	GeeCollection* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GeeCollection* _tmp4_ = NULL;
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
	g_return_val_if_fail (subject != NULL, NULL);
	if (self->priv->subject != NULL) {
		_tmp1_ = self->priv->detail != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp2_;
		_tmp2_ = alteration_equal_values (self->priv->subject, subject);
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GeeArrayList* _tmp3_ = NULL;
		GeeArrayList* details;
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
		details = _tmp3_;
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (details), self->priv->detail);
		result = GEE_COLLECTION (details);
		return result;
	}
	if (self->priv->map != NULL) {
		GeeCollection* _tmp5_ = NULL;
		_tmp5_ = gee_multi_map_get (self->priv->map, subject);
		_g_object_unref0 (_tmp4_);
		_tmp4_ = _tmp5_;
	} else {
		_g_object_unref0 (_tmp4_);
		_tmp4_ = NULL;
	}
	result = _tmp4_;
	return result;
}


gchar* alteration_to_string (Alteration* self) {
	gchar* result = NULL;
	gchar* _tmp1_;
	gchar* str;
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
	if (self->priv->subject != NULL) {
		gchar* _tmp0_ = NULL;
		g_assert (self->priv->detail != NULL);
		_tmp0_ = g_strdup_printf ("%s:%s", self->priv->subject, self->priv->detail);
		result = _tmp0_;
		return result;
	}
	g_assert (self->priv->map != NULL);
	_tmp1_ = g_strdup ("");
	str = _tmp1_;
	{
		GeeSet* _tmp2_ = NULL;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _key_it;
		_tmp2_ = gee_multi_map_get_keys (self->priv->map);
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_key_it = _tmp5_;
		while (TRUE) {
			gboolean _tmp6_;
			gpointer _tmp7_ = NULL;
			gchar* key;
			_tmp6_ = gee_iterator_next (_key_it);
			if (!_tmp6_) {
				break;
			}
			_tmp7_ = gee_iterator_get (_key_it);
			key = (gchar*) _tmp7_;
			{
				GeeCollection* _tmp8_ = NULL;
				GeeCollection* _tmp9_;
				GeeIterator* _tmp10_ = NULL;
				GeeIterator* _tmp11_;
				GeeIterator* _value_it;
				_tmp8_ = gee_multi_map_get (self->priv->map, key);
				_tmp9_ = _tmp8_;
				_tmp10_ = gee_iterable_iterator (GEE_ITERABLE (_tmp9_));
				_tmp11_ = _tmp10_;
				_g_object_unref0 (_tmp9_);
				_value_it = _tmp11_;
				while (TRUE) {
					gboolean _tmp12_;
					gpointer _tmp13_ = NULL;
					gchar* value;
					gint _tmp14_;
					gchar* _tmp16_ = NULL;
					gchar* _tmp17_;
					gchar* _tmp18_;
					_tmp12_ = gee_iterator_next (_value_it);
					if (!_tmp12_) {
						break;
					}
					_tmp13_ = gee_iterator_get (_value_it);
					value = (gchar*) _tmp13_;
					_tmp14_ = strlen (str);
					if (_tmp14_ != 0) {
						gchar* _tmp15_;
						_tmp15_ = g_strconcat (str, ", ", NULL);
						_g_free0 (str);
						str = _tmp15_;
					}
					_tmp16_ = g_strdup_printf ("%s:%s", key, value);
					_tmp17_ = _tmp16_;
					_tmp18_ = g_strconcat (str, _tmp17_, NULL);
					_g_free0 (str);
					str = _tmp18_;
					_g_free0 (_tmp17_);
					_g_free0 (value);
				}
				_g_object_unref0 (_value_it);
			}
			_g_free0 (key);
		}
		_g_object_unref0 (_key_it);
	}
	result = str;
	return result;
}


gboolean alteration_contains_any (Alteration* self, Alteration* other) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp20_ = FALSE;
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
	g_return_val_if_fail (IS_ALTERATION (other), FALSE);
	if (self == other) {
		result = TRUE;
		return result;
	}
	if (self->priv->subject != NULL) {
		_tmp2_ = other->priv->subject != NULL;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = self->priv->detail != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = other->priv->detail != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_;
		_tmp4_ = alteration_equal_values (self->priv->subject, other->priv->subject);
		if (_tmp4_) {
			gboolean _tmp5_;
			_tmp5_ = alteration_equal_values (self->priv->detail, other->priv->detail);
			_tmp3_ = _tmp5_;
		} else {
			_tmp3_ = FALSE;
		}
		result = _tmp3_;
		return result;
	}
	if (self->priv->map != NULL) {
		_tmp7_ = other->priv->map == NULL;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		gboolean _tmp8_ = FALSE;
		if (self->priv->map == NULL) {
			_tmp8_ = other->priv->map != NULL;
		} else {
			_tmp8_ = FALSE;
		}
		_tmp6_ = _tmp8_;
	}
	if (_tmp6_) {
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
		gchar* single_subject;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_;
		gchar* single_detail;
		GeeMultiMap* _tmp13_ = NULL;
		GeeMultiMap* _tmp14_;
		GeeMultiMap* multimap;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_;
		if (self->priv->subject != NULL) {
			_tmp9_ = self->priv->subject;
		} else {
			_tmp9_ = other->priv->subject;
		}
		_tmp10_ = g_strdup (_tmp9_);
		single_subject = _tmp10_;
		if (self->priv->detail != NULL) {
			_tmp11_ = self->priv->detail;
		} else {
			_tmp11_ = other->priv->detail;
		}
		_tmp12_ = g_strdup (_tmp11_);
		single_detail = _tmp12_;
		if (self->priv->map != NULL) {
			_tmp13_ = self->priv->map;
		} else {
			_tmp13_ = other->priv->map;
		}
		_tmp14_ = _g_object_ref0 (_tmp13_);
		multimap = _tmp14_;
		_tmp16_ = gee_multi_map_contains (multimap, single_subject);
		if (_tmp16_) {
			GeeCollection* _tmp17_ = NULL;
			GeeCollection* _tmp18_;
			gboolean _tmp19_;
			_tmp17_ = gee_multi_map_get (self->priv->map, single_subject);
			_tmp18_ = _tmp17_;
			_tmp19_ = gee_collection_contains (_tmp18_, single_detail);
			_tmp15_ = _tmp19_;
			_g_object_unref0 (_tmp18_);
		} else {
			_tmp15_ = FALSE;
		}
		result = _tmp15_;
		_g_object_unref0 (multimap);
		_g_free0 (single_detail);
		_g_free0 (single_subject);
		return result;
	}
	if (self->priv->map != NULL) {
		_tmp20_ = other->priv->map != NULL;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		GeeSet* _tmp21_ = NULL;
		GeeSet* keys;
		GeeSet* _tmp22_ = NULL;
		GeeSet* other_keys;
		_tmp21_ = gee_multi_map_get_keys (self->priv->map);
		keys = _tmp21_;
		g_assert (keys != NULL);
		_tmp22_ = gee_multi_map_get_keys (other->priv->map);
		other_keys = _tmp22_;
		g_assert (other_keys != NULL);
		{
			GeeIterator* _tmp23_ = NULL;
			GeeIterator* _subject_it;
			_tmp23_ = gee_iterable_iterator (GEE_ITERABLE (other_keys));
			_subject_it = _tmp23_;
			while (TRUE) {
				gboolean _tmp24_;
				gpointer _tmp25_ = NULL;
				gchar* subject;
				gboolean _tmp26_;
				GeeCollection* _tmp27_ = NULL;
				GeeCollection* details;
				GeeCollection* _tmp28_ = NULL;
				GeeCollection* other_details;
				gboolean _tmp29_ = FALSE;
				_tmp24_ = gee_iterator_next (_subject_it);
				if (!_tmp24_) {
					break;
				}
				_tmp25_ = gee_iterator_get (_subject_it);
				subject = (gchar*) _tmp25_;
				_tmp26_ = gee_collection_contains (GEE_COLLECTION (keys), subject);
				if (!_tmp26_) {
					_g_free0 (subject);
					continue;
				}
				_tmp27_ = gee_multi_map_get (self->priv->map, subject);
				details = _tmp27_;
				_tmp28_ = gee_multi_map_get (other->priv->map, subject);
				other_details = _tmp28_;
				if (details != NULL) {
					_tmp29_ = other_details != NULL;
				} else {
					_tmp29_ = FALSE;
				}
				if (_tmp29_) {
					{
						GeeIterator* _tmp30_ = NULL;
						GeeIterator* _detail_it;
						_tmp30_ = gee_iterable_iterator (GEE_ITERABLE (other_details));
						_detail_it = _tmp30_;
						while (TRUE) {
							gboolean _tmp31_;
							gpointer _tmp32_ = NULL;
							gchar* detail;
							gboolean _tmp33_;
							_tmp31_ = gee_iterator_next (_detail_it);
							if (!_tmp31_) {
								break;
							}
							_tmp32_ = gee_iterator_get (_detail_it);
							detail = (gchar*) _tmp32_;
							_tmp33_ = gee_collection_contains (details, detail);
							if (_tmp33_) {
								result = TRUE;
								_g_free0 (detail);
								_g_object_unref0 (_detail_it);
								_g_object_unref0 (other_details);
								_g_object_unref0 (details);
								_g_free0 (subject);
								_g_object_unref0 (_subject_it);
								_g_object_unref0 (other_keys);
								_g_object_unref0 (keys);
								return result;
							}
							_g_free0 (detail);
						}
						_g_object_unref0 (_detail_it);
					}
				}
				_g_object_unref0 (other_details);
				_g_object_unref0 (details);
				_g_free0 (subject);
			}
			_g_object_unref0 (_subject_it);
		}
		_g_object_unref0 (other_keys);
		_g_object_unref0 (keys);
	}
	result = FALSE;
	return result;
}


gboolean alteration_equals (Alteration* self, Alteration* other) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp6_ = FALSE;
	g_return_val_if_fail (IS_ALTERATION (self), FALSE);
	g_return_val_if_fail (IS_ALTERATION (other), FALSE);
	if (self == other) {
		result = TRUE;
		return result;
	}
	if (self->priv->subject != NULL) {
		_tmp2_ = other->priv->subject != NULL;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = self->priv->detail != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = other->priv->detail != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_;
		_tmp4_ = alteration_equal_values (self->priv->subject, other->priv->subject);
		if (_tmp4_) {
			gboolean _tmp5_;
			_tmp5_ = alteration_equal_values (self->priv->detail, other->priv->detail);
			_tmp3_ = _tmp5_;
		} else {
			_tmp3_ = FALSE;
		}
		result = _tmp3_;
		return result;
	}
	if (self->priv->map != NULL) {
		_tmp6_ = other->priv->map != NULL;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		GeeSet* _tmp7_ = NULL;
		GeeSet* keys;
		GeeSet* _tmp8_ = NULL;
		GeeSet* other_keys;
		gint _tmp9_;
		gint _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		_tmp7_ = gee_multi_map_get_keys (self->priv->map);
		keys = _tmp7_;
		g_assert (keys != NULL);
		_tmp8_ = gee_multi_map_get_keys (other->priv->map);
		other_keys = _tmp8_;
		g_assert (other_keys != NULL);
		_tmp9_ = gee_collection_get_size (GEE_COLLECTION (keys));
		_tmp10_ = gee_collection_get_size (GEE_COLLECTION (other_keys));
		if (_tmp9_ != _tmp10_) {
			result = FALSE;
			_g_object_unref0 (other_keys);
			_g_object_unref0 (keys);
			return result;
		}
		_tmp11_ = gee_collection_contains_all (GEE_COLLECTION (keys), GEE_COLLECTION (other_keys));
		if (!_tmp11_) {
			result = FALSE;
			_g_object_unref0 (other_keys);
			_g_object_unref0 (keys);
			return result;
		}
		_tmp12_ = gee_collection_contains_all (GEE_COLLECTION (other_keys), GEE_COLLECTION (keys));
		if (!_tmp12_) {
			result = FALSE;
			_g_object_unref0 (other_keys);
			_g_object_unref0 (keys);
			return result;
		}
		{
			GeeIterator* _tmp13_ = NULL;
			GeeIterator* _key_it;
			_tmp13_ = gee_iterable_iterator (GEE_ITERABLE (keys));
			_key_it = _tmp13_;
			while (TRUE) {
				gboolean _tmp14_;
				gpointer _tmp15_ = NULL;
				gchar* key;
				GeeCollection* _tmp16_ = NULL;
				GeeCollection* values;
				GeeCollection* _tmp17_ = NULL;
				GeeCollection* other_values;
				gint _tmp18_;
				gint _tmp19_;
				gboolean _tmp20_;
				gboolean _tmp21_;
				_tmp14_ = gee_iterator_next (_key_it);
				if (!_tmp14_) {
					break;
				}
				_tmp15_ = gee_iterator_get (_key_it);
				key = (gchar*) _tmp15_;
				_tmp16_ = gee_multi_map_get (self->priv->map, key);
				values = _tmp16_;
				_tmp17_ = gee_multi_map_get (other->priv->map, key);
				other_values = _tmp17_;
				_tmp18_ = gee_collection_get_size (values);
				_tmp19_ = gee_collection_get_size (other_values);
				if (_tmp18_ != _tmp19_) {
					result = FALSE;
					_g_object_unref0 (other_values);
					_g_object_unref0 (values);
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (other_keys);
					_g_object_unref0 (keys);
					return result;
				}
				_tmp20_ = gee_collection_contains_all (values, other_values);
				if (!_tmp20_) {
					result = FALSE;
					_g_object_unref0 (other_values);
					_g_object_unref0 (values);
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (other_keys);
					_g_object_unref0 (keys);
					return result;
				}
				_tmp21_ = gee_collection_contains_all (other_values, values);
				if (!_tmp21_) {
					result = FALSE;
					_g_object_unref0 (other_values);
					_g_object_unref0 (values);
					_g_free0 (key);
					_g_object_unref0 (_key_it);
					_g_object_unref0 (other_keys);
					_g_object_unref0 (keys);
					return result;
				}
				_g_object_unref0 (other_values);
				_g_object_unref0 (values);
				_g_free0 (key);
			}
			_g_object_unref0 (_key_it);
		}
		result = TRUE;
		_g_object_unref0 (other_keys);
		_g_object_unref0 (keys);
		return result;
	}
	result = FALSE;
	return result;
}


static void alteration_multimap_add_all (GeeMultiMap* dest, GeeMultiMap* src) {
	GeeSet* _tmp0_ = NULL;
	GeeSet* keys;
	g_return_if_fail (GEE_IS_MULTI_MAP (dest));
	g_return_if_fail (GEE_IS_MULTI_MAP (src));
	_tmp0_ = gee_multi_map_get_keys (src);
	keys = _tmp0_;
	{
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _key_it;
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (keys));
		_key_it = _tmp1_;
		while (TRUE) {
			gboolean _tmp2_;
			gpointer _tmp3_ = NULL;
			gchar* key;
			GeeCollection* _tmp4_ = NULL;
			GeeCollection* values;
			_tmp2_ = gee_iterator_next (_key_it);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = gee_iterator_get (_key_it);
			key = (gchar*) _tmp3_;
			_tmp4_ = gee_multi_map_get (src, key);
			values = _tmp4_;
			{
				GeeIterator* _tmp5_ = NULL;
				GeeIterator* _value_it;
				_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (values));
				_value_it = _tmp5_;
				while (TRUE) {
					gboolean _tmp6_;
					gpointer _tmp7_ = NULL;
					gchar* value;
					_tmp6_ = gee_iterator_next (_value_it);
					if (!_tmp6_) {
						break;
					}
					_tmp7_ = gee_iterator_get (_value_it);
					value = (gchar*) _tmp7_;
					gee_multi_map_set (dest, key, value);
					_g_free0 (value);
				}
				_g_object_unref0 (_value_it);
			}
			_g_object_unref0 (values);
			_g_free0 (key);
		}
		_g_object_unref0 (_key_it);
	}
	_g_object_unref0 (keys);
}


static gpointer _alteration_ref0 (gpointer self) {
	return self ? alteration_ref (self) : NULL;
}


Alteration* alteration_compress (Alteration* self, Alteration* other) {
	Alteration* result = NULL;
	gboolean _tmp0_;
	GeeMultiMap* _tmp2_ = NULL;
	GeeMultiMap* compressed;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	Alteration* _tmp5_ = NULL;
	g_return_val_if_fail (IS_ALTERATION (self), NULL);
	g_return_val_if_fail (IS_ALTERATION (other), NULL);
	_tmp0_ = alteration_equals (self, other);
	if (_tmp0_) {
		Alteration* _tmp1_;
		_tmp1_ = _alteration_ref0 (self);
		result = _tmp1_;
		return result;
	}
	_tmp2_ = alteration_create_map (self);
	compressed = _tmp2_;
	if (self->priv->subject != NULL) {
		_tmp3_ = self->priv->detail != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gee_multi_map_set (compressed, self->priv->subject, self->priv->detail);
	} else {
		g_assert (self->priv->map != NULL);
		alteration_multimap_add_all (compressed, self->priv->map);
	}
	if (other->priv->subject != NULL) {
		_tmp4_ = other->priv->detail != NULL;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		gee_multi_map_set (compressed, other->priv->subject, other->priv->detail);
	} else {
		g_assert (other->priv->map != NULL);
		alteration_multimap_add_all (compressed, other->priv->map);
	}
	_tmp5_ = alteration_new_from_map (compressed);
	result = _tmp5_;
	_g_object_unref0 (compressed);
	return result;
}


static void value_alteration_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_alteration_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		alteration_unref (value->data[0].v_pointer);
	}
}


static void value_alteration_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = alteration_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_alteration_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_alteration_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Alteration* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = alteration_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_alteration_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Alteration** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = alteration_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecAlteration* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ALTERATION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_alteration (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION), NULL);
	return value->data[0].v_pointer;
}


void value_set_alteration (GValue* value, gpointer v_object) {
	Alteration* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		alteration_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		alteration_unref (old);
	}
}


void value_take_alteration (GValue* value, gpointer v_object) {
	Alteration* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		alteration_unref (old);
	}
}


static void alteration_class_init (AlterationClass * klass) {
	alteration_parent_class = g_type_class_peek_parent (klass);
	ALTERATION_CLASS (klass)->finalize = alteration_finalize;
	g_type_class_add_private (klass, sizeof (AlterationPrivate));
}


static void alteration_instance_init (Alteration * self) {
	self->priv = ALTERATION_GET_PRIVATE (self);
	self->priv->subject = NULL;
	self->priv->detail = NULL;
	self->priv->map = NULL;
	self->ref_count = 1;
}


static void alteration_finalize (Alteration* obj) {
	Alteration * self;
	self = ALTERATION (obj);
	_g_free0 (self->priv->subject);
	_g_free0 (self->priv->detail);
	_g_object_unref0 (self->priv->map);
}


GType alteration_get_type (void) {
	static volatile gsize alteration_type_id__volatile = 0;
	if (g_once_init_enter (&alteration_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_alteration_init, value_alteration_free_value, value_alteration_copy_value, value_alteration_peek_pointer, "p", value_alteration_collect_value, "p", value_alteration_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (AlterationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) alteration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Alteration), 0, (GInstanceInitFunc) alteration_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType alteration_type_id;
		alteration_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Alteration", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&alteration_type_id__volatile, alteration_type_id);
	}
	return alteration_type_id__volatile;
}


gpointer alteration_ref (gpointer instance) {
	Alteration* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void alteration_unref (gpointer instance) {
	Alteration* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		ALTERATION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



