/* TombstoneTable.c generated by valac 0.11.7, the Vala compiler
 * generated from TombstoneTable.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sqlite3.h>


#define TYPE_TOMBSTONE_ID (tombstone_id_get_type ())
typedef struct _TombstoneID TombstoneID;

#define TYPE_TOMBSTONE_ROW (tombstone_row_get_type ())

#define TOMBSTONE_TYPE_REASON (tombstone_reason_get_type ())
typedef struct _TombstoneRow TombstoneRow;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_TOMBSTONE_TABLE (tombstone_table_get_type ())
#define TOMBSTONE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE_TABLE, TombstoneTable))
#define TOMBSTONE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE_TABLE, TombstoneTableClass))
#define IS_TOMBSTONE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE_TABLE))
#define IS_TOMBSTONE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE_TABLE))
#define TOMBSTONE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE_TABLE, TombstoneTableClass))

typedef struct _TombstoneTable TombstoneTable;
typedef struct _TombstoneTableClass TombstoneTableClass;
typedef struct _TombstoneTablePrivate TombstoneTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

struct _TombstoneID {
	gint64 id;
};

typedef enum  {
	TOMBSTONE_REASON_REMOVED_BY_USER = 0,
	TOMBSTONE_REASON_AUTO_DETECTED_DUPLICATE = 1
} TombstoneReason;

struct _TombstoneRow {
	TombstoneID id;
	gchar* filepath;
	gint64 filesize;
	gchar* md5;
	time_t time_created;
	TombstoneReason reason;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _TombstoneTable {
	DatabaseTable parent_instance;
	TombstoneTablePrivate * priv;
};

struct _TombstoneTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer tombstone_table_parent_class = NULL;
static TombstoneTable* tombstone_table_instance;
static TombstoneTable* tombstone_table_instance = NULL;
extern sqlite3* database_table_db;

GType tombstone_id_get_type (void) G_GNUC_CONST;
TombstoneID* tombstone_id_dup (const TombstoneID* self);
void tombstone_id_free (TombstoneID* self);
#define TOMBSTONE_ID_INVALID ((gint64) (-1))
void tombstone_id_init (TombstoneID *self, gint64 id);
gboolean tombstone_id_is_invalid (TombstoneID *self);
gboolean tombstone_id_is_valid (TombstoneID *self);
GType tombstone_row_get_type (void) G_GNUC_CONST;
GType tombstone_reason_get_type (void) G_GNUC_CONST;
TombstoneRow* tombstone_row_dup (const TombstoneRow* self);
void tombstone_row_free (TombstoneRow* self);
void tombstone_row_copy (const TombstoneRow* self, TombstoneRow* dest);
void tombstone_row_destroy (TombstoneRow* self);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType tombstone_table_get_type (void) G_GNUC_CONST;
enum  {
	TOMBSTONE_TABLE_DUMMY_PROPERTY
};
static TombstoneTable* tombstone_table_new (void);
static TombstoneTable* tombstone_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
void database_table_fatal (const gchar* op, gint res);
TombstoneTable* tombstone_table_get_instance (void);
GQuark database_error_quark (void);
void tombstone_table_add (TombstoneTable* self, const gchar* filepath, gint64 filesize, const gchar* md5, TombstoneReason reason, TombstoneRow* result, GError** error);
gulong now_sec (void);
gint tombstone_reason_serialize (TombstoneReason self);
void database_table_throw_error (const gchar* method, gint res, GError** error);
TombstoneRow* tombstone_table_fetch_all (TombstoneTable* self, int* result_length1, GError** error);
gint database_table_get_row_count (DatabaseTable* self);
static void _vala_TombstoneRow_array_free (TombstoneRow* array, gint array_length);
TombstoneReason tombstone_reason_unserialize (gint value);
void tombstone_table_update_file (TombstoneTable* self, TombstoneID* tombstone_id, const gchar* filepath, GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
void tombstone_table_remove (TombstoneTable* self, TombstoneID* tombstone_id, GError** error);
void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error);
static void tombstone_table_finalize (DatabaseTable* obj);


void tombstone_id_init (TombstoneID *self, gint64 id) {
	memset (self, 0, sizeof (TombstoneID));
	(*self).id = id;
}


gboolean tombstone_id_is_invalid (TombstoneID *self) {
	gboolean result = FALSE;
	result = (*self).id == TOMBSTONE_ID_INVALID;
	return result;
}


gboolean tombstone_id_is_valid (TombstoneID *self) {
	gboolean result = FALSE;
	result = (*self).id != TOMBSTONE_ID_INVALID;
	return result;
}


TombstoneID* tombstone_id_dup (const TombstoneID* self) {
	TombstoneID* dup;
	dup = g_new0 (TombstoneID, 1);
	memcpy (dup, self, sizeof (TombstoneID));
	return dup;
}


void tombstone_id_free (TombstoneID* self) {
	g_free (self);
}


GType tombstone_id_get_type (void) {
	static volatile gsize tombstone_id_type_id__volatile = 0;
	if (g_once_init_enter (&tombstone_id_type_id__volatile)) {
		GType tombstone_id_type_id;
		tombstone_id_type_id = g_boxed_type_register_static ("TombstoneID", (GBoxedCopyFunc) tombstone_id_dup, (GBoxedFreeFunc) tombstone_id_free);
		g_once_init_leave (&tombstone_id_type_id__volatile, tombstone_id_type_id);
	}
	return tombstone_id_type_id__volatile;
}


void tombstone_row_copy (const TombstoneRow* self, TombstoneRow* dest) {
	dest->id = self->id;
	dest->filepath = g_strdup (self->filepath);
	dest->filesize = self->filesize;
	dest->md5 = g_strdup (self->md5);
	dest->time_created = self->time_created;
	dest->reason = self->reason;
}


void tombstone_row_destroy (TombstoneRow* self) {
	_g_free0 ((*self).filepath);
	_g_free0 ((*self).md5);
}


TombstoneRow* tombstone_row_dup (const TombstoneRow* self) {
	TombstoneRow* dup;
	dup = g_new0 (TombstoneRow, 1);
	tombstone_row_copy (self, dup);
	return dup;
}


void tombstone_row_free (TombstoneRow* self) {
	tombstone_row_destroy (self);
	g_free (self);
}


GType tombstone_row_get_type (void) {
	static volatile gsize tombstone_row_type_id__volatile = 0;
	if (g_once_init_enter (&tombstone_row_type_id__volatile)) {
		GType tombstone_row_type_id;
		tombstone_row_type_id = g_boxed_type_register_static ("TombstoneRow", (GBoxedCopyFunc) tombstone_row_dup, (GBoxedFreeFunc) tombstone_row_free);
		g_once_init_leave (&tombstone_row_type_id__volatile, tombstone_row_type_id);
	}
	return tombstone_row_type_id__volatile;
}


static TombstoneTable* tombstone_table_construct (GType object_type) {
	TombstoneTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	self = (TombstoneTable*) database_table_construct (object_type);
	database_table_set_table_name (DATABASE_TABLE (self), "TombstoneTable");
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "CREATE TABLE IF NOT EXISTS " "TombstoneTable " "(" "id INTEGER PRIMARY KEY, " "filepath TEXT NOT NULL, " "filesize INTEGER, " "md5 TEXT, " "time_created INTEGER, " "reason INTEGER DEFAULT 0 " ")", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_step (stmt);
	res = _tmp2_;
	if (res != SQLITE_DONE) {
		database_table_fatal ("create TombstoneTable", res);
	}
	_sqlite3_finalize0 (stmt);
	return self;
}


static TombstoneTable* tombstone_table_new (void) {
	return tombstone_table_construct (TYPE_TOMBSTONE_TABLE);
}


static gpointer _database_table_ref0 (gpointer self) {
	return self ? database_table_ref (self) : NULL;
}


TombstoneTable* tombstone_table_get_instance (void) {
	TombstoneTable* result = NULL;
	TombstoneTable* _tmp1_;
	if (tombstone_table_instance == NULL) {
		TombstoneTable* _tmp0_ = NULL;
		_tmp0_ = tombstone_table_new ();
		_database_table_unref0 (tombstone_table_instance);
		tombstone_table_instance = _tmp0_;
	}
	_tmp1_ = _database_table_ref0 (tombstone_table_instance);
	result = _tmp1_;
	return result;
}


void tombstone_table_add (TombstoneTable* self, const gchar* filepath, gint64 filesize, const gchar* md5, TombstoneReason reason, TombstoneRow* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gulong _tmp2_;
	time_t time_created;
	gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	TombstoneRow row = {0};
	gint64 _tmp12_;
	TombstoneID _tmp13_ = {0};
	TombstoneID _tmp14_ = {0};
	gchar* _tmp15_;
	gchar* _tmp16_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_TOMBSTONE_TABLE (self));
	g_return_if_fail (filepath != NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "INSERT INTO TombstoneTable " "(filepath, filesize, md5, time_created, reason) " "VALUES (?, ?, ?, ?, ?)", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = now_sec ();
	time_created = (time_t) _tmp2_;
	_tmp3_ = g_strdup (filepath);
	_tmp4_ = sqlite3_bind_text (stmt, 1, _tmp3_, -1, g_free);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_bind_int64 (stmt, 2, filesize);
	res = _tmp5_;
	g_assert (res == SQLITE_OK);
	_tmp6_ = g_strdup (md5);
	_tmp7_ = sqlite3_bind_text (stmt, 3, _tmp6_, -1, g_free);
	res = _tmp7_;
	g_assert (res == SQLITE_OK);
	_tmp8_ = sqlite3_bind_int64 (stmt, 4, (gint64) time_created);
	res = _tmp8_;
	g_assert (res == SQLITE_OK);
	_tmp9_ = tombstone_reason_serialize (reason);
	_tmp10_ = sqlite3_bind_int (stmt, 5, _tmp9_);
	res = _tmp10_;
	g_assert (res == SQLITE_OK);
	_tmp11_ = sqlite3_step (stmt);
	res = _tmp11_;
	if (res != SQLITE_DONE) {
		database_table_throw_error ("TombstoneTable.add", res, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	memset (&row, 0, sizeof (TombstoneRow));
	_tmp12_ = sqlite3_last_insert_rowid (database_table_db);
	tombstone_id_init (&_tmp13_, _tmp12_);
	_tmp14_ = _tmp13_;
	row.id = _tmp14_;
	_tmp15_ = g_strdup (filepath);
	_g_free0 (row.filepath);
	row.filepath = _tmp15_;
	row.filesize = filesize;
	_tmp16_ = g_strdup (md5);
	_g_free0 (row.md5);
	row.md5 = _tmp16_;
	row.time_created = time_created;
	row.reason = reason;
	*result = row;
	_sqlite3_finalize0 (stmt);
	return;
}


static void _vala_TombstoneRow_array_free (TombstoneRow* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			tombstone_row_destroy (&array[i]);
		}
	}
	g_free (array);
}


TombstoneRow* tombstone_table_fetch_all (TombstoneTable* self, int* result_length1, GError** error) {
	TombstoneRow* result = NULL;
	gint _tmp0_;
	gint row_count;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_;
	gint res;
	TombstoneRow* _tmp4_ = NULL;
	TombstoneRow* rows;
	gint rows_length1;
	gint _rows_size_;
	gint index;
	TombstoneRow* _tmp22_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_TOMBSTONE_TABLE (self), NULL);
	_tmp0_ = database_table_get_row_count (DATABASE_TABLE (self));
	row_count = _tmp0_;
	if (row_count == 0) {
		gpointer _tmp1_;
		_tmp1_ = NULL;
		*result_length1 = 0;
		result = _tmp1_;
		return result;
	}
	_tmp3_ = sqlite3_prepare_v2 (database_table_db, "SELECT id, filepath, filesize, md5, time_created, reason " "FROM TombstoneTable", -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	res = _tmp3_;
	g_assert (res == SQLITE_OK);
	_tmp4_ = g_new0 (TombstoneRow, row_count);
	rows = _tmp4_;
	rows_length1 = row_count;
	_rows_size_ = row_count;
	index = 0;
	{
		gboolean _tmp5_;
		_tmp5_ = TRUE;
		while (TRUE) {
			gint _tmp6_;
			TombstoneRow row = {0};
			gint64 _tmp7_;
			TombstoneID _tmp8_ = {0};
			TombstoneID _tmp9_ = {0};
			const gchar* _tmp10_ = NULL;
			gchar* _tmp11_;
			gint64 _tmp12_;
			const gchar* _tmp13_ = NULL;
			gchar* _tmp14_;
			gint64 _tmp15_;
			gint _tmp16_;
			TombstoneReason _tmp17_;
			gint _tmp18_;
			TombstoneRow _tmp19_;
			TombstoneRow _tmp20_ = {0};
			TombstoneRow _tmp21_;
			if (!_tmp5_) {
			}
			_tmp5_ = FALSE;
			_tmp6_ = sqlite3_step (stmt);
			res = _tmp6_;
			if (res == SQLITE_DONE) {
				break;
			} else {
				if (res != SQLITE_ROW) {
					database_table_throw_error ("TombstoneTable.fetch_all", res, &_inner_error_);
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == DATABASE_ERROR) {
							g_propagate_error (error, _inner_error_);
							rows = (_vala_TombstoneRow_array_free (rows, rows_length1), NULL);
							_sqlite3_finalize0 (stmt);
							return NULL;
						} else {
							rows = (_vala_TombstoneRow_array_free (rows, rows_length1), NULL);
							_sqlite3_finalize0 (stmt);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
				}
			}
			memset (&row, 0, sizeof (TombstoneRow));
			_tmp7_ = sqlite3_column_int64 (stmt, 0);
			tombstone_id_init (&_tmp8_, _tmp7_);
			_tmp9_ = _tmp8_;
			row.id = _tmp9_;
			_tmp10_ = sqlite3_column_text (stmt, 1);
			_tmp11_ = g_strdup (_tmp10_);
			_g_free0 (row.filepath);
			row.filepath = _tmp11_;
			_tmp12_ = sqlite3_column_int64 (stmt, 2);
			row.filesize = _tmp12_;
			_tmp13_ = sqlite3_column_text (stmt, 3);
			_tmp14_ = g_strdup (_tmp13_);
			_g_free0 (row.md5);
			row.md5 = _tmp14_;
			_tmp15_ = sqlite3_column_int64 (stmt, 4);
			row.time_created = (time_t) _tmp15_;
			_tmp16_ = sqlite3_column_int (stmt, 5);
			_tmp17_ = tombstone_reason_unserialize (_tmp16_);
			row.reason = _tmp17_;
			_tmp18_ = index;
			index = _tmp18_ + 1;
			tombstone_row_copy (&row, &_tmp20_);
			_tmp19_ = _tmp20_;
			_tmp21_ = _tmp19_;
			tombstone_row_destroy (&rows[_tmp18_]);
			rows[_tmp18_] = _tmp21_;
			tombstone_row_destroy (&row);
		}
	}
	g_assert (index == row_count);
	_tmp22_ = rows;
	*result_length1 = rows_length1;
	result = _tmp22_;
	_sqlite3_finalize0 (stmt);
	return result;
}


void tombstone_table_update_file (TombstoneTable* self, TombstoneID* tombstone_id, const gchar* filepath, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_TOMBSTONE_TABLE (self));
	g_return_if_fail (filepath != NULL);
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), (*tombstone_id).id, "filepath", filepath, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void tombstone_table_remove (TombstoneTable* self, TombstoneID* tombstone_id, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_TOMBSTONE_TABLE (self));
	database_table_delete_by_id (DATABASE_TABLE (self), (*tombstone_id).id, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void tombstone_table_class_init (TombstoneTableClass * klass) {
	tombstone_table_parent_class = g_type_class_peek_parent (klass);
	DATABASE_TABLE_CLASS (klass)->finalize = tombstone_table_finalize;
}


static void tombstone_table_instance_init (TombstoneTable * self) {
}


static void tombstone_table_finalize (DatabaseTable* obj) {
	TombstoneTable * self;
	self = TOMBSTONE_TABLE (obj);
	DATABASE_TABLE_CLASS (tombstone_table_parent_class)->finalize (obj);
}


GType tombstone_table_get_type (void) {
	static volatile gsize tombstone_table_type_id__volatile = 0;
	if (g_once_init_enter (&tombstone_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TombstoneTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tombstone_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TombstoneTable), 0, (GInstanceInitFunc) tombstone_table_instance_init, NULL };
		GType tombstone_table_type_id;
		tombstone_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "TombstoneTable", &g_define_type_info, 0);
		g_once_init_leave (&tombstone_table_type_id__volatile, tombstone_table_type_id);
	}
	return tombstone_table_type_id__volatile;
}



