/* file.c generated by valac 0.11.7, the Vala compiler
 * generated from file.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* Returns true if the file is claimed, false if it exists, and throws an Error otherwise.  The file*/
/* will be created when the function exits and should be overwritten.  Note that the file is not*/
/* held open; claiming a file is merely based on its existance.*/
/**/
/* This function is thread-safe.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <time.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gboolean claim_file (GFile* file, GError** error);
GFile* generate_unique_file (GFile* dir, const gchar* basename, gboolean* collision, GError** error);
void disassemble_filename (const gchar* basename, gchar** name, gchar** ext);
glong find_last_offset (const gchar* str, gchar c);
guint64 query_total_file_size (GFile* file_or_dir, GCancellable* cancellable, GError** error);
void delete_all_files (GFile* dir, GeeSet* exceptions, GCancellable* cancellable, GError** error);
time_t query_file_modified (GFile* file, GError** error);
gboolean query_is_directory (GFile* file);
gboolean query_is_directory_empty (GFile* dir, GError** error);
gchar* get_display_pathname (GFile* file);
gchar* strip_pretty_path (const gchar* path);
gchar* get_file_info_id (GFileInfo* info);
void skip_uint64 (GInputStream* input, guint64 skip_amount, GError** error);


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


gboolean claim_file (GFile* file, GError** error) {
	gboolean result = FALSE;
	GFileOutputStream* _tmp0_ = NULL;
	GFileOutputStream* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	_tmp0_ = g_file_create (file, G_FILE_CREATE_NONE, NULL, &_inner_error_);
	_tmp1_ = _tmp0_;
	_g_object_unref0 (_tmp1_);
	if (_inner_error_ != NULL) {
		goto __catch0_g_error;
	}
	result = TRUE;
	return result;
	goto __finally0;
	__catch0_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		if (!g_error_matches (err, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
			gchar* _tmp2_ = NULL;
			gchar* _tmp3_;
			GError* _tmp4_;
			_tmp2_ = g_file_get_path (file);
			_tmp3_ = _tmp2_;
			g_warning ("file.vala:21: claim_file %s: %s", _tmp3_, err->message);
			_g_free0 (_tmp3_);
			_tmp4_ = _g_error_copy0 (err);
			_inner_error_ = _tmp4_;
			_g_error_free0 (err);
			goto __finally0;
		}
		result = FALSE;
		_g_error_free0 (err);
		return result;
	}
	__finally0:
	g_propagate_error (error, _inner_error_);
	return FALSE;
}


GFile* generate_unique_file (GFile* dir, const gchar* basename, gboolean* collision, GError** error) {
	gboolean _collision = FALSE;
	GFile* result = NULL;
	GFile* _tmp0_ = NULL;
	GFile* file;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (G_IS_FILE (dir), NULL);
	g_return_val_if_fail (basename != NULL, NULL);
	_tmp0_ = g_file_get_child (dir, basename);
	file = _tmp0_;
	_tmp1_ = claim_file (file, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (file);
		return NULL;
	}
	if (_tmp2_) {
		_collision = FALSE;
		result = file;
		if (collision) {
			*collision = _collision;
		}
		return result;
	}
	_collision = TRUE;
	disassemble_filename (basename, &_tmp3_, &_tmp4_);
	_g_free0 (name);
	name = _tmp3_;
	_g_free0 (ext);
	ext = _tmp4_;
	{
		gint ctr;
		ctr = 1;
		{
			gboolean _tmp5_;
			_tmp5_ = TRUE;
			while (TRUE) {
				gchar* _tmp6_ = NULL;
				gchar* _tmp9_;
				gchar* new_name;
				GFile* _tmp10_ = NULL;
				gboolean _tmp11_;
				gboolean _tmp12_;
				if (!_tmp5_) {
					ctr++;
				}
				_tmp5_ = FALSE;
				if (!(ctr < G_MAXINT)) {
					break;
				}
				if (ext != NULL) {
					gchar* _tmp7_ = NULL;
					_tmp7_ = g_strdup_printf ("%s_%d.%s", name, ctr, ext);
					_g_free0 (_tmp6_);
					_tmp6_ = _tmp7_;
				} else {
					gchar* _tmp8_ = NULL;
					_tmp8_ = g_strdup_printf ("%s_%d", name, ctr);
					_g_free0 (_tmp6_);
					_tmp6_ = _tmp8_;
				}
				_tmp9_ = g_strdup (_tmp6_);
				new_name = _tmp9_;
				_tmp10_ = g_file_get_child (dir, new_name);
				_g_object_unref0 (file);
				file = _tmp10_;
				_tmp11_ = claim_file (file, &_inner_error_);
				_tmp12_ = _tmp11_;
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_g_free0 (new_name);
					_g_free0 (_tmp6_);
					_g_free0 (ext);
					_g_free0 (name);
					_g_object_unref0 (file);
					return NULL;
				}
				if (_tmp12_) {
					result = file;
					_g_free0 (new_name);
					_g_free0 (_tmp6_);
					_g_free0 (ext);
					_g_free0 (name);
					if (collision) {
						*collision = _collision;
					}
					return result;
				}
				_g_free0 (new_name);
				_g_free0 (_tmp6_);
			}
		}
	}
	_tmp13_ = g_file_get_path (dir);
	_tmp14_ = _tmp13_;
	g_warning ("file.vala:60: generate_unique_filename %s for %s: unable to claim file", _tmp14_, basename);
	_g_free0 (_tmp14_);
	result = NULL;
	_g_free0 (ext);
	_g_free0 (name);
	_g_object_unref0 (file);
	if (collision) {
		*collision = _collision;
	}
	return result;
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_ = NULL;
	gchar* end;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	if (end == NULL) {
		result = maxlen;
		return result;
	} else {
		result = (glong) (end - str);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= 0) {
		_tmp0_ = len >= 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp1_;
		_tmp1_ = string_strnlen ((gchar*) self, offset + len);
		string_length = _tmp1_;
	} else {
		gint _tmp2_;
		_tmp2_ = strlen (self);
		string_length = (glong) _tmp2_;
	}
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}


void disassemble_filename (const gchar* basename, gchar** name, gchar** ext) {
	gchar* _name = NULL;
	gchar* _ext = NULL;
	glong _tmp0_;
	glong offset;
	g_return_if_fail (basename != NULL);
	_tmp0_ = find_last_offset (basename, '.');
	offset = _tmp0_;
	if (offset <= 0) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (basename);
		_g_free0 (_name);
		_name = _tmp1_;
		_g_free0 (_ext);
		_ext = NULL;
	} else {
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		_tmp2_ = string_substring (basename, (glong) 0, offset);
		_g_free0 (_name);
		_name = _tmp2_;
		_tmp3_ = string_substring (basename, offset + 1, (glong) (-1));
		_g_free0 (_ext);
		_ext = _tmp3_;
	}
	if (name) {
		*name = _name;
	} else {
		_g_free0 (_name);
	}
	if (ext) {
		*ext = _ext;
	} else {
		_g_free0 (_ext);
	}
}


guint64 query_total_file_size (GFile* file_or_dir, GCancellable* cancellable, GError** error) {
	guint64 result = 0ULL;
	GFileType _tmp0_;
	GFileType type;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp7_ = NULL;
	GFileEnumerator* _tmp8_;
	guint64 total_bytes;
	GFileInfo* info;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (G_IS_FILE (file_or_dir), 0ULL);
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0ULL);
	_tmp0_ = g_file_query_file_type (file_or_dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
	type = _tmp0_;
	if (type == G_FILE_TYPE_REGULAR) {
		GFileInfo* info;
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		gint64 _tmp6_;
		info = NULL;
		_tmp1_ = g_file_query_info (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error_);
		_tmp2_ = _tmp1_;
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		_g_object_unref0 (info);
		info = _tmp2_;
		goto __finally1;
		__catch1_g_error:
		{
			GError * err;
			gchar* _tmp4_ = NULL;
			gchar* _tmp5_;
			err = _inner_error_;
			_inner_error_ = NULL;
			if (g_error_matches (err, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
				GError* _tmp3_;
				_tmp3_ = _g_error_copy0 (err);
				_inner_error_ = _tmp3_;
				_g_error_free0 (err);
				goto __finally1;
			}
			_tmp4_ = g_file_get_path (file_or_dir);
			_tmp5_ = _tmp4_;
			g_debug ("file.vala:88: Unable to query filesize for %s: %s", _tmp5_, err->message);
			_g_free0 (_tmp5_);
			result = (guint64) 0;
			_g_error_free0 (err);
			_g_object_unref0 (info);
			return result;
		}
		__finally1:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (info);
			return 0ULL;
		}
		_tmp6_ = g_file_info_get_size (info);
		result = (guint64) _tmp6_;
		_g_object_unref0 (info);
		return result;
	} else {
		if (type != G_FILE_TYPE_DIRECTORY) {
			result = (guint64) 0;
			return result;
		}
	}
	_tmp7_ = g_file_enumerate_children (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error_);
	_tmp8_ = _tmp7_;
	if (_inner_error_ != NULL) {
		goto __catch2_g_error;
	}
	_g_object_unref0 (enumerator);
	enumerator = _tmp8_;
	if (enumerator == NULL) {
		result = (guint64) 0;
		_g_object_unref0 (enumerator);
		return result;
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError * err;
		gboolean _tmp9_ = FALSE;
		GError* _tmp10_;
		err = _inner_error_;
		_inner_error_ = NULL;
		if (g_error_matches (err, G_FILE_ERROR, G_FILE_ERROR_PERM)) {
			_tmp9_ = TRUE;
		} else {
			_tmp9_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED);
		}
		if (_tmp9_) {
			result = (guint64) 0;
			_g_error_free0 (err);
			_g_object_unref0 (enumerator);
			return result;
		}
		_tmp10_ = _g_error_copy0 (err);
		_inner_error_ = _tmp10_;
		_g_error_free0 (err);
		goto __finally2;
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (enumerator);
		return 0ULL;
	}
	total_bytes = (guint64) 0;
	info = NULL;
	while (TRUE) {
		GFileInfo* _tmp11_ = NULL;
		GFileInfo* _tmp12_;
		const gchar* _tmp13_ = NULL;
		GFile* _tmp14_ = NULL;
		GFile* _tmp15_;
		guint64 _tmp16_;
		guint64 _tmp17_;
		guint64 _tmp18_;
		_tmp11_ = g_file_enumerator_next_file (enumerator, cancellable, &_inner_error_);
		_tmp12_ = _tmp11_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			return 0ULL;
		}
		_g_object_unref0 (info);
		info = _tmp12_;
		if (!(info != NULL)) {
			break;
		}
		_tmp13_ = g_file_info_get_name (info);
		_tmp14_ = g_file_get_child (file_or_dir, _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = query_total_file_size (_tmp15_, cancellable, &_inner_error_);
		_tmp17_ = _tmp16_;
		_g_object_unref0 (_tmp15_);
		_tmp18_ = _tmp17_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			return 0ULL;
		}
		total_bytes = total_bytes + _tmp18_;
	}
	result = total_bytes;
	_g_object_unref0 (info);
	_g_object_unref0 (enumerator);
	return result;
}


void delete_all_files (GFile* dir, GeeSet* exceptions, GCancellable* cancellable, GError** error) {
	GFileType _tmp0_;
	GFileType type;
	GFileEnumerator* _tmp7_ = NULL;
	GFileEnumerator* enumerator;
	GFileInfo* info;
	GError * _inner_error_ = NULL;
	g_return_if_fail (G_IS_FILE (dir));
	g_return_if_fail ((exceptions == NULL) || GEE_IS_SET (exceptions));
	g_return_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable));
	_tmp0_ = g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
	type = _tmp0_;
	if (type != G_FILE_TYPE_DIRECTORY) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		GError* _tmp5_ = NULL;
		GError* _tmp6_;
		_tmp1_ = g_file_get_path (dir);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_strdup_printf ("%s is not a directory", _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_DIRECTORY, _tmp4_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		_g_free0 (_tmp2_);
		_inner_error_ = _tmp6_;
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp7_ = g_file_enumerate_children (dir, "standard::name,standard::type", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error_);
	enumerator = _tmp7_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	info = NULL;
	while (TRUE) {
		GFileInfo* _tmp8_ = NULL;
		GFileInfo* _tmp9_;
		GFileType _tmp10_;
		gboolean _tmp11_ = FALSE;
		const gchar* _tmp14_ = NULL;
		GFile* _tmp15_ = NULL;
		GFile* file;
		_tmp8_ = g_file_enumerator_next_file (enumerator, cancellable, &_inner_error_);
		_tmp9_ = _tmp8_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			return;
		}
		_g_object_unref0 (info);
		info = _tmp9_;
		if (!(info != NULL)) {
			break;
		}
		_tmp10_ = g_file_info_get_file_type (info);
		if (_tmp10_ != G_FILE_TYPE_REGULAR) {
			continue;
		}
		if (exceptions != NULL) {
			const gchar* _tmp12_ = NULL;
			gboolean _tmp13_;
			_tmp12_ = g_file_info_get_name (info);
			_tmp13_ = gee_collection_contains (GEE_COLLECTION (exceptions), _tmp12_);
			_tmp11_ = _tmp13_;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			continue;
		}
		_tmp14_ = g_file_info_get_name (info);
		_tmp15_ = g_file_get_child (dir, _tmp14_);
		file = _tmp15_;
		g_file_delete (file, cancellable, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch3_g_error;
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError * err;
			gchar* _tmp16_ = NULL;
			gchar* _tmp17_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp16_ = g_file_get_path (file);
			_tmp17_ = _tmp16_;
			g_warning ("file.vala:143: Unable to delete file %s: %s", _tmp17_, err->message);
			_g_free0 (_tmp17_);
			_g_error_free0 (err);
		}
		__finally3:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (file);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			return;
		}
		_g_object_unref0 (file);
	}
	_g_object_unref0 (info);
	_g_object_unref0 (enumerator);
}


time_t query_file_modified (GFile* file, GError** error) {
	time_t result = 0;
	GFileInfo* _tmp0_ = NULL;
	GFileInfo* info;
	GTimeVal timestamp = {0};
	GTimeVal _tmp1_ = {0};
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (G_IS_FILE (file), 0);
	_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
	info = _tmp0_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return 0;
	}
	g_get_current_time (&timestamp);
	g_file_info_get_modification_time (info, &_tmp1_);
	timestamp = _tmp1_;
	result = (time_t) timestamp.tv_sec;
	_g_object_unref0 (info);
	return result;
}


gboolean query_is_directory (GFile* file) {
	gboolean result = FALSE;
	GFileType _tmp0_;
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	_tmp0_ = g_file_query_file_type (file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
	result = _tmp0_ == G_FILE_TYPE_DIRECTORY;
	return result;
}


gboolean query_is_directory_empty (GFile* dir, GError** error) {
	gboolean result = FALSE;
	GFileType _tmp0_;
	GFileEnumerator* _tmp1_ = NULL;
	GFileEnumerator* enumerator;
	GFileInfo* _tmp2_ = NULL;
	GFileInfo* _tmp3_;
	GFileInfo* _tmp4_;
	gboolean _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
	_tmp0_ = g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
	if (_tmp0_ != G_FILE_TYPE_DIRECTORY) {
		result = FALSE;
		return result;
	}
	_tmp1_ = g_file_enumerate_children (dir, "standard::name", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
	enumerator = _tmp1_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	if (enumerator == NULL) {
		result = FALSE;
		_g_object_unref0 (enumerator);
		return result;
	}
	_tmp2_ = g_file_enumerator_next_file (enumerator, NULL, &_inner_error_);
	_tmp3_ = _tmp2_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (enumerator);
		return FALSE;
	}
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_ == NULL;
	_g_object_unref0 (_tmp4_);
	result = _tmp5_;
	_g_object_unref0 (enumerator);
	return result;
}


gchar* get_display_pathname (GFile* file) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* path;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* home;
	gboolean _tmp4_;
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	_tmp0_ = g_file_get_parse_name (file);
	path = _tmp0_;
	_tmp1_ = g_get_home_dir ();
	_tmp2_ = g_strdup (_tmp1_);
	home = _tmp2_;
	if (g_strcmp0 (path, home) == 0) {
		gchar* _tmp3_;
		_tmp3_ = g_strdup ("~");
		result = _tmp3_;
		_g_free0 (home);
		_g_free0 (path);
		return result;
	}
	_tmp4_ = g_str_has_prefix (path, home);
	if (_tmp4_) {
		gint _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		_tmp5_ = strlen (home);
		_tmp6_ = string_substring (path, (glong) _tmp5_, (glong) (-1));
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strdup_printf ("~%s", _tmp7_);
		_tmp9_ = _tmp8_;
		_g_free0 (_tmp7_);
		result = _tmp9_;
		_g_free0 (home);
		_g_free0 (path);
		return result;
	}
	result = path;
	_g_free0 (home);
	return result;
}


gchar* strip_pretty_path (const gchar* path) {
	gchar* result = NULL;
	gboolean _tmp0_;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = g_str_has_prefix (path, "~");
	if (!_tmp0_) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (path);
		result = _tmp1_;
		return result;
	}
	_tmp2_ = g_get_home_dir ();
	_tmp3_ = string_substring (path, (glong) 1, (glong) (-1));
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	result = _tmp6_;
	return result;
}


gchar* get_file_info_id (GFileInfo* info) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (G_IS_FILE_INFO (info), NULL);
	_tmp0_ = g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_ID_FILE);
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


void skip_uint64 (GInputStream* input, guint64 skip_amount, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (G_IS_INPUT_STREAM (input));
	while (TRUE) {
		if (!(skip_amount > 0)) {
			break;
		}
		if (skip_amount >= G_MAXSSIZE) {
			g_input_stream_skip (input, (gsize) G_MAXSSIZE, NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				return;
			}
			skip_amount = skip_amount - ((guint64) G_MAXSSIZE);
		} else {
			g_input_stream_skip (input, (gsize) skip_amount, NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				return;
			}
			skip_amount = (guint64) 0;
		}
	}
}



