/* Photo.c generated by valac 0.11.7, the Vala compiler
 * generated from Photo.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable*/
/* (i.e. a mimic).*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_BACKING_PHOTO_STATE (backing_photo_state_get_type ())

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_ORIENTATION (orientation_get_type ())
typedef struct _BackingPhotoState BackingPhotoState;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_KEY_VALUE_MAP (key_value_map_get_type ())
#define KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY_VALUE_MAP, KeyValueMap))
#define KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY_VALUE_MAP, KeyValueMapClass))
#define IS_KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY_VALUE_MAP))
#define IS_KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY_VALUE_MAP))
#define KEY_VALUE_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY_VALUE_MAP, KeyValueMapClass))

typedef struct _KeyValueMap KeyValueMap;
typedef struct _KeyValueMapClass KeyValueMapClass;

#define TYPE_RATING (rating_get_type ())

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _PhotoRow PhotoRow;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;

#define TYPE_ROTATION (rotation_get_type ())

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReaders PhotoBackingReaders;

#define TYPE_PIXEL_TRANSFORMER (pixel_transformer_get_type ())
#define PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformer))
#define PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))
#define IS_PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMER))
#define IS_PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMER))
#define PIXEL_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))

typedef struct _PixelTransformer PixelTransformer;
typedef struct _PixelTransformerClass PixelTransformerClass;

#define TYPE_PIXEL_TRANSFORMATION_BUNDLE (pixel_transformation_bundle_get_type ())
#define PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundle))
#define PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))
#define IS_PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define IS_PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define PIXEL_TRANSFORMATION_BUNDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))

typedef struct _PixelTransformationBundle PixelTransformationBundle;
typedef struct _PixelTransformationBundleClass PixelTransformationBundleClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
typedef struct _BackingPhotoRow BackingPhotoRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _backing_photo_row_free0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;

#define TYPE_PHOTO_FILE_FORMAT_FLAGS (photo_file_format_flags_get_type ())

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;

#define TYPE_IMPORT_RESULT (import_result_get_type ())

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))

#define TYPE_PIXEL_TRANSFORMATION_TYPE (pixel_transformation_type_get_type ())

#define TYPE_PIXEL_TRANSFORMATION (pixel_transformation_get_type ())
#define PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformation))
#define PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))
#define IS_PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION))
#define IS_PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION))
#define PIXEL_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))

typedef struct _PixelTransformation PixelTransformation;
typedef struct _PixelTransformationClass PixelTransformationClass;
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define TYPE_REDEYE_INSTANCE (redeye_instance_get_type ())
typedef struct _RedeyeInstance RedeyeInstance;

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;

#define TYPE_CONFIG (config_get_type ())
#define CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG, Config))
#define CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG, ConfigClass))
#define IS_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG))
#define IS_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG))
#define CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG, ConfigClass))

typedef struct _Config Config;
typedef struct _ConfigClass ConfigClass;
#define _config_unref0(var) ((var == NULL) ? NULL : (var = (config_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;
#define _backing_photo_state_free0(var) ((var == NULL) ? NULL : (var = (backing_photo_state_free (var), NULL)))

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;

#define TYPE_MIMIC_MANAGER (mimic_manager_get_type ())
#define MIMIC_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MIMIC_MANAGER, MimicManager))
#define MIMIC_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MIMIC_MANAGER, MimicManagerClass))
#define IS_MIMIC_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MIMIC_MANAGER))
#define IS_MIMIC_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MIMIC_MANAGER))
#define MIMIC_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MIMIC_MANAGER, MimicManagerClass))

typedef struct _MimicManager MimicManager;
typedef struct _MimicManagerClass MimicManagerClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _photo_row_free0(var) ((var == NULL) ? NULL : (var = (photo_row_free (var), NULL)))

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER
} BackingFetchMode;

struct _ImportID {
	gint64 id;
};

typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;

struct _PhotoID {
	gint64 id;
};

typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

struct _BackingPhotoState {
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _EventID {
	gint64 id;
};

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	PhotoID photo_id;
	BackingPhotoState master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
};

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, int* result_length1);
	gchar* (*get_title) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	Rating (*get_rating) (MediaSource* self);
	void (*set_rating) (MediaSource* self, Rating rating);
	void (*increase_rating) (MediaSource* self);
	void (*decrease_rating) (MediaSource* self);
	void (*get_dimensions) (MediaSource* self, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

struct _PhotoBackingReaders {
	PhotoFileReader* master;
	PhotoFileReader* mimic;
	PhotoFileReader* editable;
};

struct _PhotoPrivate {
	PhotoRow row;
	GStaticRecMutex __lock_row;
	BackingPhotoState editable;
	PhotoBackingReaders readers;
	GStaticRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	BackingPhotoState* backing_photo_state;
};

typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

struct _BackingPhotoRow {
	BackingPhotoID id;
	time_t time_created;
	BackingPhotoState state;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
typedef enum  {
	PHOTO_FILE_FORMAT_FLAGS_NONE = 0x00000000,
	PHOTO_FILE_FORMAT_FLAGS_MIMIC_RECOMMENDED = 0x00000001
} PhotoFileFormatFlags;

typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
};

typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR
} ImportResult;

struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoState backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

typedef enum  {
	PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION,
	PIXEL_TRANSFORMATION_TYPE_SHADOWS,
	PIXEL_TRANSFORMATION_TYPE_TEMPERATURE,
	PIXEL_TRANSFORMATION_TYPE_TINT,
	PIXEL_TRANSFORMATION_TYPE_SATURATION,
	PIXEL_TRANSFORMATION_TYPE_EXPOSURE
} PixelTransformationType;

struct _RedeyeInstance {
	GdkPoint center;
	gint radius;
};

typedef void (*OneShotCallback) (void* user_data);
struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
};

typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE
} LibraryPhotoSourceCollectionState;

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, void* user_data);
struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;


static gpointer photo_import_params_parent_class = NULL;
static gpointer photo_transformation_state_parent_class = NULL;
static gpointer photo_parent_class = NULL;
extern gboolean commandline_options_no_mimicked_images;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer library_photo_source_collection_parent_class = NULL;
static gpointer library_photo_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
extern MimicManager* library_photo_mimic_manager;
MimicManager* library_photo_mimic_manager = NULL;
extern TagSourceCollection* tag_global;
static FlaggableIface* library_photo_flaggable_parent_iface = NULL;
static MonitorableIface* library_photo_monitorable_parent_iface = NULL;

GType backing_fetch_mode_get_type (void) G_GNUC_CONST;
gpointer photo_import_params_ref (gpointer instance);
void photo_import_params_unref (gpointer instance);
GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_import_params (GValue* value, gpointer v_object);
void value_take_photo_import_params (GValue* value, gpointer v_object);
gpointer value_get_photo_import_params (const GValue* value);
GType photo_import_params_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST;
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_thumbnails (GValue* value, gpointer v_object);
void value_take_thumbnails (GValue* value, gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
GType photo_row_get_type (void) G_GNUC_CONST;
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType backing_photo_state_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType orientation_get_type (void) G_GNUC_CONST;
BackingPhotoState* backing_photo_state_dup (const BackingPhotoState* self);
void backing_photo_state_free (BackingPhotoState* self);
void backing_photo_state_copy (const BackingPhotoState* self, BackingPhotoState* dest);
void backing_photo_state_destroy (BackingPhotoState* self);
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer key_value_map_ref (gpointer instance);
void key_value_map_unref (gpointer instance);
GParamSpec* param_spec_key_value_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_key_value_map (GValue* value, gpointer v_object);
void value_take_key_value_map (GValue* value, gpointer v_object);
gpointer value_get_key_value_map (const GValue* value);
GType key_value_map_get_type (void) G_GNUC_CONST;
GType rating_get_type (void) G_GNUC_CONST;
GType backing_photo_id_get_type (void) G_GNUC_CONST;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
PhotoRow* photo_row_dup (const PhotoRow* self);
void photo_row_free (PhotoRow* self);
void photo_row_copy (const PhotoRow* self, PhotoRow* dest);
void photo_row_destroy (PhotoRow* self);
enum  {
	PHOTO_IMPORT_PARAMS_DUMMY_PROPERTY
};
void photo_row_init (PhotoRow *self);
PhotoImportParams* photo_import_params_new (GFile* file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id);
PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams* obj);
GType photo_transformation_state_get_type (void) G_GNUC_CONST;
#define PHOTO_TRANSFORMATION_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStatePrivate))
enum  {
	PHOTO_TRANSFORMATION_STATE_DUMMY_PROPERTY
};
PhotoTransformationState* photo_transformation_state_construct (GType object_type);
gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
void photo_transformation_state_broken (PhotoTransformationState* self);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject* obj);
gboolean rating_can_increase (Rating self);
gboolean rating_can_decrease (Rating self);
gboolean rating_is_valid (Rating self);
Rating rating_increase (Rating self);
Rating rating_decrease (Rating self);
gint rating_serialize (Rating self);
Rating rating_unserialize (gint value);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_snapshot (GValue* value, gpointer v_object);
void value_take_source_snapshot (GValue* value, gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_backing_file_state (GValue* value, gpointer v_object);
void value_take_backing_file_state (GValue* value, gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType photo_source_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType rotation_get_type (void) G_GNUC_CONST;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_adapter (GValue* value, gpointer v_object);
void value_take_photo_file_adapter (GValue* value, gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST;
GType photo_file_reader_get_type (void) G_GNUC_CONST;
static PhotoBackingReaders* photo_backing_readers_dup (const PhotoBackingReaders* self);
static void photo_backing_readers_free (PhotoBackingReaders* self);
static void photo_backing_readers_copy (const PhotoBackingReaders* self, PhotoBackingReaders* dest);
static void photo_backing_readers_destroy (PhotoBackingReaders* self);
gpointer pixel_transformer_ref (gpointer instance);
void pixel_transformer_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformer (GValue* value, gpointer v_object);
void value_take_pixel_transformer (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformer (const GValue* value);
GType pixel_transformer_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_bundle_ref (gpointer instance);
void pixel_transformation_bundle_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation_bundle (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation_bundle (GValue* value, gpointer v_object);
void value_take_pixel_transformation_bundle (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation_bundle (const GValue* value);
GType pixel_transformation_bundle_get_type (void) G_GNUC_CONST;
gpointer one_shot_scheduler_ref (gpointer instance);
void one_shot_scheduler_unref (gpointer instance);
GParamSpec* param_spec_one_shot_scheduler (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_one_shot_scheduler (GValue* value, gpointer v_object);
void value_take_one_shot_scheduler (GValue* value, gpointer v_object);
gpointer value_get_one_shot_scheduler (const GValue* value);
GType one_shot_scheduler_get_type (void) G_GNUC_CONST;
#define PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO, PhotoPrivate))
enum  {
	PHOTO_DUMMY_PROPERTY
};
GType photo_exception_get_type (void) G_GNUC_CONST;
gboolean photo_exception_prohibits (PhotoException self, PhotoException exception);
gboolean photo_exception_allows (PhotoException self, PhotoException exception);
#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 8
Photo* photo_construct (GType object_type, PhotoRow* row);
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) (-1))
PhotoSource* photo_source_construct (GType object_type, gint64 object_id);
gchar* media_source_prep_title (const gchar* title);
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self, const gchar* filepath);
gchar* string_sliced_at_last_char (const gchar* haystack, gunichar ch, gint start_index);
gchar* string_sliced_at (const gchar* str, gint index);
gboolean is_string_empty (const gchar* s);
#define BACKING_PHOTO_ID_INVALID ((gint64) (-1))
GType backing_photo_row_get_type (void) G_GNUC_CONST;
BackingPhotoRow* backing_photo_row_dup (const BackingPhotoRow* self);
void backing_photo_row_free (BackingPhotoRow* self);
void backing_photo_row_copy (const BackingPhotoRow* self, BackingPhotoRow* dest);
void backing_photo_row_destroy (BackingPhotoRow* self);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType backing_photo_table_get_type (void) G_GNUC_CONST;
BackingPhotoTable* backing_photo_table_get_instance (void);
GQuark database_error_quark (void);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self, BackingPhotoID* id, GError** error);
gchar* data_object_to_string (DataObject* self);
void backing_photo_table_remove (BackingPhotoTable* self, BackingPhotoID* backing_id, GError** error);
GType photo_table_get_type (void) G_GNUC_CONST;
PhotoTable* photo_table_get_instance (void);
void photo_table_detach_editable (PhotoTable* self, PhotoRow* row, GError** error);
static void photo_internal_remove_all_transformations (Photo* self, gboolean notify);
void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
void photo_notify_baseline_replaced (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
gboolean photo_would_use_mimic (Photo* self);
GType photo_file_format_flags_get_type (void) G_GNUC_CONST;
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value, gpointer v_object);
void value_take_photo_file_format_properties (GValue* value, gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST;
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
PhotoFileFormatFlags photo_file_format_properties_get_flags (PhotoFileFormatProperties* self);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1);
BackingFileState* backing_file_state_new_from_photo_state (BackingPhotoState* photo_state, const gchar* md5);
BackingFileState* backing_file_state_construct_from_photo_state (GType object_type, BackingPhotoState* photo_state, const gchar* md5);
static void _vala_array_add164 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
gboolean photo_has_editable (Photo* self);
static void _vala_array_add165 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
const gchar* backing_fetch_mode_to_string (BackingFetchMode self);
void photo_set_mimic_reader (Photo* self, PhotoFileReader* mimic);
PhotoFileReader* photo_get_editable_reader (Photo* self);
gboolean photo_is_mimicked (Photo* self);
gboolean photo_does_master_exist (Photo* self);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gboolean photo_does_editable_exist (Photo* self);
gboolean photo_is_master_baseline (Photo* self);
gboolean photo_is_master_source (Photo* self);
gboolean photo_is_editable_baseline (Photo* self);
gboolean photo_is_editable_source (Photo* self);
void photo_get_master_photo_state (Photo* self, BackingPhotoState* result);
BackingPhotoState* photo_get_editable_photo_state (Photo* self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
GType jpeg_quality_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params);
PhotoFileFormat photo_file_format_get_system_default_format (void);
PhotoFileFormat photo_get_master_file_format (Photo* self);
PhotoFileFormat photo_get_best_export_file_format (Photo* self);
gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params);
GFile* media_source_get_master_file (MediaSource* self);
gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult photo_prepare_for_import (PhotoImportParams* params);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
gboolean photo_is_file_image (GFile* file);
gboolean photo_file_format_is_file_supported (GFile* file);
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file, PhotoFileSnifferOptions options);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type, GFile* file, PhotoFileSnifferOptions options);
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value, gpointer v_object);
void value_take_photo_file_interrogator (GValue* value, gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void) G_GNUC_CONST;
void photo_file_interrogator_interrogate (PhotoFileInterrogator* self, GError** error);
gpointer detected_photo_information_ref (gpointer instance);
void detected_photo_information_unref (gpointer instance);
GParamSpec* param_spec_detected_photo_information (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_detected_photo_information (GValue* value, gpointer v_object);
void value_take_detected_photo_information (GValue* value, gpointer v_object);
gpointer value_get_detected_photo_information (const GValue* value);
GType detected_photo_information_get_type (void) G_GNUC_CONST;
DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
gchar* media_metadata_get_title (MediaMetadata* self);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func);
Rating photo_metadata_get_rating (PhotoMetadata* self);
#define PHOTO_ID_INVALID ((gint64) (-1))
void photo_id_init (PhotoID *self, gint64 id);
#define EVENT_ID_INVALID ((gint64) (-1))
void event_id_init (EventID *self, gint64 id);
void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails, PhotoFileReader* reader, Orientation orientation, Dimensions* original_dim, GError** error);
ImportResult import_result_convert_error (GError* err, ImportResult default_result);
void photo_create_pre_import (PhotoImportParams* params);
void dimensions_init (Dimensions *self, gint width, gint height);
gboolean photo_query_backing_photo_state (Photo* self, GFile* file, PhotoFileSnifferOptions options, BackingPhotoState* state, DetectedPhotoInformation** detected, GError** error);
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error);
static void _vala_array_add166 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add167 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add168 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add169 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add170 (gchar*** array, int* length, int* size, gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error);
void photo_table_reimport (PhotoTable* self, PhotoRow* row, GError** error);
static void _vala_array_add171 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add172 (gchar*** array, int* length, int* size, gchar* value);
void data_object_notify_altered (DataObject* self, Alteration* alteration);
Alteration* alteration_new_from_array (gchar** array, int array_length1);
Alteration* alteration_construct_from_array (GType object_type, gchar** array, int array_length1);
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error);
GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoState* backing_state, PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoState* backing_state, PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error);
void photo_get_editable_id (Photo* self, BackingPhotoID* result);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
void backing_photo_table_update (BackingPhotoTable* self, BackingPhotoID* id, BackingPhotoState* state, GError** error);
gboolean photo_set_orientation (Photo* self, Orientation orientation);
void media_source_set_title (MediaSource* self, const gchar* title);
void media_source_set_rating (MediaSource* self, Rating rating);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type, const gchar* list);
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
void photo_get_photo_id (Photo* self, PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
gchar* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
void photo_set_master_timestamp (Photo* self, GFileInfo* info);
void photo_table_update_timestamp (PhotoTable* self, PhotoID* photo_id, time_t timestamp, GError** error);
void app_window_database_error (GError* err);
Alteration* alteration_new (const gchar* subject, const gchar* detail);
Alteration* alteration_construct (GType object_type, const gchar* subject, const gchar* detail);
void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, GError** error);
void photo_update_many_editable_timestamps (GeeMap* map, GError** error);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_get_file_format (Photo* self);
gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1);
void disassemble_filename (const gchar* basename, gchar** name, gchar** ext);
gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format);
PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format, int* result_length1);
gint64 photo_get_photo_key (DataSource* source);
GType library_photo_get_type (void) G_GNUC_CONST;
static GFile* photo_real_get_file (MediaSource* base);
void photo_set_master_file (Photo* self, GFile* file);
void photo_table_set_filepath (PhotoTable* self, PhotoID* photo_id, const gchar* filepath, GError** error);
void media_source_notify_master_replaced (MediaSource* self, GFile* old_file, GFile* new_file);
static void _vala_array_add173 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add174 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add175 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add176 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_editable_file (Photo* self, GFile* file);
void backing_photo_table_set_filepath (BackingPhotoTable* self, BackingPhotoID* id, const gchar* filepath, GError** error);
static void _vala_array_add177 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add178 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add179 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_many_editable_file (GeeMap* map, GError** error);
GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
GFile* photo_get_source_file (Photo* self);
gboolean photo_file_format_can_write (PhotoFileFormat self);
static time_t photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base, EventID* result);
gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base, ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self, Alteration* other);
guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration);
gboolean photo_table_replace_flags (PhotoTable* self, PhotoID* photo_id, guint64 flags);
gboolean photo_is_flag_set (Photo* self, guint64 mask);
gboolean media_source_internal_is_flag_set (guint64 flags, guint64 selector);
guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_add_flags (guint64 flags, guint64 selector);
guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_remove_flags (guint64 flags, guint64 selector);
guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration);
void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error);
guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
gboolean photo_is_master_metadata_dirty (Photo* self);
void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self, PhotoID* photo_id, gboolean dirty, GError** error);
static Rating photo_real_get_rating (MediaSource* base);
static void photo_real_set_rating (MediaSource* base, Rating rating);
gboolean photo_table_set_rating (PhotoTable* self, PhotoID* photo_id, Rating rating);
static void photo_real_increase_rating (MediaSource* base);
static void photo_real_decrease_rating (MediaSource* base);
static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks);
void photo_table_update_backlinks (PhotoTable* self, PhotoID* photo_id, const gchar* backlinks, GError** error);
static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self, PhotoID* photo_id, EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base, DataSource* source);
gboolean data_source_equals (DataSource* self, DataSource* source);
static void photo_file_exif_updated (Photo* self);
GFile* media_source_get_file (MediaSource* self);
gboolean photo_table_master_exif_updated (PhotoTable* self, PhotoID* photoID, gint64 filesize, glong timestamp, const gchar* md5, const gchar* exif_md5, const gchar* thumbnail_md5, PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
guint64 photo_get_editable_filesize (Photo* self);
static time_t photo_real_get_exposure_time (MediaSource* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static void photo_real_set_title (MediaSource* base, const gchar* title);
gboolean photo_table_set_title (PhotoTable* self, PhotoID* photo_id, const gchar* new_title);
void photo_set_import_id (Photo* self, ImportID* import_id);
void photo_table_set_import_id (PhotoTable* self, PhotoID* photo_id, ImportID* import_id, GError** error);
void photo_set_title_persistent (Photo* self, const gchar* title, GError** error);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self, GError** error);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST;
GQuark photo_format_error_quark (void);
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self, GError** error);
void library_monitor_blacklist_file (GFile* file, const gchar* reason);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error);
void library_monitor_unblacklist_file (GFile* file);
void photo_set_exposure_time (Photo* self, time_t time);
gboolean photo_table_set_exposure_time (PhotoTable* self, PhotoID* photo_id, time_t time);
void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
static void photo_real_get_dimensions (MediaSource* base, Dimensions* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
gboolean photo_get_crop (Photo* self, Box* crop);
void box_get_dimensions (Box *self, Dimensions* result);
void photo_get_original_dimensions (Photo* self, Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_new (void);
PixelTransformationBundle* pixel_transformation_bundle_construct (GType object_type);
static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name);
void pixel_transformation_bundle_set_to_identity (PixelTransformationBundle* self);
void pixel_transformation_bundle_load (PixelTransformationBundle* self, KeyValueMap* store);
PixelTransformer* pixel_transformation_bundle_generate_transformer (PixelTransformationBundle* self);
PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_copy (PixelTransformationBundle* self);
PixelTransformer* photo_get_pixel_transformer (Photo* self);
PixelTransformer* pixel_transformer_copy (PixelTransformer* self);
gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self, const gchar* name);
GType pixel_transformation_type_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_ref (gpointer instance);
void pixel_transformation_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation (GValue* value, gpointer v_object);
void value_take_pixel_transformation (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation (const GValue* value);
GType pixel_transformation_get_type (void) G_GNUC_CONST;
PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type);
PixelTransformation* pixel_transformation_bundle_get_transformation (PixelTransformationBundle* self, PixelTransformationType type);
void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments);
gboolean pixel_transformation_bundle_is_identity (PixelTransformationBundle* self);
static gboolean photo_remove_transformation (Photo* self, const gchar* name);
KeyValueMap* pixel_transformation_bundle_save (PixelTransformationBundle* self, const gchar* group);
GeeIterable* pixel_transformation_bundle_get_transformations (PixelTransformationBundle* self);
void pixel_transformer_replace_transformation (PixelTransformer* self, PixelTransformation* old_trans, PixelTransformation* new_trans);
PixelTransformationType pixel_transformation_get_transformation_type (PixelTransformation* self);
static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error);
PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error);
gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error);
void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error);
gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error);
void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error);
void photo_get_raw_dimensions (Photo* self, Dimensions* result);
gboolean photo_has_transformations (Photo* self);
gboolean photo_only_metadata_changed (Photo* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
gboolean photo_has_alterations (Photo* self);
gchar* media_source_get_title (MediaSource* self);
PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
gboolean photo_table_set_transformation_state (PhotoTable* self, PhotoID* photo_id, Orientation orientation, GeeHashMap* transformations);
void photo_remove_all_transformations (Photo* self);
gboolean photo_table_remove_all_transformations (PhotoTable* self, PhotoID* photo_id);
gboolean photo_table_set_orientation (PhotoTable* self, PhotoID* photo_id, Orientation orientation);
Orientation photo_get_original_orientation (Photo* self);
Orientation photo_get_orientation (Photo* self);
void photo_rotate (Photo* self, Rotation rotation);
static void photo_real_rotate (Photo* self, Rotation rotation);
Orientation orientation_perform (Orientation self, Rotation rotation);
KeyValueMap* key_value_map_copy (KeyValueMap* self);
gchar* key_value_map_get_group (KeyValueMap* self);
gboolean photo_table_set_transformation (PhotoTable* self, PhotoID* photo_id, KeyValueMap* map);
gboolean photo_table_remove_transformation (PhotoTable* self, PhotoID* photo_id, const gchar* object);
gboolean photo_has_crop (Photo* self);
static gboolean photo_get_raw_crop (Photo* self, Box* crop);
gint key_value_map_get_int (KeyValueMap* self, const gchar* key, gint def);
void box_init (Box *self, gint left, gint top, gint right, gint bottom);
static void photo_set_raw_crop (Photo* self, Box* crop);
KeyValueMap* key_value_map_new (const gchar* group);
KeyValueMap* key_value_map_construct (GType object_type, const gchar* group);
void key_value_map_set_int (KeyValueMap* self, const gchar* key, gint value);
GType redeye_instance_get_type (void) G_GNUC_CONST;
RedeyeInstance* redeye_instance_dup (const RedeyeInstance* self);
void redeye_instance_free (RedeyeInstance* self);
static RedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1);
void key_value_map_get_point (KeyValueMap* self, const gchar* key, GdkPoint* def, GdkPoint* result);
gboolean photo_has_redeye_transformations (Photo* self);
static void photo_add_raw_redeye_instance (Photo* self, RedeyeInstance* redeye);
void key_value_map_set_point (KeyValueMap* self, const gchar* key, GdkPoint* point);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
gboolean scaling_is_unscaled (Scaling *self);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void box_get_scaled (Box *self, Dimensions* scaled, Box* result);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self, GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error);
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
void coord_scaled_in_space (gint x, gint y, Dimensions* original, Dimensions* scaled, GdkPoint* result);
gint radius_scaled_in_space (gint radius, Dimensions* original, Dimensions* scaled);
static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, RedeyeInstance* inst);
void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result);
void pixel_transformer_transform_pixbuf (PixelTransformer* self, GdkPixbuf* pixbuf, GCancellable* cancellable);
gboolean photo_has_user_generated_metadata (Photo* self);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self, GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, GError** error);
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
time_t media_source_get_exposure_time (MediaSource* self);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option);
void media_source_get_dimensions (MediaSource* self, Dimensions* result);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_VERSION _VERSION
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format);
void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, GError** error);
GType photo_file_writer_get_type (void) G_GNUC_CONST;
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
const gchar* photo_file_format_to_string (PhotoFileFormat self);
void photo_file_writer_write (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error);
void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error);
gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self, const gchar* ext);
gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
GFile* generate_unique_file (GFile* dir, const gchar* basename, gboolean* collision, GError** error);
static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, GError** error);
gpointer config_ref (gpointer instance);
void config_unref (gpointer instance);
GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_config (GValue* value, gpointer v_object);
void value_take_config (GValue* value, gpointer v_object);
gpointer value_get_config (const GValue* value);
GType config_get_type (void) G_GNUC_CONST;
Config* config_get_instance (void);
gchar* config_get_external_raw_app (Config* self);
gchar* config_get_external_photo_app (Config* self);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
void photo_open_master_with_external_editor (Photo* self, GError** error);
void photo_open_with_external_editor (Photo* self, GError** error);
static void photo_halt_monitoring_editable (Photo* self);
void scaling_for_original (Scaling* result);
static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error);
static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error);
void photo_revert_to_master (Photo* self);
static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error);
static void photo_update_editable_attributes (Photo* self, GError** error);
void photo_reimport_editable (Photo* self, GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, gint64 filesize, GError** error);
void backing_photo_table_add (BackingPhotoTable* self, BackingPhotoState* state, BackingPhotoRow* result, GError** error);
void photo_table_attach_editable (PhotoTable* self, PhotoRow* row, BackingPhotoID* editable_id, GError** error);
static void _vala_array_add180 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add181 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add182 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add183 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add184 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add185 (gchar*** array, int* length, int* size, gchar* value);
void backing_photo_id_init (BackingPhotoID *self, gint64 id);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
OneShotScheduler* one_shot_scheduler_new (const gchar* name, OneShotCallback callback, void* callback_target);
OneShotScheduler* one_shot_scheduler_construct (GType object_type, const gchar* name, OneShotCallback callback, void* callback_target);
void one_shot_scheduler_after_timeout (OneShotScheduler* self, guint msec, gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
void photo_get_master_dimensions (Photo* self, Dimensions* result);
void photo_set_crop (Photo* self, Box* crop);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void photo_add_redeye_instance (Photo* self, RedeyeInstance* inst_unscaled);
void redeye_instance_to_bounds_rect (RedeyeInstance* inst, GdkRectangle* result);
void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result);
void redeye_instance_from_bounds_rect (GdkRectangle* rect, RedeyeInstance* result);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y);
void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
PixelTransformationBundle* auto_enhance_create_auto_enhance_adjustments (GdkPixbuf* pixbuf);
gboolean photo_enhance (Photo* self);
void photo_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
void photo_baseline_replaced (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
void photo_master_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
void photo_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata);
void photo_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata);
void photo_source_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata);
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplPrivate))
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_DUMMY_PROPERTY
};
PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_IMPL_DUMMY_PROPERTY
};
static gchar** _vala_array_dup31 (gchar** self, int length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_DUMMY_PROPERTY
};
PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj);
static void photo_finalize (GObject* obj);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_transaction_controller (GValue* value, gpointer v_object);
void value_take_transaction_controller (GValue* value, gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionPrivate))
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_DUMMY_PROPERTY
};
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST;
gint int64_compare (void* a, void* b);
static gint _int64_compare_gcompare_func (gconstpointer a, gconstpointer b);
static gint64* _int64_dup (gint64* self);
gboolean int64_equal (void* a, void* b);
static gboolean _int64_equal_gequal_func (gconstpointer a, gconstpointer b);
LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type, MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_new (Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_construct (GType object_type, Workers* workers, GCancellable* cancellable);
GType photo_monitor_get_type (void) G_GNUC_CONST;
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self);
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items);
gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources);
GType tag_get_type (void) G_GNUC_CONST;
GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
gchar* tag_prep_tag_name (const gchar* name);
Tag* tag_for_name (const gchar* name);
void library_photo_clear_import_keywords (LibraryPhoto* self);
void tag_attach_many (Tag* self, GeeCollection* sources);
void media_source_collection_postprocess_imported_media (MediaSourceCollection* self, GeeCollection* media);
void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id);
LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id);
MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self, gint64 numeric_id);
gint64 parse_int64 (const gchar* str, gint num_base);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self, EventID* event_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key);
LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable);
gboolean backing_photo_state_matches_file_info (BackingPhotoState *self, GFileInfo* info);
void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize);
LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self, const gchar* md5);
LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self, GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type, MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
void library_photo_source_collection_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
void library_photo_source_collection_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection* obj);
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO, LibraryPhotoPrivate))
enum  {
	LIBRARY_PHOTO_DUMMY_PROPERTY
};
GType mimic_manager_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
static LibraryPhoto* library_photo_new (PhotoRow* row, GeeCollection* import_keywords);
static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row, GeeCollection* import_keywords);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const gchar* dehydrated);
static void library_photo_upgrade_rating_flags (LibraryPhoto* self, guint64 flags);
void library_photo_init (ProgressMonitor monitor, void* monitor_target);
GFile* app_dirs_get_data_subdir (const gchar* name, const gchar* subname);
MimicManager* mimic_manager_new (SourceCollection* sources, GFile* impersonators_dir);
MimicManager* mimic_manager_construct (GType object_type, SourceCollection* sources, GFile* impersonators_dir);
GeeArrayList* photo_table_get_all (PhotoTable* self);
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self, GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self, GeeCollection* sources);
void library_photo_terminate (void);
ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo);
void photo_table_add (PhotoTable* self, PhotoRow* photo_row, PhotoID* result);
gboolean photo_id_is_invalid (PhotoID *self);
void library_photo_import_failed (LibraryPhoto* photo);
void photo_table_remove (PhotoTable* self, PhotoID* photo_id, GError** error);
static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata);
void thumbnail_cache_import_from_source (ThumbnailSource* source, gboolean force, GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration);
gboolean alteration_has_subject (Alteration* self, const gchar* subject);
void one_shot_scheduler_at_priority_idle (OneShotScheduler* self, gint priority);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
static void library_photo_real_rotate (Photo* base, Rotation rotation);
void thumbnail_cache_rotate (ThumbnailSource* source, Rotation rotation, GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source, gint scale, GError** error);
LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error);
GFile* library_files_duplicate (GFile* src, GFileProgressCallback progress_callback, void* progress_callback_target, gboolean blacklist, GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self);
void photo_table_duplicate (PhotoTable* self, PhotoID* photo_id, const gchar* new_filename, BackingPhotoID* editable_id, PhotoID* result);
PhotoRow* photo_table_get_row (PhotoTable* self, PhotoID* photo_id);
void thumbnail_cache_duplicate (ThumbnailSource* src_source, ThumbnailSource* dest_source);
gboolean data_collection_add (DataCollection* self, DataObject* object);
GType event_source_get_type (void) G_GNUC_CONST;
GType event_get_type (void) G_GNUC_CONST;
Event* media_source_get_event (MediaSource* self);
void event_attach (Event* self, MediaSource* source);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self, MediaSource* source);
void tag_attach (Tag* self, MediaSource* source);
gboolean spin_event_loop (gint max);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error);
gboolean media_source_delete_original_file (MediaSource* self);
static void library_photo_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
Rating media_source_get_rating (MediaSource* self);
gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata);
static void library_photo_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

GType backing_fetch_mode_get_type (void) {
	static volatile gsize backing_fetch_mode_type_id__volatile = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {0, NULL, NULL}};
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
		g_once_init_leave (&backing_fetch_mode_type_id__volatile, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gpointer _thumbnails_ref0 (gpointer self) {
	return self ? thumbnails_ref (self) : NULL;
}


PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	Thumbnails* _tmp4_;
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	g_return_val_if_fail ((thumbnails == NULL) || IS_THUMBNAILS (thumbnails), NULL);
	self = (PhotoImportParams*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (file);
	_g_object_unref0 (self->file);
	self->file = _tmp0_;
	self->import_id = *import_id;
	self->sniffer_options = sniffer_options;
	_tmp1_ = g_strdup (exif_md5);
	_g_free0 (self->exif_md5);
	self->exif_md5 = _tmp1_;
	_tmp2_ = g_strdup (thumbnail_md5);
	_g_free0 (self->thumbnail_md5);
	self->thumbnail_md5 = _tmp2_;
	_tmp3_ = g_strdup (full_md5);
	_g_free0 (self->full_md5);
	self->full_md5 = _tmp3_;
	_tmp4_ = _thumbnails_ref0 (thumbnails);
	_thumbnails_unref0 (self->thumbnails);
	self->thumbnails = _tmp4_;
	return self;
}


PhotoImportParams* photo_import_params_new (GFile* file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
}


PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	self = (PhotoImportParams*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (file);
	_g_object_unref0 (self->file);
	self->file = _tmp0_;
	self->import_id = *import_id;
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
	_g_free0 (self->exif_md5);
	self->exif_md5 = NULL;
	_g_free0 (self->thumbnail_md5);
	self->thumbnail_md5 = NULL;
	_g_free0 (self->full_md5);
	self->full_md5 = NULL;
	_thumbnails_unref0 (self->thumbnails);
	self->thumbnails = NULL;
	return self;
}


PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id) {
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
}


static void value_photo_import_params_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_photo_import_params_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		photo_import_params_unref (value->data[0].v_pointer);
	}
}


static void value_photo_import_params_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_photo_import_params_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_photo_import_params_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PhotoImportParams* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = photo_import_params_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_photo_import_params_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoImportParams** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoImportParams* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_photo_import_params (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
	return value->data[0].v_pointer;
}


void value_set_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		photo_import_params_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_import_params_unref (old);
	}
}


void value_take_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_import_params_unref (old);
	}
}


static void photo_import_params_class_init (PhotoImportParamsClass * klass) {
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
	PHOTO_IMPORT_PARAMS_CLASS (klass)->finalize = photo_import_params_finalize;
}


static void photo_import_params_instance_init (PhotoImportParams * self) {
	PhotoRow _tmp0_ = {0};
	PhotoRow _tmp1_ = {0};
	photo_row_init (&_tmp0_);
	_tmp1_ = _tmp0_;
	self->row = _tmp1_;
	self->keywords = NULL;
	self->ref_count = 1;
}


static void photo_import_params_finalize (PhotoImportParams* obj) {
	PhotoImportParams * self;
	self = PHOTO_IMPORT_PARAMS (obj);
	_g_object_unref0 (self->file);
	_g_free0 (self->exif_md5);
	_g_free0 (self->thumbnail_md5);
	_g_free0 (self->full_md5);
	_thumbnails_unref0 (self->thumbnails);
	photo_row_destroy (&self->row);
	_g_object_unref0 (self->keywords);
}


GType photo_import_params_get_type (void) {
	static volatile gsize photo_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&photo_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_import_params_type_id;
		photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_import_params_type_id__volatile, photo_import_params_type_id);
	}
	return photo_import_params_type_id__volatile;
}


gpointer photo_import_params_ref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void photo_import_params_unref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


PhotoTransformationState* photo_transformation_state_construct (GType object_type) {
	PhotoTransformationState * self = NULL;
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
	return self;
}


gboolean photo_transformation_state_is_broken (PhotoTransformationState* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (self), FALSE);
	result = self->priv->is_broke;
	return result;
}


static void photo_transformation_state_real_broken (PhotoTransformationState* self) {
	g_return_if_fail (IS_PHOTO_TRANSFORMATION_STATE (self));
	self->priv->is_broke = TRUE;
}


static void photo_transformation_state_class_init (PhotoTransformationStateClass * klass) {
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PhotoTransformationStatePrivate));
	PHOTO_TRANSFORMATION_STATE_CLASS (klass)->broken = photo_transformation_state_real_broken;
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
	g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void photo_transformation_state_instance_init (PhotoTransformationState * self) {
	self->priv = PHOTO_TRANSFORMATION_STATE_GET_PRIVATE (self);
	self->priv->is_broke = FALSE;
}


static void photo_transformation_state_finalize (GObject* obj) {
	PhotoTransformationState * self;
	self = PHOTO_TRANSFORMATION_STATE (obj);
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
}


GType photo_transformation_state_get_type (void) {
	static volatile gsize photo_transformation_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_transformation_state_type_id__volatile, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__volatile;
}


gboolean rating_can_increase (Rating self) {
	gboolean result = FALSE;
	result = self < RATING_FIVE;
	return result;
}


gboolean rating_can_decrease (Rating self) {
	gboolean result = FALSE;
	result = self > RATING_REJECTED;
	return result;
}


gboolean rating_is_valid (Rating self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if (self >= RATING_REJECTED) {
		_tmp0_ = self <= RATING_FIVE;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


Rating rating_increase (Rating self) {
	Rating result = 0;
	Rating _tmp0_ = 0;
	gboolean _tmp1_;
	_tmp1_ = rating_can_increase (self);
	if (_tmp1_) {
		_tmp0_ = self + 1;
	} else {
		_tmp0_ = self;
	}
	result = _tmp0_;
	return result;
}


Rating rating_decrease (Rating self) {
	Rating result = 0;
	Rating _tmp0_ = 0;
	gboolean _tmp1_;
	_tmp1_ = rating_can_decrease (self);
	if (_tmp1_) {
		_tmp0_ = self - 1;
	} else {
		_tmp0_ = self;
	}
	result = _tmp0_;
	return result;
}


gint rating_serialize (Rating self) {
	gint result = 0;
	switch (self) {
		case RATING_REJECTED:
		{
			result = -1;
			return result;
		}
		case RATING_UNRATED:
		{
			result = 0;
			return result;
		}
		case RATING_ONE:
		{
			result = 1;
			return result;
		}
		case RATING_TWO:
		{
			result = 2;
			return result;
		}
		case RATING_THREE:
		{
			result = 3;
			return result;
		}
		case RATING_FOUR:
		{
			result = 4;
			return result;
		}
		case RATING_FIVE:
		{
			result = 5;
			return result;
		}
		default:
		{
			result = 0;
			return result;
		}
	}
}


Rating rating_unserialize (gint value) {
	Rating result = 0;
	if (value > RATING_FIVE) {
		result = RATING_FIVE;
		return result;
	} else {
		if (value < RATING_REJECTED) {
			result = RATING_REJECTED;
			return result;
		}
	}
	switch (value) {
		case -1:
		{
			result = RATING_REJECTED;
			return result;
		}
		case 0:
		{
			result = RATING_UNRATED;
			return result;
		}
		case 1:
		{
			result = RATING_ONE;
			return result;
		}
		case 2:
		{
			result = RATING_TWO;
			return result;
		}
		case 3:
		{
			result = RATING_THREE;
			return result;
		}
		case 4:
		{
			result = RATING_FOUR;
			return result;
		}
		case 5:
		{
			result = RATING_FIVE;
			return result;
		}
		default:
		{
			result = RATING_UNRATED;
			return result;
		}
	}
}


GType rating_get_type (void) {
	static volatile gsize rating_type_id__volatile = 0;
	if (g_once_init_enter (&rating_type_id__volatile)) {
		static const GEnumValue values[] = {{RATING_REJECTED, "RATING_REJECTED", "rejected"}, {RATING_UNRATED, "RATING_UNRATED", "unrated"}, {RATING_ONE, "RATING_ONE", "one"}, {RATING_TWO, "RATING_TWO", "two"}, {RATING_THREE, "RATING_THREE", "three"}, {RATING_FOUR, "RATING_FOUR", "four"}, {RATING_FIVE, "RATING_FIVE", "five"}, {0, NULL, NULL}};
		GType rating_type_id;
		rating_type_id = g_enum_register_static ("Rating", values);
		g_once_init_leave (&rating_type_id__volatile, rating_type_id);
	}
	return rating_type_id__volatile;
}


gboolean photo_exception_prohibits (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	result = (self & exception) != 0;
	return result;
}


gboolean photo_exception_allows (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	result = (self & exception) == 0;
	return result;
}


GType photo_exception_get_type (void) {
	static volatile gsize photo_exception_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exception_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
		GType photo_exception_type_id;
		photo_exception_type_id = g_enum_register_static ("PhotoException", values);
		g_once_init_leave (&photo_exception_type_id__volatile, photo_exception_type_id);
	}
	return photo_exception_type_id__volatile;
}


Photo* photo_construct (GType object_type, PhotoRow* row) {
	Photo * self = NULL;
	PhotoRow _tmp0_;
	PhotoRow _tmp1_ = {0};
	gchar* _tmp2_ = NULL;
	PhotoFileReader* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* basename;
	gboolean _tmp6_;
	BackingPhotoState* _tmp22_ = NULL;
	GError * _inner_error_ = NULL;
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
	photo_row_copy (row, &_tmp1_);
	_tmp0_ = _tmp1_;
	photo_row_destroy (&self->priv->row);
	self->priv->row = _tmp0_;
	_tmp2_ = media_source_prep_title (self->priv->row.title);
	_g_free0 (self->priv->row.title);
	self->priv->row.title = _tmp2_;
	_tmp3_ = photo_file_format_create_reader ((*row).master.file_format, (*row).master.filepath);
	_photo_file_adapter_unref0 (self->priv->readers.master);
	self->priv->readers.master = _tmp3_;
	_tmp4_ = string_sliced_at_last_char ((*row).master.filepath, (gunichar) G_DIR_SEPARATOR, 0);
	basename = _tmp4_;
	if (basename != NULL) {
		gchar* _tmp5_ = NULL;
		_tmp5_ = string_sliced_at (basename, 1);
		_g_free0 (self->priv->file_title);
		self->priv->file_title = _tmp5_;
	}
	_tmp6_ = is_string_empty (self->priv->file_title);
	if (_tmp6_) {
		gchar* _tmp7_;
		_tmp7_ = g_strdup ((*row).master.filepath);
		_g_free0 (self->priv->file_title);
		self->priv->file_title = _tmp7_;
	}
	if ((*row).editable_id.id != BACKING_PHOTO_ID_INVALID) {
		BackingPhotoRow* editable_row;
		BackingPhotoTable* _tmp8_ = NULL;
		BackingPhotoTable* _tmp9_;
		BackingPhotoRow* _tmp10_ = NULL;
		BackingPhotoRow* _tmp11_;
		BackingPhotoRow* _tmp12_;
		editable_row = NULL;
		_tmp8_ = backing_photo_table_get_instance ();
		_tmp9_ = _tmp8_;
		_tmp10_ = backing_photo_table_fetch (_tmp9_, &(*row).editable_id, &_inner_error_);
		_tmp11_ = _tmp10_;
		_database_table_unref0 (_tmp9_);
		_tmp12_ = _tmp11_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				goto __catch93_database_error;
			}
			_backing_photo_row_free0 (editable_row);
			_g_free0 (basename);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_backing_photo_row_free0 (editable_row);
		editable_row = _tmp12_;
		goto __finally93;
		__catch93_database_error:
		{
			GError * err;
			gchar* _tmp13_ = NULL;
			gchar* _tmp14_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp13_ = data_object_to_string (DATA_OBJECT (self));
			_tmp14_ = _tmp13_;
			g_warning ("Photo.vala:357: Unable to fetch editable state for %s: %s", _tmp14_, err->message);
			_g_free0 (_tmp14_);
			_g_error_free0 (err);
		}
		__finally93:
		if (_inner_error_ != NULL) {
			_backing_photo_row_free0 (editable_row);
			_g_free0 (basename);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		if (editable_row != NULL) {
			BackingPhotoState _tmp15_;
			BackingPhotoState _tmp16_ = {0};
			PhotoFileReader* _tmp17_ = NULL;
			backing_photo_state_copy (&(*editable_row).state, &_tmp16_);
			_tmp15_ = _tmp16_;
			backing_photo_state_destroy (&self->priv->editable);
			self->priv->editable = _tmp15_;
			_tmp17_ = photo_file_format_create_reader (self->priv->editable.file_format, self->priv->editable.filepath);
			_photo_file_adapter_unref0 (self->priv->readers.editable);
			self->priv->readers.editable = _tmp17_;
		} else {
			BackingPhotoTable* _tmp18_ = NULL;
			BackingPhotoTable* _tmp19_;
			PhotoTable* _tmp20_ = NULL;
			PhotoTable* _tmp21_;
			_tmp18_ = backing_photo_table_get_instance ();
			_tmp19_ = _tmp18_;
			backing_photo_table_remove (_tmp19_, &(*row).editable_id, &_inner_error_);
			_database_table_unref0 (_tmp19_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == DATABASE_ERROR) {
					goto __catch94_database_error;
				}
				_backing_photo_row_free0 (editable_row);
				_g_free0 (basename);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			goto __finally94;
			__catch94_database_error:
			{
				GError * err;
				err = _inner_error_;
				_inner_error_ = NULL;
				_g_error_free0 (err);
			}
			__finally94:
			if (_inner_error_ != NULL) {
				_backing_photo_row_free0 (editable_row);
				_g_free0 (basename);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_tmp20_ = photo_table_get_instance ();
			_tmp21_ = _tmp20_;
			photo_table_detach_editable (_tmp21_, &self->priv->row, &_inner_error_);
			_database_table_unref0 (_tmp21_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == DATABASE_ERROR) {
					goto __catch95_database_error;
				}
				_backing_photo_row_free0 (editable_row);
				_g_free0 (basename);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			goto __finally95;
			__catch95_database_error:
			{
				GError * err;
				err = _inner_error_;
				_inner_error_ = NULL;
				_g_error_free0 (err);
			}
			__finally95:
			if (_inner_error_ != NULL) {
				_backing_photo_row_free0 (editable_row);
				_g_free0 (basename);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			photo_internal_remove_all_transformations (self, FALSE);
		}
		_backing_photo_row_free0 (editable_row);
	}
	if (self->priv->readers.editable == NULL) {
		_tmp22_ = &self->priv->row.master;
	} else {
		_tmp22_ = &self->priv->editable;
	}
	self->priv->backing_photo_state = _tmp22_;
	_g_free0 (basename);
	return self;
}


static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
	g_signal_emit_by_name (self, "editable-replaced", old_file, new_file);
}


void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
	PHOTO_GET_CLASS (self)->notify_editable_replaced (self, old_file, new_file);
}


static void photo_real_notify_baseline_replaced (Photo* self) {
	g_return_if_fail (IS_PHOTO (self));
	g_signal_emit_by_name (self, "baseline-replaced");
}


void photo_notify_baseline_replaced (Photo* self) {
	PHOTO_GET_CLASS (self)->notify_baseline_replaced (self);
}


static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	g_signal_emit_by_name (self, "master-reimported", metadata);
}


void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
	PHOTO_GET_CLASS (self)->notify_master_reimported (self, metadata);
}


static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	g_signal_emit_by_name (self, "editable-reimported", metadata);
}


void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
	PHOTO_GET_CLASS (self)->notify_editable_reimported (self, metadata);
}


static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	g_signal_emit_by_name (self, "source-reimported", metadata);
}


void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
	PHOTO_GET_CLASS (self)->notify_source_reimported (self, metadata);
}


static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	g_signal_emit_by_name (self, "baseline-reimported", metadata);
}


void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
	PHOTO_GET_CLASS (self)->notify_baseline_reimported (self, metadata);
}


static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error) {
	Photo * self;
	gboolean result = FALSE;
	gboolean ret;
	GFile* file;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	ret = TRUE;
	file = NULL;
	{
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		if (self->priv->readers.editable != NULL) {
			GFile* _tmp0_ = NULL;
			_tmp0_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (self->priv->readers.editable));
			_g_object_unref0 (file);
			file = _tmp0_;
		}
		__finally96:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (file);
			return FALSE;
		}
	}
	photo_detach_editable (self, TRUE, FALSE);
	if (file != NULL) {
		gboolean _tmp1_;
		gboolean _tmp2_;
		_tmp1_ = g_file_trash (file, NULL, &_inner_error_);
		_tmp2_ = _tmp1_;
		if (_inner_error_ != NULL) {
			goto __catch97_g_error;
		}
		ret = _tmp2_;
		goto __finally97;
		__catch97_g_error:
		{
			GError * err;
			gchar* _tmp3_ = NULL;
			gchar* _tmp4_;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_;
			err = _inner_error_;
			_inner_error_ = NULL;
			ret = FALSE;
			_tmp3_ = g_file_get_path (file);
			_tmp4_ = _tmp3_;
			_tmp5_ = data_object_to_string (DATA_OBJECT (self));
			_tmp6_ = _tmp5_;
			g_message ("Photo.vala:425: Unable to move editable %s for %s to trash: %s", _tmp4_, _tmp6_, err->message);
			_g_free0 (_tmp6_);
			_g_free0 (_tmp4_);
			_g_error_free0 (err);
		}
		__finally97:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (file);
			return FALSE;
		}
	}
	_tmp8_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing (DATA_SOURCE (PHOTO_SOURCE (self)), &_inner_error_);
	_tmp9_ = _tmp8_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (file);
		return FALSE;
	}
	if (_tmp9_) {
		_tmp7_ = ret;
	} else {
		_tmp7_ = FALSE;
	}
	result = _tmp7_;
	_g_object_unref0 (file);
	return result;
}


gboolean photo_would_use_mimic (Photo* self) {
	gboolean result = FALSE;
	PhotoFileFormatFlags flags = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	{
		PhotoFileFormat _tmp0_;
		PhotoFileFormatProperties* _tmp1_ = NULL;
		PhotoFileFormatProperties* _tmp2_;
		PhotoFileFormatFlags _tmp3_;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		_tmp0_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (self->priv->readers.master));
		_tmp1_ = photo_file_format_get_properties (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = photo_file_format_properties_get_flags (_tmp2_);
		flags = _tmp3_;
		_photo_file_format_properties_unref0 (_tmp2_);
		__finally98:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	result = (flags & PHOTO_FILE_FORMAT_FLAGS_MIMIC_RECOMMENDED) != 0;
	return result;
}


static void _vala_array_add164 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add165 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1) {
	Photo * self;
	BackingFileState** result = NULL;
	BackingFileState** _tmp0_ = NULL;
	BackingFileState** backing;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp4_;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
	backing = _tmp0_;
	backing_length1 = 0;
	_backing_size_ = 0;
	{
		BackingFileState* _tmp1_ = NULL;
		gboolean _tmp2_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp1_ = backing_file_state_new_from_photo_state (&self->priv->row.master, self->priv->row.md5);
		_vala_array_add164 (&backing, &backing_length1, &_backing_size_, _tmp1_);
		_tmp2_ = photo_has_editable (self);
		if (_tmp2_) {
			BackingFileState* _tmp3_ = NULL;
			_tmp3_ = backing_file_state_new_from_photo_state (&self->priv->editable, NULL);
			_vala_array_add165 (&backing, &backing_length1, &_backing_size_, _tmp3_);
		}
		__finally99:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp4_ = backing;
	*result_length1 = backing_length1;
	result = _tmp4_;
	return result;
}


static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode) {
	PhotoFileReader* result = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	switch (mode) {
		case BACKING_FETCH_MODE_MASTER:
		{
			PhotoFileReader* _tmp0_ = NULL;
			_tmp0_ = photo_get_master_reader (self);
			result = _tmp0_;
			return result;
		}
		case BACKING_FETCH_MODE_BASELINE:
		{
			PhotoFileReader* _tmp1_ = NULL;
			_tmp1_ = photo_get_baseline_reader (self);
			result = _tmp1_;
			return result;
		}
		case BACKING_FETCH_MODE_SOURCE:
		{
			PhotoFileReader* _tmp2_ = NULL;
			_tmp2_ = photo_get_source_reader (self);
			result = _tmp2_;
			return result;
		}
		default:
		{
			GEnumValue* _tmp3_;
			_tmp3_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), mode);
			g_error ("Photo.vala:467: Unknown backing fetch mode %s", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
		}
	}
}


static gpointer _photo_file_adapter_ref0 (gpointer self) {
	return self ? photo_file_adapter_ref (self) : NULL;
}


static PhotoFileReader* photo_get_master_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	{
		PhotoFileReader* _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		_tmp0_ = _photo_file_adapter_ref0 (self->priv->readers.master);
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		return result;
		__finally100:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


void photo_set_mimic_reader (Photo* self, PhotoFileReader* mimic) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (IS_PHOTO_FILE_READER (mimic));
	if (commandline_options_no_mimicked_images) {
		return;
	}
	{
		PhotoFileReader* _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		_tmp0_ = _photo_file_adapter_ref0 (mimic);
		_photo_file_adapter_unref0 (self->priv->readers.mimic);
		self->priv->readers.mimic = _tmp0_;
		__finally101:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


PhotoFileReader* photo_get_editable_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	{
		PhotoFileReader* _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		_tmp0_ = _photo_file_adapter_ref0 (self->priv->readers.editable);
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		return result;
		__finally102:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static PhotoFileReader* photo_get_baseline_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	{
		PhotoFileReader* _tmp2_;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		if (self->priv->readers.editable != NULL) {
			PhotoFileReader* _tmp0_;
			_tmp0_ = _photo_file_adapter_ref0 (self->priv->readers.editable);
			result = _tmp0_;
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
			return result;
		}
		if (self->priv->readers.mimic != NULL) {
			PhotoFileReader* _tmp1_;
			_tmp1_ = _photo_file_adapter_ref0 (self->priv->readers.mimic);
			result = _tmp1_;
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
			return result;
		}
		_tmp2_ = _photo_file_adapter_ref0 (self->priv->readers.master);
		result = _tmp2_;
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		return result;
		__finally103:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static PhotoFileReader* photo_get_source_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	{
		PhotoFileReader* _tmp0_;
		PhotoFileReader* _tmp1_;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		_tmp0_ = _photo_file_adapter_ref0 (self->priv->readers.editable);
		_tmp1_ = _tmp0_;
		if (_tmp1_ == NULL) {
			PhotoFileReader* _tmp2_;
			_tmp2_ = _photo_file_adapter_ref0 (self->priv->readers.master);
			_photo_file_adapter_unref0 (_tmp1_);
			_tmp1_ = _tmp2_;
		}
		result = _tmp1_;
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		return result;
		_photo_file_adapter_unref0 (_tmp1_);
		__finally104:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gboolean photo_is_mimicked (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		result = self->priv->readers.mimic != NULL;
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		return result;
		__finally105:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


gboolean photo_has_editable (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		result = self->priv->readers.editable != NULL;
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		return result;
		__finally106:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


gboolean photo_does_master_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	{
		gboolean _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		_tmp0_ = photo_file_adapter_file_exists (PHOTO_FILE_ADAPTER (self->priv->readers.master));
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		return result;
		__finally107:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


gboolean photo_does_editable_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	{
		gboolean _tmp0_ = FALSE;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		if (self->priv->readers.editable != NULL) {
			gboolean _tmp1_;
			_tmp1_ = photo_file_adapter_file_exists (PHOTO_FILE_ADAPTER (self->priv->readers.editable));
			_tmp0_ = _tmp1_;
		} else {
			_tmp0_ = FALSE;
		}
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		return result;
		__finally108:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


gboolean photo_is_master_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	{
		gboolean _tmp0_ = FALSE;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		if (self->priv->readers.mimic == NULL) {
			_tmp0_ = self->priv->readers.editable == NULL;
		} else {
			_tmp0_ = FALSE;
		}
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		return result;
		__finally109:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


gboolean photo_is_master_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	_tmp0_ = photo_has_editable (self);
	result = !_tmp0_;
	return result;
}


gboolean photo_is_editable_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	{
		gboolean _tmp0_ = FALSE;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		if (self->priv->readers.mimic == NULL) {
			_tmp0_ = self->priv->readers.editable != NULL;
		} else {
			_tmp0_ = FALSE;
		}
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		return result;
		__finally110:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


gboolean photo_is_editable_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	_tmp0_ = photo_has_editable (self);
	result = _tmp0_;
	return result;
}


void photo_get_master_photo_state (Photo* self, BackingPhotoState* result) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	{
		BackingPhotoState _tmp0_;
		BackingPhotoState _tmp1_ = {0};
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		backing_photo_state_copy (&self->priv->row.master, &_tmp1_);
		_tmp0_ = _tmp1_;
		*result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return;
		__finally111:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static gpointer _backing_photo_state_dup0 (gpointer self) {
	return self ? backing_photo_state_dup (self) : NULL;
}


BackingPhotoState* photo_get_editable_photo_state (Photo* self) {
	BackingPhotoState* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	{
		gboolean _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = backing_photo_id_is_valid (&self->priv->row.editable_id);
		if (_tmp0_) {
			BackingPhotoState* _tmp1_;
			_tmp1_ = _backing_photo_state_dup0 (&self->priv->editable);
			result = _tmp1_;
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
			return result;
		} else {
			result = NULL;
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
			return result;
		}
		__finally112:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self) {
	PhotoFileFormat* dup;
	dup = g_new0 (PhotoFileFormat, 1);
	memcpy (dup, self, sizeof (PhotoFileFormat));
	return dup;
}


static gpointer __photo_file_format_dup0 (gpointer self) {
	return self ? _photo_file_format_dup (self) : NULL;
}


PhotoFileFormat* photo_get_editable_file_format (Photo* self) {
	PhotoFileFormat* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	PhotoFileFormat _tmp1_;
	PhotoFileFormat* _tmp2_;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	_tmp0_ = photo_get_editable_reader (self);
	reader = _tmp0_;
	if (reader == NULL) {
		result = NULL;
		_photo_file_adapter_unref0 (reader);
		return result;
	}
	_tmp1_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (reader));
	_tmp2_ = __photo_file_format_dup0 (&_tmp1_);
	result = _tmp2_;
	_photo_file_adapter_unref0 (reader);
	return result;
}


PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params) {
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_;
	PhotoFileFormat _result_;
	g_return_val_if_fail (IS_PHOTO (self), 0);
	_tmp0_ = photo_file_format_get_system_default_format ();
	_result_ = _tmp0_;
	switch ((*params).mode) {
		case EXPORT_FORMAT_MODE_UNMODIFIED:
		{
			PhotoFileFormat _tmp1_;
			_tmp1_ = photo_get_master_file_format (self);
			_result_ = _tmp1_;
			break;
		}
		case EXPORT_FORMAT_MODE_CURRENT:
		{
			PhotoFileFormat _tmp2_;
			_tmp2_ = photo_get_best_export_file_format (self);
			_result_ = _tmp2_;
			break;
		}
		case EXPORT_FORMAT_MODE_SPECIFIED:
		{
			_result_ = (*params).specified_format;
			break;
		}
		default:
		{
			g_error ("Photo.vala:603: get_export_format_for_parameters: unsupported export f" \
"ormat mode");
		}
	}
	result = _result_;
	return result;
}


gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params) {
	gchar* result = NULL;
	gchar* _result_;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	_result_ = NULL;
	switch ((*params).mode) {
		case EXPORT_FORMAT_MODE_UNMODIFIED:
		{
			GFile* _tmp0_ = NULL;
			GFile* _tmp1_;
			gchar* _tmp2_ = NULL;
			_tmp0_ = media_source_get_master_file (MEDIA_SOURCE (self));
			_tmp1_ = _tmp0_;
			_tmp2_ = g_file_get_basename (_tmp1_);
			_g_free0 (_result_);
			_result_ = _tmp2_;
			_g_object_unref0 (_tmp1_);
			break;
		}
		case EXPORT_FORMAT_MODE_CURRENT:
		case EXPORT_FORMAT_MODE_SPECIFIED:
		{
			PhotoFileFormat _tmp3_;
			gchar* _tmp4_ = NULL;
			_tmp3_ = photo_get_export_format_for_parameters (self, params);
			_tmp4_ = photo_get_export_basename (self, &_tmp3_);
			result = _tmp4_;
			_g_free0 (_result_);
			return result;
		}
		default:
		{
			g_error ("Photo.vala:622: get_export_basename_for_parameters: unsupported export" \
" format mode");
		}
	}
	g_assert (_result_ != NULL);
	result = _result_;
	return result;
}


ImportResult photo_prepare_for_import (PhotoImportParams* params) {
	ImportResult result = 0;
	GFile* _tmp0_;
	GFile* file;
	GFileInfo* info;
	GFileInfo* _tmp1_ = NULL;
	GFileInfo* _tmp2_;
	GFileType _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp7_;
	GTimeVal timestamp = {0};
	GTimeVal _tmp10_ = {0};
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	PhotoFileInterrogator* _tmp13_ = NULL;
	PhotoFileInterrogator* interrogator;
	DetectedPhotoInformation* _tmp16_ = NULL;
	DetectedPhotoInformation* detected;
	Orientation orientation;
	time_t exposure_time;
	gchar* _tmp20_;
	gchar* title;
	Rating rating;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	PhotoID _tmp31_ = {0};
	PhotoID _tmp32_ = {0};
	gchar* _tmp33_ = NULL;
	gint64 _tmp34_;
	EventID _tmp35_ = {0};
	EventID _tmp36_ = {0};
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
	_tmp0_ = _g_object_ref0 (params->file);
	file = _tmp0_;
	info = NULL;
	_tmp1_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		goto __catch113_g_error;
	}
	_g_object_unref0 (info);
	info = _tmp2_;
	goto __finally113;
	__catch113_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		result = IMPORT_RESULT_FILE_ERROR;
		_g_error_free0 (err);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		return result;
	}
	__finally113:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
	_tmp3_ = g_file_info_get_file_type (info);
	if (_tmp3_ != G_FILE_TYPE_REGULAR) {
		result = IMPORT_RESULT_NOT_A_FILE;
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		return result;
	}
	_tmp4_ = photo_is_file_image (file);
	if (!_tmp4_) {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		_tmp5_ = g_file_get_path (file);
		_tmp6_ = _tmp5_;
		g_message ("Photo.vala:659: Not importing %s: Not an image file", _tmp6_);
		_g_free0 (_tmp6_);
		result = IMPORT_RESULT_NOT_AN_IMAGE;
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		return result;
	}
	_tmp7_ = photo_file_format_is_file_supported (file);
	if (!_tmp7_) {
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		_tmp8_ = g_file_get_path (file);
		_tmp9_ = _tmp8_;
		g_message ("Photo.vala:665: Not importing %s: Unsupported extension", _tmp9_);
		_g_free0 (_tmp9_);
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		return result;
	}
	g_file_info_get_modification_time (info, &_tmp10_);
	timestamp = _tmp10_;
	if (params->exif_md5 != NULL) {
		_tmp12_ = params->thumbnail_md5 != NULL;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		_tmp11_ = params->full_md5 != NULL;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		params->sniffer_options = params->sniffer_options | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
	}
	_tmp13_ = photo_file_interrogator_new (file, params->sniffer_options);
	interrogator = _tmp13_;
	photo_file_interrogator_interrogate (interrogator, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch114_g_error;
	}
	goto __finally114;
	__catch114_g_error:
	{
		GError * err;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp14_ = g_file_get_path (file);
		_tmp15_ = _tmp14_;
		g_warning ("Photo.vala:682: Unable to interrogate photo file %s: %s", _tmp15_, err->message);
		_g_free0 (_tmp15_);
		result = IMPORT_RESULT_DECODE_ERROR;
		_g_error_free0 (err);
		_photo_file_interrogator_unref0 (interrogator);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		return result;
	}
	__finally114:
	if (_inner_error_ != NULL) {
		_photo_file_interrogator_unref0 (interrogator);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
	_tmp16_ = photo_file_interrogator_get_detected_photo_information (interrogator);
	detected = _tmp16_;
	if (detected == NULL) {
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
		_detected_photo_information_unref0 (detected);
		_photo_file_interrogator_unref0 (interrogator);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		return result;
	}
	if ((params->sniffer_options & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		_tmp17_ = g_strdup (params->exif_md5);
		_g_free0 (detected->exif_md5);
		detected->exif_md5 = _tmp17_;
		_tmp18_ = g_strdup (params->thumbnail_md5);
		_g_free0 (detected->thumbnail_md5);
		detected->thumbnail_md5 = _tmp18_;
		_tmp19_ = g_strdup (params->full_md5);
		_g_free0 (detected->md5);
		detected->md5 = _tmp19_;
	}
	orientation = ORIENTATION_TOP_LEFT;
	exposure_time = (time_t) 0;
	_tmp20_ = g_strdup ("");
	title = _tmp20_;
	rating = RATING_UNRATED;
	if (detected->metadata != NULL) {
		MetadataDateTime* _tmp21_ = NULL;
		MetadataDateTime* date_time;
		Orientation _tmp23_;
		gchar* _tmp24_ = NULL;
		GeeSet* _tmp25_ = NULL;
		Rating _tmp26_;
		_tmp21_ = photo_metadata_get_exposure_date_time (detected->metadata);
		date_time = _tmp21_;
		if (date_time != NULL) {
			time_t _tmp22_;
			_tmp22_ = metadata_date_time_get_timestamp (date_time);
			exposure_time = _tmp22_;
		}
		_tmp23_ = photo_metadata_get_orientation (detected->metadata);
		orientation = _tmp23_;
		_tmp24_ = media_metadata_get_title (MEDIA_METADATA (detected->metadata));
		_g_free0 (title);
		title = _tmp24_;
		_tmp25_ = photo_metadata_get_keywords (detected->metadata, NULL);
		_g_object_unref0 (params->keywords);
		params->keywords = GEE_COLLECTION (_tmp25_);
		_tmp26_ = photo_metadata_get_rating (detected->metadata);
		rating = _tmp26_;
		_metadata_date_time_unref0 (date_time);
	}
	if (detected->colorspace != GDK_COLORSPACE_RGB) {
		_tmp28_ = TRUE;
	} else {
		_tmp28_ = detected->channels < 3;
	}
	if (_tmp28_) {
		_tmp27_ = TRUE;
	} else {
		_tmp27_ = detected->bits_per_channel != 8;
	}
	if (_tmp27_) {
		gchar* _tmp29_ = NULL;
		gchar* _tmp30_;
		_tmp29_ = g_file_get_path (file);
		_tmp30_ = _tmp29_;
		g_message ("Photo.vala:724: Not importing %s: Unsupported color format", _tmp30_);
		_g_free0 (_tmp30_);
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
		_g_free0 (title);
		_detected_photo_information_unref0 (detected);
		_photo_file_interrogator_unref0 (interrogator);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		return result;
	}
	photo_id_init (&_tmp31_, PHOTO_ID_INVALID);
	_tmp32_ = _tmp31_;
	params->row.photo_id = _tmp32_;
	_tmp33_ = g_file_get_path (file);
	_g_free0 (params->row.master.filepath);
	params->row.master.filepath = _tmp33_;
	params->row.master.dim = detected->image_dim;
	_tmp34_ = g_file_info_get_size (info);
	params->row.master.filesize = _tmp34_;
	params->row.master.timestamp = (time_t) timestamp.tv_sec;
	params->row.exposure_time = exposure_time;
	params->row.orientation = orientation;
	params->row.master.original_orientation = orientation;
	params->row.import_id = params->import_id;
	event_id_init (&_tmp35_, EVENT_ID_INVALID);
	_tmp36_ = _tmp35_;
	params->row.event_id = _tmp36_;
	_g_object_unref0 (params->row.transformations);
	params->row.transformations = NULL;
	_tmp37_ = g_strdup (detected->md5);
	_g_free0 (params->row.md5);
	params->row.md5 = _tmp37_;
	_tmp38_ = g_strdup (detected->thumbnail_md5);
	_g_free0 (params->row.thumbnail_md5);
	params->row.thumbnail_md5 = _tmp38_;
	_tmp39_ = g_strdup (detected->exif_md5);
	_g_free0 (params->row.exif_md5);
	params->row.exif_md5 = _tmp39_;
	params->row.time_created = (time_t) 0;
	params->row.flags = (guint64) 0;
	params->row.master.file_format = detected->file_format;
	_tmp40_ = g_strdup (title);
	_g_free0 (params->row.title);
	params->row.title = _tmp40_;
	params->row.rating = rating;
	if (params->thumbnails != NULL) {
		PhotoFileReader* _tmp41_ = NULL;
		PhotoFileReader* reader;
		_tmp41_ = photo_file_format_create_reader (params->row.master.file_format, params->row.master.filepath);
		reader = _tmp41_;
		thumbnail_cache_generate_for_photo (params->thumbnails, reader, params->row.orientation, &params->row.master.dim, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch115_g_error;
		}
		goto __finally115;
		__catch115_g_error:
		{
			GError * err;
			ImportResult _tmp42_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp42_ = import_result_convert_error (err, IMPORT_RESULT_FILE_ERROR);
			result = _tmp42_;
			_g_error_free0 (err);
			_photo_file_adapter_unref0 (reader);
			_g_free0 (title);
			_detected_photo_information_unref0 (detected);
			_photo_file_interrogator_unref0 (interrogator);
			_g_object_unref0 (info);
			_g_object_unref0 (file);
			return result;
		}
		__finally115:
		if (_inner_error_ != NULL) {
			_photo_file_adapter_unref0 (reader);
			_g_free0 (title);
			_detected_photo_information_unref0 (detected);
			_photo_file_interrogator_unref0 (interrogator);
			_g_object_unref0 (info);
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0;
		}
		_photo_file_adapter_unref0 (reader);
	}
	result = IMPORT_RESULT_SUCCESS;
	_g_free0 (title);
	_detected_photo_information_unref0 (detected);
	_photo_file_interrogator_unref0 (interrogator);
	_g_object_unref0 (info);
	_g_object_unref0 (file);
	return result;
}


void photo_create_pre_import (PhotoImportParams* params) {
	GFile* _tmp0_;
	GFile* file;
	PhotoID _tmp1_ = {0};
	PhotoID _tmp2_ = {0};
	gchar* _tmp3_ = NULL;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
	EventID _tmp6_ = {0};
	EventID _tmp7_ = {0};
	g_return_if_fail (IS_PHOTO_IMPORT_PARAMS (params));
	_tmp0_ = _g_object_ref0 (params->file);
	file = _tmp0_;
	photo_id_init (&_tmp1_, PHOTO_ID_INVALID);
	_tmp2_ = _tmp1_;
	params->row.photo_id = _tmp2_;
	_tmp3_ = g_file_get_path (file);
	_g_free0 (params->row.master.filepath);
	params->row.master.filepath = _tmp3_;
	dimensions_init (&_tmp4_, 0, 0);
	_tmp5_ = _tmp4_;
	params->row.master.dim = _tmp5_;
	params->row.master.filesize = (gint64) 0;
	params->row.master.timestamp = (time_t) 0;
	params->row.exposure_time = (time_t) 0;
	params->row.orientation = ORIENTATION_TOP_LEFT;
	params->row.master.original_orientation = ORIENTATION_TOP_LEFT;
	params->row.import_id = params->import_id;
	event_id_init (&_tmp6_, EVENT_ID_INVALID);
	_tmp7_ = _tmp6_;
	params->row.event_id = _tmp7_;
	_g_object_unref0 (params->row.transformations);
	params->row.transformations = NULL;
	_g_free0 (params->row.md5);
	params->row.md5 = NULL;
	_g_free0 (params->row.thumbnail_md5);
	params->row.thumbnail_md5 = NULL;
	_g_free0 (params->row.exif_md5);
	params->row.exif_md5 = NULL;
	params->row.time_created = (time_t) 0;
	params->row.flags = (guint64) 0;
	params->row.master.file_format = PHOTO_FILE_FORMAT_JFIF;
	_g_free0 (params->row.title);
	params->row.title = NULL;
	params->row.rating = RATING_UNRATED;
	_g_object_unref0 (file);
}


gboolean photo_query_backing_photo_state (Photo* self, GFile* file, PhotoFileSnifferOptions options, BackingPhotoState* state, DetectedPhotoInformation** detected, GError** error) {
	BackingPhotoState _state = {0};
	DetectedPhotoInformation* _detected = NULL;
	gboolean result = FALSE;
	GFileInfo* info;
	GFileInfo* _tmp0_ = NULL;
	GFileInfo* _tmp1_;
	PhotoFileInterrogator* _tmp4_ = NULL;
	PhotoFileInterrogator* interrogator;
	DetectedPhotoInformation* _tmp5_ = NULL;
	GTimeVal modification_time = {0};
	GTimeVal _tmp8_ = {0};
	gchar* _tmp9_ = NULL;
	gint64 _tmp10_;
	Orientation _tmp11_ = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	info = NULL;
	_tmp0_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		goto __catch116_g_error;
	}
	_g_object_unref0 (info);
	info = _tmp1_;
	goto __finally116;
	__catch116_g_error:
	{
		GError * err;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = g_file_get_path (file);
		_tmp3_ = _tmp2_;
		g_critical ("Photo.vala:800: Unable to read file information for %s: %s", _tmp3_, err->message);
		_g_free0 (_tmp3_);
		result = FALSE;
		_g_error_free0 (err);
		_g_object_unref0 (info);
		if (state) {
			*state = _state;
		} else {
			backing_photo_state_destroy (&_state);
		}
		if (detected) {
			*detected = _detected;
		} else {
			_detected_photo_information_unref0 (_detected);
		}
		return result;
	}
	__finally116:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (info);
		return FALSE;
	}
	_tmp4_ = photo_file_interrogator_new (file, options);
	interrogator = _tmp4_;
	photo_file_interrogator_interrogate (interrogator, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_interrogator_unref0 (interrogator);
		_g_object_unref0 (info);
		return FALSE;
	}
	_tmp5_ = photo_file_interrogator_get_detected_photo_information (interrogator);
	_detected_photo_information_unref0 (_detected);
	_detected = _tmp5_;
	if (_detected == NULL) {
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		_tmp6_ = data_object_to_string (DATA_OBJECT (self));
		_tmp7_ = _tmp6_;
		g_critical ("Photo.vala:810: Photo update: %s no longer a recognized image", _tmp7_);
		_g_free0 (_tmp7_);
		result = FALSE;
		_photo_file_interrogator_unref0 (interrogator);
		_g_object_unref0 (info);
		if (state) {
			*state = _state;
		} else {
			backing_photo_state_destroy (&_state);
		}
		if (detected) {
			*detected = _detected;
		} else {
			_detected_photo_information_unref0 (_detected);
		}
		return result;
	}
	g_get_current_time (&modification_time);
	g_file_info_get_modification_time (info, &_tmp8_);
	modification_time = _tmp8_;
	_tmp9_ = g_file_get_path (file);
	_g_free0 (_state.filepath);
	_state.filepath = _tmp9_;
	_state.timestamp = (time_t) modification_time.tv_sec;
	_tmp10_ = g_file_info_get_size (info);
	_state.filesize = _tmp10_;
	_state.file_format = _detected->file_format;
	_state.dim = _detected->image_dim;
	if (_detected->metadata != NULL) {
		Orientation _tmp12_;
		_tmp12_ = photo_metadata_get_orientation (_detected->metadata);
		_tmp11_ = _tmp12_;
	} else {
		_tmp11_ = ORIENTATION_TOP_LEFT;
	}
	_state.original_orientation = _tmp11_;
	result = TRUE;
	_photo_file_interrogator_unref0 (interrogator);
	_g_object_unref0 (info);
	if (state) {
		*state = _state;
	} else {
		backing_photo_state_destroy (&_state);
	}
	if (detected) {
		*detected = _detected;
	} else {
		_detected_photo_information_unref0 (_detected);
	}
	return result;
}


static void _vala_array_add166 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add167 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add168 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add169 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add170 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static gpointer _media_metadata_ref0 (gpointer self) {
	return self ? media_metadata_ref (self) : NULL;
}


gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error) {
	PhotoReimportMasterState* _reimport_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	GFile* file;
	BackingPhotoState state = {0};
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoState _tmp4_ = {0};
	DetectedPhotoInformation* _tmp5_ = NULL;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	PhotoRow updated_row = {0};
	gchar** _tmp16_ = NULL;
	gchar** list;
	gint list_length1;
	gint _list_size_;
	BackingPhotoState _tmp29_;
	BackingPhotoState _tmp30_ = {0};
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	PhotoMetadata* metadata;
	PhotoReimportMasterStateImpl* _tmp39_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	_tmp0_ = photo_get_master_reader (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
	_tmp3_ = _tmp2_;
	_photo_file_adapter_unref0 (_tmp1_);
	file = _tmp3_;
	memset (&state, 0, sizeof (BackingPhotoState));
	_tmp6_ = photo_query_backing_photo_state (self, file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp4_, &_tmp5_, &_inner_error_);
	backing_photo_state_destroy (&state);
	state = _tmp4_;
	_detected_photo_information_unref0 (detected);
	detected = _tmp5_;
	_tmp7_ = _tmp6_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_detected_photo_information_unref0 (detected);
		backing_photo_state_destroy (&state);
		_g_object_unref0 (file);
		return FALSE;
	}
	if (!_tmp7_) {
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		_tmp8_ = g_file_get_path (file);
		_tmp9_ = _tmp8_;
		g_warning ("Photo.vala:867: Unable to retrieve photo state from %s for reimport", _tmp9_);
		_g_free0 (_tmp9_);
		result = FALSE;
		_detected_photo_information_unref0 (detected);
		backing_photo_state_destroy (&state);
		_g_object_unref0 (file);
		if (reimport_state) {
			*reimport_state = _reimport_state;
		} else {
			_photo_reimport_master_state_unref0 (_reimport_state);
		}
		return result;
	}
	if (detected->colorspace != GDK_COLORSPACE_RGB) {
		_tmp11_ = TRUE;
	} else {
		_tmp11_ = detected->channels < 3;
	}
	if (_tmp11_) {
		_tmp10_ = TRUE;
	} else {
		_tmp10_ = detected->bits_per_channel != 8;
	}
	if (_tmp10_) {
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_;
		_tmp12_ = g_file_get_path (file);
		_tmp13_ = _tmp12_;
		g_warning ("Photo.vala:876: Not re-importing %s: Unsupported color format", _tmp13_);
		_g_free0 (_tmp13_);
		result = FALSE;
		_detected_photo_information_unref0 (detected);
		backing_photo_state_destroy (&state);
		_g_object_unref0 (file);
		if (reimport_state) {
			*reimport_state = _reimport_state;
		} else {
			_photo_reimport_master_state_unref0 (_reimport_state);
		}
		return result;
	}
	photo_row_init (&updated_row);
	{
		PhotoRow _tmp14_;
		PhotoRow _tmp15_ = {0};
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		photo_row_copy (&self->priv->row, &_tmp15_);
		_tmp14_ = _tmp15_;
		photo_row_destroy (&updated_row);
		updated_row = _tmp14_;
		__finally117:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			photo_row_destroy (&updated_row);
			_detected_photo_information_unref0 (detected);
			backing_photo_state_destroy (&state);
			_g_object_unref0 (file);
			return FALSE;
		}
	}
	_tmp16_ = g_new0 (gchar*, 0 + 1);
	list = _tmp16_;
	list_length1 = 0;
	_list_size_ = 0;
	if (g_strcmp0 (updated_row.md5, detected->md5) != 0) {
		gchar* _tmp17_;
		_tmp17_ = g_strdup ("metadata:md5");
		_vala_array_add166 (&list, &list_length1, &_list_size_, _tmp17_);
	}
	if (updated_row.master.original_orientation != state.original_orientation) {
		gchar* _tmp18_;
		_tmp18_ = g_strdup ("image:orientation");
		_vala_array_add167 (&list, &list_length1, &_list_size_, _tmp18_);
		updated_row.orientation = state.original_orientation;
	}
	if (detected->metadata != NULL) {
		MetadataDateTime* _tmp19_ = NULL;
		MetadataDateTime* date_time;
		gboolean _tmp20_ = FALSE;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		gboolean _tmp25_;
		Rating _tmp27_;
		_tmp19_ = photo_metadata_get_exposure_date_time (detected->metadata);
		date_time = _tmp19_;
		if (date_time != NULL) {
			time_t _tmp21_;
			_tmp21_ = metadata_date_time_get_timestamp (date_time);
			_tmp20_ = updated_row.exposure_time != _tmp21_;
		} else {
			_tmp20_ = FALSE;
		}
		if (_tmp20_) {
			gchar* _tmp22_;
			_tmp22_ = g_strdup ("metadata:exposure-time");
			_vala_array_add168 (&list, &list_length1, &_list_size_, _tmp22_);
		}
		_tmp23_ = media_metadata_get_title (MEDIA_METADATA (detected->metadata));
		_tmp24_ = _tmp23_;
		_tmp25_ = g_strcmp0 (updated_row.title, _tmp24_) != 0;
		_g_free0 (_tmp24_);
		if (_tmp25_) {
			gchar* _tmp26_;
			_tmp26_ = g_strdup ("metadata:name");
			_vala_array_add169 (&list, &list_length1, &_list_size_, _tmp26_);
		}
		_tmp27_ = photo_metadata_get_rating (detected->metadata);
		if (updated_row.rating != _tmp27_) {
			gchar* _tmp28_;
			_tmp28_ = g_strdup ("metadata:rating");
			_vala_array_add170 (&list, &list_length1, &_list_size_, _tmp28_);
		}
		_metadata_date_time_unref0 (date_time);
	}
	backing_photo_state_copy (&state, &_tmp30_);
	_tmp29_ = _tmp30_;
	backing_photo_state_destroy (&updated_row.master);
	updated_row.master = _tmp29_;
	_tmp31_ = g_strdup (detected->md5);
	_g_free0 (updated_row.md5);
	updated_row.md5 = _tmp31_;
	_tmp32_ = g_strdup (detected->exif_md5);
	_g_free0 (updated_row.exif_md5);
	updated_row.exif_md5 = _tmp32_;
	_tmp33_ = g_strdup (detected->thumbnail_md5);
	_g_free0 (updated_row.thumbnail_md5);
	updated_row.thumbnail_md5 = _tmp33_;
	metadata = NULL;
	if (detected->metadata != NULL) {
		PhotoMetadata* _tmp34_;
		MetadataDateTime* _tmp35_ = NULL;
		MetadataDateTime* date_time;
		gchar* _tmp37_ = NULL;
		Rating _tmp38_;
		_tmp34_ = _media_metadata_ref0 (detected->metadata);
		_media_metadata_unref0 (metadata);
		metadata = _tmp34_;
		_tmp35_ = photo_metadata_get_exposure_date_time (detected->metadata);
		date_time = _tmp35_;
		if (date_time != NULL) {
			time_t _tmp36_;
			_tmp36_ = metadata_date_time_get_timestamp (date_time);
			updated_row.exposure_time = _tmp36_;
		}
		_tmp37_ = media_metadata_get_title (MEDIA_METADATA (detected->metadata));
		_g_free0 (updated_row.title);
		updated_row.title = _tmp37_;
		_tmp38_ = photo_metadata_get_rating (detected->metadata);
		updated_row.rating = _tmp38_;
		_metadata_date_time_unref0 (date_time);
	}
	_tmp39_ = photo_reimport_master_state_impl_new (&updated_row, metadata, list, list_length1);
	_photo_reimport_master_state_unref0 (_reimport_state);
	_reimport_state = PHOTO_REIMPORT_MASTER_STATE (_tmp39_);
	result = TRUE;
	_media_metadata_unref0 (metadata);
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
	photo_row_destroy (&updated_row);
	_detected_photo_information_unref0 (detected);
	backing_photo_state_destroy (&state);
	_g_object_unref0 (file);
	if (reimport_state) {
		*reimport_state = _reimport_state;
	} else {
		_photo_reimport_master_state_unref0 (_reimport_state);
	}
	return result;
}


static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
	g_return_if_fail (IS_PHOTO (self));
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
	PHOTO_GET_CLASS (self)->apply_user_metadata_for_reimport (self, metadata);
}


static gpointer _photo_reimport_master_state_ref0 (gpointer self) {
	return self ? photo_reimport_master_state_ref (self) : NULL;
}


static void _vala_array_add171 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add172 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error) {
	PhotoReimportMasterStateImpl* _tmp0_;
	PhotoReimportMasterStateImpl* reimport_state;
	PhotoTable* _tmp1_ = NULL;
	PhotoTable* _tmp2_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
	_tmp0_ = _photo_reimport_master_state_ref0 (PHOTO_REIMPORT_MASTER_STATE_IMPL (state));
	reimport_state = _tmp0_;
	_tmp1_ = photo_table_get_instance ();
	_tmp2_ = _tmp1_;
	photo_table_reimport (_tmp2_, &reimport_state->row, &_inner_error_);
	_database_table_unref0 (_tmp2_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_photo_reimport_master_state_unref0 (reimport_state);
			return;
		} else {
			_photo_reimport_master_state_unref0 (reimport_state);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	{
		PhotoRow _tmp3_;
		PhotoRow _tmp4_ = {0};
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		photo_row_copy (&reimport_state->row, &_tmp4_);
		_tmp3_ = _tmp4_;
		photo_row_destroy (&self->priv->row);
		self->priv->row = _tmp3_;
		if (!reimport_state->metadata_only) {
			photo_internal_remove_all_transformations (self, FALSE);
		}
		__finally118:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_photo_reimport_master_state_unref0 (reimport_state);
				return;
			} else {
				_photo_reimport_master_state_unref0 (reimport_state);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	if (reimport_state->metadata != NULL) {
		photo_apply_user_metadata_for_reimport (self, reimport_state->metadata);
	}
	if (!reimport_state->metadata_only) {
		gchar* _tmp5_;
		gboolean _tmp6_;
		_tmp5_ = g_strdup ("image:master");
		_vala_array_add171 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp5_);
		_tmp6_ = photo_is_master_baseline (self);
		if (_tmp6_) {
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("image:baseline");
			_vala_array_add172 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp7_);
		}
	}
	if (reimport_state->alterations_length1 > 0) {
		Alteration* _tmp8_ = NULL;
		Alteration* _tmp9_;
		_tmp8_ = alteration_new_from_array (reimport_state->alterations, reimport_state->alterations_length1);
		_tmp9_ = _tmp8_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp9_);
		_alteration_unref0 (_tmp9_);
	}
	photo_notify_master_reimported (self, reimport_state->metadata);
	_tmp10_ = photo_is_master_baseline (self);
	if (_tmp10_) {
		photo_notify_baseline_reimported (self, reimport_state->metadata);
	}
	_tmp11_ = photo_is_master_source (self);
	if (_tmp11_) {
		photo_notify_source_reimported (self, reimport_state->metadata);
	}
	_photo_reimport_master_state_unref0 (reimport_state);
}


gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _state = NULL;
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	GFile* file;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoState backing_state = {0};
	BackingPhotoState _tmp1_ = {0};
	DetectedPhotoInformation* _tmp2_ = NULL;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	PhotoReimportEditableStateImpl* _tmp9_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	_tmp0_ = photo_get_editable_file (self);
	file = _tmp0_;
	if (file == NULL) {
		result = FALSE;
		_g_object_unref0 (file);
		if (state) {
			*state = _state;
		} else {
			_photo_reimport_editable_state_unref0 (_state);
		}
		return result;
	}
	memset (&backing_state, 0, sizeof (BackingPhotoState));
	_tmp3_ = photo_query_backing_photo_state (self, file, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp1_, &_tmp2_, &_inner_error_);
	backing_photo_state_destroy (&backing_state);
	backing_state = _tmp1_;
	_detected_photo_information_unref0 (detected);
	detected = _tmp2_;
	_tmp4_ = _tmp3_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		backing_photo_state_destroy (&backing_state);
		_detected_photo_information_unref0 (detected);
		_g_object_unref0 (file);
		return FALSE;
	}
	if (!_tmp4_) {
		result = FALSE;
		backing_photo_state_destroy (&backing_state);
		_detected_photo_information_unref0 (detected);
		_g_object_unref0 (file);
		if (state) {
			*state = _state;
		} else {
			_photo_reimport_editable_state_unref0 (_state);
		}
		return result;
	}
	if (detected->colorspace != GDK_COLORSPACE_RGB) {
		_tmp6_ = TRUE;
	} else {
		_tmp6_ = detected->channels < 3;
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		_tmp5_ = detected->bits_per_channel != 8;
	}
	if (_tmp5_) {
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		_tmp7_ = g_file_get_path (file);
		_tmp8_ = _tmp7_;
		g_warning ("Photo.vala:984: Not re-importing %s: Unsupported color format", _tmp8_);
		_g_free0 (_tmp8_);
		result = FALSE;
		backing_photo_state_destroy (&backing_state);
		_detected_photo_information_unref0 (detected);
		_g_object_unref0 (file);
		if (state) {
			*state = _state;
		} else {
			_photo_reimport_editable_state_unref0 (_state);
		}
		return result;
	}
	_tmp9_ = photo_reimport_editable_state_impl_new (&backing_state, detected->metadata);
	_photo_reimport_editable_state_unref0 (_state);
	_state = PHOTO_REIMPORT_EDITABLE_STATE (_tmp9_);
	result = TRUE;
	backing_photo_state_destroy (&backing_state);
	_detected_photo_information_unref0 (detected);
	_g_object_unref0 (file);
	if (state) {
		*state = _state;
	} else {
		_photo_reimport_editable_state_unref0 (_state);
	}
	return result;
}


static gpointer _photo_reimport_editable_state_ref0 (gpointer self) {
	return self ? photo_reimport_editable_state_ref (self) : NULL;
}


void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error) {
	BackingPhotoID _tmp0_ = {0};
	BackingPhotoID _tmp1_ = {0};
	BackingPhotoID editable_id;
	gboolean _tmp2_;
	PhotoReimportEditableStateImpl* _tmp3_;
	PhotoReimportEditableStateImpl* reimport_state;
	gchar* _tmp11_;
	gchar* list;
	Alteration* _tmp13_ = NULL;
	Alteration* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
	photo_get_editable_id (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	editable_id = _tmp1_;
	_tmp2_ = backing_photo_id_is_invalid (&editable_id);
	if (_tmp2_) {
		return;
	}
	_tmp3_ = _photo_reimport_editable_state_ref0 (PHOTO_REIMPORT_EDITABLE_STATE_IMPL (state));
	reimport_state = _tmp3_;
	if (!reimport_state->metadata_only) {
		BackingPhotoTable* _tmp4_ = NULL;
		BackingPhotoTable* _tmp5_;
		_tmp4_ = backing_photo_table_get_instance ();
		_tmp5_ = _tmp4_;
		backing_photo_table_update (_tmp5_, &editable_id, &reimport_state->backing_state, &_inner_error_);
		_database_table_unref0 (_tmp5_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_photo_reimport_editable_state_unref0 (reimport_state);
				return;
			} else {
				_photo_reimport_editable_state_unref0 (reimport_state);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		{
			BackingPhotoState _tmp6_;
			BackingPhotoState _tmp7_ = {0};
			g_static_rec_mutex_lock (&self->priv->__lock_row);
			backing_photo_state_copy (&reimport_state->backing_state, &_tmp7_);
			_tmp6_ = _tmp7_;
			backing_photo_state_destroy (&self->priv->editable);
			self->priv->editable = _tmp6_;
			photo_set_orientation (self, reimport_state->backing_state.original_orientation);
			photo_internal_remove_all_transformations (self, FALSE);
			__finally119:
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == DATABASE_ERROR) {
					g_propagate_error (error, _inner_error_);
					_photo_reimport_editable_state_unref0 (reimport_state);
					return;
				} else {
					_photo_reimport_editable_state_unref0 (reimport_state);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
		}
	} else {
		photo_set_orientation (self, reimport_state->backing_state.original_orientation);
	}
	if (reimport_state->metadata != NULL) {
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		Rating _tmp10_;
		_tmp8_ = media_metadata_get_title (MEDIA_METADATA (reimport_state->metadata));
		_tmp9_ = _tmp8_;
		media_source_set_title (MEDIA_SOURCE (self), _tmp9_);
		_g_free0 (_tmp9_);
		_tmp10_ = photo_metadata_get_rating (reimport_state->metadata);
		media_source_set_rating (MEDIA_SOURCE (self), _tmp10_);
		photo_apply_user_metadata_for_reimport (self, reimport_state->metadata);
	}
	_tmp11_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
	list = _tmp11_;
	if (!reimport_state->metadata_only) {
		gchar* _tmp12_;
		_tmp12_ = g_strconcat (list, "image:editable,image:baseline", NULL);
		_g_free0 (list);
		list = _tmp12_;
	}
	_tmp13_ = alteration_new_from_list (list);
	_tmp14_ = _tmp13_;
	data_object_notify_altered (DATA_OBJECT (self), _tmp14_);
	_alteration_unref0 (_tmp14_);
	photo_notify_editable_reimported (self, reimport_state->metadata);
	_tmp15_ = photo_is_editable_baseline (self);
	if (_tmp15_) {
		photo_notify_baseline_reimported (self, reimport_state->metadata);
	}
	_tmp16_ = photo_is_editable_source (self);
	if (_tmp16_) {
		photo_notify_source_reimported (self, reimport_state->metadata);
	}
	_g_free0 (list);
	_photo_reimport_editable_state_unref0 (reimport_state);
}


static gchar* photo_real_get_typename (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
	self = PHOTO (base);
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
	result = _tmp0_;
	return result;
}


static gint64 photo_real_get_instance_id (DataSource* base) {
	Photo * self;
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	PhotoID _tmp1_ = {0};
	self = PHOTO (base);
	photo_get_photo_id (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	result = _tmp1_.id;
	return result;
}


static gchar* photo_real_get_source_id (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gint64 _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	self = PHOTO (base);
	_tmp0_ = data_source_get_typename (DATA_SOURCE (self));
	_tmp1_ = _tmp0_;
	_tmp2_ = data_source_get_instance_id (DATA_SOURCE (self));
	_tmp3_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp1_);
	result = _tmp4_;
	return result;
}


void photo_set_master_timestamp (Photo* self, GFileInfo* info) {
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	gboolean _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (G_IS_FILE_INFO (info));
	g_file_info_get_modification_time (info, &_tmp0_);
	modification = _tmp0_;
	{
		PhotoTable* _tmp1_ = NULL;
		PhotoTable* _tmp2_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->row.master.timestamp == modification.tv_sec) {
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
			return;
		}
		_tmp1_ = photo_table_get_instance ();
		_tmp2_ = _tmp1_;
		photo_table_update_timestamp (_tmp2_, &self->priv->row.photo_id, (time_t) modification.tv_sec, &_inner_error_);
		_database_table_unref0 (_tmp2_);
		if (_inner_error_ != NULL) {
			goto __finally121;
		}
		self->priv->row.master.timestamp = (time_t) modification.tv_sec;
		__finally121:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				goto __catch120_database_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally120;
	__catch120_database_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		app_window_database_error (err);
		_g_error_free0 (err);
		return;
	}
	__finally120:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp3_ = photo_is_master_baseline (self);
	if (_tmp3_) {
		Alteration* _tmp4_ = NULL;
		Alteration* _tmp5_;
		_tmp4_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
		_tmp5_ = _tmp4_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp5_);
		_alteration_unref0 (_tmp5_);
	} else {
		Alteration* _tmp6_ = NULL;
		Alteration* _tmp7_;
		_tmp6_ = alteration_new ("metadata", "master-timestamp");
		_tmp7_ = _tmp6_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp7_);
		_alteration_unref0 (_tmp7_);
	}
}


void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error) {
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	gboolean altered;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (G_IS_FILE_INFO (info));
	g_file_info_get_modification_time (info, &_tmp0_);
	modification = _tmp0_;
	altered = FALSE;
	{
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp2_ = backing_photo_id_is_valid (&self->priv->row.editable_id);
		if (_tmp2_) {
			_tmp1_ = self->priv->editable.timestamp != modification.tv_sec;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			BackingPhotoTable* _tmp3_ = NULL;
			BackingPhotoTable* _tmp4_;
			_tmp3_ = backing_photo_table_get_instance ();
			_tmp4_ = _tmp3_;
			backing_photo_table_update_timestamp (_tmp4_, &self->priv->row.editable_id, (time_t) modification.tv_sec, &_inner_error_);
			_database_table_unref0 (_tmp4_);
			if (_inner_error_ != NULL) {
				goto __finally122;
			}
			self->priv->editable.timestamp = (time_t) modification.tv_sec;
			altered = TRUE;
		}
		__finally122:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	if (altered) {
		Alteration* _tmp5_ = NULL;
		Alteration* _tmp6_;
		_tmp5_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
		_tmp6_ = _tmp5_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp6_);
		_alteration_unref0 (_tmp6_);
	}
}


void photo_update_many_editable_timestamps (GeeMap* map, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (GEE_IS_MAP (map));
	database_table_begin_transaction ();
	{
		GeeSet* _tmp0_ = NULL;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _tmp3_;
		GeeIterator* _photo_it;
		_tmp0_ = gee_map_get_keys (map);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_photo_it = _tmp3_;
		while (TRUE) {
			gboolean _tmp4_;
			gpointer _tmp5_ = NULL;
			Photo* photo;
			gpointer _tmp6_ = NULL;
			GFileInfo* _tmp7_;
			_tmp4_ = gee_iterator_next (_photo_it);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = gee_iterator_get (_photo_it);
			photo = (Photo*) _tmp5_;
			_tmp6_ = gee_map_get (map, photo);
			_tmp7_ = (GFileInfo*) _tmp6_;
			photo_update_editable_modification_time (photo, _tmp7_, &_inner_error_);
			_g_object_unref0 (_tmp7_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == DATABASE_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (photo);
					_g_object_unref0 (_photo_it);
					return;
				} else {
					_g_object_unref0 (photo);
					_g_object_unref0 (_photo_it);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
			_g_object_unref0 (photo);
		}
		_g_object_unref0 (_photo_it);
	}
	database_table_commit_transaction (&_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base) {
	Photo * self;
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat _tmp1_;
	gboolean _tmp2_;
	self = PHOTO (base);
	_tmp1_ = photo_get_file_format (self);
	_tmp2_ = photo_file_format_can_write_image (_tmp1_);
	if (_tmp2_) {
		PhotoFileFormat _tmp3_;
		_tmp3_ = photo_get_file_format (self);
		_tmp0_ = _tmp3_;
	} else {
		PhotoFileFormat _tmp4_;
		_tmp4_ = photo_file_format_get_system_default_format ();
		_tmp0_ = _tmp4_;
	}
	result = _tmp0_;
	return result;
}


static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	Scaling _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	scaling_for_best_fit (scale, TRUE, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_source_get_pixbuf (PHOTO_SOURCE (self), &_tmp1_, &_inner_error_);
	_tmp3_ = _tmp2_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	result = _tmp3_;
	return result;
}


gboolean photo_is_file_image (GFile* file) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	_tmp1_ = photo_file_format_is_file_supported (file);
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = g_file_get_basename (file);
		_tmp3_ = _tmp2_;
		_tmp4_ = photo_is_extension_found (_tmp3_, PHOTO_IMAGE_EXTENSIONS, G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
		_tmp0_ = _tmp4_;
		_g_free0 (_tmp3_);
	}
	result = _tmp0_;
	return result;
}


static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1) {
	gboolean result = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (basename != NULL, FALSE);
	disassemble_filename (basename, &_tmp0_, &_tmp1_);
	_g_free0 (name);
	name = _tmp0_;
	_g_free0 (ext);
	ext = _tmp1_;
	if (ext == NULL) {
		result = FALSE;
		_g_free0 (ext);
		_g_free0 (name);
		return result;
	}
	_tmp2_ = g_utf8_strdown (ext, (gssize) (-1));
	_g_free0 (ext);
	ext = _tmp2_;
	{
		gchar** extension_collection;
		int extension_collection_length1;
		int extension_it;
		extension_collection = extensions;
		extension_collection_length1 = extensions_length1;
		for (extension_it = 0; extension_it < extensions_length1; extension_it = extension_it + 1) {
			gchar* _tmp3_;
			gchar* extension;
			_tmp3_ = g_strdup (extension_collection[extension_it]);
			extension = _tmp3_;
			{
				if (g_strcmp0 (ext, extension) == 0) {
					result = TRUE;
					_g_free0 (extension);
					_g_free0 (ext);
					_g_free0 (name);
					return result;
				}
				_g_free0 (extension);
			}
		}
	}
	result = FALSE;
	_g_free0 (ext);
	_g_free0 (name);
	return result;
}


gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
	_tmp0_ = photo_table_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_table_has_duplicate (_tmp1_, file, thumbnail_md5, full_md5, file_format);
	_tmp3_ = _tmp2_;
	_database_table_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1) {
	PhotoID* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	gint _tmp2_;
	PhotoID* _tmp3_ = NULL;
	PhotoID* _tmp4_;
	PhotoID* _tmp5_;
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
	_tmp0_ = photo_table_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp3_ = photo_table_get_duplicate_ids (_tmp1_, file, thumbnail_md5, full_md5, file_format, &_tmp2_);
	_tmp4_ = _tmp3_;
	_database_table_unref0 (_tmp1_);
	_tmp5_ = _tmp4_;
	*result_length1 = _tmp2_;
	result = _tmp5_;
	return result;
}


gint64 photo_get_photo_key (DataSource* source) {
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	PhotoID _tmp1_ = {0};
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0LL);
	photo_get_photo_id (PHOTO (LIBRARY_PHOTO (source)), &_tmp0_);
	_tmp1_ = _tmp0_;
	result = _tmp1_.id;
	return result;
}


static GFile* photo_real_get_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	self = PHOTO (base);
	_tmp0_ = photo_get_source_reader (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
	_tmp3_ = _tmp2_;
	_photo_file_adapter_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


static void _vala_array_add173 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add174 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add175 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add176 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


void photo_set_master_file (Photo* self, GFile* file) {
	gchar* _tmp0_ = NULL;
	gchar* filepath;
	gboolean altered;
	gboolean is_baseline;
	gboolean is_source;
	gboolean name_changed;
	GFile* old_file;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (G_IS_FILE (file));
	_tmp0_ = g_file_get_path (file);
	filepath = _tmp0_;
	altered = FALSE;
	is_baseline = FALSE;
	is_source = FALSE;
	name_changed = FALSE;
	old_file = NULL;
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		{
			GFile* _tmp1_ = NULL;
			gboolean _tmp2_;
			g_static_rec_mutex_lock (&self->priv->__lock_readers);
			_tmp1_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (self->priv->readers.master));
			_g_object_unref0 (old_file);
			old_file = _tmp1_;
			_tmp2_ = g_file_equal (file, old_file);
			if (!_tmp2_) {
				PhotoTable* _tmp3_ = NULL;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
				PhotoID _tmp6_ = {0};
				gchar* _tmp7_;
				gchar* _tmp8_ = NULL;
				PhotoFileReader* _tmp9_ = NULL;
				gboolean _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
				_tmp3_ = photo_table_get_instance ();
				_tmp4_ = _tmp3_;
				photo_get_photo_id (self, &_tmp5_);
				_tmp6_ = _tmp5_;
				photo_table_set_filepath (_tmp4_, &_tmp6_, filepath, &_inner_error_);
				_database_table_unref0 (_tmp4_);
				if (_inner_error_ != NULL) {
					goto __finally125;
				}
				_tmp7_ = g_strdup (filepath);
				_g_free0 (self->priv->row.master.filepath);
				self->priv->row.master.filepath = _tmp7_;
				_tmp8_ = g_file_get_basename (file);
				_g_free0 (self->priv->file_title);
				self->priv->file_title = _tmp8_;
				_tmp9_ = photo_file_format_create_reader (self->priv->row.master.file_format, filepath);
				_photo_file_adapter_unref0 (self->priv->readers.master);
				self->priv->readers.master = _tmp9_;
				altered = TRUE;
				_tmp10_ = photo_is_master_baseline (self);
				is_baseline = _tmp10_;
				_tmp11_ = photo_is_master_source (self);
				is_source = _tmp11_;
				_tmp13_ = is_string_empty (self->priv->row.title);
				if (_tmp13_) {
					gchar* _tmp14_ = NULL;
					gchar* _tmp15_;
					gchar* _tmp16_ = NULL;
					gchar* _tmp17_;
					_tmp14_ = g_file_get_basename (old_file);
					_tmp15_ = _tmp14_;
					_tmp16_ = g_file_get_basename (file);
					_tmp17_ = _tmp16_;
					_tmp12_ = g_strcmp0 (_tmp15_, _tmp17_) != 0;
					_g_free0 (_tmp17_);
					_g_free0 (_tmp15_);
				} else {
					_tmp12_ = FALSE;
				}
				name_changed = _tmp12_;
			}
			__finally125:
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
			if (_inner_error_ != NULL) {
				goto __finally124;
			}
		}
		__finally124:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				goto __catch123_database_error;
			}
			_g_object_unref0 (old_file);
			_g_free0 (filepath);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally123;
	__catch123_database_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		app_window_database_error (err);
		_g_error_free0 (err);
	}
	__finally123:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (old_file);
		_g_free0 (filepath);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	if (altered) {
		gchar** _tmp18_ = NULL;
		gchar** alteration_list;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar* _tmp19_;
		Alteration* _tmp23_ = NULL;
		Alteration* _tmp24_;
		media_source_notify_master_replaced (MEDIA_SOURCE (self), old_file, file);
		if (is_baseline) {
			photo_notify_baseline_replaced (self);
		}
		_tmp18_ = g_new0 (gchar*, 0 + 1);
		alteration_list = _tmp18_;
		alteration_list_length1 = 0;
		_alteration_list_size_ = 0;
		_tmp19_ = g_strdup ("backing:master");
		_vala_array_add173 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp19_);
		if (name_changed) {
			gchar* _tmp20_;
			_tmp20_ = g_strdup ("metadata:name");
			_vala_array_add174 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp20_);
		}
		if (is_source) {
			gchar* _tmp21_;
			_tmp21_ = g_strdup ("backing:source");
			_vala_array_add175 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp21_);
		}
		if (is_baseline) {
			gchar* _tmp22_;
			_tmp22_ = g_strdup ("backing:baseline");
			_vala_array_add176 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp22_);
		}
		_tmp23_ = alteration_new_from_array (alteration_list, alteration_list_length1);
		_tmp24_ = _tmp23_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp24_);
		_alteration_unref0 (_tmp24_);
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
	}
	_g_object_unref0 (old_file);
	_g_free0 (filepath);
}


static void _vala_array_add177 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add178 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add179 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


void photo_set_editable_file (Photo* self, GFile* file) {
	gchar* _tmp0_ = NULL;
	gchar* filepath;
	gboolean altered;
	gboolean is_baseline;
	gboolean is_source;
	GFile* old_file;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (G_IS_FILE (file));
	_tmp0_ = g_file_get_path (file);
	filepath = _tmp0_;
	altered = FALSE;
	is_baseline = FALSE;
	is_source = FALSE;
	old_file = NULL;
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		{
			GFile* _tmp1_ = NULL;
			GFile* _tmp3_;
			gboolean _tmp4_ = FALSE;
			g_static_rec_mutex_lock (&self->priv->__lock_readers);
			if (self->priv->readers.editable != NULL) {
				GFile* _tmp2_ = NULL;
				_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (self->priv->readers.editable));
				_g_object_unref0 (_tmp1_);
				_tmp1_ = _tmp2_;
			} else {
				_g_object_unref0 (_tmp1_);
				_tmp1_ = NULL;
			}
			_tmp3_ = _g_object_ref0 (_tmp1_);
			_g_object_unref0 (old_file);
			old_file = _tmp3_;
			if (old_file != NULL) {
				gboolean _tmp5_;
				_tmp5_ = g_file_equal (old_file, file);
				_tmp4_ = !_tmp5_;
			} else {
				_tmp4_ = FALSE;
			}
			if (_tmp4_) {
				BackingPhotoTable* _tmp6_ = NULL;
				BackingPhotoTable* _tmp7_;
				gchar* _tmp8_;
				PhotoFileReader* _tmp9_ = NULL;
				gboolean _tmp10_;
				gboolean _tmp11_;
				_tmp6_ = backing_photo_table_get_instance ();
				_tmp7_ = _tmp6_;
				backing_photo_table_set_filepath (_tmp7_, &self->priv->row.editable_id, filepath, &_inner_error_);
				_database_table_unref0 (_tmp7_);
				if (_inner_error_ != NULL) {
					_g_object_unref0 (_tmp1_);
					goto __finally128;
				}
				_tmp8_ = g_strdup (filepath);
				_g_free0 (self->priv->editable.filepath);
				self->priv->editable.filepath = _tmp8_;
				_tmp9_ = photo_file_format_create_reader (self->priv->editable.file_format, filepath);
				_photo_file_adapter_unref0 (self->priv->readers.editable);
				self->priv->readers.editable = _tmp9_;
				altered = TRUE;
				_tmp10_ = photo_is_editable_baseline (self);
				is_baseline = _tmp10_;
				_tmp11_ = photo_is_editable_source (self);
				is_source = _tmp11_;
			}
			_g_object_unref0 (_tmp1_);
			__finally128:
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
			if (_inner_error_ != NULL) {
				goto __finally127;
			}
		}
		__finally127:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				goto __catch126_database_error;
			}
			_g_object_unref0 (old_file);
			_g_free0 (filepath);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally126;
	__catch126_database_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		app_window_database_error (err);
		_g_error_free0 (err);
	}
	__finally126:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (old_file);
		_g_free0 (filepath);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	if (altered) {
		gchar** _tmp12_ = NULL;
		gchar** alteration_list;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar* _tmp13_;
		Alteration* _tmp16_ = NULL;
		Alteration* _tmp17_;
		photo_notify_editable_replaced (self, old_file, file);
		if (is_baseline) {
			photo_notify_baseline_replaced (self);
		}
		_tmp12_ = g_new0 (gchar*, 0 + 1);
		alteration_list = _tmp12_;
		alteration_list_length1 = 0;
		_alteration_list_size_ = 0;
		_tmp13_ = g_strdup ("backing:editable");
		_vala_array_add177 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp13_);
		if (is_baseline) {
			gchar* _tmp14_;
			_tmp14_ = g_strdup ("backing:baseline");
			_vala_array_add178 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp14_);
		}
		if (is_source) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("backing:source");
			_vala_array_add179 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp15_);
		}
		_tmp16_ = alteration_new_from_array (alteration_list, alteration_list_length1);
		_tmp17_ = _tmp16_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp17_);
		_alteration_unref0 (_tmp17_);
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
	}
	_g_object_unref0 (old_file);
	_g_free0 (filepath);
}


void photo_set_many_editable_file (GeeMap* map, GError** error) {
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	GeeMapIterator* _tmp2_ = NULL;
	GeeMapIterator* map_iter;
	PhotoTable* _tmp8_ = NULL;
	PhotoTable* _tmp9_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (GEE_IS_MAP (map));
	_tmp0_ = photo_table_get_instance ();
	_tmp1_ = _tmp0_;
	database_table_begin_transaction ();
	_database_table_unref0 (_tmp1_);
	_tmp2_ = gee_map_map_iterator (map);
	map_iter = _tmp2_;
	while (TRUE) {
		gboolean _tmp3_;
		gpointer _tmp4_ = NULL;
		Photo* _tmp5_;
		gpointer _tmp6_ = NULL;
		GFile* _tmp7_;
		_tmp3_ = gee_map_iterator_next (map_iter);
		if (!_tmp3_) {
			break;
		}
		_tmp4_ = gee_map_iterator_get_key (map_iter);
		_tmp5_ = (Photo*) _tmp4_;
		_tmp6_ = gee_map_iterator_get_value (map_iter);
		_tmp7_ = (GFile*) _tmp6_;
		photo_set_editable_file (_tmp5_, _tmp7_);
		_g_object_unref0 (_tmp7_);
		_g_object_unref0 (_tmp5_);
	}
	_tmp8_ = photo_table_get_instance ();
	_tmp9_ = _tmp8_;
	database_table_commit_transaction (&_inner_error_);
	_database_table_unref0 (_tmp9_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (map_iter);
			return;
		} else {
			_g_object_unref0 (map_iter);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (map_iter);
}


GFile* photo_get_actual_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	_tmp0_ = photo_get_baseline_reader (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
	_tmp3_ = _tmp2_;
	_photo_file_adapter_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


static GFile* photo_real_get_master_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	self = PHOTO (base);
	_tmp0_ = photo_get_master_reader (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
	_tmp3_ = _tmp2_;
	_photo_file_adapter_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


GFile* photo_get_editable_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	GFile* _tmp1_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	_tmp0_ = photo_get_editable_reader (self);
	reader = _tmp0_;
	if (reader != NULL) {
		GFile* _tmp2_ = NULL;
		_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (reader));
		_g_object_unref0 (_tmp1_);
		_tmp1_ = _tmp2_;
	} else {
		_g_object_unref0 (_tmp1_);
		_tmp1_ = NULL;
	}
	result = _tmp1_;
	_photo_file_adapter_unref0 (reader);
	return result;
}


GFile* photo_get_source_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	_tmp0_ = photo_get_source_reader (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
	_tmp3_ = _tmp2_;
	_photo_file_adapter_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


PhotoFileFormat photo_get_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), 0);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		result = (*self->priv->backing_photo_state).file_format;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally129:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


PhotoFileFormat photo_get_best_export_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_;
	PhotoFileFormat file_format;
	gboolean _tmp1_;
	g_return_val_if_fail (IS_PHOTO (self), 0);
	_tmp0_ = photo_get_file_format (self);
	file_format = _tmp0_;
	_tmp1_ = photo_file_format_can_write (file_format);
	if (!_tmp1_) {
		PhotoFileFormat _tmp2_;
		_tmp2_ = photo_file_format_get_system_default_format ();
		file_format = _tmp2_;
	}
	result = file_format;
	return result;
}


PhotoFileFormat photo_get_master_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), 0);
	{
		PhotoFileFormat _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (self->priv->readers.master));
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally130:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


static time_t photo_real_get_timestamp (MediaSource* base) {
	Photo * self;
	time_t result = 0;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		result = (*self->priv->backing_photo_state).timestamp;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally131:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


void photo_get_photo_id (Photo* self, PhotoID* result) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		*result = self->priv->row.photo_id;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return;
		__finally132:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static inline void photo_real_get_event_id (MediaSource* base, EventID* result) {
	Photo * self;
	self = PHOTO (base);
	*result = self->priv->row.event_id;
	return;
}


inline gint64 photo_get_raw_event_id (Photo* self) {
	gint64 result = 0LL;
	g_return_val_if_fail (IS_PHOTO (self), 0LL);
	result = self->priv->row.event_id.id;
	return result;
}


static void photo_real_get_import_id (MediaSource* base, ImportID* result) {
	Photo * self;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		*result = self->priv->row.import_id;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return;
		__finally133:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void photo_get_editable_id (Photo* self, BackingPhotoID* result) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		*result = self->priv->row.editable_id;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return;
		__finally134:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static gchar* photo_real_get_master_md5 (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		gchar* _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = g_strdup (self->priv->row.md5);
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally135:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


guint64 photo_get_flags (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		result = self->priv->row.flags;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally136:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0ULL;
	}
}


static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration) {
	Alteration* _tmp0_ = NULL;
	Alteration* alteration;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration));
	_tmp0_ = alteration_new ("metadata", "flags");
	alteration = _tmp0_;
	if (additional_alteration != NULL) {
		Alteration* _tmp1_ = NULL;
		_tmp1_ = alteration_compress (alteration, additional_alteration);
		_alteration_unref0 (alteration);
		alteration = _tmp1_;
	}
	data_object_notify_altered (DATA_OBJECT (self), alteration);
	_alteration_unref0 (alteration);
}


guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	gboolean committed = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
		PhotoID _tmp3_ = {0};
		gboolean _tmp4_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = photo_table_get_instance ();
		_tmp1_ = _tmp0_;
		photo_get_photo_id (self, &_tmp2_);
		_tmp3_ = _tmp2_;
		_tmp4_ = photo_table_replace_flags (_tmp1_, &_tmp3_, flags);
		committed = _tmp4_;
		_database_table_unref0 (_tmp1_);
		if (committed) {
			self->priv->row.flags = flags;
		}
		__finally137:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0ULL;
		}
	}
	if (committed) {
		photo_notify_flags_altered (self, additional_alteration);
	}
	result = flags;
	return result;
}


gboolean photo_is_flag_set (Photo* self, guint64 mask) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	{
		gboolean _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = media_source_internal_is_flag_set (self->priv->row.flags, mask);
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally138:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
	flags = (guint64) 0;
	committed = FALSE;
	{
		guint64 _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = media_source_internal_add_flags (self->priv->row.flags, mask);
		flags = _tmp0_;
		if (self->priv->row.flags != flags) {
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
			PhotoID _tmp4_ = {0};
			gboolean _tmp5_;
			_tmp1_ = photo_table_get_instance ();
			_tmp2_ = _tmp1_;
			photo_get_photo_id (self, &_tmp3_);
			_tmp4_ = _tmp3_;
			_tmp5_ = photo_table_replace_flags (_tmp2_, &_tmp4_, flags);
			committed = _tmp5_;
			_database_table_unref0 (_tmp2_);
			if (committed) {
				self->priv->row.flags = flags;
			}
		}
		__finally139:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0ULL;
		}
	}
	if (committed) {
		photo_notify_flags_altered (self, additional_alteration);
	}
	result = flags;
	return result;
}


guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
	flags = (guint64) 0;
	committed = FALSE;
	{
		guint64 _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = media_source_internal_remove_flags (self->priv->row.flags, mask);
		flags = _tmp0_;
		if (self->priv->row.flags != flags) {
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
			PhotoID _tmp4_ = {0};
			gboolean _tmp5_;
			_tmp1_ = photo_table_get_instance ();
			_tmp2_ = _tmp1_;
			photo_get_photo_id (self, &_tmp3_);
			_tmp4_ = _tmp3_;
			_tmp5_ = photo_table_replace_flags (_tmp2_, &_tmp4_, flags);
			committed = _tmp5_;
			_database_table_unref0 (_tmp2_);
			if (committed) {
				self->priv->row.flags = flags;
			}
		}
		__finally140:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0ULL;
		}
	}
	if (committed) {
		photo_notify_flags_altered (self, additional_alteration);
	}
	result = flags;
	return result;
}


guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
	flags = (guint64) 0;
	committed = FALSE;
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		flags = (self->priv->row.flags | add) & (~remove);
		if (self->priv->row.flags != flags) {
			PhotoTable* _tmp0_ = NULL;
			PhotoTable* _tmp1_;
			PhotoID _tmp2_ = {0};
			PhotoID _tmp3_ = {0};
			gboolean _tmp4_;
			_tmp0_ = photo_table_get_instance ();
			_tmp1_ = _tmp0_;
			photo_get_photo_id (self, &_tmp2_);
			_tmp3_ = _tmp2_;
			_tmp4_ = photo_table_replace_flags (_tmp1_, &_tmp3_, flags);
			committed = _tmp4_;
			_database_table_unref0 (_tmp1_);
			if (committed) {
				self->priv->row.flags = flags;
			}
		}
		__finally141:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0ULL;
		}
	}
	if (committed) {
		photo_notify_flags_altered (self, additional_alteration);
	}
	result = flags;
	return result;
}


void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail ((add == NULL) || GEE_IS_COLLECTION (add));
	g_return_if_fail ((additional_add_alteration == NULL) || IS_ALTERATION (additional_add_alteration));
	g_return_if_fail ((remove == NULL) || GEE_IS_COLLECTION (remove));
	g_return_if_fail ((additional_remove_alteration == NULL) || IS_ALTERATION (additional_remove_alteration));
	database_table_begin_transaction ();
	if (add != NULL) {
		{
			GeeIterator* _tmp0_ = NULL;
			GeeIterator* _photo_it;
			_tmp0_ = gee_iterable_iterator (GEE_ITERABLE (add));
			_photo_it = _tmp0_;
			while (TRUE) {
				gboolean _tmp1_;
				gpointer _tmp2_ = NULL;
				Photo* photo;
				_tmp1_ = gee_iterator_next (_photo_it);
				if (!_tmp1_) {
					break;
				}
				_tmp2_ = gee_iterator_get (_photo_it);
				photo = (Photo*) _tmp2_;
				photo_add_flags (photo, add_mask, additional_add_alteration);
				_g_object_unref0 (photo);
			}
			_g_object_unref0 (_photo_it);
		}
	}
	if (remove != NULL) {
		{
			GeeIterator* _tmp3_ = NULL;
			GeeIterator* _photo_it;
			_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (remove));
			_photo_it = _tmp3_;
			while (TRUE) {
				gboolean _tmp4_;
				gpointer _tmp5_ = NULL;
				Photo* photo;
				_tmp4_ = gee_iterator_next (_photo_it);
				if (!_tmp4_) {
					break;
				}
				_tmp5_ = gee_iterator_get (_photo_it);
				photo = (Photo*) _tmp5_;
				photo_remove_flags (photo, remove_mask, additional_remove_alteration);
				_g_object_unref0 (photo);
			}
			_g_object_unref0 (_photo_it);
		}
	}
	database_table_commit_transaction (&_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
	flags = (guint64) 0;
	committed = FALSE;
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		flags = self->priv->row.flags ^ mask;
		if (self->priv->row.flags != flags) {
			PhotoTable* _tmp0_ = NULL;
			PhotoTable* _tmp1_;
			PhotoID _tmp2_ = {0};
			PhotoID _tmp3_ = {0};
			gboolean _tmp4_;
			_tmp0_ = photo_table_get_instance ();
			_tmp1_ = _tmp0_;
			photo_get_photo_id (self, &_tmp2_);
			_tmp3_ = _tmp2_;
			_tmp4_ = photo_table_replace_flags (_tmp1_, &_tmp3_, flags);
			committed = _tmp4_;
			_database_table_unref0 (_tmp1_);
			if (committed) {
				self->priv->row.flags = flags;
			}
		}
		__finally142:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return 0ULL;
		}
	}
	if (committed) {
		photo_notify_flags_altered (self, additional_alteration);
	}
	result = flags;
	return result;
}


gboolean photo_is_master_metadata_dirty (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		result = self->priv->row.metadata_dirty;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally143:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error) {
	gboolean committed;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	committed = FALSE;
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->row.metadata_dirty != dirty) {
			PhotoTable* _tmp0_ = NULL;
			PhotoTable* _tmp1_;
			PhotoID _tmp2_ = {0};
			PhotoID _tmp3_ = {0};
			_tmp0_ = photo_table_get_instance ();
			_tmp1_ = _tmp0_;
			photo_get_photo_id (self, &_tmp2_);
			_tmp3_ = _tmp2_;
			photo_table_set_metadata_dirty (_tmp1_, &_tmp3_, dirty, &_inner_error_);
			_database_table_unref0 (_tmp1_);
			if (_inner_error_ != NULL) {
				goto __finally144;
			}
			self->priv->row.metadata_dirty = dirty;
			committed = TRUE;
		}
		__finally144:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	if (committed) {
		Alteration* _tmp4_ = NULL;
		Alteration* _tmp5_;
		_tmp4_ = alteration_new ("metadata", "master-dirty");
		_tmp5_ = _tmp4_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp5_);
		_alteration_unref0 (_tmp5_);
	}
}


static Rating photo_real_get_rating (MediaSource* base) {
	Photo * self;
	Rating result = 0;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		result = self->priv->row.rating;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally145:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


static void photo_real_set_rating (MediaSource* base, Rating rating) {
	Photo * self;
	gboolean committed;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	committed = FALSE;
	{
		gboolean _tmp0_ = FALSE;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (rating != self->priv->row.rating) {
			gboolean _tmp1_;
			_tmp1_ = rating_is_valid (rating);
			_tmp0_ = _tmp1_;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			PhotoTable* _tmp2_ = NULL;
			PhotoTable* _tmp3_;
			PhotoID _tmp4_ = {0};
			PhotoID _tmp5_ = {0};
			gboolean _tmp6_;
			_tmp2_ = photo_table_get_instance ();
			_tmp3_ = _tmp2_;
			photo_get_photo_id (self, &_tmp4_);
			_tmp5_ = _tmp4_;
			_tmp6_ = photo_table_set_rating (_tmp3_, &_tmp5_, rating);
			committed = _tmp6_;
			_database_table_unref0 (_tmp3_);
			if (committed) {
				self->priv->row.rating = rating;
			}
		}
		__finally146:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (committed) {
		Alteration* _tmp7_ = NULL;
		Alteration* _tmp8_;
		_tmp7_ = alteration_new ("metadata", "rating");
		_tmp8_ = _tmp7_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp8_);
		_alteration_unref0 (_tmp8_);
	}
}


static void photo_real_increase_rating (MediaSource* base) {
	Photo * self;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		Rating _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = rating_increase (self->priv->row.rating);
		media_source_set_rating (MEDIA_SOURCE (self), _tmp0_);
		__finally147:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void photo_real_decrease_rating (MediaSource* base) {
	Photo * self;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		Rating _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = rating_decrease (self->priv->row.rating);
		media_source_set_rating (MEDIA_SOURCE (self), _tmp0_);
		__finally148:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks) {
	Photo * self;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	PhotoID _tmp2_ = {0};
	PhotoID _tmp3_ = {0};
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
	_tmp0_ = photo_table_get_instance ();
	_tmp1_ = _tmp0_;
	photo_get_photo_id (self, &_tmp2_);
	_tmp3_ = _tmp2_;
	photo_table_update_backlinks (_tmp1_, &_tmp3_, backlinks, &_inner_error_);
	_database_table_unref0 (_tmp1_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			goto __catch149_database_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		gchar* _tmp4_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp4_ = g_strdup (backlinks);
		_g_free0 (self->priv->row.backlinks);
		self->priv->row.backlinks = _tmp4_;
		__finally150:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				goto __catch149_database_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally149;
	__catch149_database_error:
	{
		GError * err;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = data_object_to_string (DATA_OBJECT (self));
		_tmp6_ = _tmp5_;
		g_warning ("Photo.vala:1572: Unable to update link state for %s: %s", _tmp6_, err->message);
		_g_free0 (_tmp6_);
		_g_error_free0 (err);
	}
	__finally149:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id) {
	Photo * self;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
		gboolean committed;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = photo_table_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = photo_table_set_event (_tmp1_, &self->priv->row.photo_id, event_id);
		_tmp3_ = _tmp2_;
		_database_table_unref0 (_tmp1_);
		committed = _tmp3_;
		if (committed) {
			self->priv->row.event_id = *event_id;
		}
		result = committed;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally151:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


static gchar* photo_real_to_string (DataObject* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	PhotoID _tmp10_ = {0};
	PhotoID _tmp11_ = {0};
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_;
	PhotoFileReader* _tmp14_ = NULL;
	PhotoFileReader* _tmp15_;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_;
	self = PHOTO (base);
	_tmp1_ = photo_is_master_baseline (self);
	if (!_tmp1_) {
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp2_ = photo_get_actual_file (self);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_file_get_path (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strconcat (" (", _tmp5_, NULL);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strconcat (_tmp7_, ")", NULL);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp8_;
		_g_free0 (_tmp7_);
		_g_free0 (_tmp5_);
		_g_object_unref0 (_tmp3_);
	} else {
		gchar* _tmp9_;
		_tmp9_ = g_strdup ("");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp9_;
	}
	photo_get_photo_id (self, &_tmp10_);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp11_.id);
	_tmp13_ = _tmp12_;
	_tmp14_ = photo_get_master_reader (self);
	_tmp15_ = _tmp14_;
	_tmp16_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp15_));
	_tmp17_ = _tmp16_;
	_tmp18_ = g_strdup_printf ("[%s] %s%s", _tmp13_, _tmp17_, _tmp0_);
	_tmp19_ = _tmp18_;
	_g_free0 (_tmp17_);
	_photo_file_adapter_unref0 (_tmp15_);
	_g_free0 (_tmp13_);
	result = _tmp19_;
	_g_free0 (_tmp0_);
	return result;
}


static gboolean photo_real_equals (DataSource* base, DataSource* source) {
	Photo * self;
	gboolean result = FALSE;
	DataSource* _tmp0_;
	Photo* _tmp1_;
	Photo* photo;
	gboolean _tmp7_;
	self = PHOTO (base);
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
	_tmp0_ = source;
	_tmp1_ = _g_object_ref0 (IS_PHOTO (_tmp0_) ? ((Photo*) _tmp0_) : NULL);
	photo = _tmp1_;
	if (photo != NULL) {
		PhotoID _tmp2_ = {0};
		PhotoID _tmp3_ = {0};
		PhotoID photo_id;
		PhotoID _tmp4_ = {0};
		PhotoID _tmp5_ = {0};
		PhotoID other_photo_id;
		gboolean _tmp6_ = FALSE;
		photo_get_photo_id (self, &_tmp2_);
		_tmp3_ = _tmp2_;
		photo_id = _tmp3_;
		photo_get_photo_id (photo, &_tmp4_);
		_tmp5_ = _tmp4_;
		other_photo_id = _tmp5_;
		if (self != photo) {
			_tmp6_ = photo_id.id != PHOTO_ID_INVALID;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			g_assert (photo_id.id != other_photo_id.id);
		}
	}
	_tmp7_ = DATA_SOURCE_CLASS (photo_parent_class)->equals (DATA_SOURCE (PHOTO_SOURCE (self)), source);
	result = _tmp7_;
	_g_object_unref0 (photo);
	return result;
}


static void photo_file_exif_updated (Photo* self) {
	GFile* _tmp0_ = NULL;
	GFile* file;
	GFileInfo* info;
	GFileInfo* _tmp1_ = NULL;
	GFileInfo* _tmp2_;
	GTimeVal timestamp = {0};
	GTimeVal _tmp5_ = {0};
	PhotoFileInterrogator* _tmp6_ = NULL;
	PhotoFileInterrogator* interrogator;
	DetectedPhotoInformation* _tmp9_ = NULL;
	DetectedPhotoInformation* detected;
	gboolean success = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = media_source_get_file (MEDIA_SOURCE (self));
	file = _tmp0_;
	info = NULL;
	_tmp1_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		goto __catch152_g_error;
	}
	_g_object_unref0 (info);
	info = _tmp2_;
	goto __finally152;
	__catch152_g_error:
	{
		GError * err;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = data_object_to_string (DATA_OBJECT (self));
		_tmp4_ = _tmp3_;
		g_error ("Photo.vala:1620: Unable to read file information for %s: %s", _tmp4_, err->message);
		_g_free0 (_tmp4_);
		_g_error_free0 (err);
	}
	__finally152:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	g_get_current_time (&timestamp);
	g_file_info_get_modification_time (info, &_tmp5_);
	timestamp = _tmp5_;
	_tmp6_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
	interrogator = _tmp6_;
	photo_file_interrogator_interrogate (interrogator, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch153_g_error;
	}
	goto __finally153;
	__catch153_g_error:
	{
		GError * err;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = g_file_get_path (file);
		_tmp8_ = _tmp7_;
		g_warning ("Photo.vala:1631: Unable to interrogate photo file %s: %s", _tmp8_, err->message);
		_g_free0 (_tmp8_);
		_g_error_free0 (err);
	}
	__finally153:
	if (_inner_error_ != NULL) {
		_photo_file_interrogator_unref0 (interrogator);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp9_ = photo_file_interrogator_get_detected_photo_information (interrogator);
	detected = _tmp9_;
	if (detected == NULL) {
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_;
		_tmp10_ = data_object_to_string (DATA_OBJECT (self));
		_tmp11_ = _tmp10_;
		g_critical ("Photo.vala:1636: file_exif_updated: %s no longer an image", _tmp11_);
		_g_free0 (_tmp11_);
		_detected_photo_information_unref0 (detected);
		_photo_file_interrogator_unref0 (interrogator);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		return;
	}
	{
		PhotoTable* _tmp12_ = NULL;
		PhotoTable* _tmp13_;
		PhotoID _tmp14_ = {0};
		PhotoID _tmp15_ = {0};
		gint64 _tmp16_;
		gboolean _tmp17_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp12_ = photo_table_get_instance ();
		_tmp13_ = _tmp12_;
		photo_get_photo_id (self, &_tmp14_);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_file_info_get_size (info);
		_tmp17_ = photo_table_master_exif_updated (_tmp13_, &_tmp15_, _tmp16_, timestamp.tv_sec, detected->md5, detected->exif_md5, detected->thumbnail_md5, &self->priv->row);
		success = _tmp17_;
		_database_table_unref0 (_tmp13_);
		__finally154:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			_detected_photo_information_unref0 (detected);
			_photo_file_interrogator_unref0 (interrogator);
			_g_object_unref0 (info);
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (success) {
		Alteration* _tmp18_ = NULL;
		Alteration* _tmp19_;
		_tmp18_ = alteration_new_from_list ("metadata:exif,metadata:md5");
		_tmp19_ = _tmp18_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp19_);
		_alteration_unref0 (_tmp19_);
	}
	_detected_photo_information_unref0 (detected);
	_photo_file_interrogator_unref0 (interrogator);
	_g_object_unref0 (info);
	_g_object_unref0 (file);
}


static guint64 photo_real_get_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		result = (guint64) (*self->priv->backing_photo_state).filesize;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally155:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0ULL;
	}
}


static guint64 photo_real_get_master_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		result = (guint64) self->priv->row.master.filesize;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally156:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0ULL;
	}
}


guint64 photo_get_editable_filesize (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		result = (guint64) self->priv->editable.filesize;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally157:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0ULL;
	}
}


static time_t photo_real_get_exposure_time (MediaSource* base) {
	Photo * self;
	time_t result = 0;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		result = self->priv->row.exposure_time;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally158:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


static gchar* photo_real_get_basename (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		gchar* _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = g_strdup (self->priv->file_title);
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally159:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gchar* photo_real_get_title (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	{
		gchar* _tmp0_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = g_strdup (self->priv->row.title);
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally160:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void photo_real_set_title (MediaSource* base, const gchar* title) {
	Photo * self;
	gchar* _tmp0_ = NULL;
	gchar* new_title;
	gboolean committed;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	_tmp0_ = media_source_prep_title (title);
	new_title = _tmp0_;
	committed = FALSE;
	{
		PhotoTable* _tmp1_ = NULL;
		PhotoTable* _tmp2_;
		gboolean _tmp3_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (g_strcmp0 (new_title, self->priv->row.title) == 0) {
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
			_g_free0 (new_title);
			return;
		}
		_tmp1_ = photo_table_get_instance ();
		_tmp2_ = _tmp1_;
		_tmp3_ = photo_table_set_title (_tmp2_, &self->priv->row.photo_id, new_title);
		committed = _tmp3_;
		_database_table_unref0 (_tmp2_);
		if (committed) {
			gchar* _tmp4_;
			_tmp4_ = g_strdup (new_title);
			_g_free0 (self->priv->row.title);
			self->priv->row.title = _tmp4_;
		}
		__finally161:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			_g_free0 (new_title);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (committed) {
		Alteration* _tmp5_ = NULL;
		Alteration* _tmp6_;
		_tmp5_ = alteration_new ("metadata", "name");
		_tmp6_ = _tmp5_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp6_);
		_alteration_unref0 (_tmp6_);
	}
	_g_free0 (new_title);
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


void photo_set_import_id (Photo* self, ImportID* import_id) {
	GError* dberr;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	dberr = NULL;
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = photo_table_get_instance ();
		_tmp1_ = _tmp0_;
		photo_table_set_import_id (_tmp1_, &self->priv->row.photo_id, import_id, &_inner_error_);
		_database_table_unref0 (_tmp1_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				goto __catch163_database_error;
			}
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
			_g_error_free0 (dberr);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		self->priv->row.import_id = *import_id;
		goto __finally163;
		__catch163_database_error:
		{
			GError * err;
			GError* _tmp2_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp2_ = _g_error_copy0 (err);
			_g_error_free0 (dberr);
			dberr = _tmp2_;
			_g_error_free0 (err);
		}
		__finally163:
		if (_inner_error_ != NULL) {
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
			_g_error_free0 (dberr);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		__finally162:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			_g_error_free0 (dberr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (dberr == NULL) {
		Alteration* _tmp3_ = NULL;
		Alteration* _tmp4_;
		_tmp3_ = alteration_new ("metadata", "import-id");
		_tmp4_ = _tmp3_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp4_);
		_alteration_unref0 (_tmp4_);
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		_tmp5_ = data_object_to_string (DATA_OBJECT (self));
		_tmp6_ = _tmp5_;
		g_warning ("Photo.vala:1720: Unable to write import ID for %s: %s", _tmp6_, dberr->message);
		_g_free0 (_tmp6_);
	}
	_g_error_free0 (dberr);
}


void photo_set_title_persistent (Photo* self, const gchar* title, GError** error) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* source;
	PhotoFileFormat _tmp1_;
	gboolean _tmp2_;
	PhotoMetadata* _tmp5_ = NULL;
	PhotoMetadata* metadata;
	PhotoFileMetadataWriter* _tmp6_ = NULL;
	PhotoFileMetadataWriter* writer;
	GFile* _tmp7_ = NULL;
	GFile* _tmp8_;
	GFile* _tmp9_ = NULL;
	GFile* _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = photo_get_source_reader (self);
	source = _tmp0_;
	_tmp1_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (source));
	_tmp2_ = photo_file_format_can_write_metadata (_tmp1_);
	if (!_tmp2_) {
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp3_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (source));
		_tmp4_ = _tmp3_;
		g_warning ("Photo.vala:1728: No photo file writer available for %s", _tmp4_);
		_g_free0 (_tmp4_);
		media_source_set_title (MEDIA_SOURCE (self), title);
		_photo_file_adapter_unref0 (source);
		return;
	}
	_tmp5_ = photo_file_reader_read_metadata (source, &_inner_error_);
	metadata = _tmp5_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (source);
		return;
	}
	photo_metadata_set_title (metadata, title, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
	_tmp6_ = photo_file_reader_create_metadata_writer (source, &_inner_error_);
	writer = _tmp6_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_media_metadata_unref0 (metadata);
		_photo_file_adapter_unref0 (source);
		return;
	}
	_tmp7_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (source));
	_tmp8_ = _tmp7_;
	library_monitor_blacklist_file (_tmp8_, "Photo.set_persistent_title");
	_g_object_unref0 (_tmp8_);
	photo_file_metadata_writer_write_metadata (writer, metadata, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __finally164;
	}
	__finally164:
	_tmp9_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (source));
	_tmp10_ = _tmp9_;
	library_monitor_unblacklist_file (_tmp10_);
	_g_object_unref0 (_tmp10_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (writer);
		_media_metadata_unref0 (metadata);
		_photo_file_adapter_unref0 (source);
		return;
	}
	media_source_set_title (MEDIA_SOURCE (self), title);
	photo_file_exif_updated (self);
	_photo_file_adapter_unref0 (writer);
	_media_metadata_unref0 (metadata);
	_photo_file_adapter_unref0 (source);
}


void photo_set_exposure_time (Photo* self, time_t time) {
	gboolean committed = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_;
		gboolean _tmp2_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = photo_table_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = photo_table_set_exposure_time (_tmp1_, &self->priv->row.photo_id, time);
		committed = _tmp2_;
		_database_table_unref0 (_tmp1_);
		if (committed) {
			self->priv->row.exposure_time = time;
		}
		__finally165:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (committed) {
		Alteration* _tmp3_ = NULL;
		Alteration* _tmp4_;
		_tmp3_ = alteration_new ("metadata", "exposure-time");
		_tmp4_ = _tmp3_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp4_);
		_alteration_unref0 (_tmp4_);
	}
}


void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* source;
	PhotoFileFormat _tmp1_;
	gboolean _tmp2_;
	PhotoMetadata* _tmp5_ = NULL;
	PhotoMetadata* metadata;
	MetadataDateTime* _tmp6_ = NULL;
	MetadataDateTime* _tmp7_;
	PhotoFileMetadataWriter* _tmp8_ = NULL;
	PhotoFileMetadataWriter* writer;
	GFile* _tmp9_ = NULL;
	GFile* _tmp10_;
	GFile* _tmp11_ = NULL;
	GFile* _tmp12_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = photo_get_source_reader (self);
	source = _tmp0_;
	_tmp1_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (source));
	_tmp2_ = photo_file_format_can_write_metadata (_tmp1_);
	if (!_tmp2_) {
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp3_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (source));
		_tmp4_ = _tmp3_;
		g_warning ("Photo.vala:1768: No photo file writer available for %s", _tmp4_);
		_g_free0 (_tmp4_);
		photo_set_exposure_time (self, time);
		_photo_file_adapter_unref0 (source);
		return;
	}
	_tmp5_ = photo_file_reader_read_metadata (source, &_inner_error_);
	metadata = _tmp5_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (source);
		return;
	}
	_tmp6_ = metadata_date_time_new (time);
	_tmp7_ = _tmp6_;
	photo_metadata_set_exposure_date_time (metadata, _tmp7_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
	_metadata_date_time_unref0 (_tmp7_);
	_tmp8_ = photo_file_reader_create_metadata_writer (source, &_inner_error_);
	writer = _tmp8_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_media_metadata_unref0 (metadata);
		_photo_file_adapter_unref0 (source);
		return;
	}
	_tmp9_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (source));
	_tmp10_ = _tmp9_;
	library_monitor_blacklist_file (_tmp10_, "Photo.set_exposure_time_persistent");
	_g_object_unref0 (_tmp10_);
	photo_file_metadata_writer_write_metadata (writer, metadata, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __finally166;
	}
	__finally166:
	_tmp11_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (source));
	_tmp12_ = _tmp11_;
	library_monitor_unblacklist_file (_tmp12_);
	_g_object_unref0 (_tmp12_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (writer);
		_media_metadata_unref0 (metadata);
		_photo_file_adapter_unref0 (source);
		return;
	}
	photo_set_exposure_time (self, time);
	photo_file_exif_updated (self);
	_photo_file_adapter_unref0 (writer);
	_media_metadata_unref0 (metadata);
	_photo_file_adapter_unref0 (source);
}


static void photo_real_get_dimensions (MediaSource* base, Dimensions* result) {
	Photo * self;
	Box crop = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
	self = PHOTO (base);
	_tmp1_ = photo_get_crop (self, &_tmp0_);
	crop = _tmp0_;
	if (_tmp1_) {
		Dimensions _tmp2_ = {0};
		Dimensions _tmp3_ = {0};
		box_get_dimensions (&crop, &_tmp2_);
		_tmp3_ = _tmp2_;
		*result = _tmp3_;
		return;
	}
	photo_get_original_dimensions (self, &_tmp4_);
	_tmp5_ = _tmp4_;
	*result = _tmp5_;
	return;
}


static void photo_locked_create_adjustments_from_data (Photo* self) {
	PixelTransformationBundle* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	KeyValueMap* map;
	PixelTransformer* _tmp2_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = pixel_transformation_bundle_new ();
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
	self->priv->adjustments = _tmp0_;
	_tmp1_ = photo_get_transformation (self, "adjustments");
	map = _tmp1_;
	if (map == NULL) {
		pixel_transformation_bundle_set_to_identity (self->priv->adjustments);
	} else {
		pixel_transformation_bundle_load (self->priv->adjustments, map);
	}
	_tmp2_ = pixel_transformation_bundle_generate_transformer (self->priv->adjustments);
	_pixel_transformer_unref0 (self->priv->transformer);
	self->priv->transformer = _tmp2_;
	_key_value_map_unref0 (map);
}


PixelTransformationBundle* photo_get_color_adjustments (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	{
		PixelTransformationBundle* _tmp0_ = NULL;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->adjustments == NULL) {
			photo_locked_create_adjustments_from_data (self);
		}
		_tmp0_ = pixel_transformation_bundle_copy (self->priv->adjustments);
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally167:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


PixelTransformer* photo_get_pixel_transformer (Photo* self) {
	PixelTransformer* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	{
		PixelTransformer* _tmp0_ = NULL;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->transformer == NULL) {
			photo_locked_create_adjustments_from_data (self);
		}
		_tmp0_ = pixel_transformer_copy (self->priv->transformer);
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally168:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gboolean photo_has_color_adjustments (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	_tmp0_ = photo_has_transformation (self, "adjustments");
	result = _tmp0_;
	return result;
}


PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type) {
	PixelTransformation* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
	PixelTransformation* _tmp2_ = NULL;
	PixelTransformation* _tmp3_;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	_tmp0_ = photo_get_color_adjustments (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = pixel_transformation_bundle_get_transformation (_tmp1_, type);
	_tmp3_ = _tmp2_;
	_pixel_transformation_bundle_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments) {
	gboolean _tmp0_;
	KeyValueMap* _tmp4_ = NULL;
	KeyValueMap* map;
	gboolean committed = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (IS_PIXEL_TRANSFORMATION_BUNDLE (new_adjustments));
	_tmp0_ = pixel_transformation_bundle_is_identity (new_adjustments);
	if (_tmp0_) {
		gboolean _result_ = FALSE;
		{
			gboolean _tmp1_;
			g_static_rec_mutex_lock (&self->priv->__lock_row);
			_tmp1_ = photo_remove_transformation (self, "adjustments");
			_result_ = _tmp1_;
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
			self->priv->adjustments = NULL;
			_pixel_transformer_unref0 (self->priv->transformer);
			self->priv->transformer = NULL;
			__finally169:
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		if (_result_) {
			Alteration* _tmp2_ = NULL;
			Alteration* _tmp3_;
			_tmp2_ = alteration_new ("image", "color-adjustments");
			_tmp3_ = _tmp2_;
			data_object_notify_altered (DATA_OBJECT (self), _tmp3_);
			_alteration_unref0 (_tmp3_);
		}
		return;
	}
	_tmp4_ = pixel_transformation_bundle_save (new_adjustments, "adjustments");
	map = _tmp4_;
	{
		gboolean _tmp5_ = FALSE;
		gboolean _tmp18_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->transformer == NULL) {
			_tmp5_ = TRUE;
		} else {
			_tmp5_ = self->priv->adjustments == NULL;
		}
		if (_tmp5_) {
			PixelTransformationBundle* _tmp6_ = NULL;
			PixelTransformer* _tmp7_ = NULL;
			_tmp6_ = pixel_transformation_bundle_copy (new_adjustments);
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
			self->priv->adjustments = _tmp6_;
			_tmp7_ = pixel_transformation_bundle_generate_transformer (new_adjustments);
			_pixel_transformer_unref0 (self->priv->transformer);
			self->priv->transformer = _tmp7_;
		} else {
			PixelTransformationBundle* _tmp17_ = NULL;
			{
				GeeIterable* _tmp8_ = NULL;
				GeeIterable* _tmp9_;
				GeeIterator* _tmp10_ = NULL;
				GeeIterator* _tmp11_;
				GeeIterator* _transformation_it;
				_tmp8_ = pixel_transformation_bundle_get_transformations (new_adjustments);
				_tmp9_ = _tmp8_;
				_tmp10_ = gee_iterable_iterator (_tmp9_);
				_tmp11_ = _tmp10_;
				_g_object_unref0 (_tmp9_);
				_transformation_it = _tmp11_;
				while (TRUE) {
					gboolean _tmp12_;
					gpointer _tmp13_ = NULL;
					PixelTransformation* transformation;
					PixelTransformationType _tmp14_;
					PixelTransformation* _tmp15_ = NULL;
					PixelTransformation* _tmp16_;
					_tmp12_ = gee_iterator_next (_transformation_it);
					if (!_tmp12_) {
						break;
					}
					_tmp13_ = gee_iterator_get (_transformation_it);
					transformation = (PixelTransformation*) _tmp13_;
					_tmp14_ = pixel_transformation_get_transformation_type (transformation);
					_tmp15_ = pixel_transformation_bundle_get_transformation (self->priv->adjustments, _tmp14_);
					_tmp16_ = _tmp15_;
					pixel_transformer_replace_transformation (self->priv->transformer, _tmp16_, transformation);
					_pixel_transformation_unref0 (_tmp16_);
					_pixel_transformation_unref0 (transformation);
				}
				_g_object_unref0 (_transformation_it);
			}
			_tmp17_ = pixel_transformation_bundle_copy (new_adjustments);
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
			self->priv->adjustments = _tmp17_;
		}
		_tmp18_ = photo_set_transformation (self, map);
		committed = _tmp18_;
		__finally170:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			_key_value_map_unref0 (map);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (committed) {
		Alteration* _tmp19_ = NULL;
		Alteration* _tmp20_;
		_tmp19_ = alteration_new ("image", "color-adjustments");
		_tmp20_ = _tmp19_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp20_);
		_alteration_unref0 (_tmp20_);
	}
	_key_value_map_unref0 (map);
}


static PhotoMetadata* photo_real_get_metadata (PhotoSource* base) {
	Photo * self;
	PhotoMetadata* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	_tmp0_ = photo_get_source_reader (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_file_reader_read_metadata (_tmp1_, &_inner_error_);
	_tmp3_ = _tmp2_;
	_photo_file_adapter_unref0 (_tmp1_);
	_tmp4_ = _tmp3_;
	if (_inner_error_ != NULL) {
		goto __catch171_g_error;
	}
	result = _tmp4_;
	return result;
	goto __finally171;
	__catch171_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("Photo.vala:1889: Unable to load metadata: %s", err->message);
		result = NULL;
		_g_error_free0 (err);
		return result;
	}
	__finally171:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	_tmp0_ = photo_get_master_reader (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_file_reader_read_metadata (_tmp1_, &_inner_error_);
	_tmp3_ = _tmp2_;
	_photo_file_adapter_unref0 (_tmp1_);
	_tmp4_ = _tmp3_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	result = _tmp4_;
	return result;
}


PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	PhotoMetadata* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	_tmp0_ = photo_get_editable_reader (self);
	reader = _tmp0_;
	if (reader != NULL) {
		PhotoMetadata* _tmp2_ = NULL;
		_tmp2_ = photo_file_reader_read_metadata (reader, &_inner_error_);
		_media_metadata_unref0 (_tmp1_);
		_tmp1_ = _tmp2_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_media_metadata_unref0 (_tmp1_);
			_photo_file_adapter_unref0 (reader);
			return NULL;
		}
	} else {
		_media_metadata_unref0 (_tmp1_);
		_tmp1_ = NULL;
	}
	result = _tmp1_;
	_photo_file_adapter_unref0 (reader);
	return result;
}


gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error) {
	PhotoReimportMasterState* _state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* master_reader;
	PhotoFileFormat _tmp1_;
	gboolean _tmp2_;
	PhotoFileMetadataWriter* _tmp3_ = NULL;
	PhotoFileMetadataWriter* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	PhotoReimportMasterState* _tmp6_ = NULL;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
	_tmp0_ = photo_get_master_reader (self);
	master_reader = _tmp0_;
	_tmp1_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (master_reader));
	_tmp2_ = photo_file_format_can_write_metadata (_tmp1_);
	if (!_tmp2_) {
		result = FALSE;
		_photo_file_adapter_unref0 (master_reader);
		if (state) {
			*state = _state;
		} else {
			_photo_reimport_master_state_unref0 (_state);
		}
		return result;
	}
	_tmp3_ = photo_file_reader_create_metadata_writer (master_reader, &_inner_error_);
	_tmp4_ = _tmp3_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (master_reader);
		return FALSE;
	}
	_tmp5_ = _tmp4_;
	photo_file_metadata_writer_write_metadata (_tmp5_, metadata, &_inner_error_);
	_photo_file_adapter_unref0 (_tmp5_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (master_reader);
		return FALSE;
	}
	_tmp7_ = photo_prepare_for_reimport_master (self, &_tmp6_, &_inner_error_);
	_photo_reimport_master_state_unref0 (_state);
	_state = _tmp6_;
	_tmp8_ = _tmp7_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (master_reader);
		return FALSE;
	}
	if (!_tmp8_) {
		result = FALSE;
		_photo_file_adapter_unref0 (master_reader);
		if (state) {
			*state = _state;
		} else {
			_photo_reimport_master_state_unref0 (_state);
		}
		return result;
	}
	PHOTO_REIMPORT_MASTER_STATE_IMPL (_state)->metadata_only = TRUE;
	result = TRUE;
	_photo_file_adapter_unref0 (master_reader);
	if (state) {
		*state = _state;
	} else {
		_photo_reimport_master_state_unref0 (_state);
	}
	return result;
}


void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
	photo_finish_reimport_master (self, state, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* editable_reader;
	PhotoFileFormat _tmp1_;
	gboolean _tmp2_;
	PhotoFileMetadataWriter* _tmp3_ = NULL;
	PhotoFileMetadataWriter* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	PhotoReimportEditableState* _tmp6_ = NULL;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
	_tmp0_ = photo_get_editable_reader (self);
	editable_reader = _tmp0_;
	if (editable_reader == NULL) {
		result = FALSE;
		_photo_file_adapter_unref0 (editable_reader);
		if (state) {
			*state = _state;
		} else {
			_photo_reimport_editable_state_unref0 (_state);
		}
		return result;
	}
	_tmp1_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (editable_reader));
	_tmp2_ = photo_file_format_can_write_metadata (_tmp1_);
	if (!_tmp2_) {
		result = FALSE;
		_photo_file_adapter_unref0 (editable_reader);
		if (state) {
			*state = _state;
		} else {
			_photo_reimport_editable_state_unref0 (_state);
		}
		return result;
	}
	_tmp3_ = photo_file_reader_create_metadata_writer (editable_reader, &_inner_error_);
	_tmp4_ = _tmp3_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (editable_reader);
		return FALSE;
	}
	_tmp5_ = _tmp4_;
	photo_file_metadata_writer_write_metadata (_tmp5_, metadata, &_inner_error_);
	_photo_file_adapter_unref0 (_tmp5_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (editable_reader);
		return FALSE;
	}
	_tmp7_ = photo_prepare_for_reimport_editable (self, &_tmp6_, &_inner_error_);
	_photo_reimport_editable_state_unref0 (_state);
	_state = _tmp6_;
	_tmp8_ = _tmp7_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (editable_reader);
		return FALSE;
	}
	if (!_tmp8_) {
		result = FALSE;
		_photo_file_adapter_unref0 (editable_reader);
		if (state) {
			*state = _state;
		} else {
			_photo_reimport_editable_state_unref0 (_state);
		}
		return result;
	}
	PHOTO_REIMPORT_EDITABLE_STATE_IMPL (_state)->metadata_only = TRUE;
	result = TRUE;
	_photo_file_adapter_unref0 (editable_reader);
	if (state) {
		*state = _state;
	} else {
		_photo_reimport_editable_state_unref0 (_state);
	}
	return result;
}


void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
	photo_finish_reimport_editable (self, state, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void photo_get_raw_dimensions (Photo* self, Dimensions* result) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		*result = (*self->priv->backing_photo_state).dim;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return;
		__finally172:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


gboolean photo_has_transformations (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	{
		gboolean _tmp0_ = FALSE;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->row.orientation != (*self->priv->backing_photo_state).original_orientation) {
			_tmp0_ = TRUE;
		} else {
			_tmp0_ = self->priv->row.transformations != NULL;
		}
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally173:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


gboolean photo_only_metadata_changed (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* metadata;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	date_time = NULL;
	_tmp0_ = photo_source_get_metadata (PHOTO_SOURCE (self));
	metadata = _tmp0_;
	if (metadata != NULL) {
		MetadataDateTime* _tmp1_ = NULL;
		_tmp1_ = photo_metadata_get_exposure_date_time (metadata);
		_metadata_date_time_unref0 (date_time);
		date_time = _tmp1_;
	}
	{
		gboolean _tmp2_ = FALSE;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->row.transformations == NULL) {
			gboolean _tmp3_ = FALSE;
			if (self->priv->row.orientation != (*self->priv->backing_photo_state).original_orientation) {
				_tmp3_ = TRUE;
			} else {
				gboolean _tmp4_ = FALSE;
				if (date_time != NULL) {
					time_t _tmp5_;
					_tmp5_ = metadata_date_time_get_timestamp (date_time);
					_tmp4_ = self->priv->row.exposure_time != _tmp5_;
				} else {
					_tmp4_ = FALSE;
				}
				_tmp3_ = _tmp4_;
			}
			_tmp2_ = _tmp3_;
		} else {
			_tmp2_ = FALSE;
		}
		result = _tmp2_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		_media_metadata_unref0 (metadata);
		_metadata_date_time_unref0 (date_time);
		return result;
		__finally174:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		_media_metadata_unref0 (metadata);
		_metadata_date_time_unref0 (date_time);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	_media_metadata_unref0 (metadata);
	_metadata_date_time_unref0 (date_time);
}


gboolean photo_has_alterations (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time;
	gchar* title;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* metadata;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	date_time = NULL;
	title = NULL;
	_tmp0_ = photo_source_get_metadata (PHOTO_SOURCE (self));
	metadata = _tmp0_;
	if (metadata != NULL) {
		MetadataDateTime* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		_tmp1_ = photo_metadata_get_exposure_date_time (metadata);
		_metadata_date_time_unref0 (date_time);
		date_time = _tmp1_;
		_tmp2_ = media_metadata_get_title (MEDIA_METADATA (metadata));
		_g_free0 (title);
		title = _tmp2_;
	}
	{
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->row.transformations != NULL) {
			_tmp5_ = TRUE;
		} else {
			_tmp5_ = self->priv->row.orientation != (*self->priv->backing_photo_state).original_orientation;
		}
		if (_tmp5_) {
			_tmp4_ = TRUE;
		} else {
			gboolean _tmp6_ = FALSE;
			if (date_time != NULL) {
				time_t _tmp7_;
				_tmp7_ = metadata_date_time_get_timestamp (date_time);
				_tmp6_ = self->priv->row.exposure_time != _tmp7_;
			} else {
				_tmp6_ = FALSE;
			}
			_tmp4_ = _tmp6_;
		}
		if (_tmp4_) {
			_tmp3_ = TRUE;
		} else {
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			_tmp8_ = media_source_get_title (MEDIA_SOURCE (self));
			_tmp9_ = _tmp8_;
			_tmp3_ = g_strcmp0 (_tmp9_, title) != 0;
			_g_free0 (_tmp9_);
		}
		result = _tmp3_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		_media_metadata_unref0 (metadata);
		_g_free0 (title);
		_metadata_date_time_unref0 (date_time);
		return result;
		__finally175:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		_media_metadata_unref0 (metadata);
		_g_free0 (title);
		_metadata_date_time_unref0 (date_time);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	_media_metadata_unref0 (metadata);
	_g_free0 (title);
	_metadata_date_time_unref0 (date_time);
}


PhotoTransformationState* photo_save_transformation_state (Photo* self) {
	PhotoTransformationState* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	{
		PixelTransformer* _tmp0_ = NULL;
		PixelTransformationBundle* _tmp2_ = NULL;
		PhotoPhotoTransformationStateImpl* _tmp4_ = NULL;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->transformer != NULL) {
			PixelTransformer* _tmp1_ = NULL;
			_tmp1_ = pixel_transformer_copy (self->priv->transformer);
			_pixel_transformer_unref0 (_tmp0_);
			_tmp0_ = _tmp1_;
		} else {
			_pixel_transformer_unref0 (_tmp0_);
			_tmp0_ = NULL;
		}
		if (self->priv->adjustments != NULL) {
			PixelTransformationBundle* _tmp3_ = NULL;
			_tmp3_ = pixel_transformation_bundle_copy (self->priv->adjustments);
			_pixel_transformation_bundle_unref0 (_tmp2_);
			_tmp2_ = _tmp3_;
		} else {
			_pixel_transformation_bundle_unref0 (_tmp2_);
			_tmp2_ = NULL;
		}
		_tmp4_ = photo_photo_transformation_state_impl_new (self, self->priv->row.orientation, self->priv->row.transformations, _tmp0_, _tmp2_);
		result = PHOTO_TRANSFORMATION_STATE (_tmp4_);
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		_pixel_transformation_bundle_unref0 (_tmp2_);
		_pixel_transformer_unref0 (_tmp0_);
		return result;
		_pixel_transformation_bundle_unref0 (_tmp2_);
		_pixel_transformer_unref0 (_tmp0_);
		__finally176:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gpointer _pixel_transformer_ref0 (gpointer self) {
	return self ? pixel_transformer_ref (self) : NULL;
}


static gpointer _pixel_transformation_bundle_ref0 (gpointer self) {
	return self ? pixel_transformation_bundle_ref (self) : NULL;
}


gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state) {
	gboolean result = FALSE;
	PhotoTransformationState* _tmp0_;
	PhotoPhotoTransformationStateImpl* _tmp1_;
	PhotoPhotoTransformationStateImpl* state_impl;
	Orientation _tmp2_;
	Orientation saved_orientation;
	GeeHashMap* _tmp3_ = NULL;
	GeeHashMap* saved_transformations;
	PixelTransformer* _tmp4_ = NULL;
	PixelTransformer* saved_transformer;
	PixelTransformationBundle* _tmp5_ = NULL;
	PixelTransformationBundle* saved_adjustments;
	gboolean committed = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (state), FALSE);
	_tmp0_ = state;
	_tmp1_ = _g_object_ref0 (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (_tmp0_) ? ((PhotoPhotoTransformationStateImpl*) _tmp0_) : NULL);
	state_impl = _tmp1_;
	if (state_impl == NULL) {
		result = FALSE;
		_g_object_unref0 (state_impl);
		return result;
	}
	_tmp2_ = photo_photo_transformation_state_impl_get_orientation (state_impl);
	saved_orientation = _tmp2_;
	_tmp3_ = photo_photo_transformation_state_impl_get_transformations (state_impl);
	saved_transformations = _tmp3_;
	_tmp4_ = photo_photo_transformation_state_impl_get_transformer (state_impl);
	saved_transformer = _tmp4_;
	_tmp5_ = photo_photo_transformation_state_impl_get_color_adjustments (state_impl);
	saved_adjustments = _tmp5_;
	{
		PhotoTable* _tmp6_ = NULL;
		PhotoTable* _tmp7_;
		gboolean _tmp8_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp6_ = photo_table_get_instance ();
		_tmp7_ = _tmp6_;
		_tmp8_ = photo_table_set_transformation_state (_tmp7_, &self->priv->row.photo_id, saved_orientation, saved_transformations);
		committed = _tmp8_;
		_database_table_unref0 (_tmp7_);
		if (committed) {
			GeeHashMap* _tmp9_;
			PixelTransformer* _tmp10_;
			PixelTransformationBundle* _tmp11_;
			self->priv->row.orientation = saved_orientation;
			_tmp9_ = _g_object_ref0 (saved_transformations);
			_g_object_unref0 (self->priv->row.transformations);
			self->priv->row.transformations = _tmp9_;
			_tmp10_ = _pixel_transformer_ref0 (saved_transformer);
			_pixel_transformer_unref0 (self->priv->transformer);
			self->priv->transformer = _tmp10_;
			_tmp11_ = _pixel_transformation_bundle_ref0 (saved_adjustments);
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
			self->priv->adjustments = _tmp11_;
		}
		__finally177:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			_pixel_transformation_bundle_unref0 (saved_adjustments);
			_pixel_transformer_unref0 (saved_transformer);
			_g_object_unref0 (saved_transformations);
			_g_object_unref0 (state_impl);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	if (committed) {
		Alteration* _tmp12_ = NULL;
		Alteration* _tmp13_;
		_tmp12_ = alteration_new ("image", "transformation-state");
		_tmp13_ = _tmp12_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp13_);
		_alteration_unref0 (_tmp13_);
	}
	result = committed;
	_pixel_transformation_bundle_unref0 (saved_adjustments);
	_pixel_transformer_unref0 (saved_transformer);
	_g_object_unref0 (saved_transformations);
	_g_object_unref0 (state_impl);
	return result;
}


void photo_remove_all_transformations (Photo* self) {
	g_return_if_fail (IS_PHOTO (self));
	photo_internal_remove_all_transformations (self, TRUE);
}


static void photo_internal_remove_all_transformations (Photo* self, gboolean notify) {
	gboolean is_altered;
	gboolean _tmp5_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	is_altered = FALSE;
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_;
		gboolean _tmp2_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = photo_table_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = photo_table_remove_all_transformations (_tmp1_, &self->priv->row.photo_id);
		is_altered = _tmp2_;
		_database_table_unref0 (_tmp1_);
		_g_object_unref0 (self->priv->row.transformations);
		self->priv->row.transformations = NULL;
		_pixel_transformer_unref0 (self->priv->transformer);
		self->priv->transformer = NULL;
		_pixel_transformation_bundle_unref0 (self->priv->adjustments);
		self->priv->adjustments = NULL;
		if (self->priv->row.orientation != (*self->priv->backing_photo_state).original_orientation) {
			PhotoTable* _tmp3_ = NULL;
			PhotoTable* _tmp4_;
			_tmp3_ = photo_table_get_instance ();
			_tmp4_ = _tmp3_;
			photo_table_set_orientation (_tmp4_, &self->priv->row.photo_id, (*self->priv->backing_photo_state).original_orientation);
			_database_table_unref0 (_tmp4_);
			self->priv->row.orientation = (*self->priv->backing_photo_state).original_orientation;
			is_altered = TRUE;
		}
		__finally178:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (is_altered) {
		_tmp5_ = notify;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		Alteration* _tmp6_ = NULL;
		Alteration* _tmp7_;
		_tmp6_ = alteration_new ("image", "revert");
		_tmp7_ = _tmp6_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp7_);
		_alteration_unref0 (_tmp7_);
	}
}


Orientation photo_get_original_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), 0);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		result = (*self->priv->backing_photo_state).original_orientation;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally179:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


Orientation photo_get_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), 0);
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		result = self->priv->row.orientation;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally180:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


gboolean photo_set_orientation (Photo* self, Orientation orientation) {
	gboolean result = FALSE;
	gboolean committed;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	committed = FALSE;
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->row.orientation != orientation) {
			PhotoTable* _tmp0_ = NULL;
			PhotoTable* _tmp1_;
			gboolean _tmp2_;
			_tmp0_ = photo_table_get_instance ();
			_tmp1_ = _tmp0_;
			_tmp2_ = photo_table_set_orientation (_tmp1_, &self->priv->row.photo_id, orientation);
			committed = _tmp2_;
			_database_table_unref0 (_tmp1_);
			if (committed) {
				self->priv->row.orientation = orientation;
			}
		}
		__finally181:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	if (committed) {
		Alteration* _tmp3_ = NULL;
		Alteration* _tmp4_;
		_tmp3_ = alteration_new ("image", "orientation");
		_tmp4_ = _tmp3_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp4_);
		_alteration_unref0 (_tmp4_);
	}
	result = committed;
	return result;
}


static void photo_real_rotate (Photo* self, Rotation rotation) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	{
		Orientation _tmp0_;
		Orientation _tmp1_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = photo_get_orientation (self);
		_tmp1_ = orientation_perform (_tmp0_, rotation);
		photo_set_orientation (self, _tmp1_);
		__finally182:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void photo_rotate (Photo* self, Rotation rotation) {
	PHOTO_GET_CLASS (self)->rotate (self, rotation);
}


static gboolean photo_has_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	g_return_val_if_fail (name != NULL, FALSE);
	{
		gboolean _tmp0_ = FALSE;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->row.transformations != NULL) {
			gboolean _tmp1_;
			_tmp1_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->row.transformations), name);
			_tmp0_ = _tmp1_;
		} else {
			_tmp0_ = FALSE;
		}
		result = _tmp0_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally183:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name) {
	KeyValueMap* result = NULL;
	KeyValueMap* map;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	g_return_val_if_fail (name != NULL, NULL);
	map = NULL;
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->row.transformations != NULL) {
			gpointer _tmp0_ = NULL;
			_tmp0_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->row.transformations), name);
			_key_value_map_unref0 (map);
			map = (KeyValueMap*) _tmp0_;
			if (map != NULL) {
				KeyValueMap* _tmp1_ = NULL;
				_tmp1_ = key_value_map_copy (map);
				_key_value_map_unref0 (map);
				map = _tmp1_;
			}
		}
		__finally184:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			_key_value_map_unref0 (map);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = map;
	return result;
}


static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	g_return_val_if_fail (IS_KEY_VALUE_MAP (trans), FALSE);
	{
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		PhotoTable* _tmp3_ = NULL;
		PhotoTable* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->row.transformations == NULL) {
			GeeHashMap* _tmp0_ = NULL;
			_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, g_str_hash, g_str_equal, g_direct_equal);
			_g_object_unref0 (self->priv->row.transformations);
			self->priv->row.transformations = _tmp0_;
		}
		_tmp1_ = key_value_map_get_group (trans);
		_tmp2_ = _tmp1_;
		gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->row.transformations), _tmp2_, trans);
		_g_free0 (_tmp2_);
		_tmp3_ = photo_table_get_instance ();
		_tmp4_ = _tmp3_;
		_tmp5_ = photo_table_set_transformation (_tmp4_, &self->priv->row.photo_id, trans);
		_tmp6_ = _tmp5_;
		_database_table_unref0 (_tmp4_);
		result = _tmp6_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		return result;
		__finally185:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


static gboolean photo_remove_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp5_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	g_return_val_if_fail (name != NULL, FALSE);
	{
		PhotoTable* _tmp2_ = NULL;
		PhotoTable* _tmp3_;
		gboolean _tmp4_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		if (self->priv->row.transformations != NULL) {
			gboolean _tmp0_;
			gint _tmp1_;
			_tmp0_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->row.transformations), name, NULL);
			altered_cache = _tmp0_;
			_tmp1_ = gee_map_get_size (GEE_MAP (self->priv->row.transformations));
			if (_tmp1_ == 0) {
				_g_object_unref0 (self->priv->row.transformations);
				self->priv->row.transformations = NULL;
			}
		} else {
			altered_cache = FALSE;
		}
		_tmp2_ = photo_table_get_instance ();
		_tmp3_ = _tmp2_;
		_tmp4_ = photo_table_remove_transformation (_tmp3_, &self->priv->row.photo_id, name);
		altered_persistent = _tmp4_;
		_database_table_unref0 (_tmp3_);
		__finally186:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	if (altered_cache) {
		_tmp5_ = TRUE;
	} else {
		_tmp5_ = altered_persistent;
	}
	result = _tmp5_;
	return result;
}


gboolean photo_has_crop (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	_tmp0_ = photo_has_transformation (self, "crop");
	result = _tmp0_;
	return result;
}


static gboolean photo_get_raw_crop (Photo* self, Box* crop) {
	Box _crop = {0};
	gboolean result = FALSE;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	gint _tmp1_;
	gint left;
	gint _tmp2_;
	gint top;
	gint _tmp3_;
	gint right;
	gint _tmp4_;
	gint bottom;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	Box _tmp8_ = {0};
	Box _tmp9_ = {0};
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	_tmp0_ = photo_get_transformation (self, "crop");
	map = _tmp0_;
	if (map == NULL) {
		result = FALSE;
		_key_value_map_unref0 (map);
		if (crop) {
			*crop = _crop;
		}
		return result;
	}
	_tmp1_ = key_value_map_get_int (map, "left", -1);
	left = _tmp1_;
	_tmp2_ = key_value_map_get_int (map, "top", -1);
	top = _tmp2_;
	_tmp3_ = key_value_map_get_int (map, "right", -1);
	right = _tmp3_;
	_tmp4_ = key_value_map_get_int (map, "bottom", -1);
	bottom = _tmp4_;
	if (left == (-1)) {
		_tmp7_ = TRUE;
	} else {
		_tmp7_ = top == (-1);
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		_tmp6_ = right == (-1);
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		_tmp5_ = bottom == (-1);
	}
	if (_tmp5_) {
		result = FALSE;
		_key_value_map_unref0 (map);
		if (crop) {
			*crop = _crop;
		}
		return result;
	}
	box_init (&_tmp8_, left, top, right, bottom);
	_tmp9_ = _tmp8_;
	_crop = _tmp9_;
	result = TRUE;
	_key_value_map_unref0 (map);
	if (crop) {
		*crop = _crop;
	}
	return result;
}


static void photo_set_raw_crop (Photo* self, Box* crop) {
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	gboolean _tmp1_;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = key_value_map_new ("crop");
	map = _tmp0_;
	key_value_map_set_int (map, "left", (*crop).left);
	key_value_map_set_int (map, "top", (*crop).top);
	key_value_map_set_int (map, "right", (*crop).right);
	key_value_map_set_int (map, "bottom", (*crop).bottom);
	_tmp1_ = photo_set_transformation (self, map);
	if (_tmp1_) {
		Alteration* _tmp2_ = NULL;
		Alteration* _tmp3_;
		_tmp2_ = alteration_new ("image", "crop");
		_tmp3_ = _tmp2_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp3_);
		_alteration_unref0 (_tmp3_);
	}
	_key_value_map_unref0 (map);
}


static RedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1) {
	RedeyeInstance* result = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	gint _tmp3_;
	gint num_points;
	RedeyeInstance* _tmp4_ = NULL;
	RedeyeInstance* res;
	gint res_length1;
	gint _res_size_;
	GdkPoint _tmp5_ = {0};
	GdkPoint default_point;
	RedeyeInstance* _tmp12_;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	_tmp0_ = photo_get_transformation (self, "redeye");
	map = _tmp0_;
	if (map == NULL) {
		RedeyeInstance* _tmp1_ = NULL;
		RedeyeInstance* _tmp2_;
		_tmp1_ = g_new0 (RedeyeInstance, 0);
		_tmp2_ = _tmp1_;
		*result_length1 = 0;
		result = _tmp2_;
		_key_value_map_unref0 (map);
		return result;
	}
	_tmp3_ = key_value_map_get_int (map, "num_points", -1);
	num_points = _tmp3_;
	g_assert (num_points > 0);
	_tmp4_ = g_new0 (RedeyeInstance, num_points);
	res = _tmp4_;
	res_length1 = num_points;
	_res_size_ = num_points;
	_tmp5_.x = 0;
	default_point = _tmp5_;
	default_point.x = -1;
	default_point.y = -1;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp6_;
			_tmp6_ = TRUE;
			while (TRUE) {
				gchar* _tmp7_ = NULL;
				gchar* center_key;
				gchar* _tmp8_ = NULL;
				gchar* radius_key;
				GdkPoint _tmp9_ = {0};
				GdkPoint _tmp10_ = {0};
				gint _tmp11_;
				if (!_tmp6_) {
					i++;
				}
				_tmp6_ = FALSE;
				if (!(i < num_points)) {
					break;
				}
				_tmp7_ = g_strdup_printf ("center%d", i);
				center_key = _tmp7_;
				_tmp8_ = g_strdup_printf ("radius%d", i);
				radius_key = _tmp8_;
				key_value_map_get_point (map, center_key, &default_point, &_tmp9_);
				_tmp10_ = _tmp9_;
				res[i].center = _tmp10_;
				g_assert (res[i].center.x != default_point.x);
				g_assert (res[i].center.y != default_point.y);
				_tmp11_ = key_value_map_get_int (map, radius_key, -1);
				res[i].radius = _tmp11_;
				g_assert (res[i].radius != (-1));
				_g_free0 (radius_key);
				_g_free0 (center_key);
			}
		}
	}
	_tmp12_ = res;
	*result_length1 = res_length1;
	result = _tmp12_;
	_key_value_map_unref0 (map);
	return result;
}


gboolean photo_has_redeye_transformations (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	_tmp0_ = photo_has_transformation (self, "redeye");
	result = _tmp0_;
	return result;
}


static void photo_add_raw_redeye_instance (Photo* self, RedeyeInstance* redeye) {
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	gint _tmp2_;
	gint num_points;
	gchar* _tmp3_ = NULL;
	gchar* radius_key;
	gchar* _tmp4_ = NULL;
	gchar* center_key;
	gboolean _tmp5_;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = photo_get_transformation (self, "redeye");
	map = _tmp0_;
	if (map == NULL) {
		KeyValueMap* _tmp1_ = NULL;
		_tmp1_ = key_value_map_new ("redeye");
		_key_value_map_unref0 (map);
		map = _tmp1_;
		key_value_map_set_int (map, "num_points", 0);
	}
	_tmp2_ = key_value_map_get_int (map, "num_points", -1);
	num_points = _tmp2_;
	g_assert (num_points >= 0);
	num_points++;
	_tmp3_ = g_strdup_printf ("radius%d", num_points - 1);
	radius_key = _tmp3_;
	_tmp4_ = g_strdup_printf ("center%d", num_points - 1);
	center_key = _tmp4_;
	key_value_map_set_int (map, radius_key, (*redeye).radius);
	key_value_map_set_point (map, center_key, &(*redeye).center);
	key_value_map_set_int (map, "num_points", num_points);
	_tmp5_ = photo_set_transformation (self, map);
	if (_tmp5_) {
		Alteration* _tmp6_ = NULL;
		Alteration* _tmp7_;
		_tmp6_ = alteration_new ("image", "redeye");
		_tmp7_ = _tmp6_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp7_);
		_alteration_unref0 (_tmp7_);
	}
	_g_free0 (center_key);
	_g_free0 (radius_key);
	_key_value_map_unref0 (map);
}


static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _scaled_image = {0};
	Dimensions _scaled_to_viewport = {0};
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	{
		Dimensions _tmp0_ = {0};
		Dimensions _tmp1_ = {0};
		gboolean _tmp2_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp2_ = photo_locked_calculate_pixbuf_dimensions (self, scaling, exceptions, &_tmp0_, &_tmp1_);
		_scaled_image = _tmp0_;
		_scaled_to_viewport = _tmp1_;
		result = _tmp2_;
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (scaled_image) {
			*scaled_image = _scaled_image;
		}
		if (scaled_to_viewport) {
			*scaled_to_viewport = _scaled_to_viewport;
		}
		return result;
		__finally187:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	if (scaled_image) {
		*scaled_image = _scaled_image;
	}
	if (scaled_to_viewport) {
		*scaled_to_viewport = _scaled_to_viewport;
	}
}


static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _scaled_image = {0};
	Dimensions _scaled_to_viewport = {0};
	gboolean result = FALSE;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions raw;
	gboolean _tmp2_;
	Orientation _tmp3_;
	Orientation orientation;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	gboolean _tmp40_;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_;
	gboolean _tmp51_;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	photo_get_raw_dimensions (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	raw = _tmp1_;
	_tmp2_ = scaling_is_unscaled (scaling);
	if (_tmp2_) {
		_scaled_image = raw;
		_scaled_to_viewport = raw;
		result = FALSE;
		if (scaled_image) {
			*scaled_image = _scaled_image;
		}
		if (scaled_to_viewport) {
			*scaled_to_viewport = _scaled_to_viewport;
		}
		return result;
	}
	_tmp3_ = photo_get_orientation (self);
	orientation = _tmp3_;
	dimensions_init (&_tmp4_, 0, 0);
	_tmp5_ = _tmp4_;
	_scaled_image = _tmp5_;
	dimensions_init (&_tmp6_, 0, 0);
	_tmp7_ = _tmp6_;
	_scaled_to_viewport = _tmp7_;
	_tmp8_ = photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP);
	if (_tmp8_) {
		Box crop = {0};
		Box _tmp9_ = {0};
		gboolean _tmp10_;
		_tmp10_ = photo_get_raw_crop (self, &_tmp9_);
		crop = _tmp9_;
		if (_tmp10_) {
			Dimensions rotated_raw;
			gboolean _tmp11_;
			Dimensions _tmp16_ = {0};
			Dimensions _tmp17_ = {0};
			Dimensions _tmp18_ = {0};
			Dimensions _tmp19_ = {0};
			Box _tmp20_ = {0};
			Box _tmp21_ = {0};
			Box scaled_crop;
			Dimensions _tmp22_ = {0};
			Dimensions _tmp23_ = {0};
			gboolean _tmp24_ = FALSE;
			gint _tmp25_;
			gint _tmp26_;
			Dimensions _tmp31_ = {0};
			Dimensions _tmp32_ = {0};
			Dimensions _tmp33_ = {0};
			Dimensions _tmp34_ = {0};
			Dimensions _tmp35_ = {0};
			Dimensions _tmp36_ = {0};
			gboolean _tmp37_;
			rotated_raw = raw;
			_tmp11_ = photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION);
			if (_tmp11_) {
				Box _tmp12_ = {0};
				Box _tmp13_ = {0};
				Dimensions _tmp14_ = {0};
				Dimensions _tmp15_ = {0};
				orientation_rotate_box (orientation, &raw, &crop, &_tmp12_);
				_tmp13_ = _tmp12_;
				crop = _tmp13_;
				orientation_rotate_dimensions (orientation, &raw, &_tmp14_);
				_tmp15_ = _tmp14_;
				rotated_raw = _tmp15_;
			}
			box_get_dimensions (&crop, &_tmp16_);
			_tmp17_ = _tmp16_;
			scaling_get_scaled_dimensions (scaling, &_tmp17_, &_tmp18_);
			_tmp19_ = _tmp18_;
			box_get_scaled (&crop, &_tmp19_, &_tmp20_);
			_tmp21_ = _tmp20_;
			scaled_crop = _tmp21_;
			box_get_dimensions (&scaled_crop, &_tmp22_);
			_tmp23_ = _tmp22_;
			_scaled_to_viewport = _tmp23_;
			_tmp25_ = box_get_width (&crop);
			_tmp26_ = box_get_width (&scaled_crop);
			if (_tmp25_ <= _tmp26_) {
				gint _tmp27_;
				gint _tmp28_;
				_tmp27_ = box_get_height (&crop);
				_tmp28_ = box_get_height (&scaled_crop);
				_tmp24_ = _tmp27_ <= _tmp28_;
			} else {
				_tmp24_ = FALSE;
			}
			if (_tmp24_) {
				Dimensions _tmp29_ = {0};
				Dimensions _tmp30_ = {0};
				_scaled_image = raw;
				box_get_dimensions (&crop, &_tmp29_);
				_tmp30_ = _tmp29_;
				_scaled_to_viewport = _tmp30_;
				result = FALSE;
				if (scaled_image) {
					*scaled_image = _scaled_image;
				}
				if (scaled_to_viewport) {
					*scaled_to_viewport = _scaled_to_viewport;
				}
				return result;
			}
			box_get_dimensions (&crop, &_tmp31_);
			_tmp32_ = _tmp31_;
			box_get_dimensions (&scaled_crop, &_tmp33_);
			_tmp34_ = _tmp33_;
			dimensions_get_scaled_similar (&rotated_raw, &_tmp32_, &_tmp34_, &_tmp35_);
			_tmp36_ = _tmp35_;
			_scaled_image = _tmp36_;
			_tmp37_ = photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION);
			if (_tmp37_) {
				Dimensions _tmp38_ = {0};
				Dimensions _tmp39_ = {0};
				orientation_derotate_dimensions (orientation, &_scaled_image, &_tmp38_);
				_tmp39_ = _tmp38_;
				_scaled_image = _tmp39_;
			}
		}
	}
	_tmp40_ = dimensions_has_area (&_scaled_image);
	if (!_tmp40_) {
		Dimensions rotated_raw;
		gboolean _tmp41_;
		Dimensions _tmp44_ = {0};
		Dimensions _tmp45_ = {0};
		gboolean _tmp46_;
		rotated_raw = raw;
		_tmp41_ = photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION);
		if (_tmp41_) {
			Dimensions _tmp42_ = {0};
			Dimensions _tmp43_ = {0};
			orientation_rotate_dimensions (orientation, &raw, &_tmp42_);
			_tmp43_ = _tmp42_;
			rotated_raw = _tmp43_;
		}
		scaling_get_scaled_dimensions (scaling, &rotated_raw, &_tmp44_);
		_tmp45_ = _tmp44_;
		_scaled_image = _tmp45_;
		_scaled_to_viewport = _scaled_image;
		_tmp46_ = photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION);
		if (_tmp46_) {
			Dimensions _tmp47_ = {0};
			Dimensions _tmp48_ = {0};
			orientation_derotate_dimensions (orientation, &_scaled_image, &_tmp47_);
			_tmp48_ = _tmp47_;
			_scaled_image = _tmp48_;
		}
	}
	if (_scaled_image.width >= raw.width) {
		_tmp49_ = _scaled_image.height >= raw.height;
	} else {
		_tmp49_ = FALSE;
	}
	if (_tmp49_) {
		_scaled_image = raw;
		result = FALSE;
		if (scaled_image) {
			*scaled_image = _scaled_image;
		}
		if (scaled_to_viewport) {
			*scaled_to_viewport = _scaled_to_viewport;
		}
		return result;
	}
	_tmp50_ = dimensions_has_area (&_scaled_image);
	g_assert (_tmp50_);
	_tmp51_ = dimensions_has_area (&_scaled_to_viewport);
	g_assert (_tmp51_);
	result = TRUE;
	if (scaled_image) {
		*scaled_image = _scaled_image;
	}
	if (scaled_to_viewport) {
		*scaled_to_viewport = _scaled_to_viewport;
	}
	return result;
}


static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* loader;
	gboolean _tmp1_;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
	gboolean _tmp6_;
	gboolean is_scaled;
	Dimensions _tmp9_ = {0};
	Dimensions _tmp10_ = {0};
	GdkPixbuf* _tmp11_ = NULL;
	GdkPixbuf* pixbuf;
	Dimensions _tmp12_ = {0};
	Dimensions _tmp13_ = {0};
	gboolean _tmp14_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	_tmp0_ = photo_get_backing_reader (self, fetch_mode);
	loader = _tmp0_;
	_tmp1_ = scaling_is_unscaled (scaling);
	if (_tmp1_) {
		GdkPixbuf* _tmp2_ = NULL;
		GdkPixbuf* _tmp3_;
		_tmp2_ = photo_file_reader_unscaled_read (loader, &_inner_error_);
		_tmp3_ = _tmp2_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_photo_file_adapter_unref0 (loader);
			return NULL;
		}
		result = _tmp3_;
		_photo_file_adapter_unref0 (loader);
		return result;
	}
	_tmp6_ = photo_calculate_pixbuf_dimensions (self, scaling, exceptions, &_tmp4_, &_tmp5_);
	scaled_image = _tmp4_;
	scaled_to_viewport = _tmp5_;
	is_scaled = _tmp6_;
	if (!is_scaled) {
		GdkPixbuf* _tmp7_ = NULL;
		GdkPixbuf* _tmp8_;
		_tmp7_ = photo_file_reader_unscaled_read (loader, &_inner_error_);
		_tmp8_ = _tmp7_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_photo_file_adapter_unref0 (loader);
			return NULL;
		}
		result = _tmp8_;
		_photo_file_adapter_unref0 (loader);
		return result;
	}
	photo_get_raw_dimensions (self, &_tmp9_);
	_tmp10_ = _tmp9_;
	_tmp11_ = photo_file_reader_scaled_read (loader, &_tmp10_, &scaled_image, &_inner_error_);
	pixbuf = _tmp11_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (loader);
		return NULL;
	}
	dimensions_for_pixbuf (pixbuf, &_tmp12_);
	_tmp13_ = _tmp12_;
	_tmp14_ = dimensions_approx_equals (&scaled_image, &_tmp13_, PHOTO_SCALING_FUDGE);
	g_assert (_tmp14_);
	result = pixbuf;
	_photo_file_adapter_unref0 (loader);
	return result;
}


GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error) {
	GdkPixbuf* result = NULL;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* pixbuf;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	{
		Dimensions _tmp0_ = {0};
		Dimensions _tmp1_ = {0};
		Orientation _tmp2_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		photo_calculate_pixbuf_dimensions (self, scaling, PHOTO_EXCEPTION_NONE, &_tmp0_, &_tmp1_);
		scaled_image = _tmp0_;
		scaled_to_viewport = _tmp1_;
		_tmp2_ = photo_get_original_orientation (self);
		original_orientation = _tmp2_;
		__finally188:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		}
	}
	_tmp3_ = photo_load_raw_pixbuf (self, scaling, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_MASTER, &_inner_error_);
	pixbuf = _tmp3_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	if (rotate) {
		GdkPixbuf* _tmp4_ = NULL;
		_tmp4_ = orientation_rotate_pixbuf (original_orientation, pixbuf);
		_g_object_unref0 (pixbuf);
		pixbuf = _tmp4_;
	}
	result = pixbuf;
	return result;
}


static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GError * _inner_error_ = NULL;
	self = PHOTO (base);
	_tmp0_ = photo_get_pixbuf_with_options (self, scaling, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	result = _tmp1_;
	return result;
}


GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	RedeyeInstance* redeye_instances;
	gint redeye_instances_length1;
	gint _redeye_instances_size_;
	Box crop = {0};
	PixelTransformer* transformer;
	Orientation orientation = 0;
	GdkPixbuf* _tmp12_ = NULL;
	GdkPixbuf* pixbuf;
	gboolean _tmp15_;
	gboolean _tmp20_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	dimensions_init (&original, 0, 0);
	dimensions_init (&scaled, 0, 0);
	redeye_instances = NULL;
	redeye_instances_length1 = 0;
	_redeye_instances_size_ = 0;
	transformer = NULL;
	{
		Dimensions _tmp0_ = {0};
		Dimensions _tmp1_ = {0};
		gboolean _tmp2_;
		gint _tmp5_;
		RedeyeInstance* _tmp6_ = NULL;
		Box _tmp7_ = {0};
		gboolean _tmp8_;
		gboolean _tmp9_;
		Orientation _tmp11_;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp2_ = photo_calculate_pixbuf_dimensions (self, scaling, exceptions, &_tmp0_, &_tmp1_);
		scaled_image = _tmp0_;
		scaled_to_viewport = _tmp1_;
		is_scaled = _tmp2_;
		if (is_scaled) {
			Dimensions _tmp3_ = {0};
			Dimensions _tmp4_ = {0};
			photo_get_raw_dimensions (self, &_tmp3_);
			_tmp4_ = _tmp3_;
			original = _tmp4_;
		}
		_tmp6_ = photo_get_raw_redeye_instances (self, &_tmp5_);
		redeye_instances = (g_free (redeye_instances), NULL);
		redeye_instances = _tmp6_;
		redeye_instances_length1 = _tmp5_;
		_redeye_instances_size_ = _tmp5_;
		_tmp8_ = photo_get_raw_crop (self, &_tmp7_);
		crop = _tmp7_;
		is_cropped = _tmp8_;
		_tmp9_ = photo_has_color_adjustments (self);
		if (_tmp9_) {
			PixelTransformer* _tmp10_ = NULL;
			_tmp10_ = photo_get_pixel_transformer (self);
			_pixel_transformer_unref0 (transformer);
			transformer = _tmp10_;
		}
		_tmp11_ = photo_get_orientation (self);
		orientation = _tmp11_;
		__finally189:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_pixel_transformer_unref0 (transformer);
			redeye_instances = (g_free (redeye_instances), NULL);
			return NULL;
		}
	}
	_tmp12_ = photo_load_raw_pixbuf (self, scaling, exceptions, fetch_mode, &_inner_error_);
	pixbuf = _tmp12_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_pixel_transformer_unref0 (transformer);
		redeye_instances = (g_free (redeye_instances), NULL);
		return NULL;
	}
	if (is_scaled) {
		Dimensions _tmp13_ = {0};
		Dimensions _tmp14_ = {0};
		dimensions_for_pixbuf (pixbuf, &_tmp13_);
		_tmp14_ = _tmp13_;
		scaled = _tmp14_;
	}
	_tmp15_ = photo_exception_allows (exceptions, PHOTO_EXCEPTION_REDEYE);
	if (_tmp15_) {
		{
			RedeyeInstance* instance_collection;
			int instance_collection_length1;
			int instance_it;
			instance_collection = redeye_instances;
			instance_collection_length1 = redeye_instances_length1;
			for (instance_it = 0; instance_it < redeye_instances_length1; instance_it = instance_it + 1) {
				RedeyeInstance instance;
				instance = instance_collection[instance_it];
				{
					GdkPixbuf* _tmp19_ = NULL;
					if (is_scaled) {
						GdkPoint _tmp16_ = {0};
						GdkPoint _tmp17_ = {0};
						gint _tmp18_;
						coord_scaled_in_space (instance.center.x, instance.center.y, &original, &scaled, &_tmp16_);
						_tmp17_ = _tmp16_;
						instance.center = _tmp17_;
						_tmp18_ = radius_scaled_in_space (instance.radius, &original, &scaled);
						instance.radius = _tmp18_;
						g_assert (instance.radius != (-1));
					}
					_tmp19_ = photo_do_redeye (self, pixbuf, &instance);
					_g_object_unref0 (pixbuf);
					pixbuf = _tmp19_;
				}
			}
		}
	}
	_tmp20_ = photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP);
	if (_tmp20_) {
		if (is_cropped) {
			gint _tmp23_;
			gint _tmp24_;
			GdkPixbuf* _tmp25_ = NULL;
			if (is_scaled) {
				Box _tmp21_ = {0};
				Box _tmp22_ = {0};
				box_get_scaled_similar (&crop, &original, &scaled, &_tmp21_);
				_tmp22_ = _tmp21_;
				crop = _tmp22_;
			}
			_tmp23_ = box_get_width (&crop);
			_tmp24_ = box_get_height (&crop);
			_tmp25_ = gdk_pixbuf_new_subpixbuf (pixbuf, crop.left, crop.top, _tmp23_, _tmp24_);
			_g_object_unref0 (pixbuf);
			pixbuf = _tmp25_;
		}
	}
	_tmp26_ = photo_exception_allows (exceptions, PHOTO_EXCEPTION_ADJUST);
	if (_tmp26_) {
		if (transformer != NULL) {
			pixel_transformer_transform_pixbuf (transformer, pixbuf, NULL);
		}
	}
	_tmp27_ = photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION);
	if (_tmp27_) {
		GdkPixbuf* _tmp28_ = NULL;
		_tmp28_ = orientation_rotate_pixbuf (orientation, pixbuf);
		_g_object_unref0 (pixbuf);
		pixbuf = _tmp28_;
	}
	if (is_scaled) {
		Dimensions _tmp29_ = {0};
		Dimensions _tmp30_ = {0};
		gboolean _tmp31_;
		dimensions_for_pixbuf (pixbuf, &_tmp29_);
		_tmp30_ = _tmp29_;
		_tmp31_ = dimensions_approx_equals (&scaled_to_viewport, &_tmp30_, PHOTO_SCALING_FUDGE);
		g_assert (_tmp31_);
	}
	result = pixbuf;
	_pixel_transformer_unref0 (transformer);
	redeye_instances = (g_free (redeye_instances), NULL);
	return result;
}


static gboolean photo_real_has_user_generated_metadata (Photo* self) {
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean photo_has_user_generated_metadata (Photo* self) {
	return PHOTO_GET_CLASS (self)->has_user_generated_metadata (self);
}


static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
	g_return_if_fail (IS_PHOTO (self));
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
	PHOTO_GET_CLASS (self)->set_user_metadata_for_export (self, metadata);
}


gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format) {
	gchar* result = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	if (file_format != NULL) {
		PhotoFileFormatProperties* _tmp0_ = NULL;
		PhotoFileFormatProperties* _tmp1_;
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFile* _tmp4_ = NULL;
		GFile* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		_tmp0_ = photo_file_format_get_properties (*file_format);
		_tmp1_ = _tmp0_;
		_tmp2_ = media_source_get_master_file (MEDIA_SOURCE (self));
		_tmp3_ = _tmp2_;
		_tmp4_ = photo_file_format_properties_convert_file_extension (_tmp1_, _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_file_get_basename (_tmp5_);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp5_);
		_g_object_unref0 (_tmp3_);
		_photo_file_format_properties_unref0 (_tmp1_);
		result = _tmp7_;
		return result;
	} else {
		PhotoFileFormat _tmp8_;
		gboolean _tmp9_;
		_tmp8_ = photo_get_file_format (self);
		_tmp9_ = photo_file_format_can_write (_tmp8_);
		if (_tmp9_) {
			PhotoFileFormat _tmp10_;
			PhotoFileFormatProperties* _tmp11_ = NULL;
			PhotoFileFormatProperties* _tmp12_;
			GFile* _tmp13_ = NULL;
			GFile* _tmp14_;
			GFile* _tmp15_ = NULL;
			GFile* _tmp16_;
			gchar* _tmp17_ = NULL;
			gchar* _tmp18_;
			_tmp10_ = photo_get_file_format (self);
			_tmp11_ = photo_file_format_get_properties (_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp13_ = media_source_get_master_file (MEDIA_SOURCE (self));
			_tmp14_ = _tmp13_;
			_tmp15_ = photo_file_format_properties_convert_file_extension (_tmp12_, _tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = g_file_get_basename (_tmp16_);
			_tmp18_ = _tmp17_;
			_g_object_unref0 (_tmp16_);
			_g_object_unref0 (_tmp14_);
			_photo_file_format_properties_unref0 (_tmp12_);
			result = _tmp18_;
			return result;
		} else {
			PhotoFileFormat _tmp19_;
			PhotoFileFormatProperties* _tmp20_ = NULL;
			PhotoFileFormatProperties* _tmp21_;
			GFile* _tmp22_ = NULL;
			GFile* _tmp23_;
			GFile* _tmp24_ = NULL;
			GFile* _tmp25_;
			gchar* _tmp26_ = NULL;
			gchar* _tmp27_;
			_tmp19_ = photo_file_format_get_system_default_format ();
			_tmp20_ = photo_file_format_get_properties (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = media_source_get_master_file (MEDIA_SOURCE (self));
			_tmp23_ = _tmp22_;
			_tmp24_ = photo_file_format_properties_convert_file_extension (_tmp21_, _tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = g_file_get_basename (_tmp25_);
			_tmp27_ = _tmp26_;
			_g_object_unref0 (_tmp25_);
			_g_object_unref0 (_tmp23_);
			_photo_file_format_properties_unref0 (_tmp21_);
			result = _tmp27_;
			return result;
		}
	}
}


static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, GError** error) {
	gboolean result = FALSE;
	PhotoFileReader* export_reader;
	gboolean is_master;
	PhotoFileFormat _tmp11_;
	PhotoFileFormatProperties* _tmp12_ = NULL;
	PhotoFileFormatProperties* format_properties;
	GFile* _tmp13_ = NULL;
	GFile* dest_file;
	PhotoFileFormat _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
	PhotoFileMetadataWriter* _tmp17_ = NULL;
	PhotoFileMetadataWriter* _tmp18_;
	PhotoFileMetadataWriter* writer;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_;
	gchar* _tmp21_ = NULL;
	gchar* _tmp22_;
	GFile* _tmp23_ = NULL;
	GFile* _tmp24_;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_;
	PhotoMetadata* _tmp32_ = NULL;
	PhotoMetadata* metadata;
	gchar* _tmp35_ = NULL;
	gchar* _tmp36_;
	time_t _tmp37_;
	gchar* _tmp41_ = NULL;
	gchar* _tmp42_;
	Dimensions _tmp43_ = {0};
	Dimensions _tmp44_ = {0};
	Orientation _tmp45_;
	Orientation _tmp46_;
	Orientation _tmp47_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	export_reader = NULL;
	is_master = TRUE;
	{
		gboolean _tmp0_ = FALSE;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		if (self->priv->readers.editable != NULL) {
			PhotoFileFormat _tmp1_;
			gboolean _tmp2_;
			_tmp1_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (self->priv->readers.editable));
			_tmp2_ = photo_file_format_can_write_metadata (_tmp1_);
			_tmp0_ = _tmp2_;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			PhotoFileReader* _tmp3_;
			_tmp3_ = _photo_file_adapter_ref0 (self->priv->readers.editable);
			_photo_file_adapter_unref0 (export_reader);
			export_reader = _tmp3_;
			is_master = FALSE;
		} else {
			PhotoFileFormat _tmp4_;
			gboolean _tmp5_;
			_tmp4_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (self->priv->readers.master));
			_tmp5_ = photo_file_format_can_write_metadata (_tmp4_);
			if (_tmp5_) {
				PhotoFileReader* _tmp6_;
				_tmp6_ = _photo_file_adapter_ref0 (self->priv->readers.master);
				_photo_file_adapter_unref0 (export_reader);
				export_reader = _tmp6_;
			} else {
				gboolean _tmp7_ = FALSE;
				if (self->priv->readers.mimic != NULL) {
					PhotoFileFormat _tmp8_;
					gboolean _tmp9_;
					_tmp8_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (self->priv->readers.mimic));
					_tmp9_ = photo_file_format_can_write_metadata (_tmp8_);
					_tmp7_ = _tmp9_;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					PhotoFileReader* _tmp10_;
					_tmp10_ = _photo_file_adapter_ref0 (self->priv->readers.mimic);
					_photo_file_adapter_unref0 (export_reader);
					export_reader = _tmp10_;
					is_master = FALSE;
				}
			}
		}
		__finally190:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_photo_file_adapter_unref0 (export_reader);
			return FALSE;
		}
	}
	if (export_reader == NULL) {
		result = FALSE;
		_photo_file_adapter_unref0 (export_reader);
		return result;
	}
	_tmp11_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (export_reader));
	_tmp12_ = photo_file_format_get_properties (_tmp11_);
	format_properties = _tmp12_;
	_tmp13_ = photo_file_format_properties_convert_file_extension (format_properties, file);
	dest_file = _tmp13_;
	_tmp14_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (export_reader));
	_tmp15_ = g_file_get_path (dest_file);
	_tmp16_ = _tmp15_;
	_tmp17_ = photo_file_format_create_metadata_writer (_tmp14_, _tmp16_, &_inner_error_);
	_tmp18_ = _tmp17_;
	_g_free0 (_tmp16_);
	writer = _tmp18_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (dest_file);
		_photo_file_format_properties_unref0 (format_properties);
		_photo_file_adapter_unref0 (export_reader);
		return FALSE;
	}
	_tmp19_ = data_object_to_string (DATA_OBJECT (self));
	_tmp20_ = _tmp19_;
	_tmp21_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (writer));
	_tmp22_ = _tmp21_;
	g_debug ("Photo.vala:2626: Exporting full-sized copy of %s to %s", _tmp20_, _tmp22_);
	_g_free0 (_tmp22_);
	_g_free0 (_tmp20_);
	_tmp23_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (export_reader));
	_tmp24_ = _tmp23_;
	g_file_copy (_tmp24_, dest_file, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
	_g_object_unref0 (_tmp24_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (writer);
		_g_object_unref0 (dest_file);
		_photo_file_format_properties_unref0 (format_properties);
		_photo_file_adapter_unref0 (export_reader);
		return FALSE;
	}
	_tmp28_ = photo_has_alterations (self);
	if (!_tmp28_) {
		_tmp27_ = is_master;
	} else {
		_tmp27_ = FALSE;
	}
	if (_tmp27_) {
		gboolean _tmp29_;
		_tmp29_ = photo_has_user_generated_metadata (self);
		_tmp26_ = !_tmp29_;
	} else {
		_tmp26_ = FALSE;
	}
	if (_tmp26_) {
		gchar* _tmp30_ = NULL;
		gchar* _tmp31_;
		_tmp30_ = media_source_get_title (MEDIA_SOURCE (self));
		_tmp31_ = _tmp30_;
		_tmp25_ = _tmp31_ == NULL;
		_g_free0 (_tmp31_);
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		result = TRUE;
		_photo_file_adapter_unref0 (writer);
		_g_object_unref0 (dest_file);
		_photo_file_format_properties_unref0 (format_properties);
		_photo_file_adapter_unref0 (export_reader);
		return result;
	}
	_tmp32_ = photo_file_reader_read_metadata (export_reader, &_inner_error_);
	metadata = _tmp32_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (writer);
		_g_object_unref0 (dest_file);
		_photo_file_format_properties_unref0 (format_properties);
		_photo_file_adapter_unref0 (export_reader);
		return FALSE;
	}
	if (metadata == NULL) {
		PhotoFileFormat _tmp33_;
		PhotoMetadata* _tmp34_ = NULL;
		_tmp33_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (export_reader));
		_tmp34_ = photo_file_format_create_metadata (_tmp33_);
		_media_metadata_unref0 (metadata);
		metadata = _tmp34_;
	}
	_tmp35_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (writer));
	_tmp36_ = _tmp35_;
	g_debug ("Photo.vala:2641: Updating metadata of %s", _tmp36_);
	_g_free0 (_tmp36_);
	_tmp37_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
	if (_tmp37_ != 0) {
		time_t _tmp38_;
		MetadataDateTime* _tmp39_ = NULL;
		MetadataDateTime* _tmp40_;
		_tmp38_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
		_tmp39_ = metadata_date_time_new (_tmp38_);
		_tmp40_ = _tmp39_;
		photo_metadata_set_exposure_date_time (metadata, _tmp40_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
		_metadata_date_time_unref0 (_tmp40_);
	} else {
		photo_metadata_set_exposure_date_time (metadata, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
	}
	_tmp41_ = media_source_get_title (MEDIA_SOURCE (self));
	_tmp42_ = _tmp41_;
	photo_metadata_set_title (metadata, _tmp42_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
	_g_free0 (_tmp42_);
	media_source_get_dimensions (MEDIA_SOURCE (self), &_tmp43_);
	_tmp44_ = _tmp43_;
	photo_metadata_set_pixel_dimensions (metadata, &_tmp44_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
	_tmp45_ = photo_get_orientation (self);
	photo_metadata_set_orientation (metadata, _tmp45_);
	photo_metadata_set_software (metadata, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
	_tmp46_ = photo_get_orientation (self);
	_tmp47_ = photo_get_original_orientation (self);
	if (_tmp46_ != _tmp47_) {
		photo_metadata_remove_exif_thumbnail (metadata);
	}
	photo_set_user_metadata_for_export (self, metadata);
	photo_file_metadata_writer_write_metadata (writer, metadata, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_media_metadata_unref0 (metadata);
		_photo_file_adapter_unref0 (writer);
		_g_object_unref0 (dest_file);
		_photo_file_format_properties_unref0 (format_properties);
		_photo_file_adapter_unref0 (export_reader);
		return FALSE;
	}
	result = TRUE;
	_media_metadata_unref0 (metadata);
	_photo_file_adapter_unref0 (writer);
	_g_object_unref0 (dest_file);
	_photo_file_format_properties_unref0 (format_properties);
	_photo_file_adapter_unref0 (export_reader);
	return result;
}


gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	_tmp3_ = scaling_is_unscaled (scaling);
	if (!_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp4_;
		_tmp4_ = photo_has_alterations (self);
		_tmp2_ = _tmp4_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp5_;
		_tmp5_ = photo_has_user_generated_metadata (self);
		_tmp1_ = _tmp5_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		PhotoFileFormat _tmp6_;
		_tmp6_ = photo_get_file_format (self);
		_tmp0_ = export_format != _tmp6_;
	}
	result = _tmp0_;
	return result;
}


void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, GError** error) {
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp11_;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_;
	PhotoFileWriter* _tmp15_ = NULL;
	PhotoFileWriter* _tmp16_;
	PhotoFileWriter* writer;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_;
	GEnumValue* _tmp21_;
	GdkPixbuf* _tmp22_ = NULL;
	GdkPixbuf* pixbuf;
	gchar* _tmp23_ = NULL;
	gchar* _tmp24_;
	PhotoMetadata* _tmp25_ = NULL;
	PhotoMetadata* metadata;
	gchar* _tmp27_ = NULL;
	gchar* _tmp28_;
	Dimensions _tmp29_ = {0};
	Dimensions _tmp30_ = {0};
	time_t _tmp31_;
	gboolean _tmp35_;
	gchar* _tmp36_ = NULL;
	gchar* _tmp37_;
	PhotoFileMetadataWriter* _tmp38_ = NULL;
	PhotoFileMetadataWriter* _tmp39_;
	PhotoFileMetadataWriter* _tmp40_;
	PhotoFileMetadataWriter* _tmp41_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (G_IS_FILE (dest_file));
	if (direct_copy_unmodified) {
		GFile* _tmp0_ = NULL;
		GFile* _tmp1_;
		_tmp0_ = media_source_get_master_file (MEDIA_SOURCE (self));
		_tmp1_ = _tmp0_;
		g_file_copy (_tmp1_, dest_file, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
		_g_object_unref0 (_tmp1_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
		return;
	}
	_tmp4_ = scaling_is_unscaled (scaling);
	if (_tmp4_) {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		_tmp6_ = photo_has_alterations (self);
		if (!_tmp6_) {
			_tmp5_ = TRUE;
		} else {
			gboolean _tmp7_;
			_tmp7_ = photo_only_metadata_changed (self);
			_tmp5_ = _tmp7_;
		}
		_tmp3_ = _tmp5_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		PhotoFileFormat _tmp8_;
		_tmp8_ = photo_get_file_format (self);
		_tmp2_ = export_format == _tmp8_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp9_ = photo_export_fullsized_backing (self, dest_file, &_inner_error_);
		_tmp10_ = _tmp9_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
		if (_tmp10_) {
			return;
		}
	}
	_tmp11_ = photo_file_format_can_write (export_format);
	if (!_tmp11_) {
		PhotoFileFormat _tmp12_;
		_tmp12_ = photo_file_format_get_system_default_format ();
		export_format = _tmp12_;
	}
	_tmp13_ = g_file_get_path (dest_file);
	_tmp14_ = _tmp13_;
	_tmp15_ = photo_file_format_create_writer (export_format, _tmp14_, &_inner_error_);
	_tmp16_ = _tmp15_;
	_g_free0 (_tmp14_);
	writer = _tmp16_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp17_ = data_object_to_string (DATA_OBJECT (self));
	_tmp18_ = _tmp17_;
	_tmp19_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (writer));
	_tmp20_ = _tmp19_;
	_tmp21_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), export_format);
	g_debug ("Photo.vala:2697: Saving transformed version of %s to %s in file format" \
" %s", _tmp18_, _tmp20_, (_tmp21_ != NULL) ? _tmp21_->value_name : NULL);
	_g_free0 (_tmp20_);
	_g_free0 (_tmp18_);
	_tmp22_ = photo_get_pixbuf_with_options (self, scaling, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
	pixbuf = _tmp22_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_file_adapter_unref0 (writer);
		return;
	}
	photo_file_writer_write (writer, pixbuf, quality, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (pixbuf);
		_photo_file_adapter_unref0 (writer);
		return;
	}
	_tmp23_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (writer));
	_tmp24_ = _tmp23_;
	g_debug ("Photo.vala:2705: Setting EXIF for %s", _tmp24_);
	_g_free0 (_tmp24_);
	_tmp25_ = photo_source_get_metadata (PHOTO_SOURCE (self));
	metadata = _tmp25_;
	if (metadata == NULL) {
		PhotoMetadata* _tmp26_ = NULL;
		_tmp26_ = photo_file_format_create_metadata (export_format);
		_media_metadata_unref0 (metadata);
		metadata = _tmp26_;
	}
	_tmp27_ = media_source_get_title (MEDIA_SOURCE (self));
	_tmp28_ = _tmp27_;
	photo_metadata_set_title (metadata, _tmp28_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
	_g_free0 (_tmp28_);
	dimensions_for_pixbuf (pixbuf, &_tmp29_);
	_tmp30_ = _tmp29_;
	photo_metadata_set_pixel_dimensions (metadata, &_tmp30_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
	photo_metadata_set_orientation (metadata, ORIENTATION_TOP_LEFT);
	photo_metadata_set_software (metadata, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
	_tmp31_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
	if (_tmp31_ != 0) {
		time_t _tmp32_;
		MetadataDateTime* _tmp33_ = NULL;
		MetadataDateTime* _tmp34_;
		_tmp32_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
		_tmp33_ = metadata_date_time_new (_tmp32_);
		_tmp34_ = _tmp33_;
		photo_metadata_set_exposure_date_time (metadata, _tmp34_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
		_metadata_date_time_unref0 (_tmp34_);
	} else {
		photo_metadata_set_exposure_date_time (metadata, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
	}
	photo_metadata_remove_tag (metadata, "Exif.Iop.RelatedImageWidth");
	photo_metadata_remove_tag (metadata, "Exif.Iop.RelatedImageHeight");
	photo_metadata_remove_exif_thumbnail (metadata);
	_tmp35_ = photo_has_user_generated_metadata (self);
	if (_tmp35_) {
		photo_set_user_metadata_for_export (self, metadata);
	}
	_tmp36_ = g_file_get_path (dest_file);
	_tmp37_ = _tmp36_;
	_tmp38_ = photo_file_format_create_metadata_writer (export_format, _tmp37_, &_inner_error_);
	_tmp39_ = _tmp38_;
	_g_free0 (_tmp37_);
	_tmp40_ = _tmp39_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_media_metadata_unref0 (metadata);
		_g_object_unref0 (pixbuf);
		_photo_file_adapter_unref0 (writer);
		return;
	}
	_tmp41_ = _tmp40_;
	photo_file_metadata_writer_write_metadata (_tmp41_, metadata, &_inner_error_);
	_photo_file_adapter_unref0 (_tmp41_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_media_metadata_unref0 (metadata);
		_g_object_unref0 (pixbuf);
		_photo_file_adapter_unref0 (writer);
		return;
	}
	_media_metadata_unref0 (metadata);
	_g_object_unref0 (pixbuf);
	_photo_file_adapter_unref0 (writer);
}


static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error) {
	PhotoFileFormat _file_format = 0;
	GFile* result = NULL;
	GFile* backing = NULL;
	gboolean _tmp2_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* editable_basename;
	gboolean collision = FALSE;
	GFile* _tmp17_ = NULL;
	GFile* _tmp18_;
	gboolean _tmp19_;
	GFile* _tmp20_ = NULL;
	GFile* _tmp21_;
	GFile* _tmp22_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	{
		PhotoFileFormat _tmp0_;
		GFile* _tmp1_ = NULL;
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		_tmp0_ = photo_get_file_format (self);
		_file_format = _tmp0_;
		_tmp1_ = media_source_get_file (MEDIA_SOURCE (self));
		_g_object_unref0 (backing);
		backing = _tmp1_;
		__finally191:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (backing);
			return NULL;
		}
	}
	_tmp2_ = photo_file_format_can_write (_file_format);
	if (!_tmp2_) {
		PhotoFileFormat _tmp3_;
		_tmp3_ = photo_file_format_get_system_default_format ();
		_file_format = _tmp3_;
	}
	_tmp4_ = g_file_get_basename (backing);
	_tmp5_ = _tmp4_;
	disassemble_filename (_tmp5_, &_tmp6_, &_tmp7_);
	_g_free0 (name);
	name = _tmp6_;
	_g_free0 (ext);
	ext = _tmp7_;
	_g_free0 (_tmp5_);
	if (ext == NULL) {
		_tmp8_ = TRUE;
	} else {
		PhotoFileFormatProperties* _tmp9_ = NULL;
		PhotoFileFormatProperties* _tmp10_;
		gboolean _tmp11_;
		_tmp9_ = photo_file_format_get_properties (_file_format);
		_tmp10_ = _tmp9_;
		_tmp11_ = photo_file_format_properties_is_recognized_extension (_tmp10_, ext);
		_tmp8_ = !_tmp11_;
		_photo_file_format_properties_unref0 (_tmp10_);
	}
	if (_tmp8_) {
		PhotoFileFormatProperties* _tmp12_ = NULL;
		PhotoFileFormatProperties* _tmp13_;
		gchar* _tmp14_ = NULL;
		_tmp12_ = photo_file_format_get_properties (_file_format);
		_tmp13_ = _tmp12_;
		_tmp14_ = photo_file_format_properties_get_default_extension (_tmp13_);
		_g_free0 (ext);
		ext = _tmp14_;
		_photo_file_format_properties_unref0 (_tmp13_);
	}
	_tmp15_ = _ ("modified");
	_tmp16_ = g_strdup_printf ("%s_%s.%s", name, _tmp15_, ext);
	editable_basename = _tmp16_;
	_tmp17_ = g_file_get_parent (backing);
	_tmp18_ = _tmp17_;
	_tmp20_ = generate_unique_file (_tmp18_, editable_basename, &_tmp19_, &_inner_error_);
	collision = _tmp19_;
	_tmp21_ = _tmp20_;
	_g_object_unref0 (_tmp18_);
	_tmp22_ = _tmp21_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (editable_basename);
		_g_free0 (ext);
		_g_free0 (name);
		_g_object_unref0 (backing);
		return NULL;
	}
	result = _tmp22_;
	_g_free0 (editable_basename);
	_g_free0 (ext);
	_g_free0 (name);
	_g_object_unref0 (backing);
	if (file_format) {
		*file_format = _file_format;
	}
	return result;
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_list_free (self);
}


static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, GError** error) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* _tmp7_;
	gchar* commandline;
	gboolean _tmp8_;
	GAppInfo* app = NULL;
	GAppInfo* _tmp9_ = NULL;
	GAppInfo* _tmp10_;
	GAppInfo* _tmp11_;
	GList* files;
	GFile* _tmp12_;
	gchar** _tmp15_ = NULL;
	gchar** argv;
	gint argv_length1;
	gint _argv_size_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_;
	GPid child_pid = 0;
	GPid _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	if (file_format == PHOTO_FILE_FORMAT_RAW) {
		Config* _tmp1_ = NULL;
		Config* _tmp2_;
		gchar* _tmp3_ = NULL;
		_tmp1_ = config_get_instance ();
		_tmp2_ = _tmp1_;
		_tmp3_ = config_get_external_raw_app (_tmp2_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
		_config_unref0 (_tmp2_);
	} else {
		Config* _tmp4_ = NULL;
		Config* _tmp5_;
		gchar* _tmp6_ = NULL;
		_tmp4_ = config_get_instance ();
		_tmp5_ = _tmp4_;
		_tmp6_ = config_get_external_photo_app (_tmp5_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp6_;
		_config_unref0 (_tmp5_);
	}
	_tmp7_ = g_strdup (_tmp0_);
	commandline = _tmp7_;
	_tmp8_ = is_string_empty (commandline);
	if (_tmp8_) {
		result = FALSE;
		_g_free0 (commandline);
		_g_free0 (_tmp0_);
		return result;
	}
	_tmp9_ = g_app_info_create_from_commandline (commandline, "", G_APP_INFO_CREATE_NONE, &_inner_error_);
	_tmp10_ = _tmp9_;
	if (_inner_error_ != NULL) {
		goto __catch192_g_error;
	}
	_tmp11_ = _g_object_ref0 (_tmp10_);
	_g_object_unref0 (app);
	app = _tmp11_;
	goto __finally192;
	__catch192_g_error:
	{
		GError * er;
		er = _inner_error_;
		_inner_error_ = NULL;
		_g_object_unref0 (app);
		app = NULL;
		_g_error_free0 (er);
	}
	__finally192:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (app);
		_g_free0 (commandline);
		_g_free0 (_tmp0_);
		return FALSE;
	}
	files = NULL;
	_tmp12_ = _g_object_ref0 (file);
	files = g_list_insert (files, _tmp12_, -1);
	if (app != NULL) {
		gboolean _tmp13_;
		gboolean _tmp14_;
		_tmp13_ = g_app_info_launch (app, files, NULL, &_inner_error_);
		_tmp14_ = _tmp13_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			__g_list_free__g_object_unref0_0 (files);
			_g_object_unref0 (app);
			_g_free0 (commandline);
			_g_free0 (_tmp0_);
			return FALSE;
		}
		result = _tmp14_;
		__g_list_free__g_object_unref0_0 (files);
		_g_object_unref0 (app);
		_g_free0 (commandline);
		_g_free0 (_tmp0_);
		return result;
	}
	_tmp15_ = g_new0 (gchar*, 2 + 1);
	argv = _tmp15_;
	argv_length1 = 2;
	_argv_size_ = 2;
	_tmp16_ = g_strdup (commandline);
	_tmp17_ = _tmp16_;
	_g_free0 (argv[0]);
	argv[0] = _tmp17_;
	_tmp18_ = g_file_get_path (file);
	_tmp19_ = _tmp18_;
	_g_free0 (argv[1]);
	argv[1] = _tmp19_;
	_tmp21_ = g_spawn_async ("/", argv, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp20_, &_inner_error_);
	child_pid = _tmp20_;
	_tmp22_ = _tmp21_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		__g_list_free__g_object_unref0_0 (files);
		_g_object_unref0 (app);
		_g_free0 (commandline);
		_g_free0 (_tmp0_);
		return FALSE;
	}
	result = _tmp22_;
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
	__g_list_free__g_object_unref0_0 (files);
	_g_object_unref0 (app);
	_g_free0 (commandline);
	_g_free0 (_tmp0_);
	return result;
}


void photo_open_master_with_external_editor (Photo* self, GError** error) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	PhotoFileFormat _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = media_source_get_master_file (MEDIA_SOURCE (self));
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_get_master_file_format (self);
	photo_launch_editor (_tmp1_, _tmp2_, &_inner_error_);
	_g_object_unref0 (_tmp1_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


void photo_open_with_external_editor (Photo* self, GError** error) {
	GFile* current_editable_file;
	GFile* create_editable_file;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp11_ = FALSE;
	PhotoFileFormat _tmp19_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	current_editable_file = NULL;
	create_editable_file = NULL;
	{
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		if (self->priv->readers.editable != NULL) {
			GFile* _tmp0_ = NULL;
			_tmp0_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (self->priv->readers.editable));
			_g_object_unref0 (current_editable_file);
			current_editable_file = _tmp0_;
		}
		if (current_editable_file == NULL) {
			PhotoFileFormat _tmp1_;
			GFile* _tmp2_ = NULL;
			GFile* _tmp3_;
			_tmp2_ = photo_generate_new_editable_file (self, &_tmp1_, &_inner_error_);
			editable_file_format = _tmp1_;
			_tmp3_ = _tmp2_;
			if (_inner_error_ != NULL) {
				goto __finally193;
			}
			_g_object_unref0 (create_editable_file);
			create_editable_file = _tmp3_;
		} else {
			PhotoFileFormat _tmp4_;
			_tmp4_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (self->priv->readers.editable));
			editable_file_format = _tmp4_;
		}
		__finally193:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (create_editable_file);
			_g_object_unref0 (current_editable_file);
			return;
		}
	}
	if (create_editable_file == NULL) {
		_tmp6_ = current_editable_file != NULL;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_;
		_tmp8_ = g_file_query_exists (current_editable_file, NULL);
		if (!_tmp8_) {
			_tmp7_ = TRUE;
		} else {
			gboolean _tmp9_;
			_tmp9_ = photo_has_transformations (self);
			_tmp7_ = _tmp9_;
		}
		_tmp5_ = _tmp7_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		GFile* _tmp10_;
		_tmp10_ = _g_object_ref0 (current_editable_file);
		_g_object_unref0 (create_editable_file);
		create_editable_file = _tmp10_;
	}
	if (create_editable_file != NULL) {
		gboolean _tmp12_;
		_tmp12_ = photo_file_format_can_write (editable_file_format);
		_tmp11_ = _tmp12_;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		Scaling _tmp13_ = {0};
		Scaling _tmp14_ = {0};
		GFile* _tmp18_;
		photo_halt_monitoring_editable (self);
		scaling_for_original (&_tmp13_);
		_tmp14_ = _tmp13_;
		photo_export (self, create_editable_file, &_tmp14_, JPEG_QUALITY_MAXIMUM, editable_file_format, FALSE, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch194_g_error;
		}
		goto __finally194;
		__catch194_g_error:
		{
			GError * err;
			GError* _tmp17_;
			err = _inner_error_;
			_inner_error_ = NULL;
			g_file_delete (create_editable_file, NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch195_g_error;
			}
			goto __finally195;
			__catch195_g_error:
			{
				GError * delete_err;
				gchar* _tmp15_ = NULL;
				gchar* _tmp16_;
				delete_err = _inner_error_;
				_inner_error_ = NULL;
				_tmp15_ = g_file_get_path (create_editable_file);
				_tmp16_ = _tmp15_;
				g_warning ("Photo.vala:2829: Unable to delete editable file %s after export error:" \
" %s", _tmp16_, delete_err->message);
				_g_free0 (_tmp16_);
				_g_error_free0 (delete_err);
			}
			__finally195:
			if (_inner_error_ != NULL) {
				_g_error_free0 (err);
				_g_error_free0 (err);
				_g_object_unref0 (create_editable_file);
				_g_object_unref0 (current_editable_file);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_tmp17_ = _g_error_copy0 (err);
			_inner_error_ = _tmp17_;
			_g_error_free0 (err);
			goto __finally194;
		}
		__finally194:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (create_editable_file);
			_g_object_unref0 (current_editable_file);
			return;
		}
		photo_attach_editable (self, editable_file_format, create_editable_file, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (create_editable_file);
			_g_object_unref0 (current_editable_file);
			return;
		}
		_tmp18_ = _g_object_ref0 (create_editable_file);
		_g_object_unref0 (current_editable_file);
		current_editable_file = _tmp18_;
	}
	g_assert (current_editable_file != NULL);
	if (self->priv->editable_monitor == NULL) {
		photo_start_monitoring_editable (self, current_editable_file, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (create_editable_file);
			_g_object_unref0 (current_editable_file);
			return;
		}
	}
	_tmp19_ = photo_get_file_format (self);
	photo_launch_editor (current_editable_file, _tmp19_, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (create_editable_file);
		_g_object_unref0 (current_editable_file);
		return;
	}
	_g_object_unref0 (create_editable_file);
	_g_object_unref0 (current_editable_file);
}


void photo_revert_to_master (Photo* self) {
	g_return_if_fail (IS_PHOTO (self));
	photo_detach_editable (self, TRUE, TRUE);
}


static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
	photo_on_editable_file_changed (self, file, other_file, event_type);
}


static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error) {
	GFileMonitor* _tmp0_ = NULL;
	GFileMonitor* _tmp1_;
	GFileMonitor* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (G_IS_FILE (file));
	photo_halt_monitoring_editable (self);
	library_monitor_blacklist_file (file, "Photo.start_monitoring_editable");
	_tmp0_ = g_file_monitor (file, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (self->priv->editable_monitor);
	self->priv->editable_monitor = _tmp2_;
	g_signal_connect_object (self->priv->editable_monitor, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
}


static void photo_halt_monitoring_editable (Photo* self) {
	GFile* _tmp0_ = NULL;
	GFile* file;
	guint _tmp1_;
	g_return_if_fail (IS_PHOTO (self));
	if (self->priv->editable_monitor == NULL) {
		return;
	}
	_tmp0_ = photo_get_editable_file (self);
	file = _tmp0_;
	if (file != NULL) {
		library_monitor_unblacklist_file (file);
	}
	g_signal_parse_name ("changed", G_TYPE_FILE_MONITOR, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (self->priv->editable_monitor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
	g_file_monitor_cancel (self->priv->editable_monitor);
	_g_object_unref0 (self->priv->editable_monitor);
	self->priv->editable_monitor = NULL;
	_g_object_unref0 (file);
}


static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_ = NULL;
	PhotoFileReader* _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (G_IS_FILE (file));
	photo_internal_remove_all_transformations (self, FALSE);
	_tmp0_ = g_file_get_path (file);
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_file_format_create_reader (file_format, _tmp1_);
	_tmp3_ = _tmp2_;
	photo_update_editable (self, FALSE, _tmp3_, &_inner_error_);
	_photo_file_adapter_unref0 (_tmp3_);
	_g_free0 (_tmp1_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


static void photo_update_editable_attributes (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	photo_update_editable (self, TRUE, NULL, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


void photo_reimport_editable (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	photo_internal_remove_all_transformations (self, FALSE);
	photo_update_editable (self, FALSE, NULL, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


static void _vala_array_add180 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add181 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add182 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add183 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add184 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add185 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	PhotoFileReader* _tmp2_ = NULL;
	PhotoFileReader* old_reader;
	PhotoFileReader* _tmp3_;
	PhotoFileReader* _tmp4_;
	PhotoFileReader* _tmp6_;
	PhotoFileReader* reader;
	BackingPhotoID _tmp7_ = {0};
	BackingPhotoID _tmp8_ = {0};
	BackingPhotoID editable_id;
	GFile* _tmp9_ = NULL;
	GFile* file;
	gboolean timestamp_changed;
	gboolean filesize_changed;
	gboolean _tmp41_ = FALSE;
	gchar** _tmp46_ = NULL;
	gchar** alteration_list;
	gint alteration_list_length1;
	gint _alteration_list_size_;
	gboolean _tmp51_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((new_reader == NULL) || IS_PHOTO_FILE_READER (new_reader));
	if (only_attributes) {
		_tmp1_ = new_reader == NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = !only_attributes;
	}
	g_assert (_tmp0_);
	_tmp2_ = photo_get_editable_reader (self);
	old_reader = _tmp2_;
	_tmp3_ = _photo_file_adapter_ref0 (new_reader);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == NULL) {
		PhotoFileReader* _tmp5_;
		_tmp5_ = _photo_file_adapter_ref0 (old_reader);
		_photo_file_adapter_unref0 (_tmp4_);
		_tmp4_ = _tmp5_;
	}
	_tmp6_ = _photo_file_adapter_ref0 (_tmp4_);
	reader = _tmp6_;
	if (reader == NULL) {
		photo_detach_editable (self, FALSE, TRUE);
		_photo_file_adapter_unref0 (reader);
		_photo_file_adapter_unref0 (_tmp4_);
		_photo_file_adapter_unref0 (old_reader);
		return;
	}
	photo_get_editable_id (self, &_tmp7_);
	_tmp8_ = _tmp7_;
	editable_id = _tmp8_;
	_tmp9_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (reader));
	file = _tmp9_;
	timestamp_changed = FALSE;
	filesize_changed = FALSE;
	if (only_attributes) {
		gboolean _tmp10_;
		GFileInfo* info = NULL;
		GFileInfo* _tmp11_ = NULL;
		GFileInfo* _tmp12_;
		GFileInfo* _tmp13_;
		GTimeVal timestamp = {0};
		GTimeVal _tmp16_ = {0};
		BackingPhotoTable* _tmp17_ = NULL;
		BackingPhotoTable* _tmp18_;
		gint64 _tmp19_;
		_tmp10_ = backing_photo_id_is_valid (&editable_id);
		g_assert (_tmp10_);
		_tmp11_ = g_file_query_filesystem_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error_);
		_tmp12_ = _tmp11_;
		if (_inner_error_ != NULL) {
			goto __catch196_g_error;
		}
		_tmp13_ = _g_object_ref0 (_tmp12_);
		_g_object_unref0 (info);
		info = _tmp13_;
		goto __finally196;
		__catch196_g_error:
		{
			GError * err;
			gchar* _tmp14_ = NULL;
			gchar* _tmp15_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp14_ = data_object_to_string (DATA_OBJECT (self));
			_tmp15_ = _tmp14_;
			g_warning ("Photo.vala:2925: Unable to read editable filesystem info for %s: %s", _tmp15_, err->message);
			_g_free0 (_tmp15_);
			photo_detach_editable (self, FALSE, TRUE);
			_g_error_free0 (err);
			_g_object_unref0 (info);
			_g_object_unref0 (file);
			_photo_file_adapter_unref0 (reader);
			_photo_file_adapter_unref0 (_tmp4_);
			_photo_file_adapter_unref0 (old_reader);
			return;
		}
		__finally196:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (info);
			_g_object_unref0 (file);
			_photo_file_adapter_unref0 (reader);
			_photo_file_adapter_unref0 (_tmp4_);
			_photo_file_adapter_unref0 (old_reader);
			return;
		}
		g_file_info_get_modification_time (info, &_tmp16_);
		timestamp = _tmp16_;
		_tmp17_ = backing_photo_table_get_instance ();
		_tmp18_ = _tmp17_;
		_tmp19_ = g_file_info_get_size (info);
		backing_photo_table_update_attributes (_tmp18_, &editable_id, (time_t) timestamp.tv_sec, _tmp19_, &_inner_error_);
		_database_table_unref0 (_tmp18_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (info);
			_g_object_unref0 (file);
			_photo_file_adapter_unref0 (reader);
			_photo_file_adapter_unref0 (_tmp4_);
			_photo_file_adapter_unref0 (old_reader);
			return;
		}
		{
			gint64 _tmp20_;
			gint64 _tmp21_;
			g_static_rec_mutex_lock (&self->priv->__lock_row);
			timestamp_changed = self->priv->editable.timestamp != timestamp.tv_sec;
			_tmp20_ = g_file_info_get_size (info);
			filesize_changed = self->priv->editable.filesize != _tmp20_;
			self->priv->editable.timestamp = (time_t) timestamp.tv_sec;
			_tmp21_ = g_file_info_get_size (info);
			self->priv->editable.filesize = _tmp21_;
			__finally197:
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (info);
				_g_object_unref0 (file);
				_photo_file_adapter_unref0 (reader);
				_photo_file_adapter_unref0 (_tmp4_);
				_photo_file_adapter_unref0 (old_reader);
				return;
			}
		}
		_g_object_unref0 (info);
	} else {
		BackingPhotoState state = {0};
		DetectedPhotoInformation* detected = NULL;
		BackingPhotoState _tmp22_ = {0};
		DetectedPhotoInformation* _tmp23_ = NULL;
		gboolean _tmp24_;
		gboolean _tmp25_;
		memset (&state, 0, sizeof (BackingPhotoState));
		_tmp24_ = photo_query_backing_photo_state (self, file, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp22_, &_tmp23_, &_inner_error_);
		backing_photo_state_destroy (&state);
		state = _tmp22_;
		_detected_photo_information_unref0 (detected);
		detected = _tmp23_;
		_tmp25_ = _tmp24_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_detected_photo_information_unref0 (detected);
			backing_photo_state_destroy (&state);
			_g_object_unref0 (file);
			_photo_file_adapter_unref0 (reader);
			_photo_file_adapter_unref0 (_tmp4_);
			_photo_file_adapter_unref0 (old_reader);
			return;
		}
		if (_tmp25_) {
			gboolean _tmp26_;
			_tmp26_ = backing_photo_id_is_valid (&editable_id);
			if (_tmp26_) {
				BackingPhotoTable* _tmp27_ = NULL;
				BackingPhotoTable* _tmp28_;
				_tmp27_ = backing_photo_table_get_instance ();
				_tmp28_ = _tmp27_;
				backing_photo_table_update (_tmp28_, &editable_id, &state, &_inner_error_);
				_database_table_unref0 (_tmp28_);
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_detected_photo_information_unref0 (detected);
					backing_photo_state_destroy (&state);
					_g_object_unref0 (file);
					_photo_file_adapter_unref0 (reader);
					_photo_file_adapter_unref0 (_tmp4_);
					_photo_file_adapter_unref0 (old_reader);
					return;
				}
				{
					BackingPhotoState _tmp29_;
					BackingPhotoState _tmp30_ = {0};
					g_static_rec_mutex_lock (&self->priv->__lock_row);
					timestamp_changed = self->priv->editable.timestamp != state.timestamp;
					filesize_changed = self->priv->editable.filesize != state.filesize;
					backing_photo_state_copy (&state, &_tmp30_);
					_tmp29_ = _tmp30_;
					backing_photo_state_destroy (&self->priv->editable);
					self->priv->editable = _tmp29_;
					g_assert (self->priv->backing_photo_state == (&self->priv->editable));
					photo_set_orientation (self, (*self->priv->backing_photo_state).original_orientation);
					__finally198:
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
					if (_inner_error_ != NULL) {
						g_propagate_error (error, _inner_error_);
						_detected_photo_information_unref0 (detected);
						backing_photo_state_destroy (&state);
						_g_object_unref0 (file);
						_photo_file_adapter_unref0 (reader);
						_photo_file_adapter_unref0 (_tmp4_);
						_photo_file_adapter_unref0 (old_reader);
						return;
					}
				}
			} else {
				BackingPhotoTable* _tmp31_ = NULL;
				BackingPhotoTable* _tmp32_;
				BackingPhotoRow _tmp33_ = {0};
				BackingPhotoRow _tmp34_ = {0};
				BackingPhotoRow _tmp35_;
				BackingPhotoRow editable_row;
				_tmp31_ = backing_photo_table_get_instance ();
				_tmp32_ = _tmp31_;
				backing_photo_table_add (_tmp32_, &state, &_tmp33_, &_inner_error_);
				_tmp34_ = _tmp33_;
				_tmp35_ = _tmp34_;
				_database_table_unref0 (_tmp32_);
				editable_row = _tmp35_;
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_detected_photo_information_unref0 (detected);
					backing_photo_state_destroy (&state);
					_g_object_unref0 (file);
					_photo_file_adapter_unref0 (reader);
					_photo_file_adapter_unref0 (_tmp4_);
					_photo_file_adapter_unref0 (old_reader);
					return;
				}
				{
					PhotoTable* _tmp36_ = NULL;
					PhotoTable* _tmp37_;
					BackingPhotoState _tmp38_;
					BackingPhotoState _tmp39_ = {0};
					g_static_rec_mutex_lock (&self->priv->__lock_row);
					timestamp_changed = editable_row.state.timestamp != state.timestamp;
					filesize_changed = editable_row.state.filesize != state.filesize;
					_tmp36_ = photo_table_get_instance ();
					_tmp37_ = _tmp36_;
					photo_table_attach_editable (_tmp37_, &self->priv->row, &editable_row.id, &_inner_error_);
					_database_table_unref0 (_tmp37_);
					if (_inner_error_ != NULL) {
						goto __finally199;
					}
					backing_photo_state_copy (&editable_row.state, &_tmp39_);
					_tmp38_ = _tmp39_;
					backing_photo_state_destroy (&self->priv->editable);
					self->priv->editable = _tmp38_;
					self->priv->backing_photo_state = &self->priv->editable;
					photo_set_orientation (self, (*self->priv->backing_photo_state).original_orientation);
					__finally199:
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
					if (_inner_error_ != NULL) {
						g_propagate_error (error, _inner_error_);
						backing_photo_row_destroy (&editable_row);
						_detected_photo_information_unref0 (detected);
						backing_photo_state_destroy (&state);
						_g_object_unref0 (file);
						_photo_file_adapter_unref0 (reader);
						_photo_file_adapter_unref0 (_tmp4_);
						_photo_file_adapter_unref0 (old_reader);
						return;
					}
				}
				backing_photo_row_destroy (&editable_row);
			}
		}
		_detected_photo_information_unref0 (detected);
		backing_photo_state_destroy (&state);
	}
	if (new_reader != NULL) {
		{
			PhotoFileReader* _tmp40_;
			g_static_rec_mutex_lock (&self->priv->__lock_readers);
			_tmp40_ = _photo_file_adapter_ref0 (new_reader);
			_photo_file_adapter_unref0 (self->priv->readers.editable);
			self->priv->readers.editable = _tmp40_;
			__finally200:
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (file);
				_photo_file_adapter_unref0 (reader);
				_photo_file_adapter_unref0 (_tmp4_);
				_photo_file_adapter_unref0 (old_reader);
				return;
			}
		}
	}
	if (!only_attributes) {
		_tmp41_ = reader != old_reader;
	} else {
		_tmp41_ = FALSE;
	}
	if (_tmp41_) {
		GFile* _tmp42_ = NULL;
		GFile* _tmp44_ = NULL;
		photo_notify_baseline_replaced (self);
		if (old_reader != NULL) {
			GFile* _tmp43_ = NULL;
			_tmp43_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (old_reader));
			_g_object_unref0 (_tmp42_);
			_tmp42_ = _tmp43_;
		} else {
			_g_object_unref0 (_tmp42_);
			_tmp42_ = NULL;
		}
		if (new_reader != NULL) {
			GFile* _tmp45_ = NULL;
			_tmp45_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (new_reader));
			_g_object_unref0 (_tmp44_);
			_tmp44_ = _tmp45_;
		} else {
			_g_object_unref0 (_tmp44_);
			_tmp44_ = NULL;
		}
		photo_notify_editable_replaced (self, _tmp42_, _tmp44_);
		_g_object_unref0 (_tmp44_);
		_g_object_unref0 (_tmp42_);
	}
	_tmp46_ = g_new0 (gchar*, 0 + 1);
	alteration_list = _tmp46_;
	alteration_list_length1 = 0;
	_alteration_list_size_ = 0;
	if (timestamp_changed) {
		gchar* _tmp47_;
		gchar* _tmp48_;
		gboolean _tmp49_;
		_tmp47_ = g_strdup ("metadata:editable-timestamp");
		_vala_array_add180 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp47_);
		_tmp48_ = g_strdup ("metadata:baseline-timestamp");
		_vala_array_add181 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp48_);
		_tmp49_ = photo_is_editable_source (self);
		if (_tmp49_) {
			gchar* _tmp50_;
			_tmp50_ = g_strdup ("metadata:source-timestamp");
			_vala_array_add182 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp50_);
		}
	}
	if (filesize_changed) {
		_tmp51_ = TRUE;
	} else {
		_tmp51_ = new_reader != NULL;
	}
	if (_tmp51_) {
		gchar* _tmp52_;
		gchar* _tmp53_;
		gboolean _tmp54_;
		_tmp52_ = g_strdup ("image:editable");
		_vala_array_add183 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp52_);
		_tmp53_ = g_strdup ("image:baseline");
		_vala_array_add184 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp53_);
		_tmp54_ = photo_is_editable_source (self);
		if (_tmp54_) {
			gchar* _tmp55_;
			_tmp55_ = g_strdup ("image:source");
			_vala_array_add185 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp55_);
		}
	}
	if (alteration_list_length1 > 0) {
		Alteration* _tmp56_ = NULL;
		Alteration* _tmp57_;
		_tmp56_ = alteration_new_from_array (alteration_list, alteration_list_length1);
		_tmp57_ = _tmp56_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp57_);
		_alteration_unref0 (_tmp57_);
	}
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (file);
	_photo_file_adapter_unref0 (reader);
	_photo_file_adapter_unref0 (_tmp4_);
	_photo_file_adapter_unref0 (old_reader);
}


static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations) {
	gboolean has_editable;
	GFile* editable_file;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp12_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	photo_halt_monitoring_editable (self);
	has_editable = FALSE;
	editable_file = NULL;
	{
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		if (self->priv->readers.editable != NULL) {
			GFile* _tmp0_ = NULL;
			_tmp0_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (self->priv->readers.editable));
			_g_object_unref0 (editable_file);
			editable_file = _tmp0_;
			_photo_file_adapter_unref0 (self->priv->readers.editable);
			self->priv->readers.editable = NULL;
			has_editable = TRUE;
		}
		__finally201:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (editable_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (has_editable) {
		BackingPhotoID editable_id = {0};
		gboolean _tmp4_;
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
		{
			gboolean _tmp1_;
			g_static_rec_mutex_lock (&self->priv->__lock_row);
			editable_id = self->priv->row.editable_id;
			_tmp1_ = backing_photo_id_is_valid (&editable_id);
			if (_tmp1_) {
				PhotoTable* _tmp2_ = NULL;
				PhotoTable* _tmp3_;
				_tmp2_ = photo_table_get_instance ();
				_tmp3_ = _tmp2_;
				photo_table_detach_editable (_tmp3_, &self->priv->row, &_inner_error_);
				_database_table_unref0 (_tmp3_);
				if (_inner_error_ != NULL) {
					goto __finally203;
				}
			}
			self->priv->backing_photo_state = &self->priv->row.master;
			__finally203:
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == DATABASE_ERROR) {
					goto __catch202_database_error;
				}
				_g_object_unref0 (editable_file);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		goto __finally202;
		__catch202_database_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			g_warning ("Photo.vala:3031: Unable to remove editable from PhotoTable: %s", err->message);
			_g_error_free0 (err);
		}
		__finally202:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (editable_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp4_ = backing_photo_id_is_valid (&editable_id);
		if (_tmp4_) {
			BackingPhotoTable* _tmp5_ = NULL;
			BackingPhotoTable* _tmp6_;
			_tmp5_ = backing_photo_table_get_instance ();
			_tmp6_ = _tmp5_;
			backing_photo_table_remove (_tmp6_, &editable_id, &_inner_error_);
			_database_table_unref0 (_tmp6_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == DATABASE_ERROR) {
					goto __catch204_database_error;
				}
				_g_object_unref0 (editable_file);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		goto __finally204;
		__catch204_database_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			g_warning ("Photo.vala:3038: Unable to remove editable from BackingPhotoTable: %s", err->message);
			_g_error_free0 (err);
		}
		__finally204:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (editable_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (remove_transformations) {
		photo_internal_remove_all_transformations (self, FALSE);
	}
	if (has_editable) {
		photo_notify_baseline_replaced (self);
		photo_notify_editable_replaced (self, editable_file, NULL);
	}
	if (delete_editable) {
		_tmp7_ = editable_file != NULL;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		g_file_trash (editable_file, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch205_g_error;
		}
		goto __finally205;
		__catch205_g_error:
		{
			GError * err;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp8_ = g_file_get_path (editable_file);
			_tmp9_ = _tmp8_;
			_tmp10_ = data_object_to_string (DATA_OBJECT (self));
			_tmp11_ = _tmp10_;
			g_warning ("Photo.vala:3054: Unable to trash editable %s for %s: %s", _tmp9_, _tmp11_, err->message);
			_g_free0 (_tmp11_);
			_g_free0 (_tmp9_);
			_g_error_free0 (err);
		}
		__finally205:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (editable_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (has_editable) {
		_tmp12_ = TRUE;
	} else {
		_tmp12_ = remove_transformations;
	}
	if (_tmp12_) {
		Alteration* _tmp13_ = NULL;
		Alteration* _tmp14_;
		_tmp13_ = alteration_new ("image", "revert");
		_tmp14_ = _tmp13_;
		data_object_notify_altered (DATA_OBJECT (self), _tmp14_);
		_alteration_unref0 (_tmp14_);
	}
	_g_object_unref0 (editable_file);
}


static void _photo_on_reimport_editable_one_shot_callback (gpointer self) {
	photo_on_reimport_editable (self);
}


static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self) {
	photo_on_update_editable_attributes (self);
}


static void _photo_on_remove_editable_one_shot_callback (gpointer self) {
	photo_on_remove_editable (self);
}


static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	GEnumValue* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
	{
		gboolean _tmp0_ = FALSE;
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
		if (self->priv->readers.editable != NULL) {
			GFile* _tmp1_ = NULL;
			GFile* _tmp2_;
			gboolean _tmp3_;
			_tmp1_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (self->priv->readers.editable));
			_tmp2_ = _tmp1_;
			_tmp3_ = g_file_equal (file, _tmp2_);
			_tmp0_ = _tmp3_;
			_g_object_unref0 (_tmp2_);
		} else {
			_tmp0_ = FALSE;
		}
		g_assert (_tmp0_);
		__finally206:
		g_static_rec_mutex_unlock (&self->priv->__lock_readers);
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp4_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), event);
	_tmp5_ = g_file_get_path (file);
	_tmp6_ = _tmp5_;
	g_debug ("Photo.vala:3069: EDITABLE %s: %s", (_tmp4_ != NULL) ? _tmp4_->value_name : NULL, _tmp6_);
	_g_free0 (_tmp6_);
	switch (event) {
		case G_FILE_MONITOR_EVENT_CHANGED:
		case G_FILE_MONITOR_EVENT_CREATED:
		{
			if (self->priv->reimport_editable_scheduler == NULL) {
				OneShotScheduler* _tmp7_ = NULL;
				_tmp7_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
				self->priv->reimport_editable_scheduler = _tmp7_;
			}
			one_shot_scheduler_after_timeout (self->priv->reimport_editable_scheduler, (guint) 1000, TRUE);
			break;
		}
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
		{
			if (self->priv->update_editable_attributes_scheduler == NULL) {
				OneShotScheduler* _tmp8_ = NULL;
				_tmp8_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
				self->priv->update_editable_attributes_scheduler = _tmp8_;
			}
			one_shot_scheduler_after_timeout (self->priv->update_editable_attributes_scheduler, (guint) 1000, TRUE);
			break;
		}
		case G_FILE_MONITOR_EVENT_DELETED:
		{
			if (self->priv->remove_editable_scheduler == NULL) {
				OneShotScheduler* _tmp9_ = NULL;
				_tmp9_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
				self->priv->remove_editable_scheduler = _tmp9_;
			}
			one_shot_scheduler_after_timeout (self->priv->remove_editable_scheduler, (guint) 3000, TRUE);
			break;
		}
		default:
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
		{
			break;
		}
	}
}


static void photo_on_reimport_editable (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = data_object_to_string (DATA_OBJECT (self));
	_tmp1_ = _tmp0_;
	g_debug ("Photo.vala:3108: Reimporting editable for %s", _tmp1_);
	_g_free0 (_tmp1_);
	photo_reimport_editable (self, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch207_g_error;
	}
	goto __finally207;
	__catch207_g_error:
	{
		GError * err;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = data_object_to_string (DATA_OBJECT (self));
		_tmp3_ = _tmp2_;
		g_warning ("Photo.vala:3112: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, err->message);
		_g_free0 (_tmp3_);
		_g_error_free0 (err);
	}
	__finally207:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void photo_on_update_editable_attributes (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = data_object_to_string (DATA_OBJECT (self));
	_tmp1_ = _tmp0_;
	g_debug ("Photo.vala:3118: Updating editable attributes for %s", _tmp1_);
	_g_free0 (_tmp1_);
	photo_update_editable_attributes (self, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch208_g_error;
	}
	goto __finally208;
	__catch208_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("Photo.vala:3122: Unable to update editable attributes: %s", err->message);
		_g_error_free0 (err);
	}
	__finally208:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void photo_on_remove_editable (Photo* self) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	GFile* _tmp1_ = NULL;
	GFile* file;
	gboolean _tmp2_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = photo_get_editable_reader (self);
	reader = _tmp0_;
	if (reader == NULL) {
		_photo_file_adapter_unref0 (reader);
		return;
	}
	_tmp1_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (reader));
	file = _tmp1_;
	_tmp2_ = g_file_query_exists (file, NULL);
	if (_tmp2_) {
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp3_ = data_object_to_string (DATA_OBJECT (self));
		_tmp4_ = _tmp3_;
		g_debug ("Photo.vala:3133: Not removing editable for %s: file exists", _tmp4_);
		_g_free0 (_tmp4_);
		_g_object_unref0 (file);
		_photo_file_adapter_unref0 (reader);
		return;
	}
	_tmp5_ = data_object_to_string (DATA_OBJECT (self));
	_tmp6_ = _tmp5_;
	g_debug ("Photo.vala:3138: Removing editable for %s: file no longer exists", _tmp6_);
	_g_free0 (_tmp6_);
	photo_detach_editable (self, FALSE, TRUE);
	_g_object_unref0 (file);
	_photo_file_adapter_unref0 (reader);
}


void photo_get_original_dimensions (Photo* self, Dimensions* result) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions dim;
	Orientation _tmp2_;
	Orientation orientation;
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
	g_return_if_fail (IS_PHOTO (self));
	photo_get_raw_dimensions (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	dim = _tmp1_;
	_tmp2_ = photo_get_orientation (self);
	orientation = _tmp2_;
	orientation_rotate_dimensions (orientation, &dim, &_tmp3_);
	_tmp4_ = _tmp3_;
	*result = _tmp4_;
	return;
}


void photo_get_master_dimensions (Photo* self, Dimensions* result) {
	Orientation _tmp0_;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = photo_get_original_orientation (self);
	photo_get_raw_dimensions (self, &_tmp1_);
	_tmp2_ = _tmp1_;
	orientation_rotate_dimensions (_tmp0_, &_tmp2_, &_tmp3_);
	_tmp4_ = _tmp3_;
	*result = _tmp4_;
	return;
}


gboolean photo_get_crop (Photo* self, Box* crop) {
	Box _crop = {0};
	gboolean result = FALSE;
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions dim;
	Orientation _tmp4_;
	Orientation orientation;
	Box _tmp5_ = {0};
	Box _tmp6_ = {0};
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
	raw = _tmp0_;
	if (!_tmp1_) {
		result = FALSE;
		if (crop) {
			*crop = _crop;
		}
		return result;
	}
	photo_get_raw_dimensions (self, &_tmp2_);
	_tmp3_ = _tmp2_;
	dim = _tmp3_;
	_tmp4_ = photo_get_orientation (self);
	orientation = _tmp4_;
	orientation_rotate_box (orientation, &dim, &raw, &_tmp5_);
	_tmp6_ = _tmp5_;
	_crop = _tmp6_;
	result = TRUE;
	if (crop) {
		*crop = _crop;
	}
	return result;
}


void photo_set_crop (Photo* self, Box* crop) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions dim;
	Orientation _tmp2_;
	Orientation orientation;
	Box _tmp3_ = {0};
	Box _tmp4_ = {0};
	Box derotated;
	gint _tmp5_;
	gint _tmp6_;
	g_return_if_fail (IS_PHOTO (self));
	photo_get_raw_dimensions (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	dim = _tmp1_;
	_tmp2_ = photo_get_orientation (self);
	orientation = _tmp2_;
	orientation_derotate_box (orientation, &dim, crop, &_tmp3_);
	_tmp4_ = _tmp3_;
	derotated = _tmp4_;
	_tmp5_ = box_get_width (&derotated);
	g_assert (_tmp5_ <= dim.width);
	_tmp6_ = box_get_height (&derotated);
	g_assert (_tmp6_ <= dim.height);
	photo_set_raw_crop (self, &derotated);
}


void photo_add_redeye_instance (Photo* self, RedeyeInstance* inst_unscaled) {
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_ = {0};
	GdkRectangle bounds_rect_unscaled;
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _tmp3_ = {0};
	GdkRectangle bounds_rect_raw;
	RedeyeInstance _tmp4_ = {0};
	RedeyeInstance _tmp5_ = {0};
	RedeyeInstance inst;
	g_return_if_fail (IS_PHOTO (self));
	redeye_instance_to_bounds_rect (inst_unscaled, &_tmp0_);
	_tmp1_ = _tmp0_;
	bounds_rect_unscaled = _tmp1_;
	photo_unscaled_to_raw_rect (self, &bounds_rect_unscaled, &_tmp2_);
	_tmp3_ = _tmp2_;
	bounds_rect_raw = _tmp3_;
	redeye_instance_from_bounds_rect (&bounds_rect_raw, &_tmp4_);
	_tmp5_ = _tmp4_;
	inst = _tmp5_;
	photo_add_raw_redeye_instance (self, &inst);
}


static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, RedeyeInstance* inst) {
	GdkPixbuf* result = NULL;
	gdouble r;
	gint* _tmp0_ = NULL;
	gint* x_insets_first_quadrant;
	gint x_insets_first_quadrant_length1;
	gint _x_insets_first_quadrant_size_;
	gint i;
	gint x_bounds_min;
	gint x_bounds_max;
	gint ymin;
	gint _tmp4_ = 0;
	gint ymax;
	gint _tmp5_ = 0;
	gint _tmp6_;
	gint inset_index;
	GdkPixbuf* _tmp24_;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
	r = (gdouble) (*inst).radius;
	_tmp0_ = g_new0 (gint, (*inst).radius + 1);
	x_insets_first_quadrant = _tmp0_;
	x_insets_first_quadrant_length1 = (*inst).radius + 1;
	_x_insets_first_quadrant_size_ = (*inst).radius + 1;
	i = 0;
	{
		gdouble y;
		y = r;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				gdouble _tmp2_;
				gdouble theta;
				gdouble _tmp3_;
				gint x;
				if (!_tmp1_) {
					y = y - 1.0;
				}
				_tmp1_ = FALSE;
				if (!(y >= 0.0)) {
					break;
				}
				_tmp2_ = asin (y / r);
				theta = _tmp2_;
				_tmp3_ = cos (theta);
				x = (gint) ((r * _tmp3_) + 0.5);
				x_insets_first_quadrant[i] = (*inst).radius - x;
				i++;
			}
		}
	}
	x_bounds_min = (*inst).center.x - (*inst).radius;
	x_bounds_max = (*inst).center.x + (*inst).radius;
	ymin = (*inst).center.y - (*inst).radius;
	if (ymin < 0) {
		_tmp4_ = 0;
	} else {
		_tmp4_ = ymin;
	}
	ymin = _tmp4_;
	ymax = (*inst).center.y;
	_tmp6_ = gdk_pixbuf_get_height (pixbuf);
	if (ymax > (_tmp6_ - 1)) {
		gint _tmp7_;
		_tmp7_ = gdk_pixbuf_get_height (pixbuf);
		_tmp5_ = _tmp7_ - 1;
	} else {
		_tmp5_ = ymax;
	}
	ymax = _tmp5_;
	inset_index = 0;
	{
		gint y_it;
		y_it = ymin;
		{
			gboolean _tmp8_;
			_tmp8_ = TRUE;
			while (TRUE) {
				gint xmin;
				gint _tmp9_ = 0;
				gint xmax;
				gint _tmp10_ = 0;
				gint _tmp11_;
				if (!_tmp8_) {
					y_it++;
				}
				_tmp8_ = FALSE;
				if (!(y_it <= ymax)) {
					break;
				}
				xmin = x_bounds_min + x_insets_first_quadrant[inset_index];
				if (xmin < 0) {
					_tmp9_ = 0;
				} else {
					_tmp9_ = xmin;
				}
				xmin = _tmp9_;
				xmax = x_bounds_max - x_insets_first_quadrant[inset_index];
				_tmp11_ = gdk_pixbuf_get_width (pixbuf);
				if (xmax > (_tmp11_ - 1)) {
					gint _tmp12_;
					_tmp12_ = gdk_pixbuf_get_width (pixbuf);
					_tmp10_ = _tmp12_ - 1;
				} else {
					_tmp10_ = xmax;
				}
				xmax = _tmp10_;
				{
					gint x_it;
					x_it = xmin;
					{
						gboolean _tmp13_;
						_tmp13_ = TRUE;
						while (TRUE) {
							GdkPixbuf* _tmp14_ = NULL;
							GdkPixbuf* _tmp15_;
							if (!_tmp13_) {
								x_it++;
							}
							_tmp13_ = FALSE;
							if (!(x_it <= xmax)) {
								break;
							}
							_tmp14_ = photo_red_reduce_pixel (self, pixbuf, x_it, y_it);
							_tmp15_ = _tmp14_;
							_g_object_unref0 (_tmp15_);
						}
					}
				}
				inset_index++;
			}
		}
	}
	ymin = (*inst).center.y;
	ymax = (*inst).center.y + (*inst).radius;
	inset_index = x_insets_first_quadrant_length1 - 1;
	{
		gint y_it;
		y_it = ymin;
		{
			gboolean _tmp16_;
			_tmp16_ = TRUE;
			while (TRUE) {
				gint xmin;
				gint _tmp17_ = 0;
				gint xmax;
				gint _tmp18_ = 0;
				gint _tmp19_;
				if (!_tmp16_) {
					y_it++;
				}
				_tmp16_ = FALSE;
				if (!(y_it <= ymax)) {
					break;
				}
				xmin = x_bounds_min + x_insets_first_quadrant[inset_index];
				if (xmin < 0) {
					_tmp17_ = 0;
				} else {
					_tmp17_ = xmin;
				}
				xmin = _tmp17_;
				xmax = x_bounds_max - x_insets_first_quadrant[inset_index];
				_tmp19_ = gdk_pixbuf_get_width (pixbuf);
				if (xmax > (_tmp19_ - 1)) {
					gint _tmp20_;
					_tmp20_ = gdk_pixbuf_get_width (pixbuf);
					_tmp18_ = _tmp20_ - 1;
				} else {
					_tmp18_ = xmax;
				}
				xmax = _tmp18_;
				{
					gint x_it;
					x_it = xmin;
					{
						gboolean _tmp21_;
						_tmp21_ = TRUE;
						while (TRUE) {
							GdkPixbuf* _tmp22_ = NULL;
							GdkPixbuf* _tmp23_;
							if (!_tmp21_) {
								x_it++;
							}
							_tmp21_ = FALSE;
							if (!(x_it <= xmax)) {
								break;
							}
							_tmp22_ = photo_red_reduce_pixel (self, pixbuf, x_it, y_it);
							_tmp23_ = _tmp22_;
							_g_object_unref0 (_tmp23_);
						}
					}
				}
				inset_index--;
			}
		}
	}
	_tmp24_ = _g_object_ref0 (pixbuf);
	result = _tmp24_;
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
	return result;
}


static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y) {
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint px_start_byte_offset;
	guint8* _tmp2_ = NULL;
	guchar* pixel_data;
	gint pixel_data_length1;
	gint _pixel_data_size_;
	guchar g;
	guchar b;
	guchar r;
	GdkPixbuf* _tmp3_;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
	_tmp0_ = gdk_pixbuf_get_rowstride (pixbuf);
	_tmp1_ = gdk_pixbuf_get_n_channels (pixbuf);
	px_start_byte_offset = (y * _tmp0_) + (x * _tmp1_);
	_tmp2_ = gdk_pixbuf_get_pixels (pixbuf);
	pixel_data = _tmp2_;
	pixel_data_length1 = -1;
	_pixel_data_size_ = -1;
	g = pixel_data[px_start_byte_offset + 1];
	b = pixel_data[px_start_byte_offset + 2];
	r = (guchar) ((g + b) / 2);
	pixel_data[px_start_byte_offset] = r;
	_tmp3_ = _g_object_ref0 (pixbuf);
	result = _tmp3_;
	return result;
}


void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result) {
	Orientation _tmp0_;
	Orientation unscaled_orientation;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
	Dimensions unscaled_dims;
	gint unscaled_x_offset_raw;
	gint unscaled_y_offset_raw;
	Box crop_box = {0};
	Box _tmp5_ = {0};
	gboolean _tmp6_;
	GdkPoint _tmp7_ = {0};
	GdkPoint _tmp8_ = {0};
	GdkPoint derotated_point;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_ = photo_get_orientation (self);
	unscaled_orientation = _tmp0_;
	media_source_get_dimensions (MEDIA_SOURCE (self), &_tmp1_);
	_tmp2_ = _tmp1_;
	orientation_rotate_dimensions (unscaled_orientation, &_tmp2_, &_tmp3_);
	_tmp4_ = _tmp3_;
	unscaled_dims = _tmp4_;
	unscaled_x_offset_raw = 0;
	unscaled_y_offset_raw = 0;
	_tmp6_ = photo_get_raw_crop (self, &_tmp5_);
	crop_box = _tmp5_;
	if (_tmp6_) {
		unscaled_x_offset_raw = crop_box.left;
		unscaled_y_offset_raw = crop_box.top;
	}
	orientation_derotate_point (unscaled_orientation, &unscaled_dims, unscaled_point, &_tmp7_);
	_tmp8_ = _tmp7_;
	derotated_point = _tmp8_;
	derotated_point.x = derotated_point.x + unscaled_x_offset_raw;
	derotated_point.y = derotated_point.y + unscaled_y_offset_raw;
	*result = derotated_point;
	return;
}


void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result) {
	GdkPoint _tmp0_ = {0};
	GdkPoint upper_left;
	GdkPoint _tmp1_ = {0};
	GdkPoint lower_right;
	GdkPoint _tmp2_ = {0};
	GdkPoint _tmp3_ = {0};
	GdkPoint _tmp4_ = {0};
	GdkPoint _tmp5_ = {0};
	GdkRectangle _tmp6_ = {0};
	GdkRectangle raw_rect;
	g_return_if_fail (IS_PHOTO (self));
	_tmp0_.x = 0;
	upper_left = _tmp0_;
	_tmp1_.x = 0;
	lower_right = _tmp1_;
	upper_left.x = (*unscaled_rect).x;
	upper_left.y = (*unscaled_rect).y;
	lower_right.x = upper_left.x + (*unscaled_rect).width;
	lower_right.y = upper_left.y + (*unscaled_rect).height;
	photo_unscaled_to_raw_point (self, &upper_left, &_tmp2_);
	_tmp3_ = _tmp2_;
	upper_left = _tmp3_;
	photo_unscaled_to_raw_point (self, &lower_right, &_tmp4_);
	_tmp5_ = _tmp4_;
	lower_right = _tmp5_;
	if (upper_left.x > lower_right.x) {
		gint temp;
		temp = upper_left.x;
		upper_left.x = lower_right.x;
		lower_right.x = temp;
	}
	if (upper_left.y > lower_right.y) {
		gint temp;
		temp = upper_left.y;
		upper_left.y = lower_right.y;
		lower_right.y = temp;
	}
	_tmp6_.x = 0;
	raw_rect = _tmp6_;
	raw_rect.x = upper_left.x;
	raw_rect.y = upper_left.y;
	raw_rect.width = lower_right.x - upper_left.x;
	raw_rect.height = lower_right.y - upper_left.y;
	*result = raw_rect;
	return;
}


PixelTransformationBundle* photo_get_enhance_transformations (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GdkPixbuf* pixbuf;
	Scaling _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_;
	PixelTransformationBundle* _tmp4_ = NULL;
	PixelTransformationBundle* transformations;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), NULL);
	pixbuf = NULL;
	scaling_for_best_fit (360, FALSE, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
	_tmp3_ = _tmp2_;
	if (_inner_error_ != NULL) {
		goto __catch209_g_error;
	}
	_g_object_unref0 (pixbuf);
	pixbuf = _tmp3_;
	goto __finally209;
	__catch209_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("Photo.vala:3353: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
		result = NULL;
		_g_error_free0 (e);
		_g_object_unref0 (pixbuf);
		return result;
	}
	__finally209:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (pixbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp4_ = auto_enhance_create_auto_enhance_adjustments (pixbuf);
	transformations = _tmp4_;
	result = transformations;
	_g_object_unref0 (pixbuf);
	return result;
}


gboolean photo_enhance (Photo* self) {
	gboolean result = FALSE;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* transformations;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
	_tmp0_ = photo_get_enhance_transformations (self);
	transformations = _tmp0_;
	if (transformations == NULL) {
		result = FALSE;
		_pixel_transformation_bundle_unref0 (transformations);
		return result;
	}
	{
		g_static_rec_mutex_lock (&self->priv->__lock_row);
		photo_set_color_adjustments (self, transformations);
		__finally210:
		g_static_rec_mutex_unlock (&self->priv->__lock_row);
		if (_inner_error_ != NULL) {
			_pixel_transformation_bundle_unref0 (transformations);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	result = TRUE;
	_pixel_transformation_bundle_unref0 (transformations);
	return result;
}


static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void photo_real_baseline_replaced (Photo* self) {
	g_return_if_fail (IS_PHOTO (self));
}


static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata) {
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
}


static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
	callback (data1, value_get_media_metadata (param_values + 1), data2);
}


static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata) {
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
}


static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
}


static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata) {
	g_return_if_fail (IS_PHOTO (self));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
}


static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self) {
	photo_photo_transformation_state_impl_on_photo_baseline_replaced (self);
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments) {
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_;
	GeeHashMap* _tmp1_ = NULL;
	PixelTransformer* _tmp2_;
	PixelTransformationBundle* _tmp3_;
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
	g_return_val_if_fail ((transformations == NULL) || GEE_IS_HASH_MAP (transformations), NULL);
	g_return_val_if_fail ((transformer == NULL) || IS_PIXEL_TRANSFORMER (transformer), NULL);
	g_return_val_if_fail ((adjustments == NULL) || IS_PIXEL_TRANSFORMATION_BUNDLE (adjustments), NULL);
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
	_tmp0_ = _g_object_ref0 (photo);
	_g_object_unref0 (self->priv->photo);
	self->priv->photo = _tmp0_;
	self->priv->orientation = orientation;
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (transformations);
	_g_object_unref0 (self->priv->transformations);
	self->priv->transformations = _tmp1_;
	_tmp2_ = _pixel_transformer_ref0 (transformer);
	_pixel_transformer_unref0 (self->priv->transformer);
	self->priv->transformer = _tmp2_;
	_tmp3_ = _pixel_transformation_bundle_ref0 (adjustments);
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
	self->priv->adjustments = _tmp3_;
	g_signal_connect_object (photo, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
	return self;
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments) {
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments);
}


static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self) {
	Orientation result = 0;
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), 0);
	result = self->priv->orientation;
	return result;
}


static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
	_tmp0_ = photo_photo_transformation_state_impl_copy_transformations (self->priv->transformations);
	result = _tmp0_;
	return result;
}


static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformer* result = NULL;
	PixelTransformer* _tmp0_ = NULL;
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
	if (self->priv->transformer != NULL) {
		PixelTransformer* _tmp1_ = NULL;
		_tmp1_ = pixel_transformer_copy (self->priv->transformer);
		_pixel_transformer_unref0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		_pixel_transformer_unref0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}


static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
	if (self->priv->adjustments != NULL) {
		PixelTransformationBundle* _tmp1_ = NULL;
		_tmp1_ = pixel_transformation_bundle_copy (self->priv->adjustments);
		_pixel_transformation_bundle_unref0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		_pixel_transformation_bundle_unref0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}


static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* clone;
	g_return_val_if_fail ((original == NULL) || GEE_IS_HASH_MAP (original), NULL);
	if (original == NULL) {
		result = NULL;
		return result;
	}
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, NULL, NULL, NULL);
	clone = _tmp0_;
	{
		GeeSet* _tmp1_ = NULL;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _tmp4_;
		GeeIterator* _object_it;
		_tmp1_ = gee_map_get_keys (GEE_MAP (original));
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_));
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_object_it = _tmp4_;
		while (TRUE) {
			gboolean _tmp5_;
			gpointer _tmp6_ = NULL;
			gchar* object;
			gpointer _tmp7_ = NULL;
			KeyValueMap* _tmp8_;
			KeyValueMap* _tmp9_ = NULL;
			KeyValueMap* _tmp10_;
			_tmp5_ = gee_iterator_next (_object_it);
			if (!_tmp5_) {
				break;
			}
			_tmp6_ = gee_iterator_get (_object_it);
			object = (gchar*) _tmp6_;
			_tmp7_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (original), object);
			_tmp8_ = (KeyValueMap*) _tmp7_;
			_tmp9_ = key_value_map_copy (_tmp8_);
			_tmp10_ = _tmp9_;
			gee_abstract_map_set (GEE_ABSTRACT_MAP (clone), object, _tmp10_);
			_key_value_map_unref0 (_tmp10_);
			_key_value_map_unref0 (_tmp8_);
			_g_free0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	result = clone;
	return result;
}


static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self) {
	gboolean _tmp0_;
	g_return_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self));
	_tmp0_ = photo_transformation_state_is_broken (PHOTO_TRANSFORMATION_STATE (self));
	if (!_tmp0_) {
		g_signal_emit_by_name (PHOTO_TRANSFORMATION_STATE (self), "broken");
	}
}


static void photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass) {
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PhotoPhotoTransformationStateImplPrivate));
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
}


static void photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self) {
	self->priv = PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE (self);
}


static void photo_photo_transformation_state_impl_finalize (GObject* obj) {
	PhotoPhotoTransformationStateImpl * self;
	guint _tmp0_;
	self = PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL (obj);
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (self->priv->photo, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
	_g_object_unref0 (self->priv->photo);
	_g_object_unref0 (self->priv->transformations);
	_pixel_transformer_unref0 (self->priv->transformer);
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
}


static GType photo_photo_transformation_state_impl_get_type (void) {
	static volatile gsize photo_photo_transformation_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__volatile, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__volatile;
}


PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type) {
	PhotoReimportMasterState* self = NULL;
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
	return self;
}


static void photo_value_reimport_master_state_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void photo_value_reimport_master_state_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		photo_reimport_master_state_unref (value->data[0].v_pointer);
	}
}


static void photo_value_reimport_master_state_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer photo_value_reimport_master_state_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* photo_value_reimport_master_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PhotoReimportMasterState* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* photo_value_reimport_master_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportMasterState** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportMasterState* spec;
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer photo_value_get_reimport_master_state (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
	return value->data[0].v_pointer;
}


void photo_value_set_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		photo_reimport_master_state_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_reimport_master_state_unref (old);
	}
}


void photo_value_take_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_reimport_master_state_unref (old);
	}
}


static void photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass) {
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
	PHOTO_REIMPORT_MASTER_STATE_CLASS (klass)->finalize = photo_reimport_master_state_finalize;
}


static void photo_reimport_master_state_instance_init (PhotoReimportMasterState * self) {
	self->ref_count = 1;
}


static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterState * self;
	self = PHOTO_REIMPORT_MASTER_STATE (obj);
}


GType photo_reimport_master_state_get_type (void) {
	static volatile gsize photo_reimport_master_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_master_state_type_id__volatile, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__volatile;
}


gpointer photo_reimport_master_state_ref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void photo_reimport_master_state_unref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static gchar** _vala_array_dup31 (gchar** self, int length) {
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow _tmp0_;
	PhotoRow _tmp1_ = {0};
	PhotoMetadata* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
	photo_row_copy (row, &_tmp1_);
	_tmp0_ = _tmp1_;
	photo_row_destroy (&self->row);
	self->row = _tmp0_;
	_tmp2_ = _media_metadata_ref0 (metadata);
	_media_metadata_unref0 (self->metadata);
	self->metadata = _tmp2_;
	_tmp3_ = (_tmp4_ = alterations, (_tmp4_ == NULL) ? ((gpointer) _tmp4_) : _vala_array_dup31 (_tmp4_, alterations_length1));
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
	self->alterations = _tmp3_;
	self->alterations_length1 = alterations_length1;
	self->_alterations_size_ = alterations_length1;
	return self;
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
}


static void photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass) {
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
	PHOTO_REIMPORT_MASTER_STATE_CLASS (klass)->finalize = photo_reimport_master_state_impl_finalize;
}


static void photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self) {
	PhotoRow _tmp0_ = {0};
	PhotoRow _tmp1_ = {0};
	photo_row_init (&_tmp0_);
	_tmp1_ = _tmp0_;
	self->row = _tmp1_;
	self->metadata_only = FALSE;
}


static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterStateImpl * self;
	self = PHOTO_REIMPORT_MASTER_STATE_IMPL (obj);
	photo_row_destroy (&self->row);
	_media_metadata_unref0 (self->metadata);
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
}


static GType photo_reimport_master_state_impl_get_type (void) {
	static volatile gsize photo_reimport_master_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__volatile, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__volatile;
}


PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type) {
	PhotoReimportEditableState* self = NULL;
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
	return self;
}


static void photo_value_reimport_editable_state_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void photo_value_reimport_editable_state_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
	}
}


static void photo_value_reimport_editable_state_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer photo_value_reimport_editable_state_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* photo_value_reimport_editable_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PhotoReimportEditableState* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* photo_value_reimport_editable_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportEditableState** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportEditableState* spec;
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer photo_value_get_reimport_editable_state (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
	return value->data[0].v_pointer;
}


void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_reimport_editable_state_unref (old);
	}
}


void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_reimport_editable_state_unref (old);
	}
}


static void photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass) {
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (klass)->finalize = photo_reimport_editable_state_finalize;
}


static void photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self) {
	self->ref_count = 1;
}


static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableState * self;
	self = PHOTO_REIMPORT_EDITABLE_STATE (obj);
}


GType photo_reimport_editable_state_get_type (void) {
	static volatile gsize photo_reimport_editable_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_editable_state_type_id__volatile, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__volatile;
}


gpointer photo_reimport_editable_state_ref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void photo_reimport_editable_state_unref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoState* backing_state, PhotoMetadata* metadata) {
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoState _tmp0_;
	BackingPhotoState _tmp1_ = {0};
	PhotoMetadata* _tmp2_;
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
	backing_photo_state_copy (backing_state, &_tmp1_);
	_tmp0_ = _tmp1_;
	backing_photo_state_destroy (&self->backing_state);
	self->backing_state = _tmp0_;
	_tmp2_ = _media_metadata_ref0 (metadata);
	_media_metadata_unref0 (self->metadata);
	self->metadata = _tmp2_;
	return self;
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoState* backing_state, PhotoMetadata* metadata) {
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
}


static void photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass) {
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (klass)->finalize = photo_reimport_editable_state_impl_finalize;
}


static void photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self) {
	BackingPhotoState _tmp0_ = {0};
	BackingPhotoState _tmp1_ = {0};
	memset (&_tmp0_, 0, sizeof (BackingPhotoState));
	_tmp1_ = _tmp0_;
	self->backing_state = _tmp1_;
	self->metadata_only = FALSE;
}


static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableStateImpl * self;
	self = PHOTO_REIMPORT_EDITABLE_STATE_IMPL (obj);
	backing_photo_state_destroy (&self->backing_state);
	_media_metadata_unref0 (self->metadata);
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
}


static GType photo_reimport_editable_state_impl_get_type (void) {
	static volatile gsize photo_reimport_editable_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__volatile, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__volatile;
}


static void photo_backing_readers_copy (const PhotoBackingReaders* self, PhotoBackingReaders* dest) {
	dest->master = _photo_file_adapter_ref0 (self->master);
	dest->mimic = _photo_file_adapter_ref0 (self->mimic);
	dest->editable = _photo_file_adapter_ref0 (self->editable);
}


static void photo_backing_readers_destroy (PhotoBackingReaders* self) {
	_photo_file_adapter_unref0 ((*self).master);
	_photo_file_adapter_unref0 ((*self).mimic);
	_photo_file_adapter_unref0 ((*self).editable);
}


static PhotoBackingReaders* photo_backing_readers_dup (const PhotoBackingReaders* self) {
	PhotoBackingReaders* dup;
	dup = g_new0 (PhotoBackingReaders, 1);
	photo_backing_readers_copy (self, dup);
	return dup;
}


static void photo_backing_readers_free (PhotoBackingReaders* self) {
	photo_backing_readers_destroy (self);
	g_free (self);
}


static GType photo_backing_readers_get_type (void) {
	static volatile gsize photo_backing_readers_type_id__volatile = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__volatile)) {
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = g_boxed_type_register_static ("PhotoBackingReaders", (GBoxedCopyFunc) photo_backing_readers_dup, (GBoxedFreeFunc) photo_backing_readers_free);
		g_once_init_leave (&photo_backing_readers_type_id__volatile, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__volatile;
}


static void photo_class_init (PhotoClass * klass) {
	photo_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PhotoPrivate));
	PHOTO_CLASS (klass)->notify_editable_replaced = photo_real_notify_editable_replaced;
	PHOTO_CLASS (klass)->notify_baseline_replaced = photo_real_notify_baseline_replaced;
	PHOTO_CLASS (klass)->notify_master_reimported = photo_real_notify_master_reimported;
	PHOTO_CLASS (klass)->notify_editable_reimported = photo_real_notify_editable_reimported;
	PHOTO_CLASS (klass)->notify_source_reimported = photo_real_notify_source_reimported;
	PHOTO_CLASS (klass)->notify_baseline_reimported = photo_real_notify_baseline_reimported;
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = photo_real_internal_delete_backing;
	MEDIA_SOURCE_CLASS (klass)->get_backing_files_state = photo_real_get_backing_files_state;
	PHOTO_CLASS (klass)->apply_user_metadata_for_reimport = photo_real_apply_user_metadata_for_reimport;
	DATA_SOURCE_CLASS (klass)->get_typename = photo_real_get_typename;
	DATA_SOURCE_CLASS (klass)->get_instance_id = photo_real_get_instance_id;
	DATA_SOURCE_CLASS (klass)->get_source_id = photo_real_get_source_id;
	THUMBNAIL_SOURCE_CLASS (klass)->get_preferred_thumbnail_format = photo_real_get_preferred_thumbnail_format;
	THUMBNAIL_SOURCE_CLASS (klass)->create_thumbnail = photo_real_create_thumbnail;
	MEDIA_SOURCE_CLASS (klass)->get_file = photo_real_get_file;
	MEDIA_SOURCE_CLASS (klass)->get_master_file = photo_real_get_master_file;
	MEDIA_SOURCE_CLASS (klass)->get_timestamp = photo_real_get_timestamp;
	MEDIA_SOURCE_CLASS (klass)->get_event_id = photo_real_get_event_id;
	MEDIA_SOURCE_CLASS (klass)->get_import_id = photo_real_get_import_id;
	MEDIA_SOURCE_CLASS (klass)->get_master_md5 = photo_real_get_master_md5;
	MEDIA_SOURCE_CLASS (klass)->get_rating = photo_real_get_rating;
	MEDIA_SOURCE_CLASS (klass)->set_rating = photo_real_set_rating;
	MEDIA_SOURCE_CLASS (klass)->increase_rating = photo_real_increase_rating;
	MEDIA_SOURCE_CLASS (klass)->decrease_rating = photo_real_decrease_rating;
	DATA_SOURCE_CLASS (klass)->commit_backlinks = photo_real_commit_backlinks;
	MEDIA_SOURCE_CLASS (klass)->set_event_id = photo_real_set_event_id;
	DATA_OBJECT_CLASS (klass)->to_string = photo_real_to_string;
	DATA_SOURCE_CLASS (klass)->equals = photo_real_equals;
	MEDIA_SOURCE_CLASS (klass)->get_filesize = photo_real_get_filesize;
	MEDIA_SOURCE_CLASS (klass)->get_master_filesize = photo_real_get_master_filesize;
	MEDIA_SOURCE_CLASS (klass)->get_exposure_time = photo_real_get_exposure_time;
	MEDIA_SOURCE_CLASS (klass)->get_basename = photo_real_get_basename;
	MEDIA_SOURCE_CLASS (klass)->get_title = photo_real_get_title;
	MEDIA_SOURCE_CLASS (klass)->set_title = photo_real_set_title;
	MEDIA_SOURCE_CLASS (klass)->get_dimensions = photo_real_get_dimensions;
	PHOTO_SOURCE_CLASS (klass)->get_metadata = photo_real_get_metadata;
	PHOTO_CLASS (klass)->rotate = photo_real_rotate;
	PHOTO_SOURCE_CLASS (klass)->get_pixbuf = photo_real_get_pixbuf;
	PHOTO_CLASS (klass)->has_user_generated_metadata = photo_real_has_user_generated_metadata;
	PHOTO_CLASS (klass)->set_user_metadata_for_export = photo_real_set_user_metadata_for_export;
	PHOTO_CLASS (klass)->editable_replaced = photo_real_editable_replaced;
	PHOTO_CLASS (klass)->baseline_replaced = photo_real_baseline_replaced;
	PHOTO_CLASS (klass)->master_reimported = photo_real_master_reimported;
	PHOTO_CLASS (klass)->editable_reimported = photo_real_editable_reimported;
	PHOTO_CLASS (klass)->baseline_reimported = photo_real_baseline_reimported;
	PHOTO_CLASS (klass)->source_reimported = photo_real_source_reimported;
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
	g_signal_new ("editable_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE);
	g_signal_new ("baseline_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("master_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
	g_signal_new ("editable_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
	g_signal_new ("baseline_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
	g_signal_new ("source_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
}


static void photo_instance_init (Photo * self) {
	BackingPhotoState _tmp0_ = {0};
	BackingPhotoState _tmp1_ = {0};
	PhotoBackingReaders _tmp2_ = {0};
	PhotoBackingReaders _tmp3_ = {0};
	self->priv = PHOTO_GET_PRIVATE (self);
	g_static_rec_mutex_init (&self->priv->__lock_row);
	memset (&_tmp0_, 0, sizeof (BackingPhotoState));
	_tmp1_ = _tmp0_;
	self->priv->editable = _tmp1_;
	g_static_rec_mutex_init (&self->priv->__lock_readers);
	memset (&_tmp2_, 0, sizeof (PhotoBackingReaders));
	_tmp3_ = _tmp2_;
	self->priv->readers = _tmp3_;
	self->priv->transformer = NULL;
	self->priv->adjustments = NULL;
	self->priv->file_title = NULL;
	self->priv->editable_monitor = NULL;
	self->priv->reimport_editable_scheduler = NULL;
	self->priv->update_editable_attributes_scheduler = NULL;
	self->priv->remove_editable_scheduler = NULL;
	self->priv->backing_photo_state = NULL;
}


static void photo_finalize (GObject* obj) {
	Photo * self;
	self = PHOTO (obj);
	g_static_rec_mutex_free (&self->priv->__lock_row);
	photo_row_destroy (&self->priv->row);
	backing_photo_state_destroy (&self->priv->editable);
	g_static_rec_mutex_free (&self->priv->__lock_readers);
	photo_backing_readers_destroy (&self->priv->readers);
	_pixel_transformer_unref0 (self->priv->transformer);
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
	_g_free0 (self->priv->file_title);
	_g_object_unref0 (self->priv->editable_monitor);
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
}


GType photo_get_type (void) {
	static volatile gsize photo_type_id__volatile = 0;
	if (g_once_init_enter (&photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
		GType photo_type_id;
		photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_type_id__volatile, photo_type_id);
	}
	return photo_type_id__volatile;
}


GType library_photo_source_collection_state_get_type (void) {
	static volatile gsize library_photo_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {0, NULL, NULL}};
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
		g_once_init_leave (&library_photo_source_collection_state_type_id__volatile, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__volatile;
}


static gint _int64_compare_gcompare_func (gconstpointer a, gconstpointer b) {
	gint result;
	result = int64_compare (a, b);
	return result;
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}


static gboolean _int64_equal_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = int64_equal (a, b);
	return result;
}


static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self) {
	gint64 result;
	result = photo_get_photo_key (source);
	return result;
}


static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
	library_photo_source_collection_on_trashcan_contents_altered (self, added, removed);
}


static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
	library_photo_source_collection_on_offline_contents_altered (self, added, removed);
}


LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type) {
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_;
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
	_tmp1_ = _tmp0_;
	g_signal_connect (SOURCE_HOLDING_TANK (_tmp1_), "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
	_source_holding_tank_unref0 (_tmp1_);
	_tmp2_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
	_tmp3_ = _tmp2_;
	g_signal_connect (SOURCE_HOLDING_TANK (_tmp3_), "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
	_source_holding_tank_unref0 (_tmp3_);
	return self;
}


LibraryPhotoSourceCollection* library_photo_source_collection_new (void) {
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
}


static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo (self, source, alteration);
	return result;
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	_tmp0_ = media_source_holding_tank_new (MEDIA_SOURCE_COLLECTION (self), _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
	result = _tmp0_;
	return result;
}


static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo (self, source, alteration);
	return result;
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	_tmp0_ = media_source_holding_tank_new (MEDIA_SOURCE_COLLECTION (self), _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
	result = _tmp0_;
	return result;
}


static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable) {
	LibraryPhotoSourceCollection * self;
	MediaMonitor* result = NULL;
	PhotoMonitor* _tmp0_ = NULL;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	g_return_val_if_fail (IS_WORKERS (workers), NULL);
	g_return_val_if_fail (G_IS_CANCELLABLE (cancellable), NULL);
	_tmp0_ = photo_monitor_new (workers, cancellable);
	result = MEDIA_MONITOR (_tmp0_);
	return result;
}


static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
	result = IS_LIBRARY_PHOTO (source);
	return result;
}


static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	gchar* result = NULL;
	gchar* _tmp0_;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
	result = _tmp0_;
	return result;
}


static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	_tmp0_ = photo_file_format_is_file_supported (file);
	result = _tmp0_;
	return result;
}


static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self) {
	library_photo_source_collection_on_editable_replaced (self, _sender, old_file, new_file);
}


static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed) {
	LibraryPhotoSourceCollection * self;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
	if (added != NULL) {
		{
			GeeIterator* _tmp0_ = NULL;
			GeeIterator* _object_it;
			_tmp0_ = gee_iterable_iterator (added);
			_object_it = _tmp0_;
			while (TRUE) {
				gboolean _tmp1_;
				gpointer _tmp2_ = NULL;
				DataObject* object;
				LibraryPhoto* _tmp3_;
				LibraryPhoto* photo;
				GFile* _tmp4_ = NULL;
				GFile* editable;
				BackingPhotoState _tmp5_ = {0};
				BackingPhotoState _tmp6_ = {0};
				BackingPhotoState _tmp7_;
				gint64 _tmp8_;
				gint64 master_filesize;
				gint64 _tmp9_ = 0LL;
				BackingPhotoState* _tmp10_ = NULL;
				BackingPhotoState* _tmp11_;
				gboolean _tmp12_;
				gint64 editable_filesize;
				_tmp1_ = gee_iterator_next (_object_it);
				if (!_tmp1_) {
					break;
				}
				_tmp2_ = gee_iterator_get (_object_it);
				object = (DataObject*) _tmp2_;
				_tmp3_ = _g_object_ref0 (LIBRARY_PHOTO (object));
				photo = _tmp3_;
				_tmp4_ = photo_get_editable_file (PHOTO (photo));
				editable = _tmp4_;
				if (editable != NULL) {
					gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->by_editable_file), editable, photo);
				}
				g_signal_connect (PHOTO (photo), "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
				photo_get_master_photo_state (PHOTO (photo), &_tmp5_);
				_tmp6_ = _tmp5_;
				_tmp7_ = _tmp6_;
				_tmp8_ = _tmp7_.filesize;
				backing_photo_state_destroy (&_tmp7_);
				master_filesize = _tmp8_;
				_tmp10_ = photo_get_editable_photo_state (PHOTO (photo));
				_tmp11_ = _tmp10_;
				_tmp12_ = _tmp11_ != NULL;
				_backing_photo_state_free0 (_tmp11_);
				if (_tmp12_) {
					BackingPhotoState* _tmp13_ = NULL;
					BackingPhotoState* _tmp14_;
					_tmp13_ = photo_get_editable_photo_state (PHOTO (photo));
					_tmp14_ = _tmp13_;
					_tmp9_ = (*_tmp14_).filesize;
					_backing_photo_state_free0 (_tmp14_);
				} else {
					_tmp9_ = (gint64) (-1);
				}
				editable_filesize = _tmp9_;
				gee_multi_map_set (self->priv->filesize_to_photo, &master_filesize, photo);
				gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->photo_to_master_filesize), photo, &master_filesize);
				if (editable_filesize >= 0) {
					gee_multi_map_set (self->priv->filesize_to_photo, &editable_filesize, photo);
					gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->photo_to_editable_filesize), photo, &editable_filesize);
				}
				_g_object_unref0 (editable);
				_g_object_unref0 (photo);
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
	}
	if (removed != NULL) {
		{
			GeeIterator* _tmp15_ = NULL;
			GeeIterator* _object_it;
			_tmp15_ = gee_iterable_iterator (removed);
			_object_it = _tmp15_;
			while (TRUE) {
				gboolean _tmp16_;
				gpointer _tmp17_ = NULL;
				DataObject* object;
				LibraryPhoto* _tmp18_;
				LibraryPhoto* photo;
				GFile* _tmp19_ = NULL;
				GFile* editable;
				guint _tmp24_;
				BackingPhotoState _tmp25_ = {0};
				BackingPhotoState _tmp26_ = {0};
				BackingPhotoState _tmp27_;
				gint64 _tmp28_;
				gint64 master_filesize;
				gint64 _tmp29_ = 0LL;
				BackingPhotoState* _tmp30_ = NULL;
				BackingPhotoState* _tmp31_;
				gboolean _tmp32_;
				gint64 editable_filesize;
				_tmp16_ = gee_iterator_next (_object_it);
				if (!_tmp16_) {
					break;
				}
				_tmp17_ = gee_iterator_get (_object_it);
				object = (DataObject*) _tmp17_;
				_tmp18_ = _g_object_ref0 (LIBRARY_PHOTO (object));
				photo = _tmp18_;
				_tmp19_ = photo_get_editable_file (PHOTO (photo));
				editable = _tmp19_;
				if (editable != NULL) {
					GFile* _tmp20_ = NULL;
					GFile* _tmp21_;
					gboolean _tmp22_;
					gboolean _tmp23_;
					gboolean is_removed;
					_tmp20_ = photo_get_editable_file (PHOTO (photo));
					_tmp21_ = _tmp20_;
					_tmp22_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->by_editable_file), _tmp21_, NULL);
					_tmp23_ = _tmp22_;
					_g_object_unref0 (_tmp21_);
					is_removed = _tmp23_;
					g_assert (is_removed);
				}
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp24_, NULL, FALSE);
				g_signal_handlers_disconnect_matched (PHOTO (photo), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp24_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
				photo_get_master_photo_state (PHOTO (photo), &_tmp25_);
				_tmp26_ = _tmp25_;
				_tmp27_ = _tmp26_;
				_tmp28_ = _tmp27_.filesize;
				backing_photo_state_destroy (&_tmp27_);
				master_filesize = _tmp28_;
				_tmp30_ = photo_get_editable_photo_state (PHOTO (photo));
				_tmp31_ = _tmp30_;
				_tmp32_ = _tmp31_ != NULL;
				_backing_photo_state_free0 (_tmp31_);
				if (_tmp32_) {
					BackingPhotoState* _tmp33_ = NULL;
					BackingPhotoState* _tmp34_;
					_tmp33_ = photo_get_editable_photo_state (PHOTO (photo));
					_tmp34_ = _tmp33_;
					_tmp29_ = (*_tmp34_).filesize;
					_backing_photo_state_free0 (_tmp34_);
				} else {
					_tmp29_ = (gint64) (-1);
				}
				editable_filesize = _tmp29_;
				gee_multi_map_remove (self->priv->filesize_to_photo, &master_filesize, photo);
				gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->photo_to_master_filesize), photo, NULL);
				if (editable_filesize >= 0) {
					gee_multi_map_remove (self->priv->filesize_to_photo, &editable_filesize, photo);
					gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->photo_to_editable_filesize), photo, NULL);
				}
				_g_object_unref0 (editable);
				_g_object_unref0 (photo);
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
	}
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered (DATA_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), added, removed);
}


static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_PHOTO (photo));
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
	if (old_file != NULL) {
		gboolean _tmp0_;
		gboolean is_removed;
		_tmp0_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->by_editable_file), old_file, NULL);
		is_removed = _tmp0_;
		g_assert (is_removed);
	}
	if (new_file != NULL) {
		gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->by_editable_file), new_file, LIBRARY_PHOTO (photo));
	}
}


static gpointer __int64_dup0 (gpointer self) {
	return self ? _int64_dup (self) : NULL;
}


static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items) {
	LibraryPhotoSourceCollection * self;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	g_return_if_fail (GEE_IS_MAP (items));
	{
		GeeSet* _tmp0_ = NULL;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _tmp3_;
		GeeIterator* _object_it;
		_tmp0_ = gee_map_get_keys (items);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_object_it = _tmp3_;
		while (TRUE) {
			gboolean _tmp4_;
			gpointer _tmp5_ = NULL;
			DataObject* object;
			gpointer _tmp6_ = NULL;
			Alteration* alteration;
			LibraryPhoto* _tmp7_;
			LibraryPhoto* photo;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_;
			_tmp4_ = gee_iterator_next (_object_it);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp5_;
			_tmp6_ = gee_map_get (items, object);
			alteration = (Alteration*) _tmp6_;
			_tmp7_ = _g_object_ref0 (LIBRARY_PHOTO (object));
			photo = _tmp7_;
			_tmp9_ = alteration_has_detail (alteration, "image", "master");
			if (_tmp9_) {
				_tmp8_ = TRUE;
			} else {
				gboolean _tmp10_;
				_tmp10_ = alteration_has_detail (alteration, "image", "editable");
				_tmp8_ = _tmp10_;
			}
			if (_tmp8_) {
				gpointer _tmp11_ = NULL;
				gint64* _tmp12_;
				gint64 _tmp13_;
				gint64 old_master_filesize;
				gint64* _tmp14_ = NULL;
				gboolean _tmp15_;
				gint64 old_editable_filesize;
				BackingPhotoState _tmp19_ = {0};
				BackingPhotoState _tmp20_ = {0};
				BackingPhotoState _tmp21_;
				gint64 _tmp22_;
				gint64 master_filesize;
				gint64 _tmp23_ = 0LL;
				BackingPhotoState* _tmp24_ = NULL;
				BackingPhotoState* _tmp25_;
				gboolean _tmp26_;
				gint64 editable_filesize;
				_tmp11_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->photo_to_master_filesize), photo);
				_tmp12_ = (gint64*) _tmp11_;
				_tmp13_ = *_tmp12_;
				_g_free0 (_tmp12_);
				old_master_filesize = _tmp13_;
				_tmp15_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->photo_to_editable_filesize), photo);
				if (_tmp15_) {
					gpointer _tmp16_ = NULL;
					_tmp16_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->photo_to_editable_filesize), photo);
					_g_free0 (_tmp14_);
					_tmp14_ = (gint64*) _tmp16_;
				} else {
					gint _tmp17_;
					gint64* _tmp18_;
					_tmp17_ = -1;
					_tmp18_ = __int64_dup0 (&_tmp17_);
					_g_free0 (_tmp14_);
					_tmp14_ = _tmp18_;
				}
				old_editable_filesize = *_tmp14_;
				gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->photo_to_master_filesize), photo, NULL);
				gee_multi_map_remove (self->priv->filesize_to_photo, &old_master_filesize, photo);
				if (old_editable_filesize >= 0) {
					gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->photo_to_editable_filesize), photo, NULL);
					gee_multi_map_remove (self->priv->filesize_to_photo, &old_editable_filesize, photo);
				}
				photo_get_master_photo_state (PHOTO (photo), &_tmp19_);
				_tmp20_ = _tmp19_;
				_tmp21_ = _tmp20_;
				_tmp22_ = _tmp21_.filesize;
				backing_photo_state_destroy (&_tmp21_);
				master_filesize = _tmp22_;
				_tmp24_ = photo_get_editable_photo_state (PHOTO (photo));
				_tmp25_ = _tmp24_;
				_tmp26_ = _tmp25_ != NULL;
				_backing_photo_state_free0 (_tmp25_);
				if (_tmp26_) {
					BackingPhotoState* _tmp27_ = NULL;
					BackingPhotoState* _tmp28_;
					_tmp27_ = photo_get_editable_photo_state (PHOTO (photo));
					_tmp28_ = _tmp27_;
					_tmp23_ = (*_tmp28_).filesize;
					_backing_photo_state_free0 (_tmp28_);
				} else {
					_tmp23_ = (gint64) (-1);
				}
				editable_filesize = _tmp23_;
				gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->photo_to_master_filesize), photo, &master_filesize);
				gee_multi_map_set (self->priv->filesize_to_photo, &master_filesize, photo);
				if (editable_filesize >= 0) {
					gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->photo_to_editable_filesize), photo, &editable_filesize);
					gee_multi_map_set (self->priv->filesize_to_photo, &editable_filesize, photo);
				}
				_g_free0 (_tmp14_);
			}
			_g_object_unref0 (photo);
			_alteration_unref0 (alteration);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered (DATA_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), items);
}


static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources) {
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* _tmp0_ = NULL;
	GeeHashMultiMap* map;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	g_return_if_fail (GEE_IS_COLLECTION (media_sources));
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL);
	map = _tmp0_;
	{
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _media_it;
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (media_sources));
		_media_it = _tmp1_;
		while (TRUE) {
			gboolean _tmp2_;
			gpointer _tmp3_ = NULL;
			MediaSource* media;
			LibraryPhoto* _tmp4_;
			LibraryPhoto* photo;
			GeeCollection* _tmp5_ = NULL;
			GeeCollection* _tmp6_;
			gboolean _tmp7_;
			_tmp2_ = gee_iterator_next (_media_it);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = gee_iterator_get (_media_it);
			media = (MediaSource*) _tmp3_;
			_tmp4_ = _g_object_ref0 (LIBRARY_PHOTO (media));
			photo = _tmp4_;
			_tmp5_ = library_photo_get_import_keywords (photo);
			_tmp6_ = _tmp5_;
			_tmp7_ = _tmp6_ != NULL;
			_g_object_unref0 (_tmp6_);
			if (_tmp7_) {
				{
					GeeCollection* _tmp8_ = NULL;
					GeeCollection* _tmp9_;
					GeeIterator* _tmp10_ = NULL;
					GeeIterator* _tmp11_;
					GeeIterator* _keyword_it;
					_tmp8_ = library_photo_get_import_keywords (photo);
					_tmp9_ = _tmp8_;
					_tmp10_ = gee_iterable_iterator (GEE_ITERABLE (_tmp9_));
					_tmp11_ = _tmp10_;
					_g_object_unref0 (_tmp9_);
					_keyword_it = _tmp11_;
					while (TRUE) {
						gboolean _tmp12_;
						gpointer _tmp13_ = NULL;
						gchar* keyword;
						gchar* _tmp14_ = NULL;
						gchar* name;
						_tmp12_ = gee_iterator_next (_keyword_it);
						if (!_tmp12_) {
							break;
						}
						_tmp13_ = gee_iterator_get (_keyword_it);
						keyword = (gchar*) _tmp13_;
						_tmp14_ = tag_prep_tag_name (keyword);
						name = _tmp14_;
						if (name != NULL) {
							Tag* _tmp15_ = NULL;
							Tag* _tmp16_;
							_tmp15_ = tag_for_name (name);
							_tmp16_ = _tmp15_;
							gee_multi_map_set (GEE_MULTI_MAP (map), _tmp16_, photo);
							_g_object_unref0 (_tmp16_);
						}
						_g_free0 (name);
						_g_free0 (keyword);
					}
					_g_object_unref0 (_keyword_it);
				}
				library_photo_clear_import_keywords (photo);
			}
			_g_object_unref0 (photo);
			_g_object_unref0 (media);
		}
		_g_object_unref0 (_media_it);
	}
	{
		GeeSet* _tmp17_ = NULL;
		GeeSet* _tmp18_;
		GeeIterator* _tmp19_ = NULL;
		GeeIterator* _tmp20_;
		GeeIterator* _tag_it;
		_tmp17_ = gee_multi_map_get_keys (GEE_MULTI_MAP (map));
		_tmp18_ = _tmp17_;
		_tmp19_ = gee_iterable_iterator (GEE_ITERABLE (_tmp18_));
		_tmp20_ = _tmp19_;
		_g_object_unref0 (_tmp18_);
		_tag_it = _tmp20_;
		while (TRUE) {
			gboolean _tmp21_;
			gpointer _tmp22_ = NULL;
			Tag* tag;
			GeeCollection* _tmp23_ = NULL;
			GeeCollection* _tmp24_;
			_tmp21_ = gee_iterator_next (_tag_it);
			if (!_tmp21_) {
				break;
			}
			_tmp22_ = gee_iterator_get (_tag_it);
			tag = (Tag*) _tmp22_;
			_tmp23_ = gee_multi_map_get (GEE_MULTI_MAP (map), tag);
			_tmp24_ = _tmp23_;
			tag_attach_many (tag, _tmp24_);
			_g_object_unref0 (_tmp24_);
			_g_object_unref0 (tag);
		}
		_g_object_unref0 (_tag_it);
	}
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (MEDIA_SOURCE_COLLECTION (self), media_sources);
	_g_object_unref0 (map);
}


static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	g_signal_emit_by_name (self, "master-reimported", photo, metadata);
}


void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_master_reimported (self, photo, metadata);
}


static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	g_signal_emit_by_name (self, "editable-reimported", photo, metadata);
}


void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_editable_reimported (self, photo, metadata);
}


static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	g_signal_emit_by_name (self, "source-reimported", photo, metadata);
}


void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_source_reimported (self, photo, metadata);
}


static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	g_signal_emit_by_name (self, "baseline-reimported", photo, metadata);
}


void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_baseline_reimported (self, photo, metadata);
}


static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	PhotoID _tmp0_ = {0};
	PhotoID _tmp1_ = {0};
	LibraryPhoto* _tmp2_ = NULL;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	photo_id_init (&_tmp0_, numeric_id);
	_tmp1_ = _tmp0_;
	_tmp2_ = library_photo_source_collection_fetch (self, &_tmp1_);
	result = MEDIA_SOURCE (_tmp2_);
	return result;
}


static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
	g_signal_emit_by_name (MEDIA_SOURCE_COLLECTION (self), "trashcan-contents-altered", GEE_COLLECTION (added), GEE_COLLECTION (removed));
}


static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
	_tmp0_ = media_source_is_trashed (MEDIA_SOURCE (LIBRARY_PHOTO (source)));
	result = _tmp0_;
	return result;
}


static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
	g_signal_emit_by_name (MEDIA_SOURCE_COLLECTION (self), "offline-contents-altered", GEE_COLLECTION (added), GEE_COLLECTION (removed));
}


static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
	_tmp0_ = media_source_is_offline (MEDIA_SOURCE (LIBRARY_PHOTO (source)));
	result = _tmp0_;
	return result;
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_ = NULL;
	gchar* end;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	if (end == NULL) {
		result = maxlen;
		return result;
	} else {
		result = (glong) (end - str);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= 0) {
		_tmp0_ = len >= 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp1_;
		_tmp1_ = string_strnlen ((gchar*) self, offset + len);
		string_length = _tmp1_;
	} else {
		gint _tmp2_;
		_tmp2_ = strlen (self);
		string_length = (glong) _tmp2_;
	}
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}


static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	gboolean _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* numeric_only;
	gint64 _tmp3_;
	MediaSource* _tmp4_ = NULL;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	g_return_val_if_fail (source_id != NULL, NULL);
	_tmp0_ = g_str_has_prefix (source_id, PHOTO_TYPENAME);
	g_assert (_tmp0_);
	_tmp1_ = strlen (PHOTO_TYPENAME);
	_tmp2_ = string_substring (source_id, (glong) _tmp1_, (glong) (-1));
	numeric_only = _tmp2_;
	_tmp3_ = parse_int64 (numeric_only, 16);
	_tmp4_ = media_source_collection_fetch_by_numeric_id (MEDIA_SOURCE_COLLECTION (self), _tmp3_);
	result = _tmp4_;
	_g_free0 (numeric_only);
	return result;
}


static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id) {
	LibraryPhotoSourceCollection * self;
	GeeCollection* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	GeeArrayList* _tmp2_ = NULL;
	GeeCollection* _tmp3_;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	_tmp0_ = photo_table_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = photo_table_get_event_source_ids (_tmp1_, event_id);
	_tmp3_ = GEE_COLLECTION (_tmp2_);
	_database_table_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id) {
	LibraryPhoto* result = NULL;
	DataSource* _tmp0_ = NULL;
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
	_tmp0_ = database_source_collection_fetch_by_key (DATABASE_SOURCE_COLLECTION (self), (*photo_id).id);
	result = LIBRARY_PHOTO (_tmp0_);
	return result;
}


LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	gpointer _tmp0_ = NULL;
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	_tmp0_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->by_editable_file), file);
	result = (LibraryPhoto*) _tmp0_;
	return result;
}


static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable) {
	BackingPhotoState _tmp0_ = {0};
	BackingPhotoState _tmp1_ = {0};
	BackingPhotoState _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	BackingPhotoState* _tmp5_ = NULL;
	BackingPhotoState* editable;
	gboolean _tmp6_ = FALSE;
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
	g_return_if_fail (G_IS_FILE_INFO (info));
	g_return_if_fail (GEE_IS_COLLECTION (matches_master));
	g_return_if_fail (GEE_IS_COLLECTION (matches_editable));
	photo_get_master_photo_state (PHOTO (photo), &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = backing_photo_state_matches_file_info (&_tmp2_, info);
	_tmp4_ = _tmp3_;
	backing_photo_state_destroy (&_tmp2_);
	if (_tmp4_) {
		gee_collection_add (matches_master, photo);
	}
	_tmp5_ = photo_get_editable_photo_state (PHOTO (photo));
	editable = _tmp5_;
	if (editable != NULL) {
		gboolean _tmp7_;
		_tmp7_ = backing_photo_state_matches_file_info (editable, info);
		_tmp6_ = _tmp7_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		gee_collection_add (matches_editable, photo);
	}
	_backing_photo_state_free0 (editable);
}


void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail (G_IS_FILE_INFO (info));
	g_return_if_fail (GEE_IS_COLLECTION (matches_master));
	g_return_if_fail (GEE_IS_COLLECTION (matches_editable));
	{
		gint64 _tmp0_;
		GeeCollection* _tmp1_ = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _tmp4_;
		GeeIterator* _photo_it;
		_tmp0_ = g_file_info_get_size (info);
		_tmp1_ = gee_multi_map_get (self->priv->filesize_to_photo, &_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_));
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_photo_it = _tmp4_;
		while (TRUE) {
			gboolean _tmp5_;
			gpointer _tmp6_ = NULL;
			LibraryPhoto* photo;
			_tmp5_ = gee_iterator_next (_photo_it);
			if (!_tmp5_) {
				break;
			}
			_tmp6_ = gee_iterator_get (_photo_it);
			photo = (LibraryPhoto*) _tmp6_;
			library_photo_source_collection_compare_backing (self, photo, info, matches_master, matches_editable);
			_g_object_unref0 (photo);
		}
		_g_object_unref0 (_photo_it);
	}
	{
		GeeCollection* _tmp7_ = NULL;
		GeeCollection* _tmp8_;
		GeeIterator* _tmp9_ = NULL;
		GeeIterator* _tmp10_;
		GeeIterator* _media_it;
		_tmp7_ = media_source_collection_get_offline_bin_contents (MEDIA_SOURCE_COLLECTION (self));
		_tmp8_ = _tmp7_;
		_tmp9_ = gee_iterable_iterator (GEE_ITERABLE (_tmp8_));
		_tmp10_ = _tmp9_;
		_g_object_unref0 (_tmp8_);
		_media_it = _tmp10_;
		while (TRUE) {
			gboolean _tmp11_;
			gpointer _tmp12_ = NULL;
			MediaSource* media;
			_tmp11_ = gee_iterator_next (_media_it);
			if (!_tmp11_) {
				break;
			}
			_tmp12_ = gee_iterator_get (_media_it);
			media = (MediaSource*) _tmp12_;
			library_photo_source_collection_compare_backing (self, LIBRARY_PHOTO (media), info, matches_master, matches_editable);
			_g_object_unref0 (media);
		}
		_g_object_unref0 (_media_it);
	}
}


gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
	g_return_val_if_fail (basename != NULL, FALSE);
	{
		GeeCollection* _tmp0_ = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _tmp3_;
		GeeIterator* _photo_it;
		_tmp0_ = gee_multi_map_get (self->priv->filesize_to_photo, &filesize);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_photo_it = _tmp3_;
		while (TRUE) {
			gboolean _tmp4_;
			gpointer _tmp5_ = NULL;
			LibraryPhoto* photo;
			GFile* _tmp6_ = NULL;
			GFile* _tmp7_;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			gboolean _tmp10_;
			_tmp4_ = gee_iterator_next (_photo_it);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = gee_iterator_get (_photo_it);
			photo = (LibraryPhoto*) _tmp5_;
			_tmp6_ = media_source_get_master_file (MEDIA_SOURCE (photo));
			_tmp7_ = _tmp6_;
			_tmp8_ = g_file_get_basename (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = g_strcmp0 (_tmp9_, basename) == 0;
			_g_free0 (_tmp9_);
			_g_object_unref0 (_tmp7_);
			if (_tmp10_) {
				result = TRUE;
				_g_object_unref0 (photo);
				_g_object_unref0 (_photo_it);
				return result;
			}
			_g_object_unref0 (photo);
		}
		_g_object_unref0 (_photo_it);
	}
	result = FALSE;
	return result;
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_ = NULL;
	LibraryPhoto* _tmp3_;
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
	_tmp1_ = _tmp0_;
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
	_tmp3_ = LIBRARY_PHOTO (_tmp2_);
	_source_holding_tank_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_ = NULL;
	LibraryPhoto* _tmp3_;
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
	g_return_val_if_fail (md5 != NULL, NULL);
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
	_tmp1_ = _tmp0_;
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
	_tmp3_ = LIBRARY_PHOTO (_tmp2_);
	_source_holding_tank_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_ = NULL;
	LibraryPhoto* _tmp3_;
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	_tmp0_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
	_tmp1_ = _tmp0_;
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
	_tmp3_ = LIBRARY_PHOTO (_tmp2_);
	_source_holding_tank_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_ = NULL;
	LibraryPhoto* _tmp3_;
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
	g_return_val_if_fail (md5 != NULL, NULL);
	_tmp0_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
	_tmp1_ = _tmp0_;
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
	_tmp3_ = LIBRARY_PHOTO (_tmp2_);
	_source_holding_tank_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self) {
	gint result = 0;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), 0);
	_tmp0_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
	_tmp1_ = _tmp0_;
	_tmp2_ = source_holding_tank_get_count (SOURCE_HOLDING_TANK (_tmp1_));
	_tmp3_ = _tmp2_;
	_source_holding_tank_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state) {
	LibraryPhotoSourceCollectionState _state = 0;
	LibraryPhoto* result = NULL;
	MediaSource* _tmp0_ = NULL;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp1_ = NULL;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_;
	MediaSource* _tmp4_ = NULL;
	MediaSource* _tmp5_;
	MediaSourceHoldingTank* _tmp6_ = NULL;
	MediaSourceHoldingTank* _tmp7_;
	MediaSource* _tmp8_ = NULL;
	MediaSource* _tmp9_;
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	_tmp0_ = media_source_collection_fetch_by_master_file (MEDIA_SOURCE_COLLECTION (self), file);
	photo = LIBRARY_PHOTO (_tmp0_);
	if (photo != NULL) {
		_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
		result = photo;
		if (state) {
			*state = _state;
		}
		return result;
	}
	_tmp1_ = library_photo_source_collection_fetch_by_editable_file (self, file);
	_g_object_unref0 (photo);
	photo = _tmp1_;
	if (photo != NULL) {
		_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
		result = photo;
		if (state) {
			*state = _state;
		}
		return result;
	}
	_tmp2_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
	_tmp3_ = _tmp2_;
	_tmp4_ = media_source_holding_tank_fetch_by_master_file (_tmp3_, file);
	_tmp5_ = _tmp4_;
	_g_object_unref0 (photo);
	photo = IS_LIBRARY_PHOTO (_tmp5_) ? ((LibraryPhoto*) _tmp5_) : NULL;
	_source_holding_tank_unref0 (_tmp3_);
	if (photo != NULL) {
		_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
		result = photo;
		if (state) {
			*state = _state;
		}
		return result;
	}
	_tmp6_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
	_tmp7_ = _tmp6_;
	_tmp8_ = media_source_holding_tank_fetch_by_master_file (_tmp7_, file);
	_tmp9_ = _tmp8_;
	_g_object_unref0 (photo);
	photo = IS_LIBRARY_PHOTO (_tmp9_) ? ((LibraryPhoto*) _tmp9_) : NULL;
	_source_holding_tank_unref0 (_tmp7_);
	if (photo != NULL) {
		_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
		result = photo;
		if (state) {
			*state = _state;
		}
		return result;
	}
	result = NULL;
	_g_object_unref0 (photo);
	if (state) {
		*state = _state;
	}
	return result;
}


static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	MediaSourceHoldingTank* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	MediaSourceHoldingTank* _tmp5_ = NULL;
	MediaSourceHoldingTank* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
	_tmp0_ = SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink (SOURCE_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), backlink);
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	_tmp1_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
	_tmp2_ = _tmp1_;
	_tmp3_ = source_holding_tank_has_backlink (SOURCE_HOLDING_TANK (_tmp2_), backlink);
	_tmp4_ = _tmp3_;
	_source_holding_tank_unref0 (_tmp2_);
	if (_tmp4_) {
		result = TRUE;
		return result;
	}
	_tmp5_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
	_tmp6_ = _tmp5_;
	_tmp7_ = source_holding_tank_has_backlink (SOURCE_HOLDING_TANK (_tmp6_), backlink);
	_tmp8_ = _tmp7_;
	_source_holding_tank_unref0 (_tmp6_);
	if (_tmp8_) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
	_tmp1_ = _tmp0_;
	source_holding_tank_remove_backlink (SOURCE_HOLDING_TANK (_tmp1_), backlink);
	_source_holding_tank_unref0 (_tmp1_);
	_tmp2_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
	_tmp3_ = _tmp2_;
	source_holding_tank_remove_backlink (SOURCE_HOLDING_TANK (_tmp3_), backlink);
	_source_holding_tank_unref0 (_tmp3_);
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink (SOURCE_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), backlink);
}


static TransactionController* library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base) {
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
	if (self->priv->_transaction_controller == NULL) {
		MediaSourceTransactionController* _tmp0_ = NULL;
		_tmp0_ = media_source_transaction_controller_new (MEDIA_SOURCE_COLLECTION (self));
		_transaction_controller_unref0 (self->priv->_transaction_controller);
		self->priv->_transaction_controller = TRANSACTION_CONTROLLER (_tmp0_);
	}
	result = self->priv->_transaction_controller;
	return result;
}


static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
}


static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
}


static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
}


static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
}


static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
}


static void library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass) {
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = library_photo_source_collection_finalize;
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceCollectionPrivate));
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_trashcan = library_photo_source_collection_real_create_trashcan;
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_offline_bin = library_photo_source_collection_real_create_offline_bin;
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_media_monitor = library_photo_source_collection_real_create_media_monitor;
	SOURCE_COLLECTION_CLASS (klass)->holds_type_of_source = library_photo_source_collection_real_holds_type_of_source;
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_typename = library_photo_source_collection_real_get_typename;
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->is_file_recognized = library_photo_source_collection_real_is_file_recognized;
	DATA_COLLECTION_CLASS (klass)->notify_contents_altered = library_photo_source_collection_real_notify_contents_altered;
	DATA_COLLECTION_CLASS (klass)->items_altered = library_photo_source_collection_real_items_altered;
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->postprocess_imported_media = library_photo_source_collection_real_postprocess_imported_media;
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_master_reimported = library_photo_source_collection_real_notify_master_reimported;
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_editable_reimported = library_photo_source_collection_real_notify_editable_reimported;
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_source_reimported = library_photo_source_collection_real_notify_source_reimported;
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_baseline_reimported = library_photo_source_collection_real_notify_baseline_reimported;
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->fetch_by_numeric_id = library_photo_source_collection_real_fetch_by_numeric_id;
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->fetch_by_source_id = library_photo_source_collection_real_fetch_by_source_id;
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_event_source_ids = library_photo_source_collection_real_get_event_source_ids;
	SOURCE_COLLECTION_CLASS (klass)->has_backlink = library_photo_source_collection_real_has_backlink;
	SOURCE_COLLECTION_CLASS (klass)->remove_backlink = library_photo_source_collection_real_remove_backlink;
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->master_reimported = library_photo_source_collection_real_master_reimported;
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->source_reimported = library_photo_source_collection_real_source_reimported;
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = library_photo_source_collection_real_get_transaction_controller;
	g_signal_new ("master_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
	g_signal_new ("editable_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
	g_signal_new ("baseline_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
	g_signal_new ("source_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
}


static void library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self) {
	GeeHashMap* _tmp0_ = NULL;
	GeeTreeMultiMap* _tmp1_ = NULL;
	GeeHashMap* _tmp2_ = NULL;
	GeeHashMap* _tmp3_ = NULL;
	self->priv = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE (self);
	self->priv->_transaction_controller = NULL;
	_tmp0_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal, NULL);
	self->priv->by_editable_file = _tmp0_;
	_tmp1_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _int64_compare_gcompare_func, NULL);
	self->priv->filesize_to_photo = GEE_MULTI_MAP (_tmp1_);
	_tmp2_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, g_direct_hash, g_direct_equal, _int64_equal_gequal_func);
	self->priv->photo_to_master_filesize = _tmp2_;
	_tmp3_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, g_direct_hash, g_direct_equal, _int64_equal_gequal_func);
	self->priv->photo_to_editable_filesize = _tmp3_;
}


static void library_photo_source_collection_finalize (DataCollection* obj) {
	LibraryPhotoSourceCollection * self;
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (obj);
	_transaction_controller_unref0 (self->priv->_transaction_controller);
	_g_object_unref0 (self->priv->by_editable_file);
	_g_object_unref0 (self->priv->filesize_to_photo);
	_g_object_unref0 (self->priv->photo_to_master_filesize);
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
}


GType library_photo_source_collection_get_type (void) {
	static volatile gsize library_photo_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_collection_type_id__volatile, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__volatile;
}


static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self) {
	library_photo_generate_thumbnails (self);
}


static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row, GeeCollection* import_keywords) {
	LibraryPhoto * self = NULL;
	GeeCollection* _tmp0_;
	OneShotScheduler* _tmp1_ = NULL;
	g_return_val_if_fail ((import_keywords == NULL) || GEE_IS_COLLECTION (import_keywords), NULL);
	self = (LibraryPhoto*) photo_construct (object_type, row);
	_tmp0_ = _g_object_ref0 (import_keywords);
	_g_object_unref0 (self->priv->import_keywords);
	self->priv->import_keywords = _tmp0_;
	_tmp1_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
	self->priv->thumbnail_scheduler = _tmp1_;
	if (((*row).flags & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != 0) {
		data_source_rehydrate_backlinks (DATA_SOURCE (self), SOURCE_COLLECTION (library_photo_global), (*row).backlinks);
	}
	if (((*row).flags & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != 0) {
		library_photo_upgrade_rating_flags (self, (*row).flags);
	}
	return self;
}


static LibraryPhoto* library_photo_new (PhotoRow* row, GeeCollection* import_keywords) {
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row, import_keywords);
}


void library_photo_init (ProgressMonitor monitor, void* monitor_target) {
	LibraryPhotoSourceCollection* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_;
	MimicManager* _tmp3_ = NULL;
	PhotoTable* _tmp4_ = NULL;
	PhotoTable* _tmp5_;
	GeeArrayList* _tmp6_ = NULL;
	GeeArrayList* _tmp7_;
	GeeArrayList* all;
	GeeArrayList* _tmp8_ = NULL;
	GeeArrayList* all_photos;
	GeeArrayList* _tmp9_ = NULL;
	GeeArrayList* trashed_photos;
	GeeArrayList* _tmp10_ = NULL;
	GeeArrayList* offline_photos;
	gint _tmp11_;
	gint count;
	GeeCollection* _tmp19_ = NULL;
	GeeCollection* _tmp20_;
	_tmp0_ = library_photo_source_collection_new ();
	_data_collection_unref0 (library_photo_global);
	library_photo_global = _tmp0_;
	_tmp1_ = app_dirs_get_data_subdir ("mimics", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = mimic_manager_new (SOURCE_COLLECTION (library_photo_global), _tmp2_);
	_g_object_unref0 (library_photo_mimic_manager);
	library_photo_mimic_manager = _tmp3_;
	_g_object_unref0 (_tmp2_);
	_tmp4_ = photo_table_get_instance ();
	_tmp5_ = _tmp4_;
	_tmp6_ = photo_table_get_all (_tmp5_);
	_tmp7_ = _tmp6_;
	_database_table_unref0 (_tmp5_);
	all = _tmp7_;
	_tmp8_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	all_photos = _tmp8_;
	_tmp9_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	trashed_photos = _tmp9_;
	_tmp10_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	offline_photos = _tmp10_;
	_tmp11_ = gee_collection_get_size (GEE_COLLECTION (all));
	count = _tmp11_;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp12_;
			_tmp12_ = TRUE;
			while (TRUE) {
				gpointer _tmp13_ = NULL;
				PhotoRow* _tmp14_;
				PhotoRow _tmp15_;
				PhotoRow _tmp16_ = {0};
				PhotoRow _tmp17_;
				PhotoRow row;
				LibraryPhoto* _tmp18_ = NULL;
				LibraryPhoto* photo;
				guint64 flags;
				if (!_tmp12_) {
					ctr++;
				}
				_tmp12_ = FALSE;
				if (!(ctr < count)) {
					break;
				}
				_tmp13_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (all), ctr);
				_tmp14_ = (PhotoRow*) _tmp13_;
				photo_row_copy (_tmp14_, &_tmp16_);
				_tmp15_ = _tmp16_;
				_tmp17_ = _tmp15_;
				_photo_row_free0 (_tmp14_);
				row = _tmp17_;
				_tmp18_ = library_photo_new (&row, NULL);
				photo = _tmp18_;
				flags = row.flags;
				if ((flags & LIBRARY_PHOTO_FLAG_TRASH) != 0) {
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (trashed_photos), photo);
				} else {
					if ((flags & LIBRARY_PHOTO_FLAG_OFFLINE) != 0) {
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (offline_photos), photo);
					} else {
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (all_photos), photo);
					}
				}
				if (monitor != NULL) {
					monitor ((guint64) ctr, (guint64) count, monitor_target);
				}
				_g_object_unref0 (photo);
				photo_row_destroy (&row);
			}
		}
	}
	_tmp19_ = data_collection_add_many (DATA_COLLECTION (library_photo_global), GEE_COLLECTION (all_photos), NULL, NULL);
	_tmp20_ = _tmp19_;
	_g_object_unref0 (_tmp20_);
	media_source_collection_add_many_to_trash (MEDIA_SOURCE_COLLECTION (library_photo_global), GEE_COLLECTION (trashed_photos));
	media_source_collection_add_many_to_offline (MEDIA_SOURCE_COLLECTION (library_photo_global), GEE_COLLECTION (offline_photos));
	_g_object_unref0 (offline_photos);
	_g_object_unref0 (trashed_photos);
	_g_object_unref0 (all_photos);
	_g_object_unref0 (all);
}


void library_photo_terminate (void) {
}


ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo) {
	LibraryPhoto* _photo = NULL;
	ImportResult result = 0;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	PhotoID _tmp2_ = {0};
	PhotoID _tmp3_ = {0};
	PhotoID _tmp4_;
	PhotoID photo_id;
	gboolean _tmp5_;
	LibraryPhoto* _tmp6_ = NULL;
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
	_tmp0_ = photo_table_get_instance ();
	_tmp1_ = _tmp0_;
	photo_table_add (_tmp1_, &params->row, &_tmp2_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_database_table_unref0 (_tmp1_);
	photo_id = _tmp4_;
	_tmp5_ = photo_id_is_invalid (&photo_id);
	if (_tmp5_) {
		result = IMPORT_RESULT_DATABASE_ERROR;
		if (photo) {
			*photo = _photo;
		} else {
			_g_object_unref0 (_photo);
		}
		return result;
	}
	_tmp6_ = library_photo_new (&params->row, params->keywords);
	_g_object_unref0 (_photo);
	_photo = _tmp6_;
	result = IMPORT_RESULT_SUCCESS;
	if (photo) {
		*photo = _photo;
	} else {
		_g_object_unref0 (_photo);
	}
	return result;
}


void library_photo_import_failed (LibraryPhoto* photo) {
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	PhotoID _tmp2_ = {0};
	PhotoID _tmp3_ = {0};
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
	_tmp0_ = photo_table_get_instance ();
	_tmp1_ = _tmp0_;
	photo_get_photo_id (PHOTO (photo), &_tmp2_);
	_tmp3_ = _tmp2_;
	photo_table_remove (_tmp1_, &_tmp3_, &_inner_error_);
	_database_table_unref0 (_tmp1_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			goto __catch211_database_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	goto __finally211;
	__catch211_database_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		app_window_database_error (err);
		_g_error_free0 (err);
	}
	__finally211:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	self = LIBRARY_PHOTO (base);
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (PHOTO (self), metadata);
	library_photo_source_collection_notify_master_reimported (library_photo_global, self, metadata);
}


static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	self = LIBRARY_PHOTO (base);
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (PHOTO (self), metadata);
	library_photo_source_collection_notify_editable_reimported (library_photo_global, self, metadata);
}


static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	self = LIBRARY_PHOTO (base);
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (PHOTO (self), metadata);
	library_photo_source_collection_notify_source_reimported (library_photo_global, self, metadata);
}


static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	self = LIBRARY_PHOTO (base);
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (PHOTO (self), metadata);
	library_photo_source_collection_notify_baseline_reimported (library_photo_global, self, metadata);
}


static void library_photo_generate_thumbnails (LibraryPhoto* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
	thumbnail_cache_import_from_source (THUMBNAIL_SOURCE (self), TRUE, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch212_g_error;
	}
	goto __finally212;
	__catch212_g_error:
	{
		GError * err;
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp0_ = data_object_to_string (DATA_OBJECT (self));
		_tmp1_ = _tmp0_;
		g_warning ("Photo.vala:3870: Unable to generate thumbnails for %s: %s", _tmp1_, err->message);
		_g_free0 (_tmp1_);
		_g_error_free0 (err);
	}
	__finally212:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	thumbnail_source_notify_thumbnail_altered (THUMBNAIL_SOURCE (self));
}


GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self) {
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
	_tmp0_ = _g_object_ref0 (self->priv->import_keywords);
	result = _tmp0_;
	return result;
}


void library_photo_clear_import_keywords (LibraryPhoto* self) {
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
	_g_object_unref0 (self->priv->import_keywords);
	self->priv->import_keywords = NULL;
}


static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration) {
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	self = LIBRARY_PHOTO (base);
	g_return_if_fail (IS_ALTERATION (alteration));
	if (!self->priv->block_thumbnail_generation) {
		gboolean _tmp1_;
		_tmp1_ = alteration_has_subject (alteration, "image");
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		one_shot_scheduler_at_priority_idle (self->priv->thumbnail_scheduler, G_PRIORITY_LOW);
	}
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered (DATA_OBJECT (PHOTO (self)), alteration);
}


static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	self = LIBRARY_PHOTO (base);
	_tmp0_ = thumbnail_source_get_thumbnail (THUMBNAIL_SOURCE (self), (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error_);
	pixbuf = _tmp0_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_NEAREST, TRUE);
	result = _tmp1_;
	_g_object_unref0 (pixbuf);
	return result;
}


static void library_photo_real_rotate (Photo* base, Rotation rotation) {
	LibraryPhoto * self;
	GError * _inner_error_ = NULL;
	self = LIBRARY_PHOTO (base);
	self->priv->block_thumbnail_generation = TRUE;
	PHOTO_CLASS (library_photo_parent_class)->rotate (PHOTO (self), rotation);
	self->priv->block_thumbnail_generation = FALSE;
	thumbnail_cache_rotate (THUMBNAIL_SOURCE (self), rotation, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch213_g_error;
	}
	goto __finally213;
	__catch213_g_error:
	{
		GError * err;
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp0_ = data_object_to_string (DATA_OBJECT (self));
		_tmp1_ = _tmp0_;
		g_warning ("Photo.vala:3915: Unable to update thumbnails for %s: %s", _tmp1_, err->message);
		_g_free0 (_tmp1_);
		_g_error_free0 (err);
	}
	__finally213:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	thumbnail_source_notify_thumbnail_altered (THUMBNAIL_SOURCE (self));
}


static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GError * _inner_error_ = NULL;
	self = LIBRARY_PHOTO (base);
	_tmp0_ = thumbnail_cache_fetch (THUMBNAIL_SOURCE (self), scale, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	result = _tmp1_;
	return result;
}


static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self) {
	library_photo_on_duplicate_progress (self, current_num_bytes, total_num_bytes);
}


LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error) {
	LibraryPhoto* result = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	GFile* dupe_file;
	BackingPhotoID dupe_editable_id = {0};
	PhotoFileReader* _tmp4_ = NULL;
	PhotoFileReader* editable_reader;
	GFile* _tmp5_ = NULL;
	GFile* _tmp7_;
	GFile* editable_file;
	PhotoTable* _tmp18_ = NULL;
	PhotoTable* _tmp19_;
	PhotoID _tmp20_ = {0};
	PhotoID _tmp21_ = {0};
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_;
	PhotoID _tmp24_ = {0};
	PhotoID _tmp25_ = {0};
	PhotoID _tmp26_;
	PhotoID dupe_id;
	PhotoTable* _tmp27_ = NULL;
	PhotoTable* _tmp28_;
	PhotoRow* _tmp29_ = NULL;
	PhotoRow* _tmp30_;
	PhotoRow _tmp31_;
	PhotoRow _tmp32_ = {0};
	PhotoRow _tmp33_;
	PhotoRow dupe_row;
	LibraryPhoto* _tmp34_ = NULL;
	LibraryPhoto* dupe;
	Event* _tmp35_ = NULL;
	Event* _tmp36_;
	GeeList* _tmp37_ = NULL;
	GeeCollection* tags;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
	_tmp0_ = media_source_get_master_file (MEDIA_SOURCE (self));
	_tmp1_ = _tmp0_;
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	dupe_file = _tmp3_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	backing_photo_id_init (&dupe_editable_id, BACKING_PHOTO_ID_INVALID);
	_tmp4_ = photo_get_editable_reader (PHOTO (self));
	editable_reader = _tmp4_;
	if (editable_reader != NULL) {
		GFile* _tmp6_ = NULL;
		_tmp6_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (editable_reader));
		_g_object_unref0 (_tmp5_);
		_tmp5_ = _tmp6_;
	} else {
		_g_object_unref0 (_tmp5_);
		_tmp5_ = NULL;
	}
	_tmp7_ = _g_object_ref0 (_tmp5_);
	editable_file = _tmp7_;
	if (editable_file != NULL) {
		GFile* _tmp8_ = NULL;
		GFile* dupe_editable;
		BackingPhotoState state = {0};
		DetectedPhotoInformation* detected = NULL;
		BackingPhotoState _tmp9_ = {0};
		DetectedPhotoInformation* _tmp10_ = NULL;
		gboolean _tmp11_;
		gboolean _tmp12_;
		_tmp8_ = library_files_duplicate (editable_file, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
		dupe_editable = _tmp8_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (editable_file);
			_g_object_unref0 (_tmp5_);
			_photo_file_adapter_unref0 (editable_reader);
			_g_object_unref0 (dupe_file);
			return NULL;
		}
		memset (&state, 0, sizeof (BackingPhotoState));
		_tmp11_ = photo_query_backing_photo_state (PHOTO (self), dupe_editable, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp9_, &_tmp10_, &_inner_error_);
		backing_photo_state_destroy (&state);
		state = _tmp9_;
		_detected_photo_information_unref0 (detected);
		detected = _tmp10_;
		_tmp12_ = _tmp11_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_detected_photo_information_unref0 (detected);
			backing_photo_state_destroy (&state);
			_g_object_unref0 (dupe_editable);
			_g_object_unref0 (editable_file);
			_g_object_unref0 (_tmp5_);
			_photo_file_adapter_unref0 (editable_reader);
			_g_object_unref0 (dupe_file);
			return NULL;
		}
		if (_tmp12_) {
			BackingPhotoTable* _tmp13_ = NULL;
			BackingPhotoTable* _tmp14_;
			BackingPhotoRow _tmp15_ = {0};
			BackingPhotoRow _tmp16_ = {0};
			BackingPhotoRow _tmp17_;
			BackingPhotoRow editable_row;
			_tmp13_ = backing_photo_table_get_instance ();
			_tmp14_ = _tmp13_;
			backing_photo_table_add (_tmp14_, &state, &_tmp15_, &_inner_error_);
			_tmp16_ = _tmp15_;
			_tmp17_ = _tmp16_;
			_database_table_unref0 (_tmp14_);
			editable_row = _tmp17_;
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_detected_photo_information_unref0 (detected);
				backing_photo_state_destroy (&state);
				_g_object_unref0 (dupe_editable);
				_g_object_unref0 (editable_file);
				_g_object_unref0 (_tmp5_);
				_photo_file_adapter_unref0 (editable_reader);
				_g_object_unref0 (dupe_file);
				return NULL;
			}
			dupe_editable_id = editable_row.id;
			backing_photo_row_destroy (&editable_row);
		}
		_detected_photo_information_unref0 (detected);
		backing_photo_state_destroy (&state);
		_g_object_unref0 (dupe_editable);
	}
	_tmp18_ = photo_table_get_instance ();
	_tmp19_ = _tmp18_;
	photo_get_photo_id (PHOTO (self), &_tmp20_);
	_tmp21_ = _tmp20_;
	_tmp22_ = g_file_get_path (dupe_file);
	_tmp23_ = _tmp22_;
	photo_table_duplicate (_tmp19_, &_tmp21_, _tmp23_, &dupe_editable_id, &_tmp24_);
	_tmp25_ = _tmp24_;
	_tmp26_ = _tmp25_;
	_g_free0 (_tmp23_);
	_database_table_unref0 (_tmp19_);
	dupe_id = _tmp26_;
	_tmp27_ = photo_table_get_instance ();
	_tmp28_ = _tmp27_;
	_tmp29_ = photo_table_get_row (_tmp28_, &dupe_id);
	_tmp30_ = _tmp29_;
	photo_row_copy (_tmp30_, &_tmp32_);
	_tmp31_ = _tmp32_;
	_tmp33_ = _tmp31_;
	_photo_row_free0 (_tmp30_);
	_database_table_unref0 (_tmp28_);
	dupe_row = _tmp33_;
	_tmp34_ = library_photo_new (&dupe_row, NULL);
	dupe = _tmp34_;
	thumbnail_cache_duplicate (THUMBNAIL_SOURCE (self), THUMBNAIL_SOURCE (dupe));
	data_collection_add (DATA_COLLECTION (library_photo_global), DATA_OBJECT (dupe));
	_tmp35_ = media_source_get_event (MEDIA_SOURCE (dupe));
	_tmp36_ = _tmp35_;
	event_attach (_tmp36_, MEDIA_SOURCE (dupe));
	_g_object_unref0 (_tmp36_);
	_tmp37_ = tag_source_collection_fetch_for_source (tag_global, MEDIA_SOURCE (self));
	tags = GEE_COLLECTION (_tmp37_);
	if (tags != NULL) {
		{
			GeeIterator* _tmp38_ = NULL;
			GeeIterator* _tag_it;
			_tmp38_ = gee_iterable_iterator (GEE_ITERABLE (tags));
			_tag_it = _tmp38_;
			while (TRUE) {
				gboolean _tmp39_;
				gpointer _tmp40_ = NULL;
				Tag* tag;
				_tmp39_ = gee_iterator_next (_tag_it);
				if (!_tmp39_) {
					break;
				}
				_tmp40_ = gee_iterator_get (_tag_it);
				tag = (Tag*) _tmp40_;
				tag_attach (tag, MEDIA_SOURCE (dupe));
				_g_object_unref0 (tag);
			}
			_g_object_unref0 (_tag_it);
		}
	}
	result = dupe;
	_g_object_unref0 (tags);
	photo_row_destroy (&dupe_row);
	_g_object_unref0 (editable_file);
	_g_object_unref0 (_tmp5_);
	_photo_file_adapter_unref0 (editable_reader);
	_g_object_unref0 (dupe_file);
	return result;
}


static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total) {
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
	spin_event_loop (-1);
}


static void library_photo_upgrade_rating_flags (LibraryPhoto* self, guint64 flags) {
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
	if ((flags & LIBRARY_PHOTO_FLAG_HIDDEN) != 0) {
		media_source_set_rating (MEDIA_SOURCE (self), RATING_REJECTED);
		photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_HIDDEN, NULL);
	}
	if ((flags & LIBRARY_PHOTO_FLAG_FAVORITE) != 0) {
		media_source_set_rating (MEDIA_SOURCE (self), RATING_FIVE);
		photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_FAVORITE, NULL);
	}
}


static gboolean library_photo_real_is_trashed (MediaSource* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	self = LIBRARY_PHOTO (base);
	_tmp0_ = photo_is_flag_set (PHOTO (self), LIBRARY_PHOTO_FLAG_TRASH);
	result = _tmp0_;
	return result;
}


static void library_photo_real_trash (MediaSource* base) {
	LibraryPhoto * self;
	self = LIBRARY_PHOTO (base);
	photo_add_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_TRASH, NULL);
}


static void library_photo_real_untrash (MediaSource* base) {
	LibraryPhoto * self;
	self = LIBRARY_PHOTO (base);
	photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_TRASH, NULL);
}


static gboolean library_photo_real_is_offline (Monitorable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	self = LIBRARY_PHOTO (base);
	_tmp0_ = photo_is_flag_set (PHOTO (self), LIBRARY_PHOTO_FLAG_OFFLINE);
	result = _tmp0_;
	return result;
}


static void library_photo_real_mark_offline (Monitorable* base) {
	LibraryPhoto * self;
	self = LIBRARY_PHOTO (base);
	photo_add_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
}


static void library_photo_real_mark_online (Monitorable* base) {
	LibraryPhoto * self;
	self = LIBRARY_PHOTO (base);
	photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
}


static gboolean library_photo_real_is_flagged (Flaggable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	self = LIBRARY_PHOTO (base);
	_tmp0_ = photo_is_flag_set (PHOTO (self), LIBRARY_PHOTO_FLAG_FLAGGED);
	result = _tmp0_;
	return result;
}


static void library_photo_real_mark_flagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_ = NULL;
	Alteration* _tmp1_;
	self = LIBRARY_PHOTO (base);
	_tmp0_ = alteration_new ("metadata", "flagged");
	_tmp1_ = _tmp0_;
	photo_add_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
	_alteration_unref0 (_tmp1_);
}


static void library_photo_real_mark_unflagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_ = NULL;
	Alteration* _tmp1_;
	self = LIBRARY_PHOTO (base);
	_tmp0_ = alteration_new ("metadata", "flagged");
	_tmp1_ = _tmp0_;
	photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
	_alteration_unref0 (_tmp1_);
}


static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GError * _inner_error_ = NULL;
	self = LIBRARY_PHOTO (base);
	_tmp0_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing (DATA_SOURCE (PHOTO (self)), &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	if (!_tmp1_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = media_source_delete_original_file (MEDIA_SOURCE (self));
	result = _tmp2_;
	return result;
}


static void library_photo_real_destroy (DataSource* base) {
	LibraryPhoto * self;
	PhotoID _tmp0_ = {0};
	PhotoID _tmp1_ = {0};
	PhotoID photo_id;
	PhotoTable* _tmp2_ = NULL;
	PhotoTable* _tmp3_;
	GError * _inner_error_ = NULL;
	self = LIBRARY_PHOTO (base);
	photo_get_photo_id (PHOTO (self), &_tmp0_);
	_tmp1_ = _tmp0_;
	photo_id = _tmp1_;
	thumbnail_cache_remove (THUMBNAIL_SOURCE (self));
	_tmp2_ = photo_table_get_instance ();
	_tmp3_ = _tmp2_;
	photo_table_remove (_tmp3_, &photo_id, &_inner_error_);
	_database_table_unref0 (_tmp3_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			goto __catch214_database_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	goto __finally214;
	__catch214_database_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		app_window_database_error (err);
		_g_error_free0 (err);
	}
	__finally214:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy (DATA_SOURCE (PHOTO (self)));
}


gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	gint _tmp0_;
	PhotoID* _tmp1_ = NULL;
	PhotoID* ids;
	gint ids_length1;
	gint _ids_size_;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
	_tmp1_ = photo_get_duplicate_ids (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
	ids = _tmp1_;
	ids_length1 = _tmp0_;
	_ids_size_ = _tmp0_;
	if (ids == NULL) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = ids_length1 == 0;
	}
	if (_tmp2_) {
		result = FALSE;
		ids = (g_free (ids), NULL);
		return result;
	}
	{
		PhotoID* id_collection;
		int id_collection_length1;
		int id_it;
		id_collection = ids;
		id_collection_length1 = ids_length1;
		for (id_it = 0; id_it < ids_length1; id_it = id_it + 1) {
			PhotoID id;
			id = id_collection[id_it];
			{
				LibraryPhoto* _tmp3_ = NULL;
				LibraryPhoto* photo;
				gboolean _tmp4_ = FALSE;
				_tmp3_ = library_photo_source_collection_fetch (library_photo_global, &id);
				photo = _tmp3_;
				if (photo != NULL) {
					gboolean _tmp5_;
					_tmp5_ = media_source_is_trashed (MEDIA_SOURCE (photo));
					_tmp4_ = !_tmp5_;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					result = TRUE;
					_g_object_unref0 (photo);
					ids = (g_free (ids), NULL);
					return result;
				}
				_g_object_unref0 (photo);
			}
		}
	}
	result = FALSE;
	ids = (g_free (ids), NULL);
	return result;
}


static gboolean library_photo_real_has_user_generated_metadata (Photo* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	GeeList* _tmp0_ = NULL;
	GeeList* tags;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoMetadata* metadata;
	Rating _tmp6_;
	Rating _tmp7_;
	GeeSet* _tmp8_ = NULL;
	GeeSet* keywords;
	gint _tmp9_ = 0;
	gint tags_count;
	gint _tmp11_ = 0;
	gint keywords_count;
	gboolean _tmp13_ = FALSE;
	self = LIBRARY_PHOTO (base);
	_tmp0_ = tag_source_collection_fetch_for_source (tag_global, MEDIA_SOURCE (self));
	tags = _tmp0_;
	_tmp1_ = photo_source_get_metadata (PHOTO_SOURCE (self));
	metadata = _tmp1_;
	if (metadata == NULL) {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		if (tags != NULL) {
			_tmp3_ = TRUE;
		} else {
			gint _tmp4_;
			_tmp4_ = gee_collection_get_size (GEE_COLLECTION (tags));
			_tmp3_ = _tmp4_ > 0;
		}
		if (_tmp3_) {
			_tmp2_ = TRUE;
		} else {
			Rating _tmp5_;
			_tmp5_ = media_source_get_rating (MEDIA_SOURCE (self));
			_tmp2_ = _tmp5_ != RATING_UNRATED;
		}
		result = _tmp2_;
		_media_metadata_unref0 (metadata);
		_g_object_unref0 (tags);
		return result;
	}
	_tmp6_ = media_source_get_rating (MEDIA_SOURCE (self));
	_tmp7_ = photo_metadata_get_rating (metadata);
	if (_tmp6_ != _tmp7_) {
		result = TRUE;
		_media_metadata_unref0 (metadata);
		_g_object_unref0 (tags);
		return result;
	}
	_tmp8_ = photo_metadata_get_keywords (metadata, NULL);
	keywords = _tmp8_;
	if (tags != NULL) {
		gint _tmp10_;
		_tmp10_ = gee_collection_get_size (GEE_COLLECTION (tags));
		_tmp9_ = _tmp10_;
	} else {
		_tmp9_ = 0;
	}
	tags_count = _tmp9_;
	if (keywords != NULL) {
		gint _tmp12_;
		_tmp12_ = gee_collection_get_size (GEE_COLLECTION (keywords));
		_tmp11_ = _tmp12_;
	} else {
		_tmp11_ = 0;
	}
	keywords_count = _tmp11_;
	if (tags_count != keywords_count) {
		result = TRUE;
		_g_object_unref0 (keywords);
		_media_metadata_unref0 (metadata);
		_g_object_unref0 (tags);
		return result;
	}
	if (tags != NULL) {
		_tmp13_ = keywords != NULL;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		{
			GeeList* _tmp14_;
			GeeList* _tag_list;
			gint _tmp15_;
			gint _tag_size;
			gint _tag_index;
			_tmp14_ = _g_object_ref0 (tags);
			_tag_list = _tmp14_;
			_tmp15_ = gee_collection_get_size (GEE_COLLECTION (_tag_list));
			_tag_size = _tmp15_;
			_tag_index = -1;
			while (TRUE) {
				gpointer _tmp16_ = NULL;
				Tag* tag;
				gchar* _tmp17_ = NULL;
				gchar* _tmp18_;
				gchar* _tmp19_ = NULL;
				gchar* _tmp20_;
				gboolean _tmp21_;
				gboolean _tmp22_;
				_tag_index = _tag_index + 1;
				if (!(_tag_index < _tag_size)) {
					break;
				}
				_tmp16_ = gee_list_get (_tag_list, _tag_index);
				tag = (Tag*) _tmp16_;
				_tmp17_ = data_object_get_name (DATA_OBJECT (tag));
				_tmp18_ = _tmp17_;
				_tmp19_ = g_utf8_normalize (_tmp18_, (gssize) (-1), G_NORMALIZE_DEFAULT);
				_tmp20_ = _tmp19_;
				_tmp21_ = gee_collection_contains (GEE_COLLECTION (keywords), _tmp20_);
				_tmp22_ = !_tmp21_;
				_g_free0 (_tmp20_);
				_g_free0 (_tmp18_);
				if (_tmp22_) {
					result = TRUE;
					_g_object_unref0 (tag);
					_g_object_unref0 (_tag_list);
					_g_object_unref0 (keywords);
					_media_metadata_unref0 (metadata);
					_g_object_unref0 (tags);
					return result;
				}
				_g_object_unref0 (tag);
			}
			_g_object_unref0 (_tag_list);
		}
	}
	result = FALSE;
	_g_object_unref0 (keywords);
	_media_metadata_unref0 (metadata);
	_g_object_unref0 (tags);
	return result;
}


static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	GeeList* _tmp0_ = NULL;
	GeeList* photo_tags;
	Rating _tmp7_;
	self = LIBRARY_PHOTO (base);
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
	_tmp0_ = tag_source_collection_fetch_for_source (tag_global, MEDIA_SOURCE (self));
	photo_tags = _tmp0_;
	if (photo_tags != NULL) {
		GeeArrayList* _tmp1_ = NULL;
		GeeCollection* string_tags;
		_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
		string_tags = GEE_COLLECTION (_tmp1_);
		{
			GeeList* _tmp2_;
			GeeList* _tag_list;
			gint _tmp3_;
			gint _tag_size;
			gint _tag_index;
			_tmp2_ = _g_object_ref0 (photo_tags);
			_tag_list = _tmp2_;
			_tmp3_ = gee_collection_get_size (GEE_COLLECTION (_tag_list));
			_tag_size = _tmp3_;
			_tag_index = -1;
			while (TRUE) {
				gpointer _tmp4_ = NULL;
				Tag* tag;
				gchar* _tmp5_ = NULL;
				gchar* _tmp6_;
				_tag_index = _tag_index + 1;
				if (!(_tag_index < _tag_size)) {
					break;
				}
				_tmp4_ = gee_list_get (_tag_list, _tag_index);
				tag = (Tag*) _tmp4_;
				_tmp5_ = data_object_get_name (DATA_OBJECT (tag));
				_tmp6_ = _tmp5_;
				gee_collection_add (string_tags, _tmp6_);
				_g_free0 (_tmp6_);
				_g_object_unref0 (tag);
			}
			_g_object_unref0 (_tag_list);
		}
		photo_metadata_set_keywords (metadata, string_tags, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
		_g_object_unref0 (string_tags);
	} else {
		photo_metadata_set_keywords (metadata, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
	}
	_tmp7_ = media_source_get_rating (MEDIA_SOURCE (self));
	photo_metadata_set_rating (metadata, _tmp7_);
	_g_object_unref0 (photo_tags);
}


static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	GeeSet* _tmp0_ = NULL;
	GeeCollection* keywords;
	self = LIBRARY_PHOTO (base);
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
	_tmp0_ = photo_metadata_get_keywords (metadata, NULL);
	keywords = GEE_COLLECTION (_tmp0_);
	if (keywords != NULL) {
		{
			GeeIterator* _tmp1_ = NULL;
			GeeIterator* _keyword_it;
			_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (keywords));
			_keyword_it = _tmp1_;
			while (TRUE) {
				gboolean _tmp2_;
				gpointer _tmp3_ = NULL;
				gchar* keyword;
				Tag* _tmp4_ = NULL;
				Tag* _tmp5_;
				_tmp2_ = gee_iterator_next (_keyword_it);
				if (!_tmp2_) {
					break;
				}
				_tmp3_ = gee_iterator_get (_keyword_it);
				keyword = (gchar*) _tmp3_;
				_tmp4_ = tag_for_name (keyword);
				_tmp5_ = _tmp4_;
				tag_attach (_tmp5_, MEDIA_SOURCE (self));
				_g_object_unref0 (_tmp5_);
				_g_free0 (keyword);
			}
			_g_object_unref0 (_keyword_it);
		}
	}
	_g_object_unref0 (keywords);
}


static void library_photo_class_init (LibraryPhotoClass * klass) {
	library_photo_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (LibraryPhotoPrivate));
	PHOTO_CLASS (klass)->notify_master_reimported = library_photo_real_notify_master_reimported;
	PHOTO_CLASS (klass)->notify_editable_reimported = library_photo_real_notify_editable_reimported;
	PHOTO_CLASS (klass)->notify_source_reimported = library_photo_real_notify_source_reimported;
	PHOTO_CLASS (klass)->notify_baseline_reimported = library_photo_real_notify_baseline_reimported;
	DATA_OBJECT_CLASS (klass)->notify_altered = library_photo_real_notify_altered;
	MEDIA_SOURCE_CLASS (klass)->get_preview_pixbuf = library_photo_real_get_preview_pixbuf;
	PHOTO_CLASS (klass)->rotate = library_photo_real_rotate;
	THUMBNAIL_SOURCE_CLASS (klass)->get_thumbnail = library_photo_real_get_thumbnail;
	MEDIA_SOURCE_CLASS (klass)->is_trashed = library_photo_real_is_trashed;
	MEDIA_SOURCE_CLASS (klass)->trash = library_photo_real_trash;
	MEDIA_SOURCE_CLASS (klass)->untrash = library_photo_real_untrash;
	MEDIA_SOURCE_CLASS (klass)->is_offline = library_photo_real_is_offline;
	MEDIA_SOURCE_CLASS (klass)->mark_offline = library_photo_real_mark_offline;
	MEDIA_SOURCE_CLASS (klass)->mark_online = library_photo_real_mark_online;
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = library_photo_real_internal_delete_backing;
	DATA_SOURCE_CLASS (klass)->destroy = library_photo_real_destroy;
	PHOTO_CLASS (klass)->has_user_generated_metadata = library_photo_real_has_user_generated_metadata;
	PHOTO_CLASS (klass)->set_user_metadata_for_export = library_photo_real_set_user_metadata_for_export;
	PHOTO_CLASS (klass)->apply_user_metadata_for_reimport = library_photo_real_apply_user_metadata_for_reimport;
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
}


static void library_photo_flaggable_interface_init (FlaggableIface * iface) {
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
	iface->is_flagged = (gboolean (*)(Flaggable*)) library_photo_real_is_flagged;
	iface->mark_flagged = (void (*)(Flaggable*)) library_photo_real_mark_flagged;
	iface->mark_unflagged = (void (*)(Flaggable*)) library_photo_real_mark_unflagged;
}


static void library_photo_monitorable_interface_init (MonitorableIface * iface) {
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
	iface->is_offline = (gboolean (*)(Monitorable*)) library_photo_real_is_offline;
	iface->mark_offline = (void (*)(Monitorable*)) library_photo_real_mark_offline;
	iface->mark_online = (void (*)(Monitorable*)) library_photo_real_mark_online;
	iface->set_master_file = (void (*)(Monitorable* ,GFile*)) photo_set_master_file;
	iface->set_master_timestamp = (void (*)(Monitorable* ,GFileInfo*)) photo_set_master_timestamp;
}


static void library_photo_instance_init (LibraryPhoto * self) {
	self->priv = LIBRARY_PHOTO_GET_PRIVATE (self);
	self->priv->block_thumbnail_generation = FALSE;
	self->priv->thumbnail_scheduler = NULL;
}


static void library_photo_finalize (GObject* obj) {
	LibraryPhoto * self;
	self = LIBRARY_PHOTO (obj);
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
	_g_object_unref0 (self->priv->import_keywords);
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
}


GType library_photo_get_type (void) {
	static volatile gsize library_photo_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType library_photo_type_id;
		library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
		g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
		g_once_init_leave (&library_photo_type_id__volatile, library_photo_type_id);
	}
	return library_photo_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



